/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsCommon/fsAsyncReaderFilter.h>
#include <atlstr.h>
#include <assert.h>
//------------------------------------------------------------------------------
fsAsyncReaderFilter::fsAsyncReaderFilter(const mxString& name) :
fsSourceFilter("Async Reader", name)
{
	HRESULT hr;
	hr = CoCreateInstance(CLSID_AsyncReader, NULL, CLSCTX_INPROC,
						IID_IBaseFilter, (void **)&_filter);

	if (hr != S_OK)
		_filter		= NULL;

	if (hr == S_OK)
	{
		hr = _filter->QueryInterface(IID_IFileSourceFilter, (void **)&_fileSource);
		if (hr != S_OK)
		{
			_fileSource = NULL;

			_filter->Release();
			_filter	= NULL;
		}
	}
}
//------------------------------------------------------------------------------
fsAsyncReaderFilter::~fsAsyncReaderFilter()
{
	if (_fileSource != NULL)
	{
		_fileSource->Release();
		_fileSource = NULL;
	}
}
//------------------------------------------------------------------------------
mxBool
fsAsyncReaderFilter::load(const mxString& filename)
{
	if (_fileSource == NULL)
		return false;
	CString str = filename.c_str();

	USES_CONVERSION;

	HRESULT hr;
	hr = _fileSource->Load(T2W(str), NULL);

	return !(FAILED(hr));
}
//------------------------------------------------------------------------------
