/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsCommon/fsAudioMixerFilter.h>
//------------------------------------------------------------------------------
fsAudioMixerFilter::fsAudioMixerFilter(const mxString& name) :
fsFilter(name)
{
	HRESULT hr;
	hr = CoCreateInstance(CLSID_AudioMixer, NULL, CLSCTX_INPROC,
						IID_IBaseFilter, (void **)&_filter);

	_audioMixer = NULL;

	if (hr == S_OK)
	{
		hr = _filter->QueryInterface(IID_IAudioMixer, (void **)&_audioMixer);
		if (hr != S_OK)
		{
			_audioMixer	= NULL;

			_filter->Release();
			_filter	= NULL;
		}
	}
}
//------------------------------------------------------------------------------
fsAudioMixerFilter::~fsAudioMixerFilter()
{
	if (_audioMixer != NULL)
		_audioMixer->Release();
}
//------------------------------------------------------------------------------
void
fsAudioMixerFilter::setBufferSize(mxUInt size)
{
	if (_audioMixer == NULL)
		return ;
	_audioMixer->put_BufferSize(size);
}
//------------------------------------------------------------------------------
mxUInt
fsAudioMixerFilter::getBufferSize() const
{
	if (_audioMixer == NULL)
		return 0;
	mxUInt size;
	_audioMixer->get_BufferSize(&size);
	return size;
}
//------------------------------------------------------------------------------
mxBool
fsAudioMixerFilter::isMixing() const
{
	if (_audioMixer == NULL)
		return false;
	mxBool flag;
	_audioMixer->is_Mixing(&flag);
	return flag;
}
//------------------------------------------------------------------------------
