/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsCaptureFilter_h__
#define __fsCaptureFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsSourceFilter.h>
//------------------------------------------------------------------------------
class fsCaptureFilter;
typedef mxObjectPtr<fsCaptureFilter>	fsCaptureFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsCaptureFilter : public fsSourceFilter
{
	friend class fsFilterEnumerator;

	MXOBJECTHEADER(fsCaptureFilter, fsSourceFilter);

protected:
	fsCaptureFilter(IBaseFilter *filter, const mxString& friendlyName);
	virtual ~fsCaptureFilter();

public:
	mxInt			getCapturePinIndex() const;
	mxInt			getPreviewPinIndex() const;

	mxBool			isAnalogVideo() const;
	mxBool			isDigitalVideo() const;

	void			setAllocatorProperties(mxUInt outputPinIndex,
											mxLong numBuf,
											mxLong bufSize,
											mxLong bufAlign,
											mxLong bufPrefix);
	void			getAllocatorProperties(mxUInt outputPinIndex,
											mxLong& numBuf,
											mxLong& bufSize,
											mxLong& bufAlign,
											mxLong& bufPrefix) const;

private:
	mxInt			_getCategoryPinIndex(mxBool isCapturePin) const;

private:
	mxInt			_capturePinIndex;
	mxInt			_previewPinIndex;
	mxBool			_isAnalogVideo;
	mxBool			_isDigitalVideo;
};
//------------------------------------------------------------------------------
//DECLARE_SAFE_COPYFUNC(fsCaptureFilterPtr);
//DECLARE_SAFE_COMPFUNC(fsCaptureFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsCaptureFilter_h__
