/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsCommon_h__
#define __fsCommon_h__
//------------------------------------------------------------------------------
#ifdef _WIN32
#ifdef FSCOMMON_EXPORTS
#define	FSCOMMONCLASS	__declspec(dllexport)
#define	FSCOMMONPROC	extern "C" __declspec(dllexport)
#else
#define	FSCOMMONCLASS	__declspec(dllimport)
#define	FSCOMMONPROC	extern "C" __declspec(dllimport)
#endif
#else
#define	FSCOMMONCLASS
#define	FSCOMMONPROC
#endif
//------------------------------------------------------------------------------
#pragma comment(lib, "mxCore.lib")
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Focus Display Type
enum rsFocusDisplayEnum {
	FSFD_NONE,
	FSFD_PARTIAL_ZOOM,
	FSFD_NON_LINEAR_ZOOM,
	FSFD_IMAGE_COMPOUND,

	NUM_FOCUSDISPLAY
};

#define FS_FOCUSDISPLAY2STR(__focusDisplay, __str)				\
	switch(__focusDisplay)										\
	{															\
	case FSFD_NONE:				str = "None";			break;	\
	case FSFD_PARTIAL_ZOOM:		str = "PartialZoom";	break;	\
	case FSFD_NON_LINEAR_ZOOM:	str = "NonLinearZoom";	break;	\
	case FSFD_IMAGE_COMPOUND:	str = "ImageCompound";	break;	\
	default:					str = "None";			break;	\
	}

#define FS_STR2FOCUSDISPLAY(__str, __focusDisplay)								\
	__str.toLower();															\
	if (__str == "none")				__focusDisplay = FSFD_NONE;				\
	else if (__str == "partialzoom")	__focusDisplay = FSFD_PARTIAL_ZOOM;		\
	else if (__str == "nonlinearzoom")	__focusDisplay = FSFD_NON_LINEAR_ZOOM;	\
	else if (__str == "imagecompound")	__focusDisplay = FSFD_IMAGE_COMPOUND;	\
	else								__focusDisplay = FSFD_NONE;

//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Video Resolution
enum rsVideoResolutionEnum {
	FSVR_SQCIF,
	FSVR_QCIF,
	FSVR_CIF,
	FSVR_160x120,
	FSVR_320x240,
	FSVR_360x240,
	FSVR_640x480,
	FSVR_720x480,
	FSVR_800x600,
	FSVR_1024x768,
	FSVR_1280x1024,
	FSVR_1600x1200,
	FSVR_HDTV720P,
	FSVR_HDTV1080I,
	FSVR_SDTV480P,
	FSVR_SDTV480I,
	FSVR_THROUGH,

	NUM_VIDEORESOLUTION
};

#define FS_RESOLUTION2STR(__resolution, __str)		\
	switch(__resolution)							\
	{												\
	case FSVR_SQCIF:	__str = "SQCIF";	break;	\
	case FSVR_QCIF:		__str = "QCIF";		break;	\
	case FSVR_CIF:		__str = "CIF";		break;	\
	case FSVR_160x120:	__str = "160x120";	break;	\
	case FSVR_320x240:	__str = "320x240";	break;	\
	case FSVR_360x240:	__str = "360x240";	break;	\
	case FSVR_640x480:	__str = "640x480";	break;	\
	case FSVR_720x480:	__str = "720x480";	break;	\
	case FSVR_800x600:	__str = "800x600";	break;	\
	case FSVR_1024x768:	__str = "1024x768";	break;	\
	case FSVR_1280x1024:__str = "1280x1024";break;	\
	case FSVR_1600x1200:__str = "1600x1200";break;	\
	case FSVR_HDTV720P:	__str = "HDTV720P";	break;	\
	case FSVR_HDTV1080I:__str = "HDTV1080I";break;	\
	case FSVR_SDTV480P:	__str = "SDTV480P";	break;	\
	case FSVR_SDTV480I:	__str = "SDTV480I";	break;	\
	case FSVR_THROUGH:	__str = "Through";	break;	\
	default:			__str = "SQCIF";	break;	\
	}

#define FS_STR2RESOLUTION(__str, __resolution)						\
	__str.toLower();												\
	if (__str == "sqcif")			__resolution = FSVR_SQCIF;		\
	else if (__str == "qcif")		__resolution = FSVR_QCIF;		\
	else if (__str == "cif")		__resolution = FSVR_CIF;		\
	else if (__str == "160x120")	__resolution = FSVR_160x120;	\
	else if (__str == "320x240")	__resolution = FSVR_320x240;	\
	else if (__str == "360x240")	__resolution = FSVR_360x240;	\
	else if (__str == "640x480")	__resolution = FSVR_640x480;	\
	else if (__str == "720x480")	__resolution = FSVR_720x480;	\
	else if (__str == "800x600")	__resolution = FSVR_800x600;	\
	else if (__str == "1024x768")	__resolution = FSVR_1024x768;	\
	else if (__str == "1280x1024")	__resolution = FSVR_1280x1024;	\
	else if (__str == "1600x1200")	__resolution = FSVR_1600x1200;	\
	else if (__str == "hdtv720p")	__resolution = FSVR_HDTV720P;	\
	else if (__str == "hdtv1080i")	__resolution = FSVR_HDTV1080I;	\
	else if (__str == "sdtv480p")	__resolution = FSVR_SDTV480P;	\
	else if (__str == "sdtv480i")	__resolution = FSVR_SDTV480I;	\
	else if (__str == "through")	__resolution = FSVR_THROUGH;	\
	else							__resolution = FSVR_SQCIF;

#define FS_RESOLUTION2SIZE(__resolution, __width, __height)			\
	switch(__resolution)											\
	{																\
	case FSVR_SQCIF:	__width = 128;	__height = 96;	break;		\
	case FSVR_QCIF:		__width = 176;	__height = 144;	break;		\
	case FSVR_CIF:		__width = 352;	__height = 288;	break;		\
	case FSVR_160x120:	__width = 160;	__height = 120;	break;		\
	case FSVR_320x240:	__width = 320;	__height = 240;	break;		\
	case FSVR_360x240:	__width = 360;	__height = 240;	break;		\
	case FSVR_640x480:	__width = 640;	__height = 480;	break;		\
	case FSVR_720x480:	__width = 720;	__height = 480;	break;		\
	case FSVR_800x600:	__width = 800;	__height = 600;	break;		\
	case FSVR_1024x768:	__width = 1024;	__height = 768;	break;		\
	case FSVR_1280x1024:__width = 1280;	__height = 1024;break;		\
	case FSVR_1600x1200:__width = 1600;	__height = 1200;break;		\
	case FSVR_HDTV720P:	__width = 1280; __height = 720;	break;		\
	case FSVR_HDTV1080I:__width = 1920; __height = 1080;break;		\
	case FSVR_SDTV480P:	__width = 852; 	__height = 480;	break;		\
	case FSVR_SDTV480I:	__width = 852; 	__height = 480;	break;		\
	default:			__width = 10;	__height = 10;	break;		\
	}

//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Mask Type
enum rsMaskTypeEnum {
	FSMT_RECTANGLE,
	FSMT_OVAL,
	FSMT_CHECKERS,

	NUM_MASKTYPE
};

#define FS_MASKTYPE2STR(__maskType, __str)					\
	switch(__maskType)										\
	{														\
	case FSMT_RECTANGLE:	__str = "Rectangle";	break;	\
	case FSMT_OVAL:			__str = "Oval";			break;	\
	case FSMT_CHECKERS:		__str = "Checkers";		break;	\
	default:				__str = "Rectangle";	break;	\
	}

#define FS_STR2MASKTYPE(__str, __maskType)						\
	__str.toLower();											\
	if (__str == "rectangle")		__maskType = FSMT_RECTANGLE;\
	else if (__str == "oval")		__maskType = FSMT_OVAL;		\
	else if (__str == "checkers")	__maskType = FSMT_CHECKERS;	\
	else							__maskType = FSMT_RECTANGLE;

//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Blending Type
enum rsBlendingTypeEnum {
	FSBT_SIMPLE,
	FSBT_BLENDING,

	NUM_BLENDINGTYPE
};

#define FS_BLENDINGTYPE2STR(__blendingType, __str)		\
	switch(__blendingType)								\
	{													\
	case FSBT_SIMPLE:	__str = "Simple";		break;	\
	case FSBT_BLENDING:	__str = "Blending";		break;	\
	default:			__str = "Simple";		break;	\
	}

#define FS_STR2BLENDINGTYPE(__str, __blendingType)					\
	__str.toLower();												\
	if (__str == "simple")			__blendingType = FSBT_SIMPLE;	\
	else if (__str == "blending")	__blendingType = FSBT_BLENDING;	\
	else							__blendingType = FSBT_SIMPLE;

//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Pointer Shape
///////
enum rsGeneralPointerEnum {
	FSGP_STANDARD,
	FSGP_ARROW,
	FSGP_CIRCLE,
	FSGP_RECTANGLE,
	FSGP_TARGET,
	FSGP_STAR,
	FSGP_DETAILPOINTER
};

#define FS_GENERALPOINTER2STR(__generalPointer, __str)			\
	switch(__generalPointer)									\
	{															\
	case FSGP_STANDARD:		__str = "Standard";			break;	\
	case FSGP_ARROW:		__str = "Arrow";			break;	\
	case FSGP_CIRCLE:		__str = "Circle";			break;	\
	case FSGP_RECTANGLE:	__str = "Rectangle";		break;	\
	case FSGP_TARGET:		__str = "Target";			break;	\
	case FSGP_STAR:			__str = "Star";				break;	\
	case FSGP_DETAILPOINTER:__str = "DetailPointer";	break;	\
	default:				__str = "Standard";			break;	\
	}

#define FS_STR2GENERALPOINTER(__str, __generalPointer)							\
	__str.toLower();															\
	if (__str == "standard")			__generalPointer = FSGP_STANDARD;		\
	else if (__str == "arrow")			__generalPointer = FSGP_ARROW;			\
	else if (__str == "circle")			__generalPointer = FSGP_CIRCLE;			\
	else if (__str == "rectangle")		__generalPointer = FSGP_RECTANGLE;		\
	else if (__str == "target")			__generalPointer = FSGP_TARGET;			\
	else if (__str == "star")			__generalPointer = FSGP_STAR;			\
	else if (__str == "detailpointer")	__generalPointer = FSGP_DETAILPOINTER;	\
	else								__generalPointer = FSGP_STANDARD;

///////
enum rsLocusPointerEnum {
	FSLP_POINTER1 = FSGP_DETAILPOINTER,
	FSLP_POINTER2,
	FSLP_POINTER3,
	FSLP_DETAILPOINTER
};

#define FS_LOCUSPOINTER2STR(__locusPointer, __str)			\
	switch(__locusPointer)									\
	{														\
	case FSLP_POINTER1:		__str = "Pointer1";		break;	\
	case FSLP_POINTER2:		__str = "Pointer2";		break;	\
	case FSLP_POINTER3:		__str = "Pointer3";		break;	\
	case FSLP_DETAILPOINTER:__str = "DetailPointer";break;	\
	default:				__str = "Pointer1";		break;	\
	}

#define FS_STR2LOCUSPOINTER(__str, __locusPointer)							\
	__str.toLower();														\
	if (__str == "pointer1")			__locusPointer = FSLP_POINTER1;		\
	else if (__str == "pointer2")		__locusPointer = FSLP_POINTER2;		\
	else if (__str == "pointer3")		__locusPointer = FSLP_POINTER3;		\
	else if (__str == "detailpointer")	__locusPointer = FSLP_DETAILPOINTER;\
	else								__locusPointer = FSLP_POINTER1;


///////
enum rsRaisePointerEnum {
	FSRP_POINTER1 = FSLP_DETAILPOINTER,
	FSRP_POINTER2,
	FSRP_POINTER3,
	FSRP_DETAILPOINTER
};

#define FS_RAISEPOINTER2STR(__raisePointer, __str)			\
	switch(__raisePointer)									\
	{														\
	case FSRP_POINTER1:		__str = "Pointer1";		break;	\
	case FSRP_POINTER2:		__str = "Pointer2";		break;	\
	case FSRP_POINTER3:		__str = "Pointer3";		break;	\
	case FSRP_DETAILPOINTER:__str = "DetailPointer";break;	\
	default:				__str = "Pointer1";		break;	\
	}

#define FS_STR2RAISEPOINTER(__str, __raisePointer)							\
	__str.toLower();														\
	if (__str == "pointer1")			__raisePointer = FSRP_POINTER1;		\
	else if (__str == "pointer2")		__raisePointer = FSRP_POINTER2;		\
	else if (__str == "pointer3")		__raisePointer = FSRP_POINTER3;		\
	else if (__str == "detailpointer")	__raisePointer = FSRP_DETAILPOINTER;\
	else								__raisePointer = FSRP_POINTER1;


///////
enum rsDetailPointerEntryEnum {
	FSDP_GENERAL,
	FSDP_LOCUS,
	FSDP_RAISE1,
	FSDP_RAISE2,
	FSDP_RAISE3,
	FSDP_RAISE4,
	FSDP_RAISE5,

	NUM_POINTERDETAILENTRY
};

#define DEFAULT_GENERALPOINTER		FSGP_STANDARD
#define DEFAULT_LOCUSPOINTER		FSLP_POINTER1
#define DEFAULT_RAISE1POINTER		FSRP_POINTER1
#define DEFAULT_RAISE2POINTER		FSRP_POINTER1
#define DEFAULT_RAISE3POINTER		FSRP_POINTER1
#define DEFAULT_RAISE4POINTER		FSRP_POINTER1
#define DEFAULT_RAISE5POINTER		FSRP_POINTER1

#define DEFAULT_GENERALPHRASE		""
#define DEFAULT_LOCUSPHRASE			""
#define DEFAULT_RAISE1PHRASE		"fBAJZ^["
#define DEFAULT_RAISE2PHRASE		"?"
#define DEFAULT_RAISE3PHRASE		"!"
#define DEFAULT_RAISE4PHRASE		""
#define DEFAULT_RAISE5PHRASE		""

//------------------------------------------------------------------------------
// Video Window Policy
enum rsVideoWindowPolicy {
	FSVWP_FITTOWINDOW,
	FSVWP_ORIGINALSIZE,

	NUM_VIDEOWINDOWPOLICY
};

#define FS_VIDEOWINDOWPOLICY2STR(__videoWindowPolicy, __str)		\
	switch(__videoWindowPolicy)										\
	{																\
	case FSVWP_FITTOWINDOW:		__str = "FitToWindow";		break;	\
	case FSVWP_ORIGINALSIZE:	__str = "OriginalSize";		break;	\
	default:					__str = "OriginalSize";		break;	\
	}

#define FS_STR2VIDEOWINDOWPOLICY(__str, __videoWindowPolicy)						\
	__str.toLower();																\
	if (__str == "fittowindow")			__videoWindowPolicy = FSVWP_FITTOWINDOW;	\
	else if (__str == "originalsize")	__videoWindowPolicy = FSVWP_ORIGINALSIZE;	\
	else								__videoWindowPolicy = FSVWP_ORIGINALSIZE;

//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Coordinate
enum rsCoordinateEnum {
	FSC_DESKTOPWINDOW,
	FSC_VIDEOWINDOW,

	NUM_COORDINATE
};

#define FS_COORDINATE2STR(__coordinate, __str)					\
	switch(__coordinate)										\
	{															\
	case FSC_DESKTOPWINDOW:	__str = "DesktopWindow";	break;	\
	case FSC_VIDEOWINDOW:		__str = "VideoWindow";	break;	\
	default:					__str = "DesktopWindow";break;	\
	}

#define FS_STR2COORDINATE(__str, __coordinate)							\
	__str.toLower();													\
	if (__str == "desktopwindow")	__coordinate = FSC_DESKTOPWINDOW;	\
	else if (__str == "videowindow")__coordinate = FSC_VIDEOWINDOW;		\
	else							__coordinate = FSC_DESKTOPWINDOW;

//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Registry Info
#define	FS_REGISTRY_COMPANY_NAME	"NIME"
#define	FS_REGISTRY_PRODUCT_NAME	"Focus Share Software (03.11.11)"
#define	VERSION_STRING				"1.1.1.1"
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Multicast IP Address
#define DEFAULT_ADDRESS				"234.5.6.7"
#define DEFAULT_TIMETOLIVE			1
#define DEFAULT_MAXTRANSMISSIONRATE	(1 * 1024 * 1024)
#define DEFAULT_TRANSMISSIONCOUNT	1
#define DEFAULT_PACKETSIZE			1024
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Reserved Port Number
#define PORT_STATUS						8000

#define PORT_SENDER_REMOTE				8010
#define PORT_SENDER_REMOTEACK			8011
#define PORT_RECEIVER_REMOTE			8020
#define PORT_RECEIVER_REMOTEACK			8021
#define PORT_MULTIRECEIVER_REMOTE		8030
#define PORT_MULTIRECEIVER_REMOTEACK	8031
#define PORT_REMOTE_INQUIRY_REPLY		8040

#define PORT_VIDEOMAIN					8100
#define PORT_VIDEOFOCUS					8101
#define PORT_AUDIO						8102
#define PORT_FOCUS_POINTER				8103

#define PORT_POINTER_MEDIATE			8200
#define PORT_POINTER_MIN				8300
#define PORT_POINTER_MAX				8399
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
#endif // __fsCommon_h__
