/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsDigitalClockFilter_h__
#define __fsDigitalClockFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsSourceFilter.h>

#include <initguid.h>
#include <flTypes/flUIDs.h>
#include <flTypes/IDigitalClock.h>
//------------------------------------------------------------------------------
class fsDigitalClockFilter;
typedef mxObjectPtr<fsDigitalClockFilter>	fsDigitalClockFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsDigitalClockFilter : public fsSourceFilter
{
	friend class fsFilterEnumerator;

	MXOBJECTHEADER(fsDigitalClockFilter, fsSourceFilter);

public:
	fsDigitalClockFilter(const mxString& name);

protected:
	virtual ~fsDigitalClockFilter();

public:
	mxInt			getOutputVideoResolution() const;
	void			setOutputVideoResolution(mxInt resolution);

	mxInt			getFrameRate() const;
	void			setFrameRate(mxInt frameRate);

	mxInt			getFontSize() const;
	void			setFontSize(mxInt fontSize);

	void			getFontColor(mxByte* color) const;
	void			setFontColor(const mxByte* color);

	void			getBackgroundColor(mxByte* color) const;
	void			setBackgroundColor(const mxByte* color);

	const mxString&	getHeaderString() const;
	void			setHeaderString(const mxString& str);

	const mxString&	getFooterString() const;
	void			setFooterString(const mxString& str);

protected:
	IDigitalClock*	_digitalClock;

	mxString		_headerString;
	mxString		_footerString;
};
//------------------------------------------------------------------------------
DECLARE_SAFE_COPYFUNC(fsDigitalClockFilterPtr);
DECLARE_SAFE_COMPFUNC(fsDigitalClockFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsDigitalClockFilter_h__
