/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsCommon/fsDrawCaptionFilter.h>
//------------------------------------------------------------------------------
fsDrawCaptionFilter::fsDrawCaptionFilter(const mxString& name) :
fsFilter(name)
{
	HRESULT hr;
	hr = CoCreateInstance(CLSID_DrawCaption, NULL, CLSCTX_INPROC,
						IID_IBaseFilter, (void **)&_filter);

	_drawCaption = NULL;

	if (hr == S_OK)
	{
		hr = _filter->QueryInterface(IID_IDrawCaption, (void **)&_drawCaption);
		if (hr != S_OK)
		{
			_drawCaption	= NULL;

			_filter->Release();
			_filter	= NULL;
		}
	}

	_caption = "";
	if (_drawCaption != NULL)
	{
		mxChar caption[DC_MAXIMUM_CAPTION_LENGTH];
		_drawCaption->get_Caption(caption);
		_caption = mxString(caption);
	}
}
//------------------------------------------------------------------------------
fsDrawCaptionFilter::~fsDrawCaptionFilter()
{
	if (_drawCaption != NULL)
		_drawCaption->Release();
}
//------------------------------------------------------------------------------
mxBool
fsDrawCaptionFilter::getCaptionOn() const
{
	if (_drawCaption == NULL)
		return false;
	mxBool flag;
	_drawCaption->get_CaptionOn(&flag);
	return flag;
}
//------------------------------------------------------------------------------
void
fsDrawCaptionFilter::setCaptionOn(mxBool captionOn)
{
	if (_drawCaption == NULL)
		return ;
	_drawCaption->put_CaptionOn(captionOn);
}
//------------------------------------------------------------------------------
const mxString&
fsDrawCaptionFilter::getCaption() const
{
	return _caption;
}
//------------------------------------------------------------------------------
void
fsDrawCaptionFilter::setCaption(const mxString& caption)
{
	if (_drawCaption == NULL)
		return ;
	_caption = caption;
	if (_caption.length() == 0)
		_drawCaption->put_Caption("");
	else
		_drawCaption->put_Caption(caption.c_str());
}
//------------------------------------------------------------------------------
mxUInt
fsDrawCaptionFilter::getFontSize() const
{
	if (_drawCaption == NULL)
		return 0;
	mxUInt fontSize;
	_drawCaption->get_FontSize(&fontSize);
	return fontSize;
}
//------------------------------------------------------------------------------
void
fsDrawCaptionFilter::setFontSize(mxUInt fontSize)
{
	if (_drawCaption == NULL)
		return ;
	_drawCaption->put_FontSize(fontSize);
}
//------------------------------------------------------------------------------
