/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsDrawCaptionFilter_h__
#define __fsDrawCaptionFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsFilter.h>

#include <initguid.h>
#include <flTypes/flUIDs.h>
#include <flTypes/IDrawCaption.h>
#include <mx/mxCore/mxString.h>
//------------------------------------------------------------------------------
class fsDrawCaptionFilter;
typedef mxObjectPtr<fsDrawCaptionFilter>	fsDrawCaptionFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsDrawCaptionFilter : public fsFilter
{
	MXOBJECTHEADER(fsDrawCaptionFilter, fsFilter);

public:
	fsDrawCaptionFilter(const mxString& name);

protected:
	virtual ~fsDrawCaptionFilter();

public:
	mxBool			getCaptionOn() const;
	void			setCaptionOn(mxBool captionOn);

	const mxString&	getCaption() const;
	void			setCaption(const mxString& caption);

	mxUInt			getFontSize() const;
	void			setFontSize(mxUInt fontSize);

protected:
	IDrawCaption*	_drawCaption;
	mxString		_caption;
};
//------------------------------------------------------------------------------
//DECLARE_SAFE_COPYFUNC(fsDrawCaptionFilterPtr);
//DECLARE_SAFE_COMPFUNC(fsDrawCaptionFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsDrawCaptionFilter_h__
