/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsCommon/fsDrawFrameFilter.h>
//------------------------------------------------------------------------------
fsDrawFrameFilter::fsDrawFrameFilter(const mxString& name) :
fsFilter(name)
{
	HRESULT hr;
	hr = CoCreateInstance(CLSID_DrawFrame, NULL, CLSCTX_INPROC,
						IID_IBaseFilter, (void **)&_filter);

	_drawFrame = NULL;

	if (hr == S_OK)
	{
		hr = _filter->QueryInterface(IID_IDrawFrame, (void **)&_drawFrame);
		if (hr != S_OK)
		{
			_drawFrame	= NULL;

			_filter->Release();
			_filter	= NULL;
		}
	}
}
//------------------------------------------------------------------------------
fsDrawFrameFilter::~fsDrawFrameFilter()
{
	if (_drawFrame != NULL)
		_drawFrame->Release();
}
//------------------------------------------------------------------------------
mxBool
fsDrawFrameFilter::getFrameOn() const
{
	if (_drawFrame == NULL)
		return false;
	mxBool flag;
	_drawFrame->get_FrameOn(&flag);
	return flag;
}
//------------------------------------------------------------------------------
void
fsDrawFrameFilter::setFrameOn(mxBool frameOn)
{
	if (_drawFrame == NULL)
		return ;
	_drawFrame->put_FrameOn(frameOn);
}
//------------------------------------------------------------------------------
mxInt
fsDrawFrameFilter::getFrameType() const
{
	if (_drawFrame == NULL)
		return 0;
	mxInt frameType;
	_drawFrame->get_FrameType(&frameType);
	return frameType;
}
//------------------------------------------------------------------------------
void
fsDrawFrameFilter::setFrameType(mxInt frameType)
{
	if (_drawFrame == NULL)
		return;
	_drawFrame->put_FrameType(frameType);
}
//------------------------------------------------------------------------------
mxBool
fsDrawFrameFilter::getPointerInDisable() const
{
	if (_drawFrame == NULL)
		return false;
	mxBool pointerInDisable;
	_drawFrame->get_PointerInDisable(&pointerInDisable);
	return pointerInDisable;
}
//------------------------------------------------------------------------------
void
fsDrawFrameFilter::setPointerInDisable(mxBool flag)
{
	if (_drawFrame == NULL)
		return;
	_drawFrame->put_PointerInDisable(flag);
}
//------------------------------------------------------------------------------
void
fsDrawFrameFilter::getPosition(mxInt& x, mxInt& y) const
{
	if (_drawFrame == NULL)
		return;
	_drawFrame->get_Position(&x, &y);
}
//------------------------------------------------------------------------------
void
fsDrawFrameFilter::setPosition(mxInt x, mxInt y)
{
	if (_drawFrame == NULL)
		return;
	_drawFrame->put_Position(x, y);
}
//------------------------------------------------------------------------------
void
fsDrawFrameFilter::getSize(mxUInt& width, mxUInt& height) const
{
	if (_drawFrame == NULL)
		return;
	_drawFrame->get_Size(&width, &height);
}
//------------------------------------------------------------------------------
void
fsDrawFrameFilter::setSize(mxUInt width, mxUInt height)
{
	if (_drawFrame == NULL)
		return;
	_drawFrame->put_Size(width, height);
}
//------------------------------------------------------------------------------
void
fsDrawFrameFilter::getColor(mxByte& r, mxByte& g, mxByte& b) const
{
	if (_drawFrame == NULL)
		return;
	_drawFrame->get_Color(&r, &g, &b);
}
//------------------------------------------------------------------------------
void
fsDrawFrameFilter::setColor(mxByte r, mxByte g, mxByte b)
{
	if (_drawFrame == NULL)
		return;
	_drawFrame->put_Color(r, g, b);
}
//------------------------------------------------------------------------------
mxUInt
fsDrawFrameFilter::getThickness() const
{
	if (_drawFrame == NULL)
		return 0;
	mxUInt thickness;
	_drawFrame->get_Thickness(&thickness);
	return thickness;
}
//------------------------------------------------------------------------------
void
fsDrawFrameFilter::setThickness(mxUInt thickness)
{
	if (_drawFrame == NULL)
		return;
	_drawFrame->put_Thickness(thickness);
}
//------------------------------------------------------------------------------
