/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsDrawFrameFilter_h__
#define __fsDrawFrameFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsFilter.h>

#include <initguid.h>
#include <flTypes/flUIDs.h>
#include <flTypes/IDrawFrame.h>
//------------------------------------------------------------------------------
class fsDrawFrameFilter;
typedef mxObjectPtr<fsDrawFrameFilter>	fsDrawFrameFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsDrawFrameFilter : public fsFilter
{
	MXOBJECTHEADER(fsDrawFrameFilter, fsFilter);

public:
	fsDrawFrameFilter(const mxString& name);

protected:
	virtual ~fsDrawFrameFilter();

public:
	mxBool			getFrameOn() const;
	void			setFrameOn(mxBool frameOn);

	mxInt			getFrameType() const;
	void			setFrameType(mxInt frameType);

	mxBool			getPointerInDisable() const;
	void			setPointerInDisable(mxBool flag);

	void			getPosition(mxInt& x, mxInt& y) const;
	void			setPosition(mxInt x, mxInt y);

	void			getSize(mxUInt& width, mxUInt& height) const;
	void			setSize(mxUInt width, mxUInt height);

	void			getColor(mxByte& r, mxByte& g, mxByte& b) const;
	void			setColor(mxByte r, mxByte g, mxByte b);

	mxUInt			getThickness() const;
	void			setThickness(mxUInt thickness);

protected:
	IDrawFrame*		_drawFrame;
};
//------------------------------------------------------------------------------
//DECLARE_SAFE_COPYFUNC(fsDrawFrameFilterPtr);
//DECLARE_SAFE_COMPFUNC(fsDrawFrameFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsDrawFrameFilter_h__
