/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsFilter_h__
#define __fsFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsCommon.h>
#include <mx/mxCore/mxString.h>
#include <mx/mxCore/mxObject.h>
#include <Dshow.h>
//------------------------------------------------------------------------------
class fsFilter;
typedef mxObjectPtr<fsFilter>	fsFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsFilter : public mxObject
{
	MXOBJECTHEADER(fsFilter, mxObject);

	friend class fsGraphManager;

protected:
	fsFilter(const mxString& name);
	fsFilter(IBaseFilter* filter);
	virtual ~fsFilter();

public:
	mxBool			isValid() const;
	IBaseFilter*	getBaseFilter() const;

	const mxString&	getName() const;
	void			setName(const mxString& name);

	mxUInt			getNumInputPins() const;
	mxUInt			getNumOutputPins() const;

	fsFilterPtr		getUpStreamFilter(mxUInt pinInIndex) const;
	fsFilterPtr		getDownStreamFilter(mxUInt pinOutIndex) const;

	mxBool			isInputConnected(mxUInt pinInIndex) const;
	mxBool			isOutputConnected(mxUInt pinOutIndex) const;

public:
	template<class T> T*		cast();
	template<class T> const T*	cast() const;
	operator const fsFilter*() const;

protected:
	IPin*			getInputPin(mxUInt index) const;
	IPin*			getOutputPin(mxUInt index) const;

private:
	mxUInt			_getNumPins(mxBool isInput) const;
	IPin*			_getPin(mxBool isInput, mxUInt index) const;

protected:
	mxString			_name;
	IBaseFilter*		_filter;
};
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsFilter.inl>
//------------------------------------------------------------------------------
DECLARE_SAFE_COPYFUNC(fsFilterPtr);
DECLARE_SAFE_COMPFUNC(fsFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsFilter_h__
