/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsFilterEnumerator_h__
#define __fsFilterEnumerator_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsCaptureFilter.h>
#include <fs/fsCommon/fsEncoderFilter.h>
#include <fs/fsCommon/fsAudioRenderFilter.h>
#include <fs/fsCommon/fsCommon.h>
#include <mx/mxCore/mxString.h>
#include <mx/mxCore/mxObject.h>
#include <Dshow.h>
//------------------------------------------------------------------------------
class fsFilterEnumerator;
typedef mxObjectPtr<fsFilterEnumerator>	fsFilterEnumeratorPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsFilterEnumerator : public mxObject
{
	MXOBJECTHEADER(fsFilterEnumerator, mxObject);

public:
	enum CategoryEnum {
		C_VIDEO_CAPTURE,
		C_VIDEO_ENCODER,
		C_AUDIO_CAPTURE,
		C_AUDIO_ENCODER,
		C_AUDIO_RENDERER,
		NUM_CATEGORY
	};

	fsFilterEnumerator(CategoryEnum category);

protected:
	virtual ~fsFilterEnumerator();

public:
	void			reset();
	mxBool			nextFilter(fsFilterPtr& filter);

protected:
	CategoryEnum		_category;
	ICreateDevEnum*		_systemDevice;
	IEnumMoniker*		_enumerator;
};
//------------------------------------------------------------------------------
#endif //__fsFilterEnumerator_h__
