/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsCommon/fsFormatTransFilter.h>
//------------------------------------------------------------------------------
fsFormatTransFilter::fsFormatTransFilter(const mxString& name) :
fsFilter(name)
{
	HRESULT hr;
	hr = CoCreateInstance(CLSID_FormatTrans, NULL, CLSCTX_INPROC,
						IID_IBaseFilter, (void **)&_filter);

	_formatTrans = NULL;

	if (hr == S_OK)
	{
		hr = _filter->QueryInterface(IID_IFormatTrans, (void **)&_formatTrans);
		if (hr != S_OK)
		{
			_formatTrans	= NULL;

			_filter->Release();
			_filter	= NULL;
		}
	}
}
//------------------------------------------------------------------------------
fsFormatTransFilter::~fsFormatTransFilter()
{
	if (_formatTrans != NULL)
		_formatTrans->Release();
}
//------------------------------------------------------------------------------
mxInt
fsFormatTransFilter::getInputVideoResolution() const
{
	if (_formatTrans == NULL)
		return 0;
	mxUInt videoResolution;
	_formatTrans->get_InputVideoResolution(&videoResolution);
	return (mxInt)videoResolution;
}
//------------------------------------------------------------------------------
void
fsFormatTransFilter::setInputVideoResolution(mxInt videoResolution)
{
	if (_formatTrans == NULL)
		return ;
	_formatTrans->put_InputVideoResolution(videoResolution);
}
//------------------------------------------------------------------------------
mxInt
fsFormatTransFilter::getInputVideoColor() const
{
	if (_formatTrans == NULL)
		return 0;
	mxUInt videoColor;
	_formatTrans->get_InputVideoColor(&videoColor);
	return (mxInt)videoColor;
}
//------------------------------------------------------------------------------
void
fsFormatTransFilter::setInputVideoColor(mxInt videoColor)
{
	if (_formatTrans == NULL)
		return ;
	_formatTrans->put_InputVideoColor(videoColor);
}
//------------------------------------------------------------------------------
mxInt
fsFormatTransFilter::getOutputVideoResolution() const
{
	if (_formatTrans == NULL)
		return 0;
	mxUInt videoResolution;
	_formatTrans->get_OutputVideoResolution(&videoResolution);
	return (mxInt)videoResolution;
}
//------------------------------------------------------------------------------
void
fsFormatTransFilter::setOutputVideoResolution(mxInt videoResolution)
{
	if (_formatTrans == NULL)
		return ;
	_formatTrans->put_OutputVideoResolution(videoResolution);
}
//------------------------------------------------------------------------------
mxInt
fsFormatTransFilter::getActualInputVideoResolution() const
{
	if (_formatTrans == NULL)
		return 0;
	mxUInt videoResolution;
	_formatTrans->get_ActualInputVideoResolution(&videoResolution);
	return (mxInt)videoResolution;
}
//------------------------------------------------------------------------------
mxInt
fsFormatTransFilter::getActualInputVideoColor() const
{
	if (_formatTrans == NULL)
		return 0;
	mxUInt videoColor;
	_formatTrans->get_ActualInputVideoColor(&videoColor);
	return (mxInt)videoColor;
}
//------------------------------------------------------------------------------
mxInt
fsFormatTransFilter::getActualOutputVideoResolution() const
{
	if (_formatTrans == NULL)
		return 0;
	mxUInt videoResolution;
	_formatTrans->get_ActualOutputVideoResolution(&videoResolution);
	return (mxInt)videoResolution;
}
//------------------------------------------------------------------------------
