/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsFormatTransFilter_h__
#define __fsFormatTransFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsFilter.h>

#include <initguid.h>
#include <flTypes/flUIDs.h>
#include <flTypes/IFormatTrans.h>
//------------------------------------------------------------------------------
class fsFormatTransFilter;
typedef mxObjectPtr<fsFormatTransFilter>	fsFormatTransFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsFormatTransFilter : public fsFilter
{
	MXOBJECTHEADER(fsFormatTransFilter, fsFilter);

public:
	fsFormatTransFilter(const mxString& name);

protected:
	virtual ~fsFormatTransFilter();

public:
	mxInt			getInputVideoResolution() const;
	void			setInputVideoResolution(mxInt videoResolution);

	mxInt			getInputVideoColor() const;
	void			setInputVideoColor(mxInt videoColor);

	mxInt			getOutputVideoResolution() const;
	void			setOutputVideoResolution(mxInt videoResolution);

	mxInt			getActualInputVideoResolution() const;
	mxInt			getActualInputVideoColor() const;

	mxInt			getActualOutputVideoResolution() const;

protected:
	IFormatTrans*		_formatTrans;
};
//------------------------------------------------------------------------------
//DECLARE_SAFE_COPYFUNC(fsFormatTransFilterPtr);
//DECLARE_SAFE_COMPFUNC(fsFormatTransFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsFormatTransFilter_h__
