/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsMulticastReceiverFilter_h__
#define __fsMulticastReceiverFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsFilter.h>
#include <mx/mxCore/mxString.h>

#include <initguid.h>
#include <flTypes/flUIDs.h>
#include <flTypes/IMulticastReceiver.h>
//------------------------------------------------------------------------------
class fsMulticastReceiverFilter;
typedef mxObjectPtr<fsMulticastReceiverFilter>	fsMulticastReceiverFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsMulticastReceiverFilter : public fsFilter
{
	MXOBJECTHEADER(fsMulticastReceiverFilter, fsFilter);

public:
	fsMulticastReceiverFilter(const mxString& name);

protected:
	virtual ~fsMulticastReceiverFilter();

public:
	const mxString&	getAddress() const;
	void			setAddress(const mxString& address);

	mxUShort		getPort() const;
	void			setPort(mxUShort port);

	mxULong			getTimeToLive() const;
	void			setTimeToLive(mxULong ttl);

	mxUInt			getNumRejectionAddress() const;
	mxString		getRejectionAddress(mxUInt index) const;
	void			addRejectionAddress(const mxString& address);
	void			removeRejectionAddress(mxUInt index);
	void			removeAllRejectionAddress();

	mxInt			getMediaType() const;
	void			setMediaType(mxInt mediaType);

	mxInt			getVideoFormat() const;
	void			setVideoFormat(mxInt videoResolution);

	mxInt			getVideoResolution() const;
	void			setVideoResolution(mxInt videoResolution);

	mxInt			getAudioFormat() const;
	void			setAudioFormat(mxInt audioFormat);

	mxInt			getAudioFrequency() const;
	void			setAudioFrequency(mxInt frequency);

	mxInt			getAudioStereo() const;
	void			setAudioStereo(mxInt stereo);

	mxInt			getAudioBitCount() const;
	void			setAudioBitCount(mxInt bitCount);

	mxBool			getEnableConnectReceiveMediaType() const;
	void			setEnableConnectReceiveMediaType(mxBool flag);

	mxUInt			getReceiveRate() const;
	mxUInt			getFrameRate() const;
	mxUInt			getNumDropPackets() const;
	mxUInt			getNumDropFrames() const;
	mxUInt			getPacketSize() const;
	void			getUserData(mxByte* userData, mxUInt& userDataLength) const;
	const mxString&	getMediaTypeString();
	const mxString&	getSenderAddress();


	mxBool			isSocketOpen() const;
	mxBool			isStreaming() const;

protected:
	IMulticastReceiver*	_receiver;
	mxString			_address;
	mxString			_mediaTypeStr;
	mxString			_senderAddress;
};
//------------------------------------------------------------------------------
DECLARE_SAFE_COPYFUNC(fsMulticastReceiverFilterPtr);
DECLARE_SAFE_COMPFUNC(fsMulticastReceiverFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsMulticastReceiverFilter_h__
