/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsMulticastSenderFilter_h__
#define __fsMulticastSenderFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsFilter.h>
#include <mx/mxCore/mxString.h>

#include <initguid.h>
#include <flTypes/flUIDs.h>
#include <flTypes/IMulticastSender.h>
//------------------------------------------------------------------------------
class fsMulticastSenderFilter;
typedef mxObjectPtr<fsMulticastSenderFilter>	fsMulticastSenderFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsMulticastSenderFilter : public fsFilter
{
	MXOBJECTHEADER(fsMulticastSenderFilter, fsFilter);

public:
	fsMulticastSenderFilter(const mxString& name);

protected:
	virtual ~fsMulticastSenderFilter();

public:
	mxBool			getEnableTransmission() const;
	void			setEnableTransmission(mxBool flag);

	const mxString&	getAddress() const;
	void			setAddress(const mxString& address);

	mxUShort		getPort() const;
	void			setPort(mxUShort port);

	mxULong			getTimeToLive() const;
	void			setTimeToLive(mxULong ttl);

	mxULong			getIPv6InterfaceNo() const;
	void			setIPv6InterfaceNo(mxULong ipv6InterfaceNo);

	mxUInt			getMaximumPacketSize() const;
	void			setMaximumPacketSize(mxUInt size);

	mxUInt			getMaximumTransmissionRate() const;
	void			setMaximumTransmissionRate(mxUInt rate);

	mxUInt			getTransmissionCount() const;
	void			setTransmissionCount(mxUInt count);

	void			getUserData(mxByte* userData, mxUInt& userDataLength) const;
	void			setUserData(const mxByte* userData, mxUInt userDataLength);

	mxInt			getInputMediaType() const;
	mxInt			getInputVideoFormat() const;
	mxInt			getInputVideoResolution() const;
	mxInt			getInputAudioFormat() const;
	mxInt			getInputAudioFrequency() const;
	mxInt			getInputAudioStereo() const;
	mxInt			getInputAudioBitCount() const;
	mxUInt			getTransmissionRate() const;
	mxUInt			getFrameRate() const;

protected:
	IMulticastSender*		_sender;

	mxString				_address;
};
//------------------------------------------------------------------------------
//DECLARE_SAFE_COPYFUNC(fsMulticastSenderFilterPtr);
//DECLARE_SAFE_COMPFUNC(fsMulticastSenderFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsMulticastSenderFilter_h__
