/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsNamePriorityList_h__
#define __fsNamePriorityList_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsCommon.h>
#include <mx/mxCore/mxHash.h>
#include <mx/mxCore/mxString.h>
#include <mx/mxCore/mxObject.h>
//------------------------------------------------------------------------------
class fsNamePriorityList;
typedef mxObjectPtr<fsNamePriorityList>	fsNamePriorityListPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsNamePriorityList : public mxObject
{
	MXOBJECTHEADER(fsNamePriorityList, mxObject);

public:
	enum PriorityEnum {
		P_RECOMMENDED,
		P_GENERAL,
		P_UNRECOMMENDED,
	};
	typedef mxArray<PriorityEnum>	PriorityEnumArray;

public:
	fsNamePriorityList();

protected:
	~fsNamePriorityList();

public:
	mxBool			load(const mxString& filename);
	mxBool			save(const mxString& filename);

public:
	void			setPriority(const mxString& name, PriorityEnum priority = P_GENERAL);
	PriorityEnum	getPriority(const mxString& name);
	void			removePriority(const mxString& name);
	void			removeAllPriorities();

private:
	mxStringArray						_names;
	PriorityEnumArray					_priorities;

	mxHashMap<mxString, PriorityEnum>	_hash;
};
//------------------------------------------------------------------------------
#endif // __fsNamePriorityList_h__
