/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsCommon/fsNonLinearZoomFilter.h>
//------------------------------------------------------------------------------
fsNonLinearZoomFilter::fsNonLinearZoomFilter(const mxString& name) :
fsFilter(name)
{
	HRESULT hr;
	hr = CoCreateInstance(CLSID_NonLinearZoom, NULL, CLSCTX_INPROC,
						IID_IBaseFilter, (void **)&_filter);

	_nonLinearZoom = NULL;

	if (hr == S_OK)
	{
		hr = _filter->QueryInterface(IID_INonLinearZoom, (void **)&_nonLinearZoom);
		if (hr != S_OK)
		{
			_nonLinearZoom	= NULL;

			_filter->Release();
			_filter	= NULL;
		}
	}
}
//------------------------------------------------------------------------------
fsNonLinearZoomFilter::~fsNonLinearZoomFilter()
{
	if (_nonLinearZoom != NULL)
		_nonLinearZoom->Release();
}
//------------------------------------------------------------------------------
void
fsNonLinearZoomFilter::setOutputVideoResolution(mxInt videoResolution)
{
	if (_nonLinearZoom == NULL)
		return ;
	_nonLinearZoom->put_OutputVideoResolution((mxUInt)videoResolution);
}
//------------------------------------------------------------------------------
mxInt
fsNonLinearZoomFilter::getOutputVideoResolution() const
{
	if (_nonLinearZoom == NULL)
		return 0;
	mxInt videoResolution;
	_nonLinearZoom->get_OutputVideoResolution((mxUInt *)&videoResolution);
	return videoResolution;
}
//------------------------------------------------------------------------------
void
fsNonLinearZoomFilter::setMask(mxInt mask)
{
	if (_nonLinearZoom == NULL)
		return ;
	_nonLinearZoom->put_Mask((mxUInt)mask);
}
//------------------------------------------------------------------------------
mxInt
fsNonLinearZoomFilter::getMask() const
{
	if (_nonLinearZoom == NULL)
		return 0;
	mxInt mask;
	_nonLinearZoom->get_Mask((mxUInt *)&mask);
	return mask;
}
//------------------------------------------------------------------------------
void
fsNonLinearZoomFilter::setMaskSize(mxUInt width, mxUInt height)
{
	if (_nonLinearZoom == NULL)
		return ;
	_nonLinearZoom->put_MaskSize((mxInt)width, (mxInt)height);
}
//------------------------------------------------------------------------------
void
fsNonLinearZoomFilter::getMaskSize(mxUInt& width, mxUInt& height) const
{
	width = 1;
	height = 1;
	if (_nonLinearZoom == NULL)
		return ;
	_nonLinearZoom->get_MaskSize((mxInt *)&width, (mxInt *)&height);
}
//------------------------------------------------------------------------------

