/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsNonLinearZoomFilter_h__
#define __fsNonLinearZoomFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsFilter.h>

#include <initguid.h>
#include <flTypes/flUIDs.h>
#include <flTypes/INonLinearZoom.h>
//------------------------------------------------------------------------------
class fsNonLinearZoomFilter;
typedef mxObjectPtr<fsNonLinearZoomFilter>	fsNonLinearZoomFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsNonLinearZoomFilter : public fsFilter
{
	MXOBJECTHEADER(fsNonLinearZoomFilter, fsFilter);

public:
	fsNonLinearZoomFilter(const mxString& name);

protected:
	virtual ~fsNonLinearZoomFilter();

public:
	void				setOutputVideoResolution(mxInt videoResolution);
	mxInt				getOutputVideoResolution() const;

	void				setMask(mxInt mask);
	mxInt				getMask() const;

	void				setMaskSize(mxUInt width, mxUInt height);
	void				getMaskSize(mxUInt& width, mxUInt& height) const;

protected:
	INonLinearZoom*		_nonLinearZoom;
};
//------------------------------------------------------------------------------
//DECLARE_SAFE_COPYFUNC(fsNonLinearZoomFilterPtr);
//DECLARE_SAFE_COMPFUNC(fsNonLinearZoomFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsNonLinearZoomFilter_h__
