/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsPointerMixerFilter_h__
#define __fsPointerMixerFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsFilter.h>
#include <mx/mxCore/mxString.h>

#include <initguid.h>
#include <flTypes/flUIDs.h>
#include <flTypes/IPointerMixer.h>
//------------------------------------------------------------------------------
class fsPointerMixerFilter;
typedef mxObjectPtr<fsPointerMixerFilter>	fsPointerMixerFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsPointerMixerFilter : public fsFilter
{
	MXOBJECTHEADER(fsPointerMixerFilter, fsFilter);

public:
	fsPointerMixerFilter(const mxString& name);

protected:
	virtual ~fsPointerMixerFilter();

public:
	void			setWindowPosition(mxFloat x, mxFloat y);
	void			getWindowPosition(mxFloat& x, mxFloat& y) const;

	void			setWindowSize(mxFloat width, mxFloat height);
	void			getWindowSize(mxFloat& width, mxFloat& height) const;

	mxUInt			getNumPointerShape() const;
	mxBool			addPointerShape(const mxString& filename);
	void			removePointerShape(mxUInt index);
	const mxString&	getPointerShapeName(mxUInt index) const;
	void			setPointerShapeName(mxUInt index, const mxString& name);
	void			getPointerShapeOrigin(mxUInt index, mxInt& originX, mxInt& originY) const;
	void			setPointerShapeOrigin(mxUInt index, mxInt originX, mxInt originY);

protected:
	IPointerMixer*		_pointerMixer;

	mxArray<mxString>	_pointerShapeNames;
};
//------------------------------------------------------------------------------
//DECLARE_SAFE_COPYFUNC(fsPointerMixerFilterPtr);
//DECLARE_SAFE_COMPFUNC(fsPointerMixerFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsPointerMixerFilter_h__
