/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsCommon/fsSourceFilter.h>
#include <assert.h>
//------------------------------------------------------------------------------
fsSourceFilter::fsSourceFilter(const mxString& friendlyName, const mxString& name) :
fsFilter(name)
{
	_friendlyName	= friendlyName;
}
//------------------------------------------------------------------------------
fsSourceFilter::~fsSourceFilter()
{
}
//------------------------------------------------------------------------------
const mxString&
fsSourceFilter::getFriendlyName() const
{
	return _friendlyName;
}
//------------------------------------------------------------------------------
mxUInt
fsSourceFilter::getNumPropertyPages() const
{
	return 1;
}
//------------------------------------------------------------------------------
const mxString PAGE_NAME = "Source Property Page";
//------------------------------------------------------------------------------
const mxString&
fsSourceFilter::getPropertyPageName(mxUInt pageIndex) const
{
	return PAGE_NAME;
}
//------------------------------------------------------------------------------
mxBool
fsSourceFilter::showPropertyPage(HWND windowHandle, mxUInt pageIndex)
{
	HRESULT hr;
	ISpecifyPropertyPages *propertyPage = NULL;
	CAUUID cauuid;

	hr = _filter->QueryInterface(IID_ISpecifyPropertyPages, (void **)&propertyPage);

	if (hr == S_OK)
	{
		hr = propertyPage->GetPages(&cauuid);
		hr = OleCreatePropertyFrame(windowHandle, 30, 30, NULL, 1,
									(IUnknown **)&_filter, cauuid.cElems,
									(GUID *)cauuid.pElems, 0, 0, NULL);
		CoTaskMemFree(cauuid.pElems);
		propertyPage->Release();
		propertyPage = NULL;

		return true;
	}

	return false;
}
//------------------------------------------------------------------------------
