/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsStillPictureFilter_h__
#define __fsStillPictureFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsSourceFilter.h>

#include <initguid.h>
#include <flTypes/flUIDs.h>
#include <flTypes/IStillPicture.h>
//------------------------------------------------------------------------------
class fsStillPictureFilter;
typedef mxObjectPtr<fsStillPictureFilter>	fsStillPictureFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsStillPictureFilter : public fsSourceFilter
{
	friend class fsFilterEnumerator;

	MXOBJECTHEADER(fsStillPictureFilter, fsSourceFilter);

public:
	fsStillPictureFilter(const mxString& name);

protected:
	virtual ~fsStillPictureFilter();

public:
	mxInt			getOutputVideoResolution() const;
	void			setOutputVideoResolution(mxInt resolution);

	mxInt			getOutputMode() const;
	void			setOutputMode(mxInt mode);

	const mxString&	getFilename() const;
	void			setFilename(const mxString& filename);

	mxInt			getFrameRate() const;
	void			setFrameRate(mxInt frameRate);

	mxBool			getNoiseOn() const;
	void			setNoiseOn(mxBool flag);

protected:
	IStillPicture*	_stillPicture;

	mxString		_filename;
};
//------------------------------------------------------------------------------
DECLARE_SAFE_COPYFUNC(fsStillPictureFilterPtr);
DECLARE_SAFE_COMPFUNC(fsStillPictureFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsStillPictureFilter_h__
