/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsCommon/fsVideoExtractFilter.h>
//------------------------------------------------------------------------------
fsVideoExtractFilter::fsVideoExtractFilter(const mxString& name) :
fsFilter(name)
{
	HRESULT hr;
	hr = CoCreateInstance(CLSID_VideoExtract, NULL, CLSCTX_INPROC,
						IID_IBaseFilter, (void **)&_filter);

	_videoExtract = NULL;

	if (hr == S_OK)
	{
		hr = _filter->QueryInterface(IID_IVideoExtract, (void **)&_videoExtract);
		if (hr != S_OK)
		{
			_videoExtract	= NULL;

			_filter->Release();
			_filter	= NULL;
		}
	}
}
//------------------------------------------------------------------------------
fsVideoExtractFilter::~fsVideoExtractFilter()
{
	if (_videoExtract != NULL)
		_videoExtract->Release();
}
//------------------------------------------------------------------------------
mxInt
fsVideoExtractFilter::getOutputVideoResolution() const
{
	if (_videoExtract == NULL)
		return 0;
	mxUInt videoResolution;
	_videoExtract->get_OutputVideoResolution(&videoResolution);
	return (mxInt)videoResolution;
}
//------------------------------------------------------------------------------
void
fsVideoExtractFilter::setOutputVideoResolution(mxInt videoResolution)
{
	if (_videoExtract == NULL)
		return ;
	_videoExtract->put_OutputVideoResolution(videoResolution);
}
//------------------------------------------------------------------------------
