/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsCommon/fsVideoOverlayMixerFilter.h>
//------------------------------------------------------------------------------
fsVideoOverlayMixerFilter::fsVideoOverlayMixerFilter(const mxString& name) :
fsFilter(name)
{
	HRESULT hr;
	hr = CoCreateInstance(CLSID_VideoOverlayMixer, NULL, CLSCTX_INPROC,
						IID_IBaseFilter, (void **)&_filter);

	_videoOverlayMixer = NULL;

	if (hr == S_OK)
	{
		hr = _filter->QueryInterface(IID_IVideoOverlayMixer, (void **)&_videoOverlayMixer);
		if (hr != S_OK)
		{
			_videoOverlayMixer	= NULL;

			_filter->Release();
			_filter	= NULL;
		}
	}
}
//------------------------------------------------------------------------------
fsVideoOverlayMixerFilter::~fsVideoOverlayMixerFilter()
{
	if (_videoOverlayMixer != NULL)
		_videoOverlayMixer->Release();
}
//------------------------------------------------------------------------------
void
fsVideoOverlayMixerFilter::setMask(mxInt mask)
{
	if (_videoOverlayMixer == NULL)
		return ;
	_videoOverlayMixer->put_Mask((mxUInt)mask);
}
//------------------------------------------------------------------------------
mxInt
fsVideoOverlayMixerFilter::getMask() const
{
	if (_videoOverlayMixer == NULL)
		return 0;
	mxInt mask;
	_videoOverlayMixer->get_Mask((mxUInt *)&mask);
	return mask;
}
//------------------------------------------------------------------------------
void
fsVideoOverlayMixerFilter::setBlending(mxInt blending)
{
	if (_videoOverlayMixer == NULL)
		return ;
	_videoOverlayMixer->put_Blending((mxUInt)blending);
}
//------------------------------------------------------------------------------
mxInt
fsVideoOverlayMixerFilter::getBlending() const
{
	if (_videoOverlayMixer == NULL)
		return 0;
	mxInt blending;
	_videoOverlayMixer->get_Blending((mxUInt *)&blending);
	return blending;
}
//------------------------------------------------------------------------------
void
fsVideoOverlayMixerFilter::setFrameRate(mxInt rate)
{
	if (_videoOverlayMixer == NULL)
		return ;
	_videoOverlayMixer->put_FrameRate(rate);
}
//------------------------------------------------------------------------------
mxInt
fsVideoOverlayMixerFilter::getFrameRate() const
{
	if (_videoOverlayMixer == NULL)
		return 0;
	mxInt frameRate;
	_videoOverlayMixer->get_FrameRate(&frameRate);
	return frameRate;
}
//------------------------------------------------------------------------------
