/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsVideoOverlayMixerFilter_h__
#define __fsVideoOverlayMixerFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsFilter.h>

#include <initguid.h>
#include <flTypes/flUIDs.h>
#include <flTypes/IVideoOverlayMixer.h>
//------------------------------------------------------------------------------
class fsVideoOverlayMixerFilter;
typedef mxObjectPtr<fsVideoOverlayMixerFilter>	fsVideoOverlayMixerFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsVideoOverlayMixerFilter : public fsFilter
{
	MXOBJECTHEADER(fsVideoOverlayMixerFilter, fsFilter);

public:
	fsVideoOverlayMixerFilter(const mxString& name);

protected:
	virtual ~fsVideoOverlayMixerFilter();

public:
	void				setMask(mxInt mask);
	mxInt				getMask() const;

	void				setBlending(mxInt blending);
	mxInt				getBlending() const;

	void				setFrameRate(mxInt rate);
	mxInt				getFrameRate() const;

protected:
	IVideoOverlayMixer*		_videoOverlayMixer;
};
//------------------------------------------------------------------------------
//DECLARE_SAFE_COPYFUNC(fsVideoOverlayMixerFilterPtr);
//DECLARE_SAFE_COMPFUNC(fsVideoOverlayMixerFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsVideoOverlayMixerFilter_h__
