/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsVideoRenderFilter_h__
#define __fsVideoRenderFilter_h__
//------------------------------------------------------------------------------
#include <fs/fsCommon/fsFilter.h>
//------------------------------------------------------------------------------
class fsVideoRenderFilter;
typedef mxObjectPtr<fsVideoRenderFilter>	fsVideoRenderFilterPtr;
//------------------------------------------------------------------------------
class FSCOMMONCLASS fsVideoRenderFilter : public fsFilter
{
	MXOBJECTHEADER(fsVideoRenderFilter, fsFilter);

public:
	fsVideoRenderFilter(const mxString& name);

protected:
	virtual ~fsVideoRenderFilter();

public:
	void		getVideoWindowPosition(mxInt& x, mxInt& y) const;
	void		setVideoWindowPosition(mxInt x, mxInt y);

	void		getVideoWindowSize(mxUInt& width, mxUInt& height) const;
	void		setVideoWindowSize(mxUInt width, mxUInt height);

	mxBool		getVisible() const;
	void		setVisible(mxBool flag);

	HWND		getWindowOwner() const;
	void		setWindowOwner(HWND owner);

	mxLong		getWindowStyle() const;
	void		setWindowStyle(mxLong style);

protected:
	IVideoWindow*		_videoWindow;
};
//------------------------------------------------------------------------------
//DECLARE_SAFE_COPYFUNC(fsVideoRenderFilterPtr);
//DECLARE_SAFE_COMPFUNC(fsVideoRenderFilterPtr);
//------------------------------------------------------------------------------
#endif //__fsVideoRenderFilter_h__
