/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsCommon/fsVolumeIndicatorFilter.h>
//------------------------------------------------------------------------------
fsVolumeIndicatorFilter::fsVolumeIndicatorFilter(const mxString& name) :
fsFilter(name)
{
	HRESULT hr;
	hr = CoCreateInstance(CLSID_VolumeIndicator, NULL, CLSCTX_INPROC,
						IID_IBaseFilter, (void **)&_filter);

	_volumeIndicator = NULL;

	if (hr == S_OK)
	{
		hr = _filter->QueryInterface(IID_IVolumeIndicator, (void **)&_volumeIndicator);
		if (hr != S_OK)
		{
			_volumeIndicator	= NULL;

			_filter->Release();
			_filter	= NULL;
		}
	}
}
//------------------------------------------------------------------------------
fsVolumeIndicatorFilter::~fsVolumeIndicatorFilter()
{
	if (_volumeIndicator != NULL)
		_volumeIndicator->Release();
}
//------------------------------------------------------------------------------
void
fsVolumeIndicatorFilter::getVolume(mxInt& left, mxInt& right) const
{
	if (_volumeIndicator == NULL)
	{
		left = right = 0;
		return ;
	}
	VolumeInfo volume;
	_volumeIndicator->get_Volume(&volume);
	left = volume.left;
	right = volume.right;
}
//------------------------------------------------------------------------------
void
fsVolumeIndicatorFilter::setEvaluationTime(mxULong evalTime)
{
	if (_volumeIndicator == NULL)
		return ;
	_volumeIndicator->put_EvaluationTime(evalTime);
}
//------------------------------------------------------------------------------
mxULong
fsVolumeIndicatorFilter::getEvaluationTime() const
{
	if (_volumeIndicator == NULL)
		return 0;
	mxULong evalTime;
	_volumeIndicator->get_EvaluationTime(&evalTime);
	return evalTime;
}
//------------------------------------------------------------------------------
