//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsConsoleTest/RInterface.h>
#include <fs/fsCommon/fsCommon.h>
//------------------------------------------------------------------------------
RInterface::RInterface()
{
	_remoteInterface = new fsRemoteInterface(invokeNotifyProc, this);
//	_remoteInterface->setPort(fsRemoteInterface::PID_TRANSMIT, PORT_SENDER_REMOTE);
//	_remoteInterface->setPort(fsRemoteInterface::PID_RECEIVE, PORT_SENDER_REMOTEACK);
//	_remoteInterface->setMaximumTransmissionRate(10 * 1024 * 1024);
//	_remoteInterface->setTransmissionCount(2);
//	_remoteInterface->setPacketSize(1024);
	_remoteInterface->open();
}
//------------------------------------------------------------------------------
RInterface::~RInterface()
{
	_remoteInterface = NULL;
}
//------------------------------------------------------------------------------
void
RInterface::setType(mxInt type)
{
	fsInvokeData param;
	param.writeInt(type);
	_remoteInterface->invoke("setType", param);
}
//------------------------------------------------------------------------------
mxInt
RInterface::getType() const
{
	fsInvokeData param;
	fsInvokeData retVal;
	if (!_remoteInterface->invoke("getType", param, retVal))
		return 0;

	return retVal.readInt();
}
//------------------------------------------------------------------------------
void
RInterface::setSize(mxUInt width, mxUInt height)
{
	fsInvokeData param;
	param.writeInt((mxInt)width);
	param.writeInt((mxInt)height);
	_remoteInterface->invoke("setSize", param);
}
//------------------------------------------------------------------------------
void
RInterface::getSize(mxUInt& width, mxUInt& height) const
{
	fsInvokeData param;
	fsInvokeData retVal;
	if (!_remoteInterface->invoke("getSize", param, retVal))
		return ;
	width = (mxUInt)retVal.readInt();
	height = (mxUInt)retVal.readInt();
}
//------------------------------------------------------------------------------
void
RInterface::setName(const mxString& name)
{
	fsInvokeData param;
	param.writeString(name);
	_remoteInterface->invoke("setName", param);
}
//------------------------------------------------------------------------------
mxString name = "";
//------------------------------------------------------------------------------
const mxString&
RInterface::getName() const
{
	fsInvokeData param;
	fsInvokeData retVal;
	if (!_remoteInterface->invoke("getName", param, retVal))
	{
		name = "";
		return name;
	}

	name = retVal.readString();
	return name;
}
//------------------------------------------------------------------------------
void
RInterface::invokeNotify(const mxString& method)
{
	printf("Time-out method(%s)\n", method.c_str());
}
//------------------------------------------------------------------------------
void
RInterface::invokeNotifyProc(const mxString& method, mxBool result, void *data)
{
	RInterface *rint = (RInterface *)data;
	rint->invokeNotify(method);
}
//------------------------------------------------------------------------------
