/*
**	Copyright (c) 2003 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <rs/rsConsoleTest/rsTempGraphManager.h>
#include <rs/rsCommon/rsFilterEnumerator.h>
#include <mx/mxCore/mxFile.h>
#ifdef _DEBUG
#include <mx/mxCore/mxNotify.h>
#endif
//------------------------------------------------------------------------------
rsTempGraphManager::rsTempGraphManager(HWND windowHandle) :
rsGraphManager(windowHandle)
{
	_videoSources.setBufferSize(16);
	_videoSources.setGrowSize(16);

	_audioSources.setBufferSize(16);
	_audioSources.setGrowSize(16);

	_videoEncoders.setBufferSize(16);
	_videoEncoders.setGrowSize(16);

	_audioEncoders.setBufferSize(16);
	_audioEncoders.setGrowSize(16);

}
//------------------------------------------------------------------------------
rsTempGraphManager::~rsTempGraphManager()
{
}
//------------------------------------------------------------------------------
// Initialize / Shutdown
mxBool
rsTempGraphManager::initialize()
{
	if (!inherited::initialize())
		return false;

	if (!createFilters())
	{
		deleteFilters();
		inherited::shutdown();
		return false;
	}
	
	setupFilters();

	return true;
}
//------------------------------------------------------------------------------
mxBool
rsTempGraphManager::shutdown()
{
	deleteFilters();
	return inherited::shutdown();
}
//------------------------------------------------------------------------------
// Filter Graph Operation
mxBool
rsTempGraphManager::buildGraph()
{
	if (_videoSources.getSize() == 0)
		return false;

	return true;
}
//------------------------------------------------------------------------------
mxBool
rsTempGraphManager::clearGraph()
{
	// Window Setting
	setVideoWindowVisible(false);
	setVideoWindowOwner(NULL);

	// Remove All Filters from FilterGraph
	removeAllFilters();

	return true;
}
//------------------------------------------------------------------------------
// Connection
// ̊֐́AconnectFilterIndirect()ĂяoƂɁA
// ԃtB^ꂽꍇɌĂяo܂B
// ԃtB^ɑ΂A炩̃p[^ݒsꍇɎgp܂B
void
rsTempGraphManager::processIntermediateFilter(const rsFilterPtr* filters, mxUInt numFilters)
{
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
void
rsTempGraphManager::mediaEventNotify(mxLong evCode, mxLong param1, mxLong param2)
{
#ifdef _DEBUG
	mxNotify::post(mxNotify::INFO, "Event Code = %p", evCode);
#endif

	if (evCode == EC_COMPLETE)
	{
		LONGLONG pos = 0;
		_mediaSeeking->SetPositions(&pos, AM_SEEKING_AbsolutePositioning,
									NULL, AM_SEEKING_NoPositioning);
#ifdef _DEBUG
		mxNotify::post(mxNotify::INFO, "SetPos Complete");
#endif
	}

}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
mxBool
rsTempGraphManager::createFilters()
{
	rsFilterPtr filter = NULL;
	rsFilterEnumeratorPtr enumerator;

	//
	// Create Filters
	//

	// Video Sources
	//	Video Captures Filters
	enumerator = new rsFilterEnumerator(rsFilterEnumerator::C_VIDEO_CAPTURE);
	while(enumerator->nextFilter(filter))
		_videoSources.add(filter);

	// Audio Sources
	//	Audio Capture Filters
	enumerator = new rsFilterEnumerator(rsFilterEnumerator::C_AUDIO_CAPTURE);
	while(enumerator->nextFilter(filter))
		_audioSources.add(filter);

	// Video Encoder
	_videoEncoders.add(NULL);
	enumerator = new rsFilterEnumerator(rsFilterEnumerator::C_VIDEO_ENCODER);
	while(enumerator->nextFilter(filter))
		_videoEncoders.add(filter);

	// Audio Encoder
	_audioEncoders.add(NULL);
	enumerator = new rsFilterEnumerator(rsFilterEnumerator::C_AUDIO_ENCODER);
	while(enumerator->nextFilter(filter))
		_audioEncoders.add(filter);

	return true;
}
//------------------------------------------------------------------------------
void
rsTempGraphManager::deleteFilters()
{
	_videoSources.setSize(0);
	_audioSources.setSize(0);
	_videoEncoders.setSize(0);
	_audioEncoders.setSize(0);
}
//------------------------------------------------------------------------------
void
rsTempGraphManager::setupFilters()
{
}
//------------------------------------------------------------------------------
