/*
**	Copyright (c) 2003 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __rsTempGraphManager_h__
#define __rsTempGraphManager_h__
//------------------------------------------------------------------------------
#include <rs/rsCommon/rsGraphManager.h>
#include <rs/rsCommon/rsFilter.h>
#include <mx/mxCore/mxString.h>
#include <mx/mxCore/mxObject.h>
#include <Dshow.h>
//------------------------------------------------------------------------------
class rsTempGraphManager;
typedef mxObjectPtr<rsTempGraphManager>	rsTempGraphManagerPtr;
//------------------------------------------------------------------------------
class rsTempGraphManager : public rsGraphManager
{
	MXOBJECTHEADER(rsTempGraphManager, rsGraphManager);

public:
	rsTempGraphManager(HWND windowHandle);

protected:
	virtual ~rsTempGraphManager();

public:
	// Initialize / Shutdown
	virtual mxBool			initialize();
	virtual mxBool			shutdown();

	// Filter Graph Operation
	virtual mxBool			buildGraph();
	virtual mxBool			clearGraph();

	// Connection
	virtual void			processIntermediateFilter(const rsFilterPtr* filters, mxUInt numFilters);

protected:
	virtual void			mediaEventNotify(mxLong evCode, mxLong param1, mxLong param2);

private:
	mxBool					createFilters();
	void					deleteFilters();
	void					setupFilters();

protected:
	// Source Filters
	mxArray<rsFilterPtr>	_videoSources;
	mxArray<rsFilterPtr>	_audioSources;

	// Encoder Filters
	mxArray<rsFilterPtr>	_videoEncoders;
	mxArray<rsFilterPtr>	_audioEncoders;
};
//------------------------------------------------------------------------------
#endif
