/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "StdAfx.h"
#include <fs/fsMultiReceiver/fsMultiReceiverInterface.h>
#include <fs/fsMulticastTools/fsMulticastAddress.h>

//------------------------------------------------------------------------------
// ̃}NLɂƃ[gsȂ
// sW[ŃRpC܂B
//#define REMOTE_DO_NOT_USE
//------------------------------------------------------------------------------

#include <fs/fsMulticastTools/fsMulticastDetector.h>
#include <fs/fsMultiReceiver/fsMultiReceiver.h>
static fsMultiReceiverPtr		g_multiReceiver = NULL;

#ifndef REMOTE_DO_NOT_USE
#include <fs/fsMultiReceiver/fsMultiReceiverSkelEx.h>
static fsMultiReceiverSkelPtr	g_multiReceiverSkel	= NULL;
#endif

#include <crtdbg.h>

//------------------------------------------------------------------------------

mxChar str[1024];

#define MXSTR2STR(__str, __mxstr)			\
	mxString mxstr = __mxstr;				\
	if (mxstr.length() != 0)				\
		strcpy(__str, mxstr.c_str());		\
	else									\
		__str[0] = 0;

//------------------------------------------------------------------------------
//
// Initialize / Shutdown
//
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC bool MVSTD
fsMultiReceiverInitialize()
{
	mxCore::initialize();

	while(true)
	{
		fsMulticastDetectorPtr detector = new fsMulticastDetector();
		detector->setTryUnicast(false);
		if (detector->open())
			break;

		mxInt ret = MessageBox(
						NULL,
						TEXT("Initialization of Multicast went wrong."),
						TEXT("Error"),
						MB_ABORTRETRYIGNORE | MB_ICONEXCLAMATION);
		if (ret == IDABORT)
			return false;
		else if (ret == IDRETRY)
			continue;
		else if (ret == IDIGNORE)
            break;
	}

#ifdef REMOTE_DO_NOT_USE

	g_multiReceiver = new fsMultiReceiver();
    return g_multiReceiver->initialize();

#else

	g_multiReceiver = new fsMultiReceiver();
	if (!g_multiReceiver->initialize())
		return false;
	g_multiReceiverSkel = new fsMultiReceiverSkelEx(g_multiReceiver->cast<fsMultiReceiverIf>());
	g_multiReceiverSkel->open();

	return true;
	
#endif

}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC bool MVSTD
fsMultiReceiverShutdown()
{
	if (g_multiReceiver != NULL)
	{

#ifdef REMOTE_DO_NOT_USE

		g_multiReceiver->shutdown();
		g_multiReceiver = NULL;

#else

		if (g_multiReceiverSkel != NULL)
			g_multiReceiverSkel->close();

		g_multiReceiver->shutdown();
		g_multiReceiver = NULL;

		g_multiReceiverSkel = NULL;

#endif
	}

	mxCore::shutdown();

#ifdef _DEBUG
	_CrtDumpMemoryLeaks();
#endif // _DEBUG

	return true;
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Multimedia Receiver
//
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC int MVSTD
fsMultiReceiverGetNumMediaReceiver()
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getNumMediaReceiver();
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC bool MVSTD
fsMultiReceiverAddMediaReceiver(const char * address)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->addMediaReceiver(address);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC bool MVSTD
fsMultiReceiverRemoveMediaReceiver(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->removeMediaReceiver(index);
}
//------------------------------------------------------------------------------
// Streaming Control
FSMULTIRECEIVERPROC bool MVSTD
fsMultiReceiverGetMediaReceiverValid(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getMediaReceiverValid(index);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC const char * MVSTD
fsMultiReceiverGetMediaReceiverErrorMessage(int index)
{
	assert(g_multiReceiver != NULL);
	MXSTR2STR(str, g_multiReceiver->getMediaReceiverErrorMessage(index));
	return str;
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC bool MVSTD
fsMultiReceiverGetMediaReceiverStreaming(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getMediaReceiverStreaming(index);
}
//------------------------------------------------------------------------------
// Monitor
FSMULTIRECEIVERPROC bool MVSTD
fsMultiReceiverGetMediaReceiverSocketOpen(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getMediaReceiverSocketOpen(index);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC const char * MVSTD
fsMultiReceiverGetMediaReceiverCaption(int index)
{
	assert(g_multiReceiver != NULL);
	MXSTR2STR(str, g_multiReceiver->getMediaReceiverCaption(index));
	return str;
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC const char * MVSTD
fsMultiReceiverGetMediaReceiverMediaTypeString(int index)
{
	assert(g_multiReceiver != NULL);
	MXSTR2STR(str, g_multiReceiver->getMediaReceiverMediaTypeString(index));
	return str;
}
//------------------------------------------------------------------------------
// Multicast Settings
FSMULTIRECEIVERPROC const char * MVSTD
fsMultiReceiverGetMediaReceiverAddress(int index)
{
	assert(g_multiReceiver != NULL);
	MXSTR2STR(str, g_multiReceiver->getMediaReceiverAddress(index));
	return str;
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC int MVSTD
fsMultiReceiverGetMediaReceiverReceiveRate(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getMediaReceiverReceiveRate(index);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC int MVSTD
fsMultiReceiverGetMediaReceiverFrameRate(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getMediaReceiverFrameRate(index);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC int MVSTD
fsMultiReceiverGetMediaReceiverNumDropPackets(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getMediaReceiverNumDropPackets(index);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC int MVSTD
fsMultiReceiverGetMediaReceiverNumDropFrames(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getMediaReceiverNumDropFrames(index);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC int MVSTD
fsMultiReceiverGetMediaReceiverPacketSize(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getMediaReceiverPacketSize(index);
}
//------------------------------------------------------------------------------
// Video Settings
FSMULTIRECEIVERPROC void MVSTD
fsMultiReceiverSetMediaReceiverVideoPosition(int index, int x, int y)
{
	assert(g_multiReceiver != NULL);
	g_multiReceiver->setMediaReceiverVideoPosition(index, x, y);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC void MVSTD
fsMultiReceiverGetMediaReceiverVideoPosition(int index, int* x, int* y)
{
	assert(g_multiReceiver != NULL);
	g_multiReceiver->getMediaReceiverVideoPosition(index, *x, *y);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC void MVSTD
fsMultiReceiverSetMediaReceiverVideoSize(int index, int width, int height)
{
	assert(g_multiReceiver != NULL);
	g_multiReceiver->setMediaReceiverVideoSize(index, width, height);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC void MVSTD
fsMultiReceiverGetMediaReceiverVideoSize(int index, int* width, int* height)
{
	assert(g_multiReceiver != NULL);
	g_multiReceiver->getMediaReceiverVideoSize(index, *width, *height);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Video Window Settings
//
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC void MVSTD
fsMultiReceiverSetVideoWindowMinimize(bool flag)
{
	assert(g_multiReceiver != NULL);
	g_multiReceiver->setVideoWindowMinimize(flag);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC bool MVSTD
fsMultiReceiverGetVideoWindowMinimize()
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getVideoWindowMinimize();
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC bool MVSTD
fsMultiReceiverCheckQuit()
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->checkQuit();
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC bool MVSTD
fsMultiReceiverCheckRequestAddMediaReceiver(char* address)
{
	assert(g_multiReceiver != NULL);
	mxString addr;
	mxBool flag = g_multiReceiver->checkRequestAddMediaReceiver(addr);
	if (addr.length() != 0)
		strcpy(address, addr.c_str());
	return flag;
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC bool MVSTD
fsMultiReceiverCheckRequestRemoveMediaReceiver(int* index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->checkRequestRemoveMediaReceiver(*index);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// IniFile
FSMULTIRECEIVERPROC bool MVSTD
fsMultiReceiverWriteIniFile(const char* filename)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->writeIniFile(filename);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC bool MVSTD
fsMultiReceiverReadIniFile(const char* filename)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->readIniFile(filename);
}
//------------------------------------------------------------------------------
// Registry
FSMULTIRECEIVERPROC void MVSTD
fsMultiReceiverWriteRegistry(const char* section, const char* entry, const char* value)
{
	assert(g_multiReceiver != NULL);
	g_multiReceiver->writeRegistry(section, entry, value);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC void MVSTD
fsMultiReceiverReadRegistry(const char* section, const char* entry, const char* defaultValue, char* value)
{
	mxString valueStr;
	assert(g_multiReceiver != NULL);
	g_multiReceiver->readRegistry(section, entry, defaultValue, valueStr);
	MXSTR2STR(value, valueStr);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Callback
FSMULTIRECEIVERPROC bool MVSTD
fsMultiReceiverSetUICallbackFunction(fsMultiReceiverUICallbackFunction func, void* data)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->setUICallbackFunction(func, data);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// RMI Multicast Setting
//
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC  void MVSTD
fsMultiReceiverSetAddress(const char* address)
{
	assert(g_multiReceiverSkel != NULL);
	const fsRMIPropertyPtr& property = g_multiReceiverSkel->getRMIProperty();
	property->setAddress(address);
	g_multiReceiverSkel->setRMIProperty(property);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC  const char* MVSTD
fsMultiReceiverGetAddress()
{
	assert(g_multiReceiverSkel != NULL);
	const fsRMIPropertyPtr& property = g_multiReceiverSkel->getRMIProperty();
	MXSTR2STR(str, property->getAddress());
	return str;
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC  void MVSTD
fsMultiReceiverSetTimeToLive(int ttl)
{
	assert(g_multiReceiverSkel != NULL);
	const fsRMIPropertyPtr& property = g_multiReceiverSkel->getRMIProperty();
	property->setTimeToLive(ttl);
	g_multiReceiverSkel->setRMIProperty(property);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC  int MVSTD
fsMultiReceiverGetTimeToLive()
{
	assert(g_multiReceiverSkel != NULL);
	const fsRMIPropertyPtr& property = g_multiReceiverSkel->getRMIProperty();
	return property->getTimeToLive();
}
//------------------------------------------------------------------------------
// Create Address
FSMULTIRECEIVERPROC  const char* MVSTD
fsMultiReceiverCreateIPv4Address()
{
	MXSTR2STR(str, fsMulticastAddress::createAddress(fsMulticastAddress::AF_IPv4));
	return str;
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERPROC  const char* MVSTD
fsMultiReceiverCreateIPv6Address()
{
	MXSTR2STR(str, fsMulticastAddress::createAddress(fsMulticastAddress::AF_IPv6));
	return str;
}
//------------------------------------------------------------------------------
