/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsMultiReceiverInterface_h__
#define __fsMultiReceiverInterface_h__
//------------------------------------------------------------------------------
#ifdef _WIN32
#ifdef FSMULTIRECEIVER_EXPORTS
#define	FSMULTIRECEIVERCLASS	__declspec(dllexport)
#define	FSMULTIRECEIVERPROC	extern "C" __declspec(dllexport)
#else
#define	FSMULTIRECEIVERCLASS	__declspec(dllimport)
#define	FSMULTIRECEIVERPROC	extern "C" __declspec(dllimport)
#endif
#else
#define	FSMULTIRECEIVERCLASS
#define	FSMULTIRECEIVERPROC
#endif
#define	MVSTD			__stdcall
//------------------------------------------------------------------------------

//
// Initialize / Shutdown
//
FSMULTIRECEIVERPROC bool MVSTD			fsMultiReceiverInitialize();
FSMULTIRECEIVERPROC bool MVSTD			fsMultiReceiverShutdown();

//
// Multimedia Receiver
//
FSMULTIRECEIVERPROC int MVSTD			fsMultiReceiverGetNumMediaReceiver();
FSMULTIRECEIVERPROC bool MVSTD			fsMultiReceiverAddMediaReceiver(const char * address);
FSMULTIRECEIVERPROC bool MVSTD			fsMultiReceiverRemoveMediaReceiver(int index);

// Streaming Control
FSMULTIRECEIVERPROC bool MVSTD			fsMultiReceiverGetMediaReceiverValid(int index);
FSMULTIRECEIVERPROC const char * MVSTD	fsMultiReceiverGetMediaReceiverErrorMessage(int index);
FSMULTIRECEIVERPROC bool MVSTD			fsMultiReceiverGetMediaReceiverStreaming(int index);

// Monitor
FSMULTIRECEIVERPROC bool MVSTD			fsMultiReceiverGetMediaReceiverSocketOpen(int index);
FSMULTIRECEIVERPROC const char * MVSTD	fsMultiReceiverGetMediaReceiverCaption(int index);
FSMULTIRECEIVERPROC const char * MVSTD	fsMultiReceiverGetMediaReceiverMediaTypeString(int index);

// Multicast Settings
FSMULTIRECEIVERPROC const char * MVSTD	fsMultiReceiverGetMediaReceiverAddress(int index);
FSMULTIRECEIVERPROC int MVSTD			fsMultiReceiverGetMediaReceiverReceiveRate(int index);
FSMULTIRECEIVERPROC int MVSTD			fsMultiReceiverGetMediaReceiverFrameRate(int index);
FSMULTIRECEIVERPROC int MVSTD			fsMultiReceiverGetMediaReceiverNumDropPackets(int index);
FSMULTIRECEIVERPROC int MVSTD			fsMultiReceiverGetMediaReceiverNumDropFrames(int index);
FSMULTIRECEIVERPROC int MVSTD			fsMultiReceiverGetMediaReceiverPacketSize(int index);

// Video Settings
FSMULTIRECEIVERPROC void MVSTD			fsMultiReceiverSetMediaReceiverVideoPosition(int index, int x, int y);
FSMULTIRECEIVERPROC void MVSTD			fsMultiReceiverGetMediaReceiverVideoPosition(int index, int* x, int* y);
FSMULTIRECEIVERPROC void MVSTD			fsMultiReceiverSetMediaReceiverVideoSize(int index, int width, int height);
FSMULTIRECEIVERPROC void MVSTD			fsMultiReceiverGetMediaReceiverVideoSize(int index, int* width, int* height);

//
// Video Window Settings
//
FSMULTIRECEIVERPROC void MVSTD			fsMultiReceiverSetVideoWindowMinimize(bool flag);
FSMULTIRECEIVERPROC bool MVSTD			fsMultiReceiverGetVideoWindowMinimize();


FSMULTIRECEIVERPROC bool MVSTD			fsMultiReceiverCheckQuit();
FSMULTIRECEIVERPROC bool MVSTD			fsMultiReceiverCheckRequestAddMediaReceiver(char* address);
FSMULTIRECEIVERPROC bool MVSTD			fsMultiReceiverCheckRequestRemoveMediaReceiver(int* index);

// IniFile
FSMULTIRECEIVERPROC bool MVSTD			fsMultiReceiverWriteIniFile(const char* filename);
FSMULTIRECEIVERPROC bool MVSTD			fsMultiReceiverReadIniFile(const char* filename);

// Registry
FSMULTIRECEIVERPROC void MVSTD			fsMultiReceiverWriteRegistry(const char* section, const char* entry, const char* value);
FSMULTIRECEIVERPROC void MVSTD			fsMultiReceiverReadRegistry(const char* section, const char* entry, const char* defaultValue, char* value);

// Callback
typedef int (*fsMultiReceiverUICallbackFunction)(const char*, void*, void*);
FSMULTIRECEIVERPROC bool MVSTD			fsMultiReceiverSetUICallbackFunction(fsMultiReceiverUICallbackFunction func, void* data);

//
// RMI Multicast Setting
//
FSMULTIRECEIVERPROC void MVSTD			fsMultiReceiverSetAddress(const char* address);
FSMULTIRECEIVERPROC const char* MVSTD	fsMultiReceiverGetAddress();
FSMULTIRECEIVERPROC void MVSTD			fsMultiReceiverSetTimeToLive(int ttl);
FSMULTIRECEIVERPROC int MVSTD			fsMultiReceiverGetTimeToLive();

// Create Address
FSMULTIRECEIVERPROC const char* MVSTD	fsMultiReceiverCreateIPv4Address();
FSMULTIRECEIVERPROC const char* MVSTD	fsMultiReceiverCreateIPv6Address();

//------------------------------------------------------------------------------
#endif //__fsMultiReceiverInterface_h__
