/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsMultiReceiverIf_h__
#define __fsMultiReceiverIf_h__
//------------------------------------------------------------------------------
#include <mx/mxCore/mxString.h>
#include <mx/mxCore/mxCore.h>
//------------------------------------------------------------------------------
class __declspec(novtable) fsMultiReceiverIf
{
public:
	//
	// Multimedia Receiver
	//
	virtual mxInt			getNumMediaReceiver() const = 0;
	virtual mxBool			addMediaReceiver(const mxString& address) = 0;
	virtual mxBool			removeMediaReceiver(mxInt index) = 0;

	// Streaming Control
	virtual mxBool			getMediaReceiverValid(mxInt index) const = 0;
	virtual const mxString& getMediaReceiverErrorMessage(mxInt index) const = 0;
	virtual mxBool			getMediaReceiverStreaming(mxInt index) const = 0;

	// Monitor
	virtual mxBool			getMediaReceiverSocketOpen(mxInt index) const = 0;
	virtual const mxString&	getMediaReceiverCaption(mxInt index) const = 0;
	virtual const mxString&	getMediaReceiverMediaTypeString(mxInt index) const = 0;

	// Multicast Settings
	virtual const mxString& getMediaReceiverAddress(mxInt index) const = 0;
	virtual mxInt			getMediaReceiverReceiveRate(mxInt index) const = 0;
	virtual mxInt			getMediaReceiverFrameRate(mxInt index) const = 0;
	virtual mxInt			getMediaReceiverNumDropPackets(mxInt index) const = 0;
	virtual mxInt			getMediaReceiverNumDropFrames(mxInt index) const = 0;
	virtual mxInt			getMediaReceiverPacketSize(mxInt index) const = 0;

	// Video Settings
	virtual void			setMediaReceiverVideoPosition(mxInt index, mxInt x, mxInt y) = 0;
	virtual void			getMediaReceiverVideoPosition(mxInt index, mxInt& x, mxInt& y) const = 0;
	virtual void			setMediaReceiverVideoSize(mxInt index, mxInt width, mxInt height) = 0;
	virtual void			getMediaReceiverVideoSize(mxInt index, mxInt& width, mxInt& height) const = 0;

	//
	// Video Window Settings
	//
	virtual void			setVideoWindowMinimize(mxBool flag) = 0;
	virtual mxBool			getVideoWindowMinimize() const = 0;

	//
	// Other
	//
	virtual void			quit() = 0;

public:
	// [gĂяoł́AaddMediaReceiver()g킸Å֐ĂяoB
	// WindowsbZ[WXbhȊÕXbhŌĂяoۂɁA
	// Ot}l[W[fbhbNNƂւ̑ΉB
	virtual mxBool			_requestAddMediaReceiver(const mxString& address) = 0;
	virtual mxBool			_requestRemoveMediaReceiver(mxInt index) = 0;
};
//------------------------------------------------------------------------------
#endif //__fsMultiReceiverIf_h__
