/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsMultiReceiverSkel_h__
#define __fsMultiReceiverSkel_h__
//------------------------------------------------------------------------------
#include <fs/fsMultiReceiverRMI/fsMultiReceiverRMI.h>
#include <fs/fsMulticastTools/fsRemoteObject.h>
#include <mx/mxCore/mxObject.h>
//------------------------------------------------------------------------------
class fsMultiReceiverIf;
class fsMultiReceiverSkel;
typedef mxObjectPtr<fsMultiReceiverSkel>	fsMultiReceiverSkelPtr;
//------------------------------------------------------------------------------
class FSMULTIRECEIVERRMICLASS fsMultiReceiverSkel : public mxObject
{
	MXOBJECTHEADER(fsMultiReceiverSkel, mxObject);

public:
	fsMultiReceiverSkel(fsMultiReceiverIf* multiReceiver);

protected:
	virtual ~fsMultiReceiverSkel();

public:
	mxBool				open();
	mxBool				close();
	void				setRMIProperty(const fsRMIPropertyPtr& property);
	const fsRMIPropertyPtr&		getRMIProperty() const;

public:
	const fsMultiReceiverIf*	getMultiReceiver() const;

protected:
	virtual void		invoke(const mxString& method,
								fsInvokeData& param,
								fsInvokeData& retVal);
	static void			invokeProc(const mxString& method,
								fsInvokeData& param,
								fsInvokeData& retVal,
								void *data);

protected:
	fsRemoteObjectPtr	_rObject;
	fsMultiReceiverIf*	_multiReceiver;
};
//------------------------------------------------------------------------------
#endif //__fsMultiReceiverSkel_h__
