/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsMultiReceiverStub_h__
#define __fsMultiReceiverStub_h__
//------------------------------------------------------------------------------
#include <fs/fsMultiReceiverRMI/fsMultiReceiverIf.h>
#include <fs/fsMultiReceiverRMI/fsMultiReceiverRMI.h>
#include <fs/fsMulticastTools/fsRemoteInterface.h>
#include <mx/mxCore/mxObject.h>
//------------------------------------------------------------------------------
class fsMultiReceiverStub;
typedef mxObjectPtr<fsMultiReceiverStub>	fsMultiReceiverStubPtr;
//------------------------------------------------------------------------------
class FSMULTIRECEIVERRMICLASS fsMultiReceiverStub : public mxObject, public fsMultiReceiverIf
{
	MXOBJECTHEADER(fsMultiReceiverStub, mxObject);

public:
	fsMultiReceiverStub();

protected:
	virtual ~fsMultiReceiverStub();

public:
	mxBool			open();
	mxBool			close();
	void			setRMIProperty(const fsRMIPropertyPtr& property);
	const fsRMIPropertyPtr&	getRMIProperty() const;

public:
	//
	// Implements fsMultiReceiverIf
	//

	//
	// Multimedia Receiver
	//
	mxInt			getNumMediaReceiver() const;
	mxBool			addMediaReceiver(const mxString& address);
	mxBool			removeMediaReceiver(mxInt index);

	// Streaming Control
	mxBool			getMediaReceiverValid(mxInt index) const;
	const mxString& getMediaReceiverErrorMessage(mxInt index) const;
	mxBool			getMediaReceiverStreaming(mxInt index) const;

	// Monitor
	mxBool			getMediaReceiverSocketOpen(mxInt index) const;
	const mxString&	getMediaReceiverCaption(mxInt index) const;
	const mxString&	getMediaReceiverMediaTypeString(mxInt index) const;

	// Multicast Settings
	const mxString& getMediaReceiverAddress(mxInt index) const;
	mxInt			getMediaReceiverReceiveRate(mxInt index) const;
	mxInt			getMediaReceiverFrameRate(mxInt index) const;
	mxInt			getMediaReceiverNumDropPackets(mxInt index) const;
	mxInt			getMediaReceiverNumDropFrames(mxInt index) const;
	mxInt			getMediaReceiverPacketSize(mxInt index) const;

	// Video Settings
	void			setMediaReceiverVideoPosition(mxInt index, mxInt x, mxInt y);
	void			getMediaReceiverVideoPosition(mxInt index, mxInt& x, mxInt& y) const;
	void			setMediaReceiverVideoSize(mxInt index, mxInt width, mxInt height);
	void			getMediaReceiverVideoSize(mxInt index, mxInt& width, mxInt& height) const;

	//
	// Video Window Settings
	//
	void			setVideoWindowMinimize(mxBool flag);
	mxBool			getVideoWindowMinimize() const;

	//
	// Other
	//
	void			quit();

public:
	mxBool			_requestAddMediaReceiver(const mxString& address);
	mxBool			_requestRemoveMediaReceiver(mxInt index);

protected:
	virtual void	invokeNotify(const mxString& method, mxBool result) = 0;
	static void		invokeNotifyProc(const mxString& method, mxBool result, void *data);

protected:
	fsRemoteInterfacePtr		_rInterface;
};
//------------------------------------------------------------------------------
#endif //__fsMultiReceiverStub_h__
