/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsMultiReceiverRemote_h__
#define __fsMultiReceiverRemote_h__
//------------------------------------------------------------------------------
#include <fs/fsMultiReceiverRMI/fsMultiReceiverStub.h>
//------------------------------------------------------------------------------
class fsMultiReceiverRemote;
typedef mxObjectPtr<fsMultiReceiverRemote>	fsMultiReceiverRemotePtr;
//------------------------------------------------------------------------------
class fsMultiReceiverRemote : public fsMultiReceiverStub
{
	MXOBJECTHEADER(fsMultiReceiverRemote, fsMultiReceiverStub);

public:
	fsMultiReceiverRemote();

protected:
	virtual ~fsMultiReceiverRemote();

public:
	// IniFile
	mxBool			writeIniFile(const mxString& filename);
	mxBool			readIniFile(const mxString& filename);

	// Registry
	void			writeRegistry(const mxString& section, const mxString& entry,
								const mxString& value);
	void			readRegistry(const mxString& section, const mxString& entry,
								const mxString& defaultValue, mxString& value);

	// Callback
	typedef int (*fsMultiReceiverUICallbackFunction)(const char*, void*, void*);
	mxBool			setUICallbackFunction(fsMultiReceiverUICallbackFunction func, void* data);

	//
	// RMI Multicast Setting
	//
	void			setAddress(const mxString& address);
	const mxString&	getAddress() const;
	void			setTimeToLive(mxULong ttl);
	mxULong			getTimeToLive() const;

	// Create Address
	mxString		createIPv4Address();
	mxString		createIPv6Address();

protected:
	void			invokeNotify(const mxString& method, mxBool result);

protected:
	fsMultiReceiverUICallbackFunction	_UICallbackFunction;
	void*								_UICallbackData;
};
//------------------------------------------------------------------------------
#endif //__fsMultiReceiverRemote_h__
