/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "StdAfx.h"
#include <fs/fsMultiReceiverRemote/fsMultiReceiverRemoteInterface.h>
#include <fs/fsMultiReceiverRemote/fsMultiReceiverRemote.h>
#include <crtdbg.h>
//------------------------------------------------------------------------------

static fsMultiReceiverRemotePtr	g_multiReceiver	= NULL;

//------------------------------------------------------------------------------

mxChar str[1024];

#define MXSTR2STR(__str, __mxstr)			\
	mxString mxstr = __mxstr;				\
	if (mxstr.length() != 0)				\
		strcpy(__str, mxstr.c_str());		\
	else									\
		__str[0] = 0;

//------------------------------------------------------------------------------
//
// Initialize / Shutdown
//
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC bool MVSTD
fsMultiReceiverInitialize()
{
	mxCore::initialize();
	g_multiReceiver = new fsMultiReceiverRemote();
	return g_multiReceiver->open();
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC bool MVSTD
fsMultiReceiverShutdown()
{
	assert(g_multiReceiver != NULL);
	g_multiReceiver->close();
	g_multiReceiver = NULL;

	mxCore::shutdown();

#ifdef _DEBUG
	_CrtDumpMemoryLeaks();
#endif // _DEBUG

	return true;
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Multimedia Receiver
//
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC int MVSTD
fsMultiReceiverGetNumMediaReceiver()
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getNumMediaReceiver();
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC bool MVSTD
fsMultiReceiverAddMediaReceiver(const char * address)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->_requestAddMediaReceiver(address);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC bool MVSTD
fsMultiReceiverRemoveMediaReceiver(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->_requestRemoveMediaReceiver(index);
}
//------------------------------------------------------------------------------
// Streaming Control
FSMULTIRECEIVERREMOTEPROC bool MVSTD
fsMultiReceiverGetMediaReceiverValid(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getMediaReceiverValid(index);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC const char * MVSTD
fsMultiReceiverGetMediaReceiverErrorMessage(int index)
{
	assert(g_multiReceiver != NULL);
	MXSTR2STR(str, g_multiReceiver->getMediaReceiverErrorMessage(index));
	return str;
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC bool MVSTD
fsMultiReceiverGetMediaReceiverStreaming(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getMediaReceiverStreaming(index);
}
//------------------------------------------------------------------------------
// Monitor
FSMULTIRECEIVERREMOTEPROC bool MVSTD
fsMultiReceiverGetMediaReceiverSocketOpen(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getMediaReceiverSocketOpen(index);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC const char * MVSTD
fsMultiReceiverGetMediaReceiverCaption(int index)
{
	assert(g_multiReceiver != NULL);
	MXSTR2STR(str, g_multiReceiver->getMediaReceiverCaption(index));
	return str;
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC const char * MVSTD
fsMultiReceiverGetMediaReceiverMediaTypeString(int index)
{
	assert(g_multiReceiver != NULL);
	MXSTR2STR(str, g_multiReceiver->getMediaReceiverMediaTypeString(index));
	return str;
}
//------------------------------------------------------------------------------
// Multicast Settings
FSMULTIRECEIVERREMOTEPROC const char * MVSTD
fsMultiReceiverGetMediaReceiverAddress(int index)
{
	assert(g_multiReceiver != NULL);
	MXSTR2STR(str, g_multiReceiver->getMediaReceiverAddress(index));
	return str;
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC int MVSTD
fsMultiReceiverGetMediaReceiverReceiveRate(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getMediaReceiverReceiveRate(index);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC int MVSTD
fsMultiReceiverGetMediaReceiverFrameRate(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getMediaReceiverFrameRate(index);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC int MVSTD
fsMultiReceiverGetMediaReceiverNumDropPackets(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getMediaReceiverNumDropPackets(index);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC int MVSTD
fsMultiReceiverGetMediaReceiverNumDropFrames(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getMediaReceiverNumDropFrames(index);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC int MVSTD
fsMultiReceiverGetMediaReceiverPacketSize(int index)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getMediaReceiverPacketSize(index);
}
//------------------------------------------------------------------------------
// Video Settings
FSMULTIRECEIVERREMOTEPROC void MVSTD
fsMultiReceiverSetMediaReceiverVideoPosition(int index, int x, int y)
{
	assert(g_multiReceiver != NULL);
	g_multiReceiver->setMediaReceiverVideoPosition(index, x, y);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC void MVSTD
fsMultiReceiverGetMediaReceiverVideoPosition(int index, int* x, int* y)
{
	assert(g_multiReceiver != NULL);
	g_multiReceiver->getMediaReceiverVideoPosition(index, *x, *y);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC void MVSTD
fsMultiReceiverSetMediaReceiverVideoSize(int index, int width, int height)
{
	assert(g_multiReceiver != NULL);
	g_multiReceiver->setMediaReceiverVideoSize(index, width, height);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC void MVSTD
fsMultiReceiverGetMediaReceiverVideoSize(int index, int* width, int* height)
{
	assert(g_multiReceiver != NULL);
	g_multiReceiver->getMediaReceiverVideoSize(index, *width, *height);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Video Window Settings
//
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC void MVSTD
fsMultiReceiverSetVideoWindowMinimize(bool flag)
{
	assert(g_multiReceiver != NULL);
	g_multiReceiver->setVideoWindowMinimize(flag);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC bool MVSTD
fsMultiReceiverGetVideoWindowMinimize()
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getVideoWindowMinimize();
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Other
//
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC void MVSTD
fsMultiReceiverQuit()
{
	assert(g_multiReceiver != NULL);
	g_multiReceiver->quit();
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// IniFile
FSMULTIRECEIVERREMOTEPROC bool MVSTD
fsMultiReceiverWriteIniFile(const char* filename)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->writeIniFile(filename);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC bool MVSTD
fsMultiReceiverReadIniFile(const char* filename)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->readIniFile(filename);
}
//------------------------------------------------------------------------------
// Registry
FSMULTIRECEIVERREMOTEPROC void MVSTD
fsMultiReceiverWriteRegistry(const char* section, const char* entry, const char* value)
{
	assert(g_multiReceiver != NULL);
	g_multiReceiver->writeRegistry(section, entry, value);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC void MVSTD
fsMultiReceiverReadRegistry(const char* section, const char* entry, const char* defaultValue, char* value)
{
	mxString valueStr;
	assert(g_multiReceiver != NULL);
	g_multiReceiver->readRegistry(section, entry, defaultValue, valueStr);
	MXSTR2STR(value, valueStr);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Callback
FSMULTIRECEIVERREMOTEPROC bool MVSTD
fsMultiReceiverSetUICallbackFunction(fsMultiReceiverUICallbackFunction func, void* data)
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->setUICallbackFunction(func, data);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// RMI Multicast Setting
//
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC void MVSTD
fsMultiReceiverSetAddress(const char* address)
{
	assert(g_multiReceiver != NULL);
	g_multiReceiver->setAddress(address);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC const char* MVSTD
fsMultiReceiverGetAddress()
{
	assert(g_multiReceiver != NULL);
	MXSTR2STR(str, g_multiReceiver->getAddress());
	return str;
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC void MVSTD
fsMultiReceiverSetTimeToLive(int ttl)
{
	assert(g_multiReceiver != NULL);
	g_multiReceiver->setTimeToLive(ttl);
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC int MVSTD
fsMultiReceiverGetTimeToLive()
{
	assert(g_multiReceiver != NULL);
	return g_multiReceiver->getTimeToLive();
}
//------------------------------------------------------------------------------
// Create Address
FSMULTIRECEIVERREMOTEPROC const char* MVSTD
fsMultiReceiverCreateIPv4Address()
{
	assert(g_multiReceiver != NULL);
	MXSTR2STR(str, g_multiReceiver->createIPv4Address());
	return str;
}
//------------------------------------------------------------------------------
FSMULTIRECEIVERREMOTEPROC const char* MVSTD
fsMultiReceiverCreateIPv6Address()
{
	assert(g_multiReceiver != NULL);
	MXSTR2STR(str, g_multiReceiver->createIPv6Address());
	return str;
}
//------------------------------------------------------------------------------
