/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsMultiReceiverInterface_h__
#define __fsMultiReceiverInterface_h__
//------------------------------------------------------------------------------
#ifdef _WIN32
#ifdef FSMULTIRECEIVERREMOTE_EXPORTS
#define	FSMULTIRECEIVERREMOTECLASS	__declspec(dllexport)
#define	FSMULTIRECEIVERREMOTEPROC	extern "C" __declspec(dllexport)
#else
#define	FSMULTIRECEIVERREMOTECLASS	__declspec(dllimport)
#define	FSMULTIRECEIVERREMOTEPROC	extern "C" __declspec(dllimport)
#endif
#else
#define	FSMULTIRECEIVERREMOTECLASS
#define	FSMULTIRECEIVERREMOTEPROC
#endif
#define	MVSTD			__stdcall
//------------------------------------------------------------------------------

//
// Initialize / Shutdown
//
FSMULTIRECEIVERREMOTEPROC bool MVSTD			fsMultiReceiverInitialize();
FSMULTIRECEIVERREMOTEPROC bool MVSTD			fsMultiReceiverShutdown();

//
// Multimedia Receiver
//
FSMULTIRECEIVERREMOTEPROC int MVSTD				fsMultiReceiverGetNumMediaReceiver();
FSMULTIRECEIVERREMOTEPROC bool MVSTD			fsMultiReceiverAddMediaReceiver(const char * address);
FSMULTIRECEIVERREMOTEPROC bool MVSTD			fsMultiReceiverRemoveMediaReceiver(int index);

// Streaming Control
FSMULTIRECEIVERREMOTEPROC bool MVSTD			fsMultiReceiverGetMediaReceiverValid(int index);
FSMULTIRECEIVERREMOTEPROC const char * MVSTD	fsMultiReceiverGetMediaReceiverErrorMessage(int index);
FSMULTIRECEIVERREMOTEPROC bool MVSTD			fsMultiReceiverGetMediaReceiverStreaming(int index);

// Monitor
FSMULTIRECEIVERREMOTEPROC bool MVSTD			fsMultiReceiverGetMediaReceiverSocketOpen(int index);
FSMULTIRECEIVERREMOTEPROC const char * MVSTD	fsMultiReceiverGetMediaReceiverCaption(int index);
FSMULTIRECEIVERREMOTEPROC const char * MVSTD	fsMultiReceiverGetMediaReceiverMediaTypeString(int index);

// Multicast Settings
FSMULTIRECEIVERREMOTEPROC const char * MVSTD	fsMultiReceiverGetMediaReceiverAddress(int index);
FSMULTIRECEIVERREMOTEPROC int MVSTD				fsMultiReceiverGetMediaReceiverReceiveRate(int index);
FSMULTIRECEIVERREMOTEPROC int MVSTD				fsMultiReceiverGetMediaReceiverFrameRate(int index);
FSMULTIRECEIVERREMOTEPROC int MVSTD				fsMultiReceiverGetMediaReceiverNumDropPackets(int index);
FSMULTIRECEIVERREMOTEPROC int MVSTD				fsMultiReceiverGetMediaReceiverNumDropFrames(int index);
FSMULTIRECEIVERREMOTEPROC int MVSTD				fsMultiReceiverGetMediaReceiverPacketSize(int index);

// Video Settings
FSMULTIRECEIVERREMOTEPROC void MVSTD			fsMultiReceiverSetMediaReceiverVideoPosition(int index, int x, int y);
FSMULTIRECEIVERREMOTEPROC void MVSTD			fsMultiReceiverGetMediaReceiverVideoPosition(int index, int* x, int* y);
FSMULTIRECEIVERREMOTEPROC void MVSTD			fsMultiReceiverSetMediaReceiverVideoSize(int index, int width, int height);
FSMULTIRECEIVERREMOTEPROC void MVSTD			fsMultiReceiverGetMediaReceiverVideoSize(int index, int* width, int* height);

//
// Video Window Settings
//
FSMULTIRECEIVERREMOTEPROC void MVSTD			fsMultiReceiverSetVideoWindowMinimize(bool flag);
FSMULTIRECEIVERREMOTEPROC bool MVSTD			fsMultiReceiverGetVideoWindowMinimize();

//
// Other
//
FSMULTIRECEIVERREMOTEPROC void MVSTD			fsMultiReceiverQuit();

// IniFile
FSMULTIRECEIVERREMOTEPROC bool MVSTD			fsMultiReceiverWriteIniFile(const char* filename);
FSMULTIRECEIVERREMOTEPROC bool MVSTD			fsMultiReceiverReadIniFile(const char* filename);

// Registry
FSMULTIRECEIVERREMOTEPROC void MVSTD			fsMultiReceiverWriteRegistry(const char* section, const char* entry, const char* value);
FSMULTIRECEIVERREMOTEPROC void MVSTD			fsMultiReceiverReadRegistry(const char* section, const char* entry, const char* defaultValue, char* value);

// Callback
typedef int (*fsMultiReceiverUICallbackFunction)(const char*, void*, void*);
FSMULTIRECEIVERREMOTEPROC bool MVSTD			fsMultiReceiverSetUICallbackFunction(fsMultiReceiverUICallbackFunction func, void* data);

//
// RMI Multicast Setting
//
FSMULTIRECEIVERREMOTEPROC void MVSTD			fsMultiReceiverSetAddress(const char* address);
FSMULTIRECEIVERREMOTEPROC const char* MVSTD		fsMultiReceiverGetAddress();
FSMULTIRECEIVERREMOTEPROC void MVSTD			fsMultiReceiverSetTimeToLive(int ttl);
FSMULTIRECEIVERREMOTEPROC int MVSTD				fsMultiReceiverGetTimeToLive();

// Create Address
FSMULTIRECEIVERREMOTEPROC const char* MVSTD		fsMultiReceiverCreateIPv4Address();
FSMULTIRECEIVERREMOTEPROC const char* MVSTD		fsMultiReceiverCreateIPv6Address();

//------------------------------------------------------------------------------
#endif //__fsMultiReceiverInterface_h__
