/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsInvokeData_h__
#define __fsInvokeData_h__
//------------------------------------------------------------------------------
#include <fs/fsMulticastTools/fsMulticastTools.h>
#include <mx/mxCore/mxString.h>
#include <mx/mxCore/mxCore.h>
//------------------------------------------------------------------------------
class FSMULTICASTTOOLSCLASS fsInvokeData
{
	friend class fsRemoteInterface;
	friend class fsRemoteObject;

public:
	fsInvokeData();
	virtual ~fsInvokeData();

public:
	void			reset();

public:
	void			writeBool(mxBool value);
	void			writeByte(mxByte value);
	void			writeShort(mxShort value);
	void			writeInt(mxInt value);
	void			writeFloat(mxFloat value);
	void			writeString(const mxString& str);

	void			writeBool(const mxBool *value, mxUInt length);
	void			writeByte(const mxByte *value, mxUInt length);
	void			writeShort(const mxShort *value, mxUInt length);
	void			writeInt(const mxInt *value, mxUInt length);
	void			writeFloat(const mxFloat *value, mxUInt length);

public:
	mxBool			readBool();
	mxByte			readByte();
	mxShort			readShort();
	mxInt			readInt();
	mxFloat			readFloat();
	mxString		readString();

	void			readBool(mxBool *value, mxUInt length);
	void			readByte(mxByte *value, mxUInt length);
	void			readShort(mxShort *value, mxUInt length);
	void			readInt(mxInt *value, mxUInt length);
	void			readFloat(mxFloat *value, mxUInt length);

public:
	fsInvokeData&	operator =(const fsInvokeData& invokeData);

protected:
	const mxByte*	getData() const;
	mxByte*			getData();

	void			setDataLength(mxUInt length);
	mxUInt			getDataLength() const;

private:
	mxBool			_write(const void *data, size_t length);
	mxBool			_read(void *data, size_t length);

protected:
	mxByte*			_buffer;
	mxUInt			_bufferSize;

	mxUInt			_dataLength;
	mxUInt			_readPos;
};
//------------------------------------------------------------------------------
#include <fs/fsMulticastTools/fsInvokeData.inl>
//------------------------------------------------------------------------------
#endif //__fsInvokeData_h__
