/*
**	Copyright (c) 2003 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsInvokeData_inl__
#define __fsInvokeData_inl__
//------------------------------------------------------------------------------
inline void
fsInvokeData::reset()
{
	_dataLength		= 0;
	_readPos		= 0;
}
//------------------------------------------------------------------------------
inline void
fsInvokeData::writeBool(mxBool value)
{
	_write(&value, sizeof(mxBool));
}
//------------------------------------------------------------------------------
inline void
fsInvokeData::writeByte(mxByte value)
{
	_write(&value, sizeof(mxByte));
}
//------------------------------------------------------------------------------
inline void
fsInvokeData::writeShort(mxShort value)
{
	_write(&value, sizeof(mxShort));
}
//------------------------------------------------------------------------------
inline void
fsInvokeData::writeInt(mxInt value)
{
	_write(&value, sizeof(mxInt));
}
//------------------------------------------------------------------------------
inline void
fsInvokeData::writeFloat(mxFloat value)
{
	_write(&value, sizeof(mxFloat));
}
//------------------------------------------------------------------------------

inline void
fsInvokeData::writeBool(const mxBool *value, mxUInt length)
{
	_write(value, sizeof(mxBool) * length);
}
//------------------------------------------------------------------------------
inline void
fsInvokeData::writeByte(const mxByte *value, mxUInt length)
{
	_write(value, sizeof(mxByte) * length);
}
//------------------------------------------------------------------------------
inline void
fsInvokeData::writeShort(const mxShort *value, mxUInt length)
{
	_write(value, sizeof(mxShort) * length);
}
//------------------------------------------------------------------------------
inline void
fsInvokeData::writeInt(const mxInt *value, mxUInt length)
{
	_write(value, sizeof(mxInt) * length);
}
//------------------------------------------------------------------------------
inline void
fsInvokeData::writeFloat(const mxFloat *value, mxUInt length)
{
	_write(value, sizeof(mxFloat) * length);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
inline mxBool
fsInvokeData::readBool()
{
	mxBool value;
	return (_read(&value, sizeof(mxBool)) ? value : false);
}
//------------------------------------------------------------------------------
inline mxByte
fsInvokeData::readByte()
{
	mxByte value;
	return (_read(&value, sizeof(mxByte)) ? value : 0);
}
//------------------------------------------------------------------------------
inline mxShort
fsInvokeData::readShort()
{
	mxShort value;
	return (_read(&value, sizeof(mxShort)) ? value : 0);
}
//------------------------------------------------------------------------------
inline mxInt
fsInvokeData::readInt()
{
	mxInt value;
	return (_read(&value, sizeof(mxInt)) ? value : 0);
}
//------------------------------------------------------------------------------
inline mxFloat
fsInvokeData::readFloat()
{
	mxFloat value;
	return (_read(&value, sizeof(mxFloat)) ? value : 0.0f);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
inline void
fsInvokeData::readBool(mxBool *value, mxUInt length)
{
	if (!_read(value, sizeof(mxBool) * length))
		memset(value, 0, sizeof(mxBool) * length);
}
//------------------------------------------------------------------------------
inline void
fsInvokeData::readByte(mxByte *value, mxUInt length)
{
	if (!_read(value, sizeof(mxByte) * length))
		memset(value, 0, sizeof(mxByte) * length);
}
//------------------------------------------------------------------------------
inline void
fsInvokeData::readShort(mxShort *value, mxUInt length)
{
	if (!_read(value, sizeof(mxShort) * length))
		memset(value, 0, sizeof(mxShort) * length);
}
//------------------------------------------------------------------------------
inline void
fsInvokeData::readInt(mxInt *value, mxUInt length)
{
	if (!_read(value, sizeof(mxInt) * length))
		memset(value, 0, sizeof(mxInt) * length);
}
//------------------------------------------------------------------------------
inline void
fsInvokeData::readFloat(mxFloat *value, mxUInt length)
{
	if (!_read(value, sizeof(mxFloat) * length))
		memset(value, 0, sizeof(mxFloat) * length);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
inline const mxByte*
fsInvokeData::getData() const
{
	return _buffer;
}
//------------------------------------------------------------------------------
inline mxByte*
fsInvokeData::getData()
{
	return _buffer;
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
inline mxUInt
fsInvokeData::getDataLength() const
{
	return _dataLength;
}
//------------------------------------------------------------------------------
#endif //__fsInvokeData_inl__
