/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsMulticastTools/fsKey.h>
#include <sys/timeb.h>
//------------------------------------------------------------------------------
fsKey::fsKey()
{
	memset(_key, 0, sizeof(mxLong) * KEY_LENGTH);
}
//------------------------------------------------------------------------------
fsKey::~fsKey()
{
}
//------------------------------------------------------------------------------
mxBool
fsKey::operator ==(const fsKey& key) const
{
	return (memcmp(_key, key._key, sizeof(mxLong) * KEY_LENGTH) == 0);
}
//------------------------------------------------------------------------------
mxBool
fsKey::operator !=(const fsKey& key) const
{
	return (memcmp(_key, key._key, sizeof(mxLong) * KEY_LENGTH) != 0);
}
//------------------------------------------------------------------------------
fsKey&
fsKey::operator =(const fsKey& key)
{
	memcpy(_key, key._key, sizeof(mxLong) * KEY_LENGTH);
	return *this;
}
//------------------------------------------------------------------------------
fsKey
fsKey::createNewKey()
{
	fsKey key;
	mxChar *ptr = (mxChar *)key._key;

	// Current Time
	struct _timeb timebuffer;
	_ftime(&timebuffer);

	*((time_t *)ptr) = timebuffer.time;
	ptr += sizeof(time_t);

	*((mxUShort *)ptr) = timebuffer.millitm;
	ptr += sizeof(mxUShort);

	// Current Process ID
	DWORD processId = GetCurrentProcessId();
	*((DWORD *)ptr) = processId;
	ptr += sizeof(DWORD);

	// IP Address
	const flString& localhost = flNetwork::getLocalhost();
	flUInt hashCode = localhost.hash();
	*((flUInt *)ptr) = hashCode;
	ptr += sizeof(flUInt);

	return key;
}
//------------------------------------------------------------------------------

