/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsMulticastTools/fsMulticastAddress.h>
#include <time.h>
#include <stdlib.h>
#include <math.h>
//------------------------------------------------------------------------------
mxBool	fsMulticastAddress::_isInitRand = false;
//------------------------------------------------------------------------------
fsMulticastAddress::fsMulticastAddress()
{
}
//------------------------------------------------------------------------------
fsMulticastAddress::~fsMulticastAddress()
{
}
//------------------------------------------------------------------------------
mxString
fsMulticastAddress::createAddress(AddressFamilyEnum addressFamily)
{
	if (!_isInitRand)
		initRand();

	mxString address = "";

	switch(addressFamily)
	{
	case AF_IPv4:
		{
			const mxUInt RangeMin	= 0xE0000100;
			const mxUInt RangeMax	= 0xEFFFFFFF;
			const mxUInt Range		= 0x0FFFFEFF;

			mxUInt r1 = mxUInt(ceilf(rand() / mxFloat(RAND_MAX) * 15.0f)) + 224;
			mxUInt r2 = mxUInt(ceilf(rand() / mxFloat(RAND_MAX) * 255.0f));
			mxUInt r3 = mxUInt(ceilf(rand() / mxFloat(RAND_MAX) * 255.0f));
			mxUInt r4 = mxUInt(ceilf(rand() / mxFloat(RAND_MAX) * 255.0f));

			r1 <<= 24;
			r2 <<= 16;
			r3 <<= 8;

			mxUInt value = ((r1 + r2 + r3 + r4) % Range) + RangeMin;

			mxByte b1 = (mxByte)((value & 0xFF000000) >> 24);
			mxByte b2 = (mxByte)((value & 0x00FF0000) >> 16);
			mxByte b3 = (mxByte)((value & 0x0000FF00) >> 8);
			mxByte b4 = (mxByte)(value & 0x000000FF);

			address.format("%d.%d.%d.%d", b1, b2, b3, b4);
		}
		break;

	case AF_IPv6:
		{
			address = "ff00";

			mxInt val;
			mxString str;

			for(mxUInt i = 0; i < 7; i++)
			{
				val = ((rand() % 0xFF) << 8) + (rand() % 0xFF);
				str.format("%x", val);
				str.toLower();

				address += ":" + str;
			}
		}
		break;

	}

	return address;
}
//------------------------------------------------------------------------------
void
fsMulticastAddress::initRand()
{
	_isInitRand = true;

	// Time
	time_t t;
	time(&t);

	srand((mxUInt)t);
}
//------------------------------------------------------------------------------
