/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsMulticastDetector_h__
#define __fsMulticastDetector_h__
//------------------------------------------------------------------------------
#include <fs/fsMulticastTools/fsMulticastTools.h>
#include <mx/mxCore/mxString.h>
#include <mx/mxCore/mxObject.h>
#include <flNetwork/flFMTReceiver.h>
//------------------------------------------------------------------------------
class fsMulticastDetector;
typedef mxObjectPtr<fsMulticastDetector>	fsMulticastDetectorPtr;
//------------------------------------------------------------------------------
class FSMULTICASTTOOLSCLASS fsMulticastDetector : public mxObject
{
	MXOBJECTHEADER(fsMulticastDetector, mxObject);

public:
	fsMulticastDetector();

protected:
	virtual ~fsMulticastDetector();

public:
	void			setAddress(const mxString& address);
	mxString		getAddress() const;
	void			setPort(mxUShort port);
	mxUShort		getPort() const;
	void			setTryUnicast(mxBool flag);
	mxBool			getTryUnicast() const;

	mxBool			open();
	mxBool			close();
	mxBool			isOpen() const;

protected:
	void			receive(flChar *data, flUInt dataSize);
	static void __stdcall	receiveProc(flChar *data, flUInt dataSize, void* receiveParam);

public:
	mxBool			detected(mxULong evalTime = 1000) const;

protected:
	flFMTReceiver*		_receiver;

	mxBool				_isOpen;
	mxULong				_receiveTime;
};
//------------------------------------------------------------------------------
DECLARE_SAFE_COPYFUNC(fsMulticastDetectorPtr);
DECLARE_SAFE_COMPFUNC(fsMulticastDetectorPtr);
//------------------------------------------------------------------------------
#endif //__fsMulticastDetector_h__
