/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsMulticastTools/fsMulticastDetectors.h>
//------------------------------------------------------------------------------
fsMulticastDetectors::fsMulticastDetectors() :
mxObject()
{
}
//------------------------------------------------------------------------------
fsMulticastDetectors::~fsMulticastDetectors()
{
}
//------------------------------------------------------------------------------
mxBool
fsMulticastDetectors::add(const mxString& address, mxUShort port)
{
	if (address.length() == 0)
		return false;

	mxString key = address + "/" + mxString((mxInt)port);
	fsMulticastDetectorPtr value = new fsMulticastDetector();
	value->setAddress(address);
	value->setPort(port);

	if (!value->open())
		return false;

	_detectors.insert(key, value);
	return true;
}
//------------------------------------------------------------------------------
mxBool
fsMulticastDetectors::remove(const mxString& address, mxUShort port)
{
	if (address.length() == 0)
		return false;

	mxString key = address + "/" + mxString((mxInt)port);
	fsMulticastDetectorPtr value;
	if (!_detectors.get(key, value))
		return false;

	value->close();
	_detectors.remove(key);
	_detectors.resizeTable(mxHashMap<mxString, fsMulticastDetectors>::DEFAULT_TABLESIZE);

	return true;
}
//------------------------------------------------------------------------------
mxBool
fsMulticastDetectors::detected(const mxString& address, mxUShort port, mxULong evalTime) const
{
	if (address.length() == 0)
		return false;

	mxString key = address + "/" + mxString((mxInt)port);
	fsMulticastDetectorPtr value;
	if (!_detectors.get(key, value))
		return false;
	return value->detected(evalTime);
}
//------------------------------------------------------------------------------
