/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsRMIProperty_h__
#define __fsRMIProperty_h__
//------------------------------------------------------------------------------
#include <fs/fsMulticastTools/fsMulticastTools.h>
#include <mx/mxCore/mxObject.h>
#include <mx/mxCore/mxString.h>
//------------------------------------------------------------------------------
class fsRMIProperty;
typedef mxObjectPtr<fsRMIProperty>	fsRMIPropertyPtr;
//------------------------------------------------------------------------------
class FSMULTICASTTOOLSCLASS fsRMIProperty : public mxObject
{
	MXOBJECTHEADER(fsRMIProperty, mxObject);

public:
	fsRMIProperty();

protected:
	virtual ~fsRMIProperty();

public:
	enum PortIDEnum {
		PID_TRANSMIT,
		PID_RECEIVE,

		NUM_PID
	};

	void			setAddress(const mxString& address);
	const mxString&	getAddress() const;
	void			setPort(PortIDEnum portID, mxUShort port);
	mxUShort		getPort(PortIDEnum portID) const;
	void			setTimeToLive(mxULong ttl);
	mxULong			getTimeToLive() const;
	void			setPacketSize(mxUInt size);
	mxUInt			getPacketSize() const;
	void			setMaximumTransmissionRate(mxUInt rate);
	mxUInt			getMaximumTransmissionRate() const;
	void			setTransmissionCount(mxUInt count);
	mxUInt			getTransmissionCount() const;
	void			setInvokeTimeout(mxUInt timeout);
	mxUInt			getInvokeTimeout() const;

private:
	mxString		_address;
	mxUShort		_ports[NUM_PID];
	mxULong			_ttl;
	mxUInt			_packetSize;
	mxUInt			_transmissionRate;
	mxUInt			_transmissionCount;
	mxUInt			_invokeTimeout;
};
//------------------------------------------------------------------------------
#endif //__fsRMIProperty_h__
