/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsRemoteBase_h__
#define __fsRemoteBase_h__
//------------------------------------------------------------------------------
#include <fs/fsMulticastTools/fsRMIProperty.h>
#include <fs/fsMulticastTools/fsMulticastTools.h>
#include <flNetwork/flFMTSender.h>
#include <flNetwork/flFMTReceiver.h>
#include <mx/mxCore/mxThread.h>
#include <mx/mxCore/mxString.h>
#include <mx/mxCore/mxObject.h>
//------------------------------------------------------------------------------
#define ID_INVOKE				0
#define ID_RETURN				1
//------------------------------------------------------------------------------
#define MAX_PARAMETERLENGTH		2048
#define MAX_RETURNDATALENGTH	2048
#define MAX_METHODNAMELENGTH	1024
//------------------------------------------------------------------------------
class FSMULTICASTTOOLSCLASS fsRemoteBase : public mxObject
{
	MXOBJECTHEADER(fsRemoteBase, mxObject);

public:
	fsRemoteBase();

protected:
	virtual ~fsRemoteBase();

public:
	//
	// Open / Close
	//
	mxBool					open();
	mxBool					close();
	mxBool					isOpen() const;

	//
	// Property setting
	//
	void					setProperty(const fsRMIPropertyPtr& property);
	const fsRMIPropertyPtr&	getProperty() const;

protected:
	virtual void			updateProperty();

protected:
	virtual void			receive(flChar *data, flUInt dataSize) = 0;

protected:
	mxUInt					threadLoop();
	static mxUInt __stdcall	threadLoopProc(void* data);

protected:
	flFMTSender*		_sender;
	flFMTReceiver*		_receiver;
	mxBool				_isOpen;

	fsRMIPropertyPtr	_property;

	mxBool				_threadRun;
	mxThread*			_thread;
};
//------------------------------------------------------------------------------
#endif // __fsRemoteBase_h__
