/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsRemoteInterface_h__
#define __fsRemoteInterface_h__
//------------------------------------------------------------------------------
#include <fs/fsMulticastTools/fsRemoteBase.h>
#include <fs/fsMulticastTools/fsInvokeData.h>
#include <mx/mxCore/mxCriticalSection.h>
#include <mx/mxCore/mxArray.h>
#include <flBase/flByteStream.h>
//------------------------------------------------------------------------------
struct fsReturn
{
	mxUInt			InvokeCount;
	fsInvokeData	Data;
};
//------------------------------------------------------------------------------
class fsRemoteInterface;
typedef mxObjectPtr<fsRemoteInterface>	fsRemoteInterfacePtr;
//------------------------------------------------------------------------------
class FSMULTICASTTOOLSCLASS fsRemoteInterface : public fsRemoteBase
{
	MXOBJECTHEADER(fsRemoteInterface, fsRemoteBase);

	typedef void	(*InvokeNotifyProc)(const mxString& method, mxBool result, void* invokeNotifyData);

public:
	fsRemoteInterface(InvokeNotifyProc invokeNotifyProc, void* invokeNotifyData);

protected:
	virtual ~fsRemoteInterface();

public:
	mxBool			invoke(const mxString& method, const fsInvokeData& param, fsInvokeData& retVal);
	mxBool			invoke(const mxString& method, const fsInvokeData& param);
	mxBool			invoke(const mxString& method);

protected:
	virtual void	receive(flChar *data, flUInt dataSize);

protected:
	InvokeNotifyProc	_invokeNotifyProc;
	void*				_invokeNotifyData;

	mxUInt				_invokeCount;

	flInputByteStream	_iStream;
	flOutputByteStream	_oStream;

	mxCriticalSection	_returnCS;
	fsReturn			_return;
};
//------------------------------------------------------------------------------
#endif // __fsRemoteInterface_h__
