/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "Stdafx.h"
#include <fs/fsMulticastTools/fsRemoteObject.h>
//------------------------------------------------------------------------------
fsRemoteObject::fsRemoteObject(InvokeProc invokeProc, void* invokeData) :
fsRemoteBase()
{
	_invokeProc = invokeProc;
	_invokeData = invokeData;
}
//------------------------------------------------------------------------------
fsRemoteObject::~fsRemoteObject()
{
}
//------------------------------------------------------------------------------
void
fsRemoteObject::receive(flChar *data, flUInt dataSize)
{
	if (_invokeProc == NULL)
		return ;

	//
	// Receive Invoke
	//
	_iStream.reset();
	_iStream.set(data, dataSize);

	// Read Invoke ID
	mxUInt id;
	_iStream.readUInt(id);
	if (id != ID_INVOKE)
		return ;

	// Read Invoke Count
	mxUInt invokeCount;
	_iStream.readUInt(invokeCount);

	// Read Instance Ptr
	mxLong instance;
	_iStream.readLong(instance);

	// Read Method
	mxChar method[MAX_METHODNAMELENGTH];
	mxUInt methodLen;
	_iStream.readUInt(methodLen);
	_iStream.readChar(method, methodLen);

	// Read Parameter
	mxUInt length;
	_iStream.readUInt(length);
	_param.setDataLength(length);
	_iStream.readChar((flChar *)_param.getData(), length);

	//
	// Call Invoke Procedure
	//
	_retVal.reset();
	_invokeProc(mxString(method), _param, _retVal, _invokeData);

	//
	// Send Return 
	//
	if (_retVal.getDataLength() == 0)
		return ;

	_oStream.reset();

	_oStream.writeUInt(ID_RETURN);
	_oStream.writeUInt(invokeCount);
	_oStream.writeLong(instance);
	_oStream.writeUInt(_retVal.getDataLength());
	_oStream.writeChar((const flChar *)_retVal.getData(), _retVal.getDataLength());

	flChar *sdata = NULL;
	flUInt sdataSize = 0;
	_oStream.get(sdata, sdataSize);
	_sender->send(sdata, sdataSize);
}
//------------------------------------------------------------------------------
