/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsRemoteObject_h__
#define __fsRemoteObject_h__
//------------------------------------------------------------------------------
#include <fs/fsMulticastTools/fsRemoteBase.h>
#include <fs/fsMulticastTools/fsInvokeData.h>
#include <mx/mxCore/mxCore.h>
#include <flBase/flByteStream.h>
//------------------------------------------------------------------------------
class fsRemoteObject;
typedef mxObjectPtr<fsRemoteObject>	fsRemoteObjectPtr;
//------------------------------------------------------------------------------
class FSMULTICASTTOOLSCLASS fsRemoteObject : public fsRemoteBase
{
	MXOBJECTHEADER(fsRemoteObject, fsRemoteBase);

	typedef void (*InvokeProc)(const mxString& method,
							   fsInvokeData& param,
							   fsInvokeData& retVal,
							   void* invokeData);

public:
	fsRemoteObject(InvokeProc invokeProc, void* invokeData);

protected:
	virtual ~fsRemoteObject();

protected:
	virtual void	receive(flChar *data, flUInt dataSize);

protected:
	InvokeProc			_invokeProc;
	void*				_invokeData;

	fsInvokeData		_param;
	fsInvokeData		_retVal;

	flInputByteStream	_iStream;
	flOutputByteStream	_oStream;
};
//------------------------------------------------------------------------------
#endif // __fsRemoteObject_h__
