/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "StdAfx.h"
#include <fs/fsReceiver/fsReceiverInterface.h>

//------------------------------------------------------------------------------
// ̃}NLɂƃ[gsȂ
// sW[ŃRpC܂B
//#define REMOTE_DO_NOT_USE
//------------------------------------------------------------------------------

#include <fs/fsMulticastTools/fsMulticastDetector.h>
#include <fs/fsReceiver/fsReceiver.h>
static fsReceiverPtr		g_receiver = NULL;

#ifndef REMOTE_DO_NOT_USE
#include <fs/fsReceiverRMI/fsReceiverSkel.h>
static fsReceiverSkelPtr	g_receiverSkel	= NULL;
#endif

#include <crtdbg.h>

//------------------------------------------------------------------------------

mxChar str[1024];

#define MXSTR2STR(__str, __mxstr)			\
	mxString mxstr = __mxstr;				\
	if (mxstr.length() != 0)				\
		strcpy(__str, mxstr.c_str());		\
	else									\
		__str[0] = 0;

//------------------------------------------------------------------------------
//
// Initialize / Shutdown
//
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverInitialize(HWND windowHandle)
{
	mxCore::initialize();

	while(true)
	{
		fsMulticastDetectorPtr detector = new fsMulticastDetector();
		detector->setTryUnicast(false);
		if (detector->open())
			break;

		mxInt ret = MessageBox(
						windowHandle,
						TEXT("Initialization of Multicast went wrong."),
						TEXT("Error"),
						MB_ABORTRETRYIGNORE | MB_ICONEXCLAMATION);
		if (ret == IDABORT)
			return false;
		else if (ret == IDRETRY)
			continue;
		else if (ret == IDIGNORE)
            break;
	}

#ifdef REMOTE_DO_NOT_USE

	g_receiver = new fsReceiver();
    return g_receiver->initialize(windowHandle);

#else

	g_receiver = new fsReceiver();
	if (!g_receiver->initialize(windowHandle))
		return false;
	g_receiverSkel = new fsReceiverSkel(g_receiver->cast<fsReceiverIf>());
	g_receiverSkel->open();

	return true;
	
#endif
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverShutdown()
{
	if (g_receiver != NULL)
	{

#ifdef REMOTE_DO_NOT_USE

		g_receiver->shutdown();
		g_receiver = NULL;

#else

		if (g_receiverSkel != NULL)
			g_receiverSkel->close();

		g_receiver->shutdown();
		g_receiver = NULL;

		g_receiverSkel = NULL;

#endif
	}

	mxCore::shutdown();

#ifdef _DEBUG
	_CrtDumpMemoryLeaks();
#endif // _DEBUG

	return true;
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverIsInitialized()
{
	return (g_receiver != NULL);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Streaming Control
//
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverGetValid()
{
	assert(g_receiver != NULL);
	return g_receiver->getValid();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverGetErrorMessage(int* id, int* type, char *message)
{
	assert(g_receiver != NULL);

	mxString mes;
	g_receiver->getErrorMessage(*id, *type, mes);

	MXSTR2STR(message, mes);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetStart(bool flag)
{
	assert(g_receiver != NULL);
	g_receiver->setStart(flag);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverGetStart()
{
	assert(g_receiver != NULL);
	return g_receiver->getStart();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetPointerTransmissionOn(bool flag)
{
	assert(g_receiver != NULL);
	g_receiver->setPointerTransmissionOn(flag);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverGetPointerTransmissionOn()
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerTransmissionOn();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverReceiveSenderData()
{
	assert(g_receiver != NULL);
	return g_receiver->receiveSenderData();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverReceiveVideo()
{
	assert(g_receiver != NULL);
	return g_receiver->receiveVideo();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverReceiveAudio()
{
	assert(g_receiver != NULL);
	return g_receiver->receiveAudio();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverReceivePointerFocus()
{
	assert(g_receiver != NULL);
	return g_receiver->receivePointerFocus();
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Multicast Settings
//
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetAddress(const char* address)
{
	assert(g_receiver != NULL);
	g_receiver->setAddress(address);

	const fsRMIPropertyPtr& property = g_receiverSkel->getRMIProperty();
	property->setAddress(address);
	g_receiverSkel->setRMIProperty(property);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC const char* MVSTD
fsReceiverGetAddress()
{
	assert(g_receiver != NULL);
	MXSTR2STR(str, g_receiver->getAddress());
	return str;
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetTimeToLive(int ttl)
{
	assert(g_receiver != NULL);
	g_receiver->setTimeToLive(ttl);

	const fsRMIPropertyPtr& property = g_receiverSkel->getRMIProperty();
	property->setTimeToLive(ttl);
	g_receiverSkel->setRMIProperty(property);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetTimeToLive()
{
	assert(g_receiver != NULL);
	return g_receiver->getTimeToLive();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetSynchronizeSenderAddressOn(bool flag)
{
	assert(g_receiver != NULL);
	g_receiver->setSynchronizeSenderAddressOn(flag);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverGetSynchronizeSenderAddressOn()
{
	assert(g_receiver != NULL);
	return g_receiver->getSynchronizeSenderAddressOn();
}
//------------------------------------------------------------------------------
// Create Address
FSRECEIVERPROC const char* MVSTD
fsReceiverCreateIPv4Address()
{
	assert(g_receiver != NULL);
	MXSTR2STR(str, g_receiver->createIPv4Address());
	return str;
}
//------------------------------------------------------------------------------
FSRECEIVERPROC const char* MVSTD
fsReceiverCreateIPv6Address()
{
	assert(g_receiver != NULL);
	MXSTR2STR(str, g_receiver->createIPv6Address());
	return str;
}
//------------------------------------------------------------------------------
// Rejection Address
FSRECEIVERPROC const char* MVSTD
fsReceiverGetCurrentReceiveAddress()
{
	assert(g_receiver != NULL);
	MXSTR2STR(str, g_receiver->getCurrentReceiveAddress());
	return str;
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetNumRejectionAddress()
{
	assert(g_receiver != NULL);
	return (mxInt)g_receiver->getNumRejectionAddress();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC const char* MVSTD
fsReceiverGetRejectionAddress(int index)
{
	assert(g_receiver != NULL);
	MXSTR2STR(str, g_receiver->getRejectionAddress((mxUInt)index));
	return str;
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverAddRejectionAddress(const char* address)
{
	assert(g_receiver != NULL);
	g_receiver->addRejectionAddress(address);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverRemoveRejectionAddress(unsigned int index)
{
	assert(g_receiver != NULL);
	g_receiver->removeRejectionAddress(index);
}
//------------------------------------------------------------------------------
// VideoReceiver (Main)
FSRECEIVERPROC int MVSTD
fsReceiverGetVideoReceiverMainReceiveRate()
{
	assert(g_receiver != NULL);
	return g_receiver->getVideoReceiverMainReceiveRate();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetVideoReceiverMainFrameRate()
{
	assert(g_receiver != NULL);
	return g_receiver->getVideoReceiverMainFrameRate();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetVideoReceiverMainNumDropPackets()
{
	assert(g_receiver != NULL);
	return g_receiver->getVideoReceiverMainNumDropPackets();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetVideoReceiverMainNumDropFrames()
{
	assert(g_receiver != NULL);
	return g_receiver->getVideoReceiverMainNumDropFrames();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetVideoReceiverMainPacketSize()
{
	assert(g_receiver != NULL);
	return g_receiver->getVideoReceiverMainPacketSize();
}
//------------------------------------------------------------------------------
// VideoReceiver (Sub)
FSRECEIVERPROC int MVSTD
fsReceiverGetVideoReceiverSubReceiveRate()
{
	assert(g_receiver != NULL);
	return g_receiver->getVideoReceiverSubReceiveRate();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetVideoReceiverSubFrameRate()
{
	assert(g_receiver != NULL);
	return g_receiver->getVideoReceiverSubFrameRate();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetVideoReceiverSubNumDropPackets()
{
	assert(g_receiver != NULL);
	return g_receiver->getVideoReceiverSubNumDropPackets();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetVideoReceiverSubNumDropFrames()
{
	assert(g_receiver != NULL);
	return g_receiver->getVideoReceiverSubNumDropFrames();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetVideoReceiverSubPacketSize()
{
	assert(g_receiver != NULL);
	return g_receiver->getVideoReceiverSubPacketSize();
}
//------------------------------------------------------------------------------
// AudioReceiver
FSRECEIVERPROC int MVSTD
fsReceiverGetAudioReceiverReceiveRate()
{
	assert(g_receiver != NULL);
	return g_receiver->getAudioReceiverReceiveRate();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetAudioReceiverFrameRate()
{
	assert(g_receiver != NULL);
	return g_receiver->getAudioReceiverFrameRate();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetAudioReceiverNumDropPackets()
{
	assert(g_receiver != NULL);
	return g_receiver->getAudioReceiverNumDropPackets();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetAudioReceiverNumDropFrames()
{
	assert(g_receiver != NULL);
	return g_receiver->getAudioReceiverNumDropFrames();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetAudioReceiverPacketSize()
{
	assert(g_receiver != NULL);
	return g_receiver->getAudioReceiverPacketSize();
}
//------------------------------------------------------------------------------
// PointerReceiver (Focus)
FSRECEIVERPROC int MVSTD
fsReceiverGetPointerFocusReceiverReceiveRate()
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerFocusReceiverReceiveRate();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetPointerFocusReceiverFrameRate()
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerFocusReceiverFrameRate();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetPointerFocusReceiverNumDropPackets()
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerFocusReceiverNumDropPackets();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetPointerFocusReceiverNumDropFrames()
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerFocusReceiverNumDropFrames();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetPointerFocusReceiverPacketSize()
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerFocusReceiverPacketSize();
}
//------------------------------------------------------------------------------
// PointerReceiver[s]
FSRECEIVERPROC int MVSTD
fsReceiverGetPointerReceiverReceiveRate()
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerReceiverReceiveRate();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetPointerReceiverFrameRate()
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerReceiverFrameRate();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetPointerReceiverNumDropPackets()
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerReceiverNumDropPackets();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetPointerReceiverNumDropFrames()
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerReceiverNumDropFrames();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetPointerReceiverPacketSize()
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerReceiverPacketSize();
}
//------------------------------------------------------------------------------
// Pointer Sender
FSRECEIVERPROC void MVSTD
fsReceiverSetPointerSenderMaxTransmissionRate(int rate)
{
	assert(g_receiver != NULL);
	g_receiver->setPointerSenderMaxTransmissionRate(rate);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetPointerSenderMaxTransmissionRate()
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerSenderMaxTransmissionRate();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetPointerSenderTransmissionCount(int count)
{
	assert(g_receiver != NULL);
	g_receiver->setPointerSenderTransmissionCount(count);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetPointerSenderTransmissionCount()
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerSenderTransmissionCount();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetPointerSenderPacketSize(int packetSize)
{
	assert(g_receiver != NULL);
	g_receiver->setPointerSenderPacketSize(packetSize);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetPointerSenderPacketSize()
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerSenderPacketSize();
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Multicast Detector Settings
//
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverAddMulticastDetector(const char* address)
{
	assert(g_receiver != NULL);
	return g_receiver->addMulticastDetector(address);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverRemoveMulticastDetector(const char* address)
{
	assert(g_receiver != NULL);
	return g_receiver->removeMulticastDetector(address);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverWasDetectedMulticast(const char* address)
{
	assert(g_receiver != NULL);
	return g_receiver->wasDetectedMulticast(address);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Pointer Settings
//
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetPointerAutomaticSetupOn(bool flag)
{
	assert(g_receiver != NULL);
	g_receiver->setPointerAutomaticSetupOn(flag);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverGetPointerAutomaticSetupOn()
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerAutomaticSetupOn();
}
//------------------------------------------------------------------------------
// Basic Settings
FSRECEIVERPROC void MVSTD
fsReceiverSetGeneralPointer(int pointer)
{
	assert(g_receiver != NULL);
	g_receiver->setGeneralPointer(pointer);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetGeneralPointer()
{
	assert(g_receiver != NULL);
	return g_receiver->getGeneralPointer();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetRaiseOn(bool flag)
{
	assert(g_receiver != NULL);
	g_receiver->setRaiseOn(flag);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverGetRaiseOn()
{
	assert(g_receiver != NULL);
	return g_receiver->getRaiseOn();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetRaisePointer(int pointer)
{
	assert(g_receiver != NULL);
	g_receiver->setRaisePointer(pointer);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetRaisePointer()
{
	assert(g_receiver != NULL);
	return g_receiver->getRaisePointer();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetDrawLocusOn(bool flag)
{
	assert(g_receiver != NULL);
	g_receiver->setDrawLocusOn(flag);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverGetDrawLocusOn()
{
	assert(g_receiver != NULL);
	return g_receiver->getDrawLocusOn();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetLocusPointer(int pointer)
{
	assert(g_receiver != NULL);
	g_receiver->setLocusPointer(pointer);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetLocusPointer()
{
	assert(g_receiver != NULL);
	return g_receiver->getLocusPointer();
}
//------------------------------------------------------------------------------
// Detail Settings
FSRECEIVERPROC void MVSTD
fsReceiverSetPointer(int entryNo, int pointer)
{
	assert(g_receiver != NULL);
	g_receiver->setPointer(entryNo, pointer);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetPointer(int entryNo)
{
	assert(g_receiver != NULL);
	return g_receiver->getPointer(entryNo);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetPointerPhrase(int entryNo, const char* phrase)
{
	assert(g_receiver != NULL);
	g_receiver->setPointerPhrase(entryNo, phrase);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC const char* MVSTD
fsReceiverGetPointerPhrase(int entryNo)
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerPhrase(entryNo).c_str();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetPointerColor(int entryNo, const unsigned char* color)
{
	assert(g_receiver != NULL);
	g_receiver->setPointerColor(entryNo, color);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverGetPointerColor(int entryNo, unsigned char* color)
{
	assert(g_receiver != NULL);
	g_receiver->getPointerColor(entryNo, color);
}
//------------------------------------------------------------------------------
// Other Settings
FSRECEIVERPROC void MVSTD
fsReceiverSetPointerCoordinate(int coordinate)
{
	assert(g_receiver != NULL);
	g_receiver->setPointerCoordinate(coordinate);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetPointerCoordinate()
{
	assert(g_receiver != NULL);
	return g_receiver->getPointerCoordinate();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverComputePointerRegion()
{
	assert(g_receiver != NULL);
	g_receiver->computePointerRegion();
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Caption Settings
//
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverUpdateCaption()
{
	assert(g_receiver != NULL);
	g_receiver->updateCaption();
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Video Window Settings
//
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetVideoWindowPolicy(int policy)
{
	assert(g_receiver != NULL);
	g_receiver->setVideoWindowPolicy(policy);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetVideoWindowPolicy()
{
	assert(g_receiver != NULL);
	return g_receiver->getVideoWindowPolicy();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetKeepVideoAspect(bool flag)
{
	assert(g_receiver != NULL);
	g_receiver->setKeepVideoAspect(flag);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverGetKeepVideoAspect()
{
	assert(g_receiver != NULL);
	return g_receiver->getKeepVideoAspect();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetFitWindowToVideo(bool flag)
{
	assert(g_receiver != NULL);
	g_receiver->setFitWindowToVideo(flag);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverGetFitWindowToVideo()
{
	assert(g_receiver != NULL);
	return g_receiver->getFitWindowToVideo();
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverComputeVideoWindow()
{
	assert(g_receiver != NULL);
	g_receiver->computeVideoWindow();
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Volume Settings
//
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverGetVolume(int* left, int* right)
{
	assert(g_receiver != NULL);
	g_receiver->getVolume(*left, *right);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverSetVolumeEvaluationTime(int evalTime)
{
	assert(g_receiver != NULL);
	g_receiver->setVolumeEvaluationTime(evalTime);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC int MVSTD
fsReceiverGetVolumeEvaluationTime()
{
	assert(g_receiver != NULL);
	return g_receiver->getVolumeEvaluationTime();
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// Quit
FSRECEIVERPROC bool MVSTD
fsReceiverCheckQuit()
{
	assert(g_receiver != NULL);
	return g_receiver->checkQuit();
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// IniFile
FSRECEIVERPROC bool MVSTD
fsReceiverWriteIniFile(const char* filename)
{
	assert(g_receiver != NULL);
	return g_receiver->writeIniFile(filename);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC bool MVSTD
fsReceiverReadIniFile(const char* filename)
{
	assert(g_receiver != NULL);
	return g_receiver->readIniFile(filename);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Registry
FSRECEIVERPROC void MVSTD
fsReceiverReadRegistry(const char* section, const char* entry, const char* defaultValue, char* value)
{
	assert(g_receiver != NULL);
	mxString valueStr;
	g_receiver->readRegistry(section, entry, defaultValue, valueStr);
	MXSTR2STR(value, valueStr);
}
//------------------------------------------------------------------------------
FSRECEIVERPROC void MVSTD
fsReceiverWriteRegistry(const char* section, const char* entry, const char* value)
{
	assert(g_receiver != NULL);
	g_receiver->writeRegistry(section, entry, value);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Callback
FSRECEIVERPROC bool MVSTD
fsReceiverSetCallbackFunction(fsReceiverUICallbackFunction function, void* data)
{
    assert(g_receiver != NULL);
    return g_receiver->setUICallbackFunction(function, data);
}
//------------------------------------------------------------------------------
