/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsReceiverInterface_h__
#define __fsReceiverInterface_h__
//------------------------------------------------------------------------------
#ifdef _WIN32
#ifdef FSRECEIVER_EXPORTS
#define	FSRECEIVERCLASS	__declspec(dllexport)
#define	FSRECEIVERPROC	extern "C" __declspec(dllexport)
#else
#define	FSRECEIVERCLASS	__declspec(dllimport)
#define	FSRECEIVERPROC	extern "C" __declspec(dllimport)
#endif
#else
#define	FSRECEIVERCLASS
#define	FSRECEIVERPROC
#endif
#define	MVSTD			__stdcall
//------------------------------------------------------------------------------

// General Pointer
#define FSRECEIVER_FSGP_STANDARD		0
#define FSRECEIVER_FSGP_ARROW			1
#define FSRECEIVER_FSGP_CIRCLE			2
#define FSRECEIVER_FSGP_RECTANGLE		3
#define FSRECEIVER_FSGP_TARGET			4
#define FSRECEIVER_FSGP_STAR			5
#define FSRECEIVER_FSGP_DETAILPOINTER	6

// Locus Pointer
#define FSRECEIVER_FSLP_POINTER1		6
#define FSRECEIVER_FSLP_POINTER2		7
#define FSRECEIVER_FSLP_POINTER3		8
#define FSRECEIVER_FSLP_DETAILPOINTER	9

// Raise Pointer
#define FSRECEIVER_FSRP_POINTER1		9
#define FSRECEIVER_FSRP_POINTER2		10
#define FSRECEIVER_FSRP_POINTER3		11
#define FSRECEIVER_FSRP_DETAILPOINTER	12

// Detail Pointer Entry
#define FSRECEIVER_FSDP_GENERAL			0
#define FSRECEIVER_FSDP_LOCUS			1
#define FSRECEIVER_FSDP_RAISE1			2
#define FSRECEIVER_FSDP_RAISE2			3
#define FSRECEIVER_FSDP_RAISE3			4
#define FSRECEIVER_FSDP_RAISE4			5
#define FSRECEIVER_FSDP_RAISE5			6
#define FSRECEIVER_NUM_POINTERDETAILENTRY	7

// Video Window Policy
#define FSRECEIVER_FSVWP_FITTOWINDOW	0
#define FSRECEIVER_FSVWP_ORIGINALSIZE	1

// Coordinate
#define FSRECEIVER_FSC_DESKTOPWINDOW	0
#define FSRECEIVER_FSC_VIDEOWINDOW		1

// Error Message Type (rsErrorMessage::TypeEnum)
#define FSRECEIVER_T_NONE				0
#define FSRECEIVER_T_WRONG_CAPTURE		1
#define FSRECEIVER_T_WRONG_ENCODER		2
#define FSRECEIVER_T_WRONG_MEDIATYPE	3
#define FSRECEIVER_T_NOTFOUND_DECODER	4
#define FSRECEIVER_T_UNEXPECTED			5


//
// Initialize / Shutdown
//
FSRECEIVERPROC bool MVSTD			fsReceiverInitialize(HWND windowHandle);
FSRECEIVERPROC bool MVSTD			fsReceiverShutdown();
FSRECEIVERPROC bool MVSTD			fsReceiverIsInitialized();

//
// Streaming Control
//
FSRECEIVERPROC bool MVSTD			fsReceiverGetValid();
FSRECEIVERPROC void MVSTD			fsReceiverGetErrorMessage(int* id, int* type, char *message);
FSRECEIVERPROC void MVSTD			fsReceiverSetStart(bool flag);
FSRECEIVERPROC bool MVSTD			fsReceiverGetStart();
FSRECEIVERPROC void MVSTD			fsReceiverSetPointerTransmissionOn(bool flag);
FSRECEIVERPROC bool MVSTD			fsReceiverGetPointerTransmissionOn();
FSRECEIVERPROC bool MVSTD			fsReceiverReceiveSenderData();
FSRECEIVERPROC bool MVSTD			fsReceiverReceiveVideo();
FSRECEIVERPROC bool MVSTD			fsReceiverReceiveAudio();
FSRECEIVERPROC bool MVSTD			fsReceiverReceivePointerFocus();

//
// Multicast Settings
//
FSRECEIVERPROC void MVSTD			fsReceiverSetAddress(const char* address);
FSRECEIVERPROC const char* MVSTD	fsReceiverGetAddress();
FSRECEIVERPROC void MVSTD			fsReceiverSetTimeToLive(int ttl);
FSRECEIVERPROC int MVSTD			fsReceiverGetTimeToLive();
FSRECEIVERPROC void MVSTD			fsReceiverSetSynchronizeSenderAddressOn(bool flag);
FSRECEIVERPROC bool MVSTD			fsReceiverGetSynchronizeSenderAddressOn();

// Create Address
FSRECEIVERPROC const char* MVSTD	fsReceiverCreateIPv4Address();
FSRECEIVERPROC const char* MVSTD	fsReceiverCreateIPv6Address();

// Rejection Address
FSRECEIVERPROC const char* MVSTD	fsReceiverGetCurrentReceiveAddress();
FSRECEIVERPROC int MVSTD			fsReceiverGetNumRejectionAddress();
FSRECEIVERPROC const char* MVSTD	fsReceiverGetRejectionAddress(int index);
FSRECEIVERPROC void MVSTD			fsReceiverAddRejectionAddress(const char* address);
FSRECEIVERPROC void MVSTD			fsReceiverRemoveRejectionAddress(unsigned int index);

// VideoReceiver (Main)
FSRECEIVERPROC int MVSTD			fsReceiverGetVideoReceiverMainReceiveRate();
FSRECEIVERPROC int MVSTD			fsReceiverGetVideoReceiverMainFrameRate();
FSRECEIVERPROC int MVSTD			fsReceiverGetVideoReceiverMainNumDropPackets();
FSRECEIVERPROC int MVSTD			fsReceiverGetVideoReceiverMainNumDropFrames();
FSRECEIVERPROC int MVSTD			fsReceiverGetVideoReceiverMainPacketSize();

// VideoReceiver (Sub)
FSRECEIVERPROC int MVSTD			fsReceiverGetVideoReceiverSubReceiveRate();
FSRECEIVERPROC int MVSTD			fsReceiverGetVideoReceiverSubFrameRate();
FSRECEIVERPROC int MVSTD			fsReceiverGetVideoReceiverSubNumDropPackets();
FSRECEIVERPROC int MVSTD			fsReceiverGetVideoReceiverSubNumDropFrames();
FSRECEIVERPROC int MVSTD			fsReceiverGetVideoReceiverSubPacketSize();

// AudioReceiver
FSRECEIVERPROC int MVSTD			fsReceiverGetAudioReceiverReceiveRate();
FSRECEIVERPROC int MVSTD			fsReceiverGetAudioReceiverFrameRate();
FSRECEIVERPROC int MVSTD			fsReceiverGetAudioReceiverNumDropPackets();
FSRECEIVERPROC int MVSTD			fsReceiverGetAudioReceiverNumDropFrames();
FSRECEIVERPROC int MVSTD			fsReceiverGetAudioReceiverPacketSize();

// PointerReceiver Focus
FSRECEIVERPROC int MVSTD			fsReceiverGetPointerFocusReceiverReceiveRate();
FSRECEIVERPROC int MVSTD			fsReceiverGetPointerFocusReceiverFrameRate();
FSRECEIVERPROC int MVSTD			fsReceiverGetPointerFocusReceiverNumDropPackets();
FSRECEIVERPROC int MVSTD			fsReceiverGetPointerFocusReceiverNumDropFrames();
FSRECEIVERPROC int MVSTD			fsReceiverGetPointerFocusReceiverPacketSize();

// PointerReceivers
FSRECEIVERPROC int MVSTD			fsReceiverGetPointerReceiverReceiveRate();
FSRECEIVERPROC int MVSTD			fsReceiverGetPointerReceiverFrameRate();
FSRECEIVERPROC int MVSTD			fsReceiverGetPointerReceiverNumDropPackets();
FSRECEIVERPROC int MVSTD			fsReceiverGetPointerReceiverNumDropFrames();
FSRECEIVERPROC int MVSTD			fsReceiverGetPointerReceiverPacketSize();

// Pointer Sender
FSRECEIVERPROC void MVSTD			fsReceiverSetPointerSenderMaxTransmissionRate(int rate);
FSRECEIVERPROC int MVSTD			fsReceiverGetPointerSenderMaxTransmissionRate();
FSRECEIVERPROC void MVSTD			fsReceiverSetPointerSenderTransmissionCount(int count);
FSRECEIVERPROC int MVSTD			fsReceiverGetPointerSenderTransmissionCount();
FSRECEIVERPROC void MVSTD			fsReceiverSetPointerSenderPacketSize(int packetSize);
FSRECEIVERPROC int MVSTD			fsReceiverGetPointerSenderPacketSize();


//
// Multicast Detector Settings
//
FSRECEIVERPROC bool MVSTD			fsReceiverAddMulticastDetector(const char* address);
FSRECEIVERPROC bool MVSTD			fsReceiverRemoveMulticastDetector(const char* address);
FSRECEIVERPROC bool MVSTD			fsReceiverWasDetectedMulticast(const char* address);


//
// Pointer Settings
//
FSRECEIVERPROC void MVSTD			fsReceiverSetPointerAutomaticSetupOn(bool flag);
FSRECEIVERPROC bool MVSTD			fsReceiverGetPointerAutomaticSetupOn();

// Basic Settings
FSRECEIVERPROC void MVSTD			fsReceiverSetGeneralPointer(int pointer);
FSRECEIVERPROC int MVSTD			fsReceiverGetGeneralPointer();
FSRECEIVERPROC void MVSTD			fsReceiverSetRaiseOn(bool flag);
FSRECEIVERPROC bool MVSTD			fsReceiverGetRaiseOn();
FSRECEIVERPROC void MVSTD			fsReceiverSetRaisePointer(int pointer);
FSRECEIVERPROC int MVSTD			fsReceiverGetRaisePointer();
FSRECEIVERPROC void MVSTD			fsReceiverSetDrawLocusOn(bool flag);
FSRECEIVERPROC bool MVSTD			fsReceiverGetDrawLocusOn();
FSRECEIVERPROC void MVSTD			fsReceiverSetLocusPointer(int pointer);
FSRECEIVERPROC int MVSTD			fsReceiverGetLocusPointer();

// Detail Settings
FSRECEIVERPROC void MVSTD			fsReceiverSetPointer(int entryNo, int pointer);
FSRECEIVERPROC int MVSTD			fsReceiverGetPointer(int entryNo);
FSRECEIVERPROC void MVSTD			fsReceiverSetPointerPhrase(int entryNo, const char* phrase);
FSRECEIVERPROC const char* MVSTD	fsReceiverGetPointerPhrase(int entryNo);
FSRECEIVERPROC void MVSTD			fsReceiverSetPointerColor(int entryNo, const unsigned char* color);
FSRECEIVERPROC void MVSTD			fsReceiverGetPointerColor(int entryNo, unsigned char* color);

// Other Settings
FSRECEIVERPROC void MVSTD			fsReceiverSetPointerCoordinate(int coordinate);
FSRECEIVERPROC int MVSTD			fsReceiverGetPointerCoordinate();
FSRECEIVERPROC void MVSTD			fsReceiverComputePointerRegion();

//
// Caption Settings
//
FSRECEIVERPROC void MVSTD			fsReceiverUpdateCaption();

//
// Video Window Settings
//
FSRECEIVERPROC void MVSTD			fsReceiverSetVideoWindowPolicy(int policy);
FSRECEIVERPROC int MVSTD			fsReceiverGetVideoWindowPolicy();
FSRECEIVERPROC void MVSTD			fsReceiverSetKeepVideoAspect(bool flag);
FSRECEIVERPROC bool MVSTD			fsReceiverGetKeepVideoAspect();
FSRECEIVERPROC void MVSTD			fsReceiverSetFitWindowToVideo(bool flag);
FSRECEIVERPROC bool MVSTD			fsReceiverGetFitWindowToVideo();
FSRECEIVERPROC void MVSTD			fsReceiverComputeVideoWindow();

//
// Volume Settings
//
FSRECEIVERPROC void MVSTD			fsReceiverGetVolume(int* left, int* right);
FSRECEIVERPROC void MVSTD			fsReceiverSetVolumeEvaluationTime(int evalTime);
FSRECEIVERPROC int MVSTD			fsReceiverGetVolumeEvaluationTime();


// Quit
FSRECEIVERPROC bool MVSTD			fsReceiverCheckQuit();

// IniFile
FSRECEIVERPROC bool MVSTD			fsReceiverWriteIniFile(const char* filename);
FSRECEIVERPROC bool MVSTD			fsReceiverReadIniFile(const char* filename);

// Registry
FSRECEIVERPROC void MVSTD			fsReceiverReadRegistry(const char* section, const char* entry, const char* defaultValue, char* value);
FSRECEIVERPROC void MVSTD			fsReceiverWriteRegistry(const char* section, const char* entry, const char* value);

// Callback
typedef int (*fsReceiverUICallbackFunction)(const char*, void*, void*);
FSRECEIVERPROC bool MVSTD			fsReceiverSetCallbackFunction(fsReceiverUICallbackFunction function, void* data);

//------------------------------------------------------------------------------
#endif // __fsReceiverInterface_h__
