/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsReceiverSkel_h__
#define __fsReceiverSkel_h__
//------------------------------------------------------------------------------
#include <fs/fsReceiverRMI/fsReceiverRMI.h>
#include <fs/fsMulticastTools/fsRemoteObject.h>
#include <mx/mxCore/mxObject.h>
//------------------------------------------------------------------------------
class fsReceiverIf;
class fsReceiverSkel;
typedef mxObjectPtr<fsReceiverSkel>	fsReceiverSkelPtr;
//------------------------------------------------------------------------------
class FSRECEIVERRMICLASS fsReceiverSkel : public mxObject
{
	MXOBJECTHEADER(fsReceiverSkel, mxObject);

public:
	fsReceiverSkel(fsReceiverIf* sender);

protected:
	virtual ~fsReceiverSkel();

public:
	mxBool				open();
	mxBool				close();
	void				setRMIProperty(const fsRMIPropertyPtr& property);
	const fsRMIPropertyPtr&	getRMIProperty() const;

public:
	const fsReceiverIf*	getReceiver() const;

protected:
	virtual void		invoke(const mxString& method,
								fsInvokeData& param,
								fsInvokeData& retVal);
	static void			invokeProc(const mxString& method,
								fsInvokeData& param,
								fsInvokeData& retVal,
								void *data);

protected:
	fsRemoteObjectPtr	_rObject;
	fsReceiverIf*		_receiver;
};
//------------------------------------------------------------------------------
#endif //__fsReceiverSkel_h__
