/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsReceiverRemote_h__
#define __fsReceiverRemote_h__
//------------------------------------------------------------------------------
#include <fs/fsReceiverRMI/fsReceiverStub.h>
//------------------------------------------------------------------------------
class fsReceiverRemote;
typedef mxObjectPtr<fsReceiverRemote>	fsReceiverRemotePtr;
//------------------------------------------------------------------------------
class fsReceiverRemote : public fsReceiverStub
{
	MXOBJECTHEADER(fsReceiverRemote, fsReceiverStub);

public:
	fsReceiverRemote();

protected:
	virtual ~fsReceiverRemote();

public:
	// Callback
	typedef int (*fsReceiverUICallbackFunction)(const char*, void*, void*);
	mxBool		setUICallbackFunction(fsReceiverUICallbackFunction func, void* data);

	// IniFile
	mxBool		writeIniFile(const mxString& filename);
	mxBool		readIniFile(const mxString& filename);

	// Registry
	void		writeRegistry(const mxString& section, const mxString& entry,
							const mxString& value);
	void		readRegistry(const mxString& section, const mxString& entry,
							const mxString& defaultValue, mxString& value);

protected:
	void		invokeNotify(const mxString& method, mxBool result);

protected:
	fsReceiverUICallbackFunction	_UICallbackFunction;
	void*							_UICallbackData;
};
//------------------------------------------------------------------------------
#endif //__fsReceiverRemote_h__
