/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsReceiverInterface_h__
#define __fsReceiverInterface_h__
//------------------------------------------------------------------------------
#ifdef _WIN32
#ifdef FSRECEIVERREMOTE_EXPORTS
#define	FSRECEIVERREMOTECLASS	__declspec(dllexport)
#define	FSRECEIVERREMOTEPROC	extern "C" __declspec(dllexport)
#else
#define	FSRECEIVERREMOTECLASS	__declspec(dllimport)
#define	FSRECEIVERREMOTEPROC	extern "C" __declspec(dllimport)
#endif
#else
#define	FSRECEIVERREMOTECLASS
#define	FSRECEIVERREMOTEPROC
#endif
#define	MVSTD			__stdcall
//------------------------------------------------------------------------------

// General Pointer
#define FSRECEIVER_FSGP_STANDARD		0
#define FSRECEIVER_FSGP_ARROW			1
#define FSRECEIVER_FSGP_CIRCLE			2
#define FSRECEIVER_FSGP_RECTANGLE		3
#define FSRECEIVER_FSGP_TARGET			4
#define FSRECEIVER_FSGP_STAR			5
#define FSRECEIVER_FSGP_DETAILPOINTER	6

// Locus Pointer
#define FSRECEIVER_FSLP_POINTER1		6
#define FSRECEIVER_FSLP_POINTER2		7
#define FSRECEIVER_FSLP_POINTER3		8
#define FSRECEIVER_FSLP_DETAILPOINTER	9

// Raise Pointer
#define FSRECEIVER_FSRP_POINTER1		9
#define FSRECEIVER_FSRP_POINTER2		10
#define FSRECEIVER_FSRP_POINTER3		11
#define FSRECEIVER_FSRP_DETAILPOINTER	12

// Detail Pointer Entry
#define FSRECEIVER_FSDP_GENERAL			0
#define FSRECEIVER_FSDP_LOCUS			1
#define FSRECEIVER_FSDP_RAISE1			2
#define FSRECEIVER_FSDP_RAISE2			3
#define FSRECEIVER_FSDP_RAISE3			4
#define FSRECEIVER_FSDP_RAISE4			5
#define FSRECEIVER_FSDP_RAISE5			6
#define FSRECEIVER_NUM_POINTERDETAILENTRY	7

// Video Window Policy
#define FSRECEIVER_FSVWP_FITTOWINDOW	0
#define FSRECEIVER_FSVWP_ORIGINALSIZE	1

// Coordinate
#define FSRECEIVER_FSC_DESKTOPWINDOW	0
#define FSRECEIVER_FSC_VIDEOWINDOW		1

// Error Message Type (rsErrorMessage::TypeEnum)
#define FSRECEIVER_T_NONE				0
#define FSRECEIVER_T_WRONG_CAPTURE		1
#define FSRECEIVER_T_WRONG_ENCODER		2
#define FSRECEIVER_T_WRONG_MEDIATYPE	3
#define FSRECEIVER_T_NOTFOUND_DECODER	4
#define FSRECEIVER_T_UNEXPECTED			5


//
// Initialize / Shutdown
//
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverInitialize();
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverShutdown();
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverIsInitialized();

//
// Streaming Control
//
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverGetValid();
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverGetErrorMessage(int* id, int* type, char *message);
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetStart(bool flag);
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverGetStart();
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetPointerTransmissionOn(bool flag);
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverGetPointerTransmissionOn();
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverReceiveSenderData();
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverReceiveVideo();
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverReceiveAudio();
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverReceivePointerFocus();

//
// Multicast Settings
//
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetAddress(const char* address);
FSRECEIVERREMOTEPROC const char* MVSTD	fsReceiverGetAddress();
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetTimeToLive(int ttl);
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetTimeToLive();
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetSynchronizeSenderAddressOn(bool flag);
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverGetSynchronizeSenderAddressOn();

// Create Address
FSRECEIVERREMOTEPROC const char* MVSTD	fsReceiverCreateIPv4Address();
FSRECEIVERREMOTEPROC const char* MVSTD	fsReceiverCreateIPv6Address();

// Rejection Address
FSRECEIVERREMOTEPROC const char* MVSTD	fsReceiverGetCurrentReceiveAddress();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetNumRejectionAddress();
FSRECEIVERREMOTEPROC const char* MVSTD	fsReceiverGetRejectionAddress(int index);
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverAddRejectionAddress(const char* address);
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverRemoveRejectionAddress(unsigned int index);

// VideoReceiver (Main)
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetVideoReceiverMainReceiveRate();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetVideoReceiverMainFrameRate();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetVideoReceiverMainNumDropPackets();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetVideoReceiverMainNumDropFrames();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetVideoReceiverMainPacketSize();

// VideoReceiver (Sub)
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetVideoReceiverSubReceiveRate();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetVideoReceiverSubFrameRate();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetVideoReceiverSubNumDropPackets();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetVideoReceiverSubNumDropFrames();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetVideoReceiverSubPacketSize();

// AudioReceiver
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetAudioReceiverReceiveRate();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetAudioReceiverFrameRate();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetAudioReceiverNumDropPackets();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetAudioReceiverNumDropFrames();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetAudioReceiverPacketSize();

// PointerReceiver Focus
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetPointerFocusReceiverReceiveRate();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetPointerFocusReceiverFrameRate();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetPointerFocusReceiverNumDropPackets();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetPointerFocusReceiverNumDropFrames();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetPointerFocusReceiverPacketSize();

// PointerReceivers
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetPointerReceiverReceiveRate();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetPointerReceiverFrameRate();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetPointerReceiverNumDropPackets();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetPointerReceiverNumDropFrames();
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetPointerReceiverPacketSize();

// Pointer Sender
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetPointerSenderMaxTransmissionRate(int rate);
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetPointerSenderMaxTransmissionRate();
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetPointerSenderTransmissionCount(int count);
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetPointerSenderTransmissionCount();
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetPointerSenderPacketSize(int packetSize);
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetPointerSenderPacketSize();


//
// Multicast Detector Settings
//
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverAddMulticastDetector(const char* address);
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverRemoveMulticastDetector(const char* address);
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverWasDetectedMulticast(const char* address);


//
// Pointer Settings
//
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetPointerAutomaticSetupOn(bool flag);
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverGetPointerAutomaticSetupOn();

// Basic Settings
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetGeneralPointer(int pointer);
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetGeneralPointer();
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetRaiseOn(bool flag);
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverGetRaiseOn();
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetRaisePointer(int pointer);
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetRaisePointer();
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetDrawLocusOn(bool flag);
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverGetDrawLocusOn();
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetLocusPointer(int pointer);
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetLocusPointer();

// Detail Settings
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetPointer(int entryNo, int pointer);
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetPointer(int entryNo);
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetPointerPhrase(int entryNo, const char* phrase);
FSRECEIVERREMOTEPROC const char* MVSTD	fsReceiverGetPointerPhrase(int entryNo);
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetPointerColor(int entryNo, const unsigned char* color);
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverGetPointerColor(int entryNo, unsigned char* color);

// Other Settings
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetPointerCoordinate(int coordinate);
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetPointerCoordinate();
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverComputePointerRegion();


//
// Caption Settings
//
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverUpdateCaption();

//
// Video Window Settings
//
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetVideoWindowPolicy(int policy);
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetVideoWindowPolicy();
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetKeepVideoAspect(bool flag);
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverGetKeepVideoAspect();
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetFitWindowToVideo(bool flag);
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverGetFitWindowToVideo();
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverComputeVideoWindow();

//
// Volume Settings
//
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverGetVolume(int* left, int* right);
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverSetVolumeEvaluationTime(int evalTime);
FSRECEIVERREMOTEPROC int MVSTD			fsReceiverGetVolumeEvaluationTime();

//
// Other
//
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverQuit();


// IniFile
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverWriteIniFile(const char* filename);
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverReadIniFile(const char* filename);

// Registry
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverReadRegistry(const char* section, const char* entry, const char* defaultValue, char* value);
FSRECEIVERREMOTEPROC void MVSTD			fsReceiverWriteRegistry(const char* section, const char* entry, const char* value);

// Callback
typedef int (*fsReceiverUICallbackFunction)(const char*, void*, void*);
FSRECEIVERREMOTEPROC bool MVSTD			fsReceiverSetCallbackFunction(fsReceiverUICallbackFunction function, void* data);

//------------------------------------------------------------------------------
#endif // __fsReceiverInterface_h__
