/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "StdAfx.h"
#include <fs/fsSender/fsSenderInterface.h>

//------------------------------------------------------------------------------
// ̃}NLɂƃ[gsȂ
// sW[ŃRpC܂B
//#define REMOTE_DO_NOT_USE
//------------------------------------------------------------------------------

#include <fs/fsMulticastTools/fsMulticastDetector.h>
#include <fs/fsSender/fsSender.h>
static fsSenderPtr		g_sender		= NULL;

#ifndef REMOTE_DO_NOT_USE
#include <fs/fsSenderRMI/fsSenderSkel.h>
static fsSenderSkelPtr	g_senderSkel	= NULL;
#endif

#include <crtdbg.h>

//------------------------------------------------------------------------------

mxChar str[1024];

#define MXSTR2STR(__str, __mxstr)			\
	mxString mxstr = __mxstr;				\
	if (mxstr.length() != 0)				\
		strcpy(__str, mxstr.c_str());		\
	else									\
		__str[0] = 0;

//------------------------------------------------------------------------------
// Initialize / Shutdown
FSSENDERPROC bool MVSTD
fsSenderInitialize(HWND windowHandle)
{
	mxCore::initialize();

	while(true)
	{
		fsMulticastDetectorPtr detector = new fsMulticastDetector();
		detector->setTryUnicast(false);
		if (detector->open())
			break;

		mxInt ret = MessageBox(
						windowHandle,
						TEXT("Initialization of Multicast went wrong."),
						TEXT("Error"),
						MB_ABORTRETRYIGNORE | MB_ICONEXCLAMATION);
		if (ret == IDABORT)
			return false;
		else if (ret == IDRETRY)
			continue;
		else if (ret == IDIGNORE)
            break;
	}

#ifdef REMOTE_DO_NOT_USE

	g_sender = new fsSender();
	return g_sender->initialize(windowHandle);

#else

	g_sender = new fsSender();
	if (!g_sender->initialize(windowHandle))
		return false;

	g_senderSkel = new fsSenderSkel(g_sender->cast<fsSenderIf>());
	g_senderSkel->open();
	
    return true;

#endif
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderShutdown()
{
	if (g_sender !=  NULL)
	{

#ifdef REMOTE_DO_NOT_USE

		g_sender->shutdown();
		g_sender = NULL;

#else

		if (g_senderSkel != NULL)
			g_senderSkel->close();

		g_sender->shutdown();
		g_sender = NULL;

		g_senderSkel = NULL;

#endif

	}

	mxCore::shutdown();

#ifdef _DEBUG
	_CrtDumpMemoryLeaks();
#endif // _DEBUG

	return true;
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderIsInitialized()
{
	return (g_sender != NULL);
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
//
// Streaming Control
//
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderGetValid()
{
	assert(g_sender != NULL);
	return g_sender->getValid();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderGetErrorMessage(int* id, int* type, char* message)
{
	assert(g_sender != NULL);

	mxString mes;
	g_sender->getErrorMessage(*id, *type, mes);

	MXSTR2STR(message, mes);
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetStart(bool flag)
{
	assert(g_sender != NULL);
	g_sender->setStart(flag);
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderGetStart()
{
	assert(g_sender != NULL);
	return g_sender->getStart();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetVideoTransmissionOn(bool flag)
{
	assert(g_sender != NULL);
	g_sender->setVideoTransmissionOn(flag);
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderGetVideoTransmissionOn()
{
	assert(g_sender != NULL);
	return g_sender->getVideoTransmissionOn();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetAudioTransmissionOn(bool flag)
{
	assert(g_sender != NULL);
	g_sender->setAudioTransmissionOn(flag);
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderGetAudioTransmissionOn()
{
	assert(g_sender != NULL);
	return g_sender->getAudioTransmissionOn();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetFocusTransmissionOn(bool flag)
{
	assert(g_sender != NULL);
	g_sender->setFocusTransmissionOn(flag);
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderGetFocusTransmissionOn()
{
	assert(g_sender != NULL);
	return g_sender->getFocusTransmissionOn();
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Multicast Settings
//
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetAddress(const char* address)
{
	assert(g_sender != NULL);
	g_sender->setAddress(address);

	const fsRMIPropertyPtr& property = g_senderSkel->getRMIProperty();
	property->setAddress(address);
	g_senderSkel->setRMIProperty(property);
}
//------------------------------------------------------------------------------
FSSENDERPROC const char* MVSTD
fsSenderGetAddress()
{
	assert(g_sender != NULL);
	MXSTR2STR(str, g_sender->getAddress());
	return str;
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetTimeToLive(int ttl)
{
	assert(g_sender != NULL);
	g_sender->setTimeToLive((mxULong)ttl);

	const fsRMIPropertyPtr& property = g_senderSkel->getRMIProperty();
	property->setTimeToLive(ttl);
	g_senderSkel->setRMIProperty(property);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetTimeToLive()
{
	assert(g_sender != NULL);
	return (int)g_sender->getTimeToLive();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetTransmissionCount(int count)
{
	assert(g_sender != NULL);
	g_sender->setTransmissionCount((mxUInt)count);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetTransmissionCount()
{
	assert(g_sender != NULL);
	return (int)g_sender->getTransmissionCount();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetPacketSize(int size)
{
	assert(g_sender != NULL);
	g_sender->setPacketSize((mxUInt)size);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetPacketSize()
{
	assert(g_sender != NULL);
	return (int)g_sender->getPacketSize();
}
//------------------------------------------------------------------------------
// Create Address
FSSENDERPROC const char* MVSTD
fsSenderCreateIPv4Address()
{
	assert(g_sender != NULL);
	MXSTR2STR(str, g_sender->createIPv4Address());
	return str;
}
//------------------------------------------------------------------------------
FSSENDERPROC const char* MVSTD
fsSenderCreateIPv6Address()
{
	assert(g_sender != NULL);
	MXSTR2STR(str, g_sender->createIPv6Address());
	return str;
}
//------------------------------------------------------------------------------
// Video Sender (Main)
FSSENDERPROC void MVSTD
fsSenderSetVideoSenderMainMaxTransmissionRate(int rateInKBitPerSec)
{
	assert(g_sender != NULL);
	g_sender->setVideoSenderMainMaxTransmissionRate(rateInKBitPerSec);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetVideoSenderMainMaxTransmissionRate()
{
	assert(g_sender != NULL);
	return g_sender->getVideoSenderMainMaxTransmissionRate();
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetVideoSenderMainTransmissionRate()
{
	assert(g_sender != NULL);
	return g_sender->getVideoSenderMainTransmissionRate();
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetVideoSenderMainFrameRate()
{
	assert(g_sender != NULL);
	return g_sender->getVideoSenderMainFrameRate();
}
//------------------------------------------------------------------------------
// Video Sender (Sub)
FSSENDERPROC void MVSTD
fsSenderSetVideoSenderSubMaxTransmissionRate(int rateInKBitPerSec)
{
	assert(g_sender != NULL);
	g_sender->setVideoSenderSubMaxTransmissionRate(rateInKBitPerSec);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetVideoSenderSubMaxTransmissionRate()
{
	assert(g_sender != NULL);
	return g_sender->getVideoSenderSubMaxTransmissionRate();
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetVideoSenderSubTransmissionRate()
{
	assert(g_sender != NULL);
	return g_sender->getVideoSenderSubTransmissionRate();
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetVideoSenderSubFrameRate()
{
	assert(g_sender != NULL);
	return g_sender->getVideoSenderSubFrameRate();
}
//------------------------------------------------------------------------------
// Audio Sender
FSSENDERPROC void MVSTD
fsSenderSetAudioSenderMaxTransmissionRate(int rateInKBitPerSec)
{
	assert(g_sender != NULL);
	g_sender->setAudioSenderMaxTransmissionRate(rateInKBitPerSec);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetAudioSenderMaxTransmissionRate()
{
	assert(g_sender != NULL);
	return g_sender->getAudioSenderMaxTransmissionRate();
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetAudioSenderTransmissionRate()
{
	assert(g_sender != NULL);
	return g_sender->getAudioSenderTransmissionRate();
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetAudioSenderFrameRate()
{
	assert(g_sender != NULL);
	return g_sender->getAudioSenderFrameRate();
}
//------------------------------------------------------------------------------
// Pointer Sender
FSSENDERPROC void MVSTD
fsSenderSetPointerSenderMaxTransmissionRate(int rateInKBitPerSec)
{
	assert(g_sender != NULL);
	g_sender->setPointerSenderMaxTransmissionRate(rateInKBitPerSec);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetPointerSenderMaxTransmissionRate()
{
	assert(g_sender != NULL);
	return g_sender->getPointerSenderMaxTransmissionRate();
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetPointerSenderTransmissionRate()
{
	assert(g_sender != NULL);
	return g_sender->getPointerSenderTransmissionRate();
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetPointerSenderFrameRate()
{
	assert(g_sender != NULL);
	return g_sender->getPointerSenderFrameRate();
}
//------------------------------------------------------------------------------
// Status Sender
FSSENDERPROC void MVSTD
fsSenderSetStatusSenderMaxTransmissionRate(int rateInKBitPerSec)
{
	assert(g_sender != NULL);
	g_sender->setStatusSenderMaxTransmissionRate(rateInKBitPerSec);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetStatusSenderMaxTransmissionRate()
{
	assert(g_sender != NULL);
	return g_sender->getStatusSenderMaxTransmissionRate();
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Multicast Detector Settings
//
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderAddMulticastDetector(const char* address)
{
	assert(g_sender != NULL);
	return g_sender->addMulticastDetector(address);
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderRemoveMulticastDetector(const char* address)
{
	assert(g_sender != NULL);
	return g_sender->removeMulticastDetector(address);
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderWasDetectedMulticast(const char* address)
{
	assert(g_sender != NULL);
	return g_sender->wasDetectedMulticast(address);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Source Settings
//
//------------------------------------------------------------------------------
// Video Source
FSSENDERPROC int MVSTD
fsSenderGetNumVideoSources()
{
	assert(g_sender != NULL);
	return g_sender->getNumVideoSources();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetVideoSource(int index)
{
	assert(g_sender != NULL);
	g_sender->setVideoSource(index);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetVideoSource()
{
	assert(g_sender != NULL);
	return g_sender->getVideoSource();
}
//------------------------------------------------------------------------------
FSSENDERPROC const char* MVSTD
fsSenderGetVideoSourceFriendlyName(int index)
{
	assert(g_sender != NULL);
	MXSTR2STR(str, g_sender->getVideoSourceFriendlyName(index));
	return str;
}
//------------------------------------------------------------------------------
// Audio Source
FSSENDERPROC int MVSTD
fsSenderGetNumAudioSources()
{
	assert(g_sender != NULL);
	return g_sender->getNumAudioSources();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetAudioSource(int index)
{
	assert(g_sender != NULL);
	g_sender->setAudioSource(index);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetAudioSource()
{
	assert(g_sender != NULL);
	return g_sender->getAudioSource();
}
//------------------------------------------------------------------------------
FSSENDERPROC const char* MVSTD
fsSenderGetAudioSourceFriendlyName(int index)
{
	assert(g_sender != NULL);
	MXSTR2STR(str, g_sender->getAudioSourceFriendlyName(index));
	return str;
}
//------------------------------------------------------------------------------
// Video Source Property Page
FSSENDERPROC int MVSTD
fsSenderGetNumVideoSourcePropertyPages()
{
	assert(g_sender != NULL);
	return g_sender->getNumVideoSourcePropertyPages();
}
//------------------------------------------------------------------------------
FSSENDERPROC const char* MVSTD
fsSenderGetVideoSourcePropertyPageName(int index)
{
	assert(g_sender != NULL);
	MXSTR2STR(str, g_sender->getVideoSourcePropertyPageName(index));
	return str;
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderShowVideoSourcePropertyPage(HWND windowHandle, int index)
{
	assert(g_sender != NULL);
	g_sender->showVideoSourcePropertyPage(windowHandle, index);
}
//------------------------------------------------------------------------------
// Audio Source Property Page
FSSENDERPROC int MVSTD
fsSenderGetNumAudioSourcePropertyPages()
{
	assert(g_sender != NULL);
	return g_sender->getNumAudioSourcePropertyPages();
}
//------------------------------------------------------------------------------
FSSENDERPROC const char* MVSTD
fsSenderGetAudioSourcePropertyPageName(int index)
{
	assert(g_sender != NULL);
	MXSTR2STR(str, g_sender->getAudioSourcePropertyPageName(index));
	return str;
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderShowAudioSourcePropertyPage(HWND windowHandle, int index)
{
	assert(g_sender != NULL);
	g_sender->showAudioSourcePropertyPage(windowHandle, index);
}
//------------------------------------------------------------------------------
// Video Clip
FSSENDERPROC bool MVSTD
fsSenderIsPlayVideoClip()
{
	assert(g_sender != NULL);
	return g_sender->isPlayVideoClip();
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderPlayVideoClip(const char* filename)
{
	assert(g_sender != NULL);
	return g_sender->playVideoClip(filename);
}
//------------------------------------------------------------------------------
// Sound File
FSSENDERPROC bool MVSTD
fsSenderIsPlaySoundFile()
{
	assert(g_sender != NULL);
	return g_sender->isPlaySoundFile();
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderPlaySoundFile(const char* filename)
{
	assert(g_sender != NULL);
	return g_sender->playSoundFile(filename);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Encoder Settings
//
//------------------------------------------------------------------------------
// Video Encoder
FSSENDERPROC int MVSTD
fsSenderGetNumVideoEncoder()
{
	assert(g_sender != NULL);
	return g_sender->getNumVideoEncoder();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetVideoEncoder(int index)
{
	assert(g_sender != NULL);
	g_sender->setVideoEncoder(index);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetVideoEncoder()
{
	assert(g_sender != NULL);
	return g_sender->getVideoEncoder();
}
//------------------------------------------------------------------------------
FSSENDERPROC const char* MVSTD
fsSenderGetVideoEncoderFriendlyName(int index)
{
	assert(g_sender != NULL);
	MXSTR2STR(str, g_sender->getVideoEncoderFriendlyName(index));
	return str;
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetVideoEncoderPriority(int index)
{
	assert(g_sender != NULL);
	return g_sender->getVideoEncoderPriority(index);
}
//------------------------------------------------------------------------------
// Audio Encoder
FSSENDERPROC int MVSTD
fsSenderGetNumAudioEncoder()
{
	assert(g_sender != NULL);
	return g_sender->getNumAudioEncoder();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetAudioEncoder(int index)
{
	assert(g_sender != NULL);
	g_sender->setAudioEncoder(index);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetAudioEncoder()
{
	assert(g_sender != NULL);
	return g_sender->getAudioEncoder();
}
//------------------------------------------------------------------------------
FSSENDERPROC const char* MVSTD
fsSenderGetAudioEncoderFriendlyName(int index)
{
	assert(g_sender != NULL);
	MXSTR2STR(str, g_sender->getAudioEncoderFriendlyName(index));
	return str;
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetAudioEncoderPriority(int index)
{
	assert(g_sender != NULL);
	return g_sender->getAudioEncoderPriority(index);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Focus Display Settings
//
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetFocusDisplay(int focusDisplay)
{
	assert(g_sender != NULL);
	g_sender->setFocusDisplay(focusDisplay);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetFocusDisplay()
{
	assert(g_sender != NULL);
	return g_sender->getFocusDisplay();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetFocusFrameVisible(bool flag)
{
	assert(g_sender != NULL);
	g_sender->setFocusFrameVisible(flag);
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderGetFocusFrameVisible()
{
	assert(g_sender != NULL);
	return g_sender->getFocusFrameVisible();
}
//------------------------------------------------------------------------------
// Video Resolution
FSSENDERPROC void MVSTD
fsSenderSetVideoResolution(int videoResolution)
{
	assert(g_sender != NULL);
	g_sender->setVideoResolution(videoResolution);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetVideoResolution()
{
	assert(g_sender != NULL);
	return g_sender->getVideoResolution();
}
//------------------------------------------------------------------------------
// Partial Zoom
FSSENDERPROC void MVSTD
fsSenderSetPartialZoomSourceVideoResolution(int videoResolution)
{
	assert(g_sender != NULL);
	g_sender->setPartialZoomSourceVideoResolution(videoResolution);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetPartialZoomSourceVideoResolution()
{
	assert(g_sender != NULL);
	return g_sender->getPartialZoomSourceVideoResolution();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetPartialZoomOutputVideoResolution(int videoResolution)
{
	assert(g_sender != NULL);
	g_sender->setPartialZoomOutputVideoResolution(videoResolution);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetPartialZoomOutputVideoResolution()
{
	assert(g_sender != NULL);
	return g_sender->getPartialZoomOutputVideoResolution();
}
//------------------------------------------------------------------------------
// Non-Linear Zoom
FSSENDERPROC void MVSTD
fsSenderSetNonLinearZoomOutputVideoResolution(int videoResolution)
{
	assert(g_sender != NULL);
	g_sender->setNonLinearZoomOutputVideoResolution(videoResolution);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetNonLinearZoomOutputVideoResolution()
{
	assert(g_sender != NULL);
	return g_sender->getNonLinearZoomOutputVideoResolution();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetNonLinearZoomMaskType(int maskType)
{
	assert(g_sender != NULL);
	g_sender->setNonLinearZoomMaskType(maskType);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetNonLinearZoomMaskType()
{
	assert(g_sender != NULL);
	return g_sender->getNonLinearZoomMaskType();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetNonLinearZoomMaskSize(int width, int height)
{
	assert(g_sender != NULL);
	g_sender->setNonLinearZoomMaskSize(width, height);
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderGetNonLinearZoomMaskSize(int* width, int* height)
{
	assert(g_sender != NULL);
	g_sender->getNonLinearZoomMaskSize(*width, *height);
}
//------------------------------------------------------------------------------
// Image Compound
FSSENDERPROC void MVSTD
fsSenderSetImageCompoundBaseVideoResolution(int videoResolution)
{
	assert(g_sender != NULL);
	g_sender->setImageCompoundBaseVideoResolution(videoResolution);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetImageCompoundBaseVideoResolution()
{
	assert(g_sender != NULL);
	return g_sender->getImageCompoundBaseVideoResolution();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetImageCompoundAdditionalVideoResolution(int videoResolution)
{
	assert(g_sender != NULL);
	g_sender->setImageCompoundAdditionalVideoResolution(videoResolution);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetImageCompoundAdditionalVideoResolution()
{
	assert(g_sender != NULL);
	return g_sender->getImageCompoundAdditionalVideoResolution();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetImageCompoundMaskType(int maskType)
{
	assert(g_sender != NULL);
	g_sender->setImageCompoundMaskType(maskType);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetImageCompoundMaskType()
{
	assert(g_sender != NULL);
	return g_sender->getImageCompoundMaskType();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetImageCompoundBlendingType(int blendingType)
{
	assert(g_sender != NULL);
	g_sender->setImageCompoundBlendingType(blendingType);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetImageCompoundBlendingType()
{
	assert(g_sender != NULL);
	return g_sender->getImageCompoundBlendingType();
}
//------------------------------------------------------------------------------
// Other Settings
FSSENDERPROC void MVSTD
fsSenderSetFocusCoordinate(int coordinate)
{
	assert(g_sender != NULL);
	g_sender->setFocusCoordinate(coordinate);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetFocusCoordinate()
{
	assert(g_sender != NULL);
	return g_sender->getFocusCoordinate();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderComputeFocusRegion()
{
	assert(g_sender != NULL);
	g_sender->computeFocusRegion();
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Direct Video Mode Settings
//
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetDirectVideoModeOn(bool flag)
{
	assert(g_sender != NULL);
	g_sender->setDirectVideoModeOn(flag);
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderGetDirectVideoModeOn()
{
	assert(g_sender != NULL);
	return g_sender->getDirectVideoModeOn();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetDVInterleavedModeOn(bool flag)
{
	assert(g_sender != NULL);
	g_sender->setDVInterleavedModeOn(flag);
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderGetDVInterleavedModeOn()
{
	assert(g_sender != NULL);
	return g_sender->getDVInterleavedModeOn();
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderIsValidDVInterleavedMode()
{
	assert(g_sender != NULL);
	return g_sender->isValidDVInterleavedMode();
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Caption Settings
//
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetCaptionOn(bool flag)
{
	assert(g_sender != NULL);
	g_sender->setCaptionOn(flag);
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderGetCaptionOn()
{
	assert(g_sender != NULL);
	return g_sender->getCaptionOn();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetCaption(const char* caption)
{
	assert(g_sender != NULL);
	g_sender->setCaption(caption);
}
//------------------------------------------------------------------------------
FSSENDERPROC const char* MVSTD
fsSenderGetCaption()
{
	assert(g_sender != NULL);
	MXSTR2STR(str, g_sender->getCaption());
	return str;
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Video Window Settings
//
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetVideoWindowPolicy(int policy)
{
	assert(g_sender != NULL);
	g_sender->setVideoWindowPolicy(policy);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetVideoWindowPolicy()
{
	assert(g_sender != NULL);
	return g_sender->getVideoWindowPolicy();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetKeepVideoAspect(bool flag)
{
	assert(g_sender != NULL);
	g_sender->setKeepVideoAspect(flag);
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderGetKeepVideoAspect()
{
	assert(g_sender != NULL);
	return g_sender->getKeepVideoAspect();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetFitWindowToVideo(bool flag)
{
	assert(g_sender != NULL);
	g_sender->setFitWindowToVideo(flag);
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderGetFitWindowToVideo()
{
	assert(g_sender != NULL);
	return g_sender->getFitWindowToVideo();
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderComputeVideoWindow()
{
	assert(g_sender != NULL);
	g_sender->computeVideoWindow();
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
// Volume Settings
//
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderGetVolume(int* left, int* right)
{
	assert(g_sender != NULL);
	g_sender->getVolume(*left, *right);
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderSetVolumeEvaluationTime(int evalTime)
{
	assert(g_sender != NULL);
	g_sender->setVolumeEvaluationTime(evalTime);
}
//------------------------------------------------------------------------------
FSSENDERPROC int MVSTD
fsSenderGetVolumeEvaluationTime()
{
	assert(g_sender != NULL);
	return g_sender->getVolumeEvaluationTime();
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// Quit
FSSENDERPROC bool MVSTD
fsSenderCheckQuit()
{
	assert(g_sender != NULL);
	return g_sender->checkQuit();
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Status
FSSENDERPROC void MVSTD
fsSenderSendStatus()
{
	assert(g_sender != NULL);
	g_sender->sendStatus();
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Ini File
FSSENDERPROC bool MVSTD
fsSenderWriteIniFile(const char* filename)
{
	assert(g_sender != NULL);
	return g_sender->writeIniFile(filename);
}
//------------------------------------------------------------------------------
FSSENDERPROC bool MVSTD
fsSenderReadIniFile(const char* filename)
{
	assert(g_sender != NULL);
	return g_sender->readIniFile(filename);
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderReadRegistry(const char* section, const char* entry, const char* defaultValue, char* value)
{
	assert(g_sender != NULL);
	mxString valueStr;
	g_sender->readRegistry(section, entry, defaultValue, valueStr);
	MXSTR2STR(value, valueStr);
}
//------------------------------------------------------------------------------
FSSENDERPROC void MVSTD
fsSenderWriteRegistry(const char* section, const char* entry, const char* value)
{
	assert(g_sender != NULL);
	g_sender->writeRegistry(section, entry, value);
}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Callback
FSSENDERPROC bool MVSTD
fsSenderSetUICallbackFunction(fsSenderUICallbackFunction func, void* data)
{
	assert(g_sender != NULL);
	return g_sender->setUICallbackFunction(func, data);
}
//------------------------------------------------------------------------------
