/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsSenderInterface_h__
#define __fsSenderInterface_h__
//------------------------------------------------------------------------------
#ifdef _WIN32
#ifdef FSSENDER_EXPORTS
#define	FSSENDERCLASS	__declspec(dllexport)
#define	FSSENDERPROC		extern "C" __declspec(dllexport)
#else
#define	FSSENDERCLASS	__declspec(dllimport)
#define	FSSENDERPROC		extern "C" __declspec(dllimport)
#endif
#else
#define	FSSENDERCLASS
#define	FSSENDERPROC
#endif
#define	MVSTD			__stdcall
//------------------------------------------------------------------------------

// Focus Display Type
#define FSSENDER_FSFD_NONE				0
#define FSSENDER_FSFD_PARTIAL_ZOOM		1
#define FSSENDER_FSFD_NON_LINEAR_ZOOM	2
#define FSSENDER_FSFD_IMAGE_COMPOUND	3
#define FSSENDER_NUM_FOCUSDISPLAY		4

// Video Resolution
#define FSSENDER_FSVR_SQCIF				0
#define FSSENDER_FSVR_QCIF				1
#define FSSENDER_FSVR_CIF				2
#define FSSENDER_FSVR_160x120			3
#define FSSENDER_FSVR_320x240			4
#define FSSENDER_FSVR_360x240			5
#define FSSENDER_FSVR_640x480			6
#define FSSENDER_FSVR_720x480			7
#define FSSENDER_FSVR_800x600			8
#define FSSENDER_FSVR_1024x768			9
#define FSSENDER_FSVR_1280x1024			10
#define FSSENDER_FSVR_1600x1200			11
#define FSSENDER_FSVR_HDTV720P			12
#define FSSENDER_FSVR_HDTV1080I			13
#define FSSENDER_FSVR_SDTV480P			14
#define FSSENDER_FSVR_SDTV480I			15
#define FSSENDER_FSVR_THROUGH			16
#define FSSENDER_NUM_VIDEORESOLUTION	17

// Mask Type
#define FSSENDER_FSMT_RECTANGLE			0
#define FSSENDER_FSMT_OVAL				1
#define FSSENDER_FSMT_CHECKERS			2
#define FSSENDER_NUM_MASKTYPE			3

// Blending Type
#define FSSENDER_FSBT_SIMPLE			0
#define FSSENDER_FSBT_BLENDING			1
#define FSSENDER_NUM_BLENDINGTYPE		2

// Video Window Policy
#define FSSENDER_FSVWP_FITTOWINDOW		0
#define FSSENDER_FSVWP_ORIGINALSIZE		1

// Coordinate
#define FSSENDER_FSC_DESKTOPWINDOW		0
#define FSSENDER_FSC_VIDEOWINDOW		1

// Priority (rsNamePriority::PriorityEnum)
#define FSSENDER_P_RECOMMEND			0
#define FSSENDER_P_GENERALLY			1
#define FSSENDER_P_NOTRECOMMEND			2

// Error Message Type (rsErrorMessage::TypeEnum)
#define FSSENDER_T_NONE					0
#define FSSENDER_T_WRONG_CAPTURE		1
#define FSSENDER_T_WRONG_ENCODER		2
#define FSSENDER_T_WRONG_MEDIATYPE		3
#define FSSENDER_T_NOTFOUND_DECODER		4
#define FSSENDER_T_UNEXPECTED			5

// Initialize / Shutdown
FSSENDERPROC bool MVSTD			fsSenderInitialize(HWND windowHandle);
FSSENDERPROC bool MVSTD			fsSenderShutdown();
FSSENDERPROC bool MVSTD			fsSenderIsInitialized();

//
// Streaming Control
//
FSSENDERPROC bool MVSTD			fsSenderGetValid();
FSSENDERPROC void MVSTD			fsSenderGetErrorMessage(int* id, int* type, char* message);
FSSENDERPROC void MVSTD			fsSenderSetStart(bool flag);
FSSENDERPROC bool MVSTD			fsSenderGetStart();
FSSENDERPROC void MVSTD			fsSenderSetVideoTransmissionOn(bool flag);
FSSENDERPROC bool MVSTD			fsSenderGetVideoTransmissionOn();
FSSENDERPROC void MVSTD			fsSenderSetAudioTransmissionOn(bool flag);
FSSENDERPROC bool MVSTD			fsSenderGetAudioTransmissionOn();
FSSENDERPROC void MVSTD			fsSenderSetFocusTransmissionOn(bool flag);
FSSENDERPROC bool MVSTD			fsSenderGetFocusTransmissionOn();

//
// Multicast Settings
//
FSSENDERPROC void MVSTD			fsSenderSetAddress(const char* address);
FSSENDERPROC const char* MVSTD	fsSenderGetAddress();
FSSENDERPROC void MVSTD			fsSenderSetTimeToLive(int ttl);
FSSENDERPROC int MVSTD			fsSenderGetTimeToLive();
FSSENDERPROC void MVSTD			fsSenderSetTransmissionCount(int count);
FSSENDERPROC int MVSTD			fsSenderGetTransmissionCount();
FSSENDERPROC void MVSTD			fsSenderSetPacketSize(int size);
FSSENDERPROC int MVSTD			fsSenderGetPacketSize();

// Create Address
FSSENDERPROC const char* MVSTD	fsSenderCreateIPv4Address();
FSSENDERPROC const char* MVSTD	fsSenderCreateIPv6Address();

// Video Sender (Main)
FSSENDERPROC void MVSTD			fsSenderSetVideoSenderMainMaxTransmissionRate(int rateInKBitPerSec);
FSSENDERPROC int MVSTD			fsSenderGetVideoSenderMainMaxTransmissionRate();
FSSENDERPROC int MVSTD			fsSenderGetVideoSenderMainTransmissionRate();
FSSENDERPROC int MVSTD			fsSenderGetVideoSenderMainFrameRate();

// Video Sender (Sub)
FSSENDERPROC void MVSTD			fsSenderSetVideoSenderSubMaxTransmissionRate(int rateInKBitPerSec);
FSSENDERPROC int MVSTD			fsSenderGetVideoSenderSubMaxTransmissionRate();
FSSENDERPROC int MVSTD			fsSenderGetVideoSenderSubTransmissionRate();
FSSENDERPROC int MVSTD			fsSenderGetVideoSenderSubFrameRate();

// Audio Sender
FSSENDERPROC void MVSTD			fsSenderSetAudioSenderMaxTransmissionRate(int rateInKBitPerSec);
FSSENDERPROC int MVSTD			fsSenderGetAudioSenderMaxTransmissionRate();
FSSENDERPROC int MVSTD			fsSenderGetAudioSenderTransmissionRate();
FSSENDERPROC int MVSTD			fsSenderGetAudioSenderFrameRate();

// Pointer Sender
FSSENDERPROC void MVSTD			fsSenderSetPointerSenderMaxTransmissionRate(int rateInKBitPerSec);
FSSENDERPROC int MVSTD			fsSenderGetPointerSenderMaxTransmissionRate();
FSSENDERPROC int MVSTD			fsSenderGetPointerSenderTransmissionRate();
FSSENDERPROC int MVSTD			fsSenderGetPointerSenderFrameRate();

// Status Sender
FSSENDERPROC void MVSTD			fsSenderSetStatusSenderMaxTransmissionRate(int rateInKBitPerSec);
FSSENDERPROC int MVSTD			fsSenderGetStatusSenderMaxTransmissionRate();

//
// Multicast Detector Settings
//
FSSENDERPROC bool MVSTD			fsSenderAddMulticastDetector(const char* address);
FSSENDERPROC bool MVSTD			fsSenderRemoveMulticastDetector(const char* address);
FSSENDERPROC bool MVSTD			fsSenderWasDetectedMulticast(const char* address);

//
// Source Settings
//

// Video Source
FSSENDERPROC int MVSTD			fsSenderGetNumVideoSources();
FSSENDERPROC void MVSTD			fsSenderSetVideoSource(int index);
FSSENDERPROC int MVSTD			fsSenderGetVideoSource();
FSSENDERPROC const char* MVSTD	fsSenderGetVideoSourceFriendlyName(int index);

// Audio Source
FSSENDERPROC int MVSTD			fsSenderGetNumAudioSources();
FSSENDERPROC void MVSTD			fsSenderSetAudioSource(int index);
FSSENDERPROC int MVSTD			fsSenderGetAudioSource();
FSSENDERPROC const char* MVSTD	fsSenderGetAudioSourceFriendlyName(int index);

// Video Source Property Page
FSSENDERPROC int MVSTD			fsSenderGetNumVideoSourcePropertyPages();
FSSENDERPROC const char* MVSTD	fsSenderGetVideoSourcePropertyPageName(int index);
FSSENDERPROC void MVSTD			fsSenderShowVideoSourcePropertyPage(HWND windowHandle, int index);

// Audio Source Property Page
FSSENDERPROC int MVSTD			fsSenderGetNumAudioSourcePropertyPages();
FSSENDERPROC const char* MVSTD	fsSenderGetAudioSourcePropertyPageName(int index);
FSSENDERPROC void MVSTD			fsSenderShowAudioSourcePropertyPage(HWND windowHandle, int index);

// Video Clip
FSSENDERPROC bool MVSTD			fsSenderIsPlayVideoClip();
FSSENDERPROC bool MVSTD			fsSenderPlayVideoClip(const char* filename);

// Sound File
FSSENDERPROC bool MVSTD			fsSenderIsPlaySoundFile();
FSSENDERPROC bool MVSTD			fsSenderPlaySoundFile(const char* filename);


//
// Encoder Settings
//

// Video Encoder
FSSENDERPROC int MVSTD			fsSenderGetNumVideoEncoder();
FSSENDERPROC void MVSTD			fsSenderSetVideoEncoder(int index);
FSSENDERPROC int MVSTD			fsSenderGetVideoEncoder();
FSSENDERPROC const char* MVSTD	fsSenderGetVideoEncoderFriendlyName(int index);
FSSENDERPROC int MVSTD			fsSenderGetVideoEncoderPriority(int index);

// Audio Encoder
FSSENDERPROC int MVSTD			fsSenderGetNumAudioEncoder();
FSSENDERPROC void MVSTD			fsSenderSetAudioEncoder(int index);
FSSENDERPROC int MVSTD			fsSenderGetAudioEncoder();
FSSENDERPROC const char* MVSTD	fsSenderGetAudioEncoderFriendlyName(int index);
FSSENDERPROC int MVSTD			fsSenderGetAudioEncoderPriority(int index);

//
// Focus Display Settings
//
FSSENDERPROC void MVSTD			fsSenderSetFocusDisplay(int focusDisplay);
FSSENDERPROC int MVSTD			fsSenderGetFocusDisplay();
FSSENDERPROC void MVSTD			fsSenderSetFocusFrameVisible(bool flag);
FSSENDERPROC bool MVSTD			fsSenderGetFocusFrameVisible();

// Video Resolution
FSSENDERPROC void MVSTD			fsSenderSetVideoResolution(int videoResolution);
FSSENDERPROC int MVSTD			fsSenderGetVideoResolution();

// Partial Zoom
FSSENDERPROC void MVSTD			fsSenderSetPartialZoomSourceVideoResolution(int videoResolution);
FSSENDERPROC int MVSTD			fsSenderGetPartialZoomSourceVideoResolution();
FSSENDERPROC void MVSTD			fsSenderSetPartialZoomOutputVideoResolution(int videoResolution);
FSSENDERPROC int MVSTD			fsSenderGetPartialZoomOutputVideoResolution();

// Non-Linear Zoom
FSSENDERPROC void MVSTD			fsSenderSetNonLinearZoomOutputVideoResolution(int videoResolution);
FSSENDERPROC int MVSTD			fsSenderGetNonLinearZoomOutputVideoResolution();
FSSENDERPROC void MVSTD			fsSenderSetNonLinearZoomMaskType(int maskType);
FSSENDERPROC int MVSTD			fsSenderGetNonLinearZoomMaskType();
FSSENDERPROC void MVSTD			fsSenderSetNonLinearZoomMaskSize(int width, int height);
FSSENDERPROC void MVSTD			fsSenderGetNonLinearZoomMaskSize(int* width, int* height);

// Image Compound
FSSENDERPROC void MVSTD			fsSenderSetImageCompoundBaseVideoResolution(int videoResolution);
FSSENDERPROC int MVSTD			fsSenderGetImageCompoundBaseVideoResolution();
FSSENDERPROC void MVSTD			fsSenderSetImageCompoundAdditionalVideoResolution(int videoResolution);
FSSENDERPROC int MVSTD			fsSenderGetImageCompoundAdditionalVideoResolution();
FSSENDERPROC void MVSTD			fsSenderSetImageCompoundMaskType(int maskType);
FSSENDERPROC int MVSTD			fsSenderGetImageCompoundMaskType();
FSSENDERPROC void MVSTD			fsSenderSetImageCompoundBlendingType(int blendingType);
FSSENDERPROC int MVSTD			fsSenderGetImageCompoundBlendingType();

// Other Settings
FSSENDERPROC void MVSTD			fsSenderSetFocusCoordinate(int coordinate);
FSSENDERPROC int MVSTD			fsSenderGetFocusCoordinate();
FSSENDERPROC void MVSTD			fsSenderComputeFocusRegion();

//
// Direct Video Mode Settings
//
FSSENDERPROC void MVSTD			fsSenderSetDirectVideoModeOn(bool flag);
FSSENDERPROC bool MVSTD			fsSenderGetDirectVideoModeOn();
FSSENDERPROC void MVSTD			fsSenderSetDVInterleavedModeOn(bool flag);
FSSENDERPROC bool MVSTD			fsSenderGetDVInterleavedModeOn();
FSSENDERPROC bool MVSTD			fsSenderIsValidDVInterleavedMode();

//
// Caption Settings
//
FSSENDERPROC void MVSTD			fsSenderSetCaptionOn(bool flag);
FSSENDERPROC bool MVSTD			fsSenderGetCaptionOn();
FSSENDERPROC void MVSTD			fsSenderSetCaption(const char* caption);
FSSENDERPROC const char* MVSTD	fsSenderGetCaption();

//
// Video Window Settings
//
FSSENDERPROC void MVSTD			fsSenderSetVideoWindowPolicy(int policy);
FSSENDERPROC int MVSTD			fsSenderGetVideoWindowPolicy();
FSSENDERPROC void MVSTD			fsSenderSetKeepVideoAspect(bool flag);
FSSENDERPROC bool MVSTD			fsSenderGetKeepVideoAspect();
FSSENDERPROC void MVSTD			fsSenderSetFitWindowToVideo(bool flag);
FSSENDERPROC bool MVSTD			fsSenderGetFitWindowToVideo();
FSSENDERPROC void MVSTD			fsSenderComputeVideoWindow();

//
// Volume Settings
//
FSSENDERPROC void MVSTD			fsSenderGetVolume(int* left, int* right);
FSSENDERPROC void MVSTD			fsSenderSetVolumeEvaluationTime(int evalTime);
FSSENDERPROC int MVSTD			fsSenderGetVolumeEvaluationTime();


// Quit
FSSENDERPROC bool MVSTD			fsSenderCheckQuit();

// Status
FSSENDERPROC void MVSTD			fsSenderSendStatus();

// Ini File
FSSENDERPROC bool MVSTD			fsSenderWriteIniFile(const char* filename);
FSSENDERPROC bool MVSTD			fsSenderReadIniFile(const char* filename);
FSSENDERPROC void MVSTD			fsSenderReadRegistry(const char* section, const char* entry, const char* defaultValue, char* value);
FSSENDERPROC void MVSTD			fsSenderWriteRegistry(const char* section, const char* entry, const char* value);

// Callback
typedef int (*fsSenderUICallbackFunction)(const char*, void*, void*);
FSSENDERPROC bool MVSTD			fsSenderSetUICallbackFunction(fsSenderUICallbackFunction func, void* data);

//------------------------------------------------------------------------------
#endif  //__fsSenderInterface_h__
