/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsSenderSkel_h__
#define __fsSenderSkel_h__
//------------------------------------------------------------------------------
#include <fs/fsSenderRMI/fsSenderRMI.h>
#include <fs/fsMulticastTools/fsRemoteObject.h>
#include <mx/mxCore/mxObject.h>
//------------------------------------------------------------------------------
class fsSenderIf;
class fsSenderSkel;
typedef mxObjectPtr<fsSenderSkel>	fsSenderSkelPtr;
//------------------------------------------------------------------------------
class FSSENDERRMICLASS fsSenderSkel : public mxObject
{
	MXOBJECTHEADER(fsSenderSkel, mxObject);

public:
	fsSenderSkel(fsSenderIf* sender);

protected:
	virtual ~fsSenderSkel();

public:
	mxBool				open();
	mxBool				close();
	void				setRMIProperty(const fsRMIPropertyPtr& property);
	const fsRMIPropertyPtr&	getRMIProperty() const;

public:
	const fsSenderIf*	getSender() const;

protected:
	virtual void		invoke(const mxString& method,
								fsInvokeData& param,
								fsInvokeData& retVal);
	static void			invokeProc(const mxString& method,
								fsInvokeData& param,
								fsInvokeData& retVal,
								void *data);

protected:
	fsRemoteObjectPtr	_rObject;
	fsSenderIf*			_sender;
};
//------------------------------------------------------------------------------
#endif //__fsSenderSkel_h__
