/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsSenderRemote_h__
#define __fsSenderRemote_h__
//------------------------------------------------------------------------------
#include <fs/fsSenderRMI/fsSenderStub.h>
//------------------------------------------------------------------------------
class fsSenderRemote;
typedef mxObjectPtr<fsSenderRemote>	fsSenderRemotePtr;
//------------------------------------------------------------------------------
class fsSenderRemote : public fsSenderStub
{
	MXOBJECTHEADER(fsSenderRemote, fsSenderStub);

public:
	fsSenderRemote();

protected:
	virtual ~fsSenderRemote();

public:
	// Callback
	typedef int (*fsSenderUICallbackFunction)(const char*, void*, void*);
	mxBool		setUICallbackFunction(fsSenderUICallbackFunction func, void* data);

	// IniFile
	mxBool		writeIniFile(const mxString& filename);
	mxBool		readIniFile(const mxString& filename);

	// Registry
	void		writeRegistry(const mxString& section, const mxString& entry,
							const mxString& value);
	void		readRegistry(const mxString& section, const mxString& entry,
							const mxString& defaultValue, mxString& value);

protected:
	void		invokeNotify(const mxString& method, mxBool result);

protected:
	fsSenderUICallbackFunction	_UICallbackFunction;
	void*						_UICallbackData;
};
//------------------------------------------------------------------------------
#endif //__fsSenderRemote_h__
