/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsSenderRemoteInterface_h__
#define __fsSenderRemoteInterface_h__
//------------------------------------------------------------------------------
#ifdef _WIN32
#ifdef FSSENDERREMOTE_EXPORTS
#define	FSSENDERREMOTECLASS	__declspec(dllexport)
#define	FSSENDERREMOTEPROC		extern "C" __declspec(dllexport)
#else
#define	FSSENDERREMOTECLASS	__declspec(dllimport)
#define	FSSENDERREMOTEPROC		extern "C" __declspec(dllimport)
#endif
#else
#define	FSSENDERREMOTECLASS
#define	FSSENDERREMOTEPROC
#endif
#define	MVSTD			__stdcall
//------------------------------------------------------------------------------

// Focus Display Type
#define FSSENDER_FSFD_NONE				0
#define FSSENDER_FSFD_PARTIAL_ZOOM		1
#define FSSENDER_FSFD_NON_LINEAR_ZOOM	2
#define FSSENDER_FSFD_IMAGE_COMPOUND	3
#define FSSENDER_NUM_FOCUSDISPLAY		4

// Video Resolution
#define FSSENDER_FSVR_SQCIF				0
#define FSSENDER_FSVR_QCIF				1
#define FSSENDER_FSVR_CIF				2
#define FSSENDER_FSVR_160x120			3
#define FSSENDER_FSVR_320x240			4
#define FSSENDER_FSVR_360x240			5
#define FSSENDER_FSVR_640x480			6
#define FSSENDER_FSVR_720x480			7
#define FSSENDER_FSVR_800x600			8
#define FSSENDER_FSVR_1024x768			9
#define FSSENDER_FSVR_1280x1024			10
#define FSSENDER_FSVR_1600x1200			11
#define FSSENDER_FSVR_HDTV720P			12
#define FSSENDER_FSVR_HDTV1080I			13
#define FSSENDER_FSVR_SDTV480P			14
#define FSSENDER_FSVR_SDTV480I			15
#define FSSENDER_FSVR_THROUGH			16
#define FSSENDER_NUM_VIDEORESOLUTION	17

// Mask Type
#define FSSENDER_FSMT_RECTANGLE			0
#define FSSENDER_FSMT_OVAL				1
#define FSSENDER_FSMT_CHECKERS			2
#define FSSENDER_NUM_MASKTYPE			3

// Blending Type
#define FSSENDER_FSBT_SIMPLE			0
#define FSSENDER_FSBT_BLENDING			1
#define FSSENDER_NUM_BLENDINGTYPE		2

// Video Window Policy
#define FSSENDER_FSVWP_FITTOWINDOW		0
#define FSSENDER_FSVWP_ORIGINALSIZE		1

// Coordinate
#define FSSENDER_FSC_DESKTOPWINDOW		0
#define FSSENDER_FSC_VIDEOWINDOW		1

// Priority (rsNamePriority::PriorityEnum)
#define FSSENDER_P_RECOMMEND			0
#define FSSENDER_P_GENERALLY			1
#define FSSENDER_P_NOTRECOMMEND			2

// Error Message Type (rsErrorMessage::TypeEnum)
#define FSSENDER_T_NONE					0
#define FSSENDER_T_WRONG_CAPTURE		1
#define FSSENDER_T_WRONG_ENCODER		2
#define FSSENDER_T_WRONG_MEDIATYPE		3
#define FSSENDER_T_NOTFOUND_DECODER		4
#define FSSENDER_T_UNEXPECTED			5


// Initialize / Shutdown
FSSENDERREMOTEPROC bool MVSTD			fsSenderInitialize();
FSSENDERREMOTEPROC bool MVSTD			fsSenderShutdown();
FSSENDERREMOTEPROC bool MVSTD			fsSenderIsInitialized();


//
// Streaming Control
//
FSSENDERREMOTEPROC bool MVSTD			fsSenderGetValid();
FSSENDERREMOTEPROC void MVSTD			fsSenderGetErrorMessage(int* id, int* type, char* message);
FSSENDERREMOTEPROC void MVSTD			fsSenderSetStart(bool flag);
FSSENDERREMOTEPROC bool MVSTD			fsSenderGetStart();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetVideoTransmissionOn(bool flag);
FSSENDERREMOTEPROC bool MVSTD			fsSenderGetVideoTransmissionOn();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetAudioTransmissionOn(bool flag);
FSSENDERREMOTEPROC bool MVSTD			fsSenderGetAudioTransmissionOn();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetFocusTransmissionOn(bool flag);
FSSENDERREMOTEPROC bool MVSTD			fsSenderGetFocusTransmissionOn();

//
// Multicast Settings
//
FSSENDERREMOTEPROC void MVSTD			fsSenderSetAddress(const char* address);
FSSENDERREMOTEPROC const char* MVSTD	fsSenderGetAddress();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetTimeToLive(int ttl);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetTimeToLive();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetTransmissionCount(int count);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetTransmissionCount();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetPacketSize(int size);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetPacketSize();

// Create Address
FSSENDERREMOTEPROC const char* MVSTD	fsSenderCreateIPv4Address();
FSSENDERREMOTEPROC const char* MVSTD	fsSenderCreateIPv6Address();

// Video Sender (Main)
FSSENDERREMOTEPROC void MVSTD			fsSenderSetVideoSenderMainMaxTransmissionRate(int rateInKBitPerSec);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetVideoSenderMainMaxTransmissionRate();
FSSENDERREMOTEPROC int MVSTD			fsSenderGetVideoSenderMainTransmissionRate();
FSSENDERREMOTEPROC int MVSTD			fsSenderGetVideoSenderMainFrameRate();

// Video Sender (Sub)
FSSENDERREMOTEPROC void MVSTD			fsSenderSetVideoSenderSubMaxTransmissionRate(int rateInKBitPerSec);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetVideoSenderSubMaxTransmissionRate();
FSSENDERREMOTEPROC int MVSTD			fsSenderGetVideoSenderSubTransmissionRate();
FSSENDERREMOTEPROC int MVSTD			fsSenderGetVideoSenderSubFrameRate();

// Audio Sender
FSSENDERREMOTEPROC void MVSTD			fsSenderSetAudioSenderMaxTransmissionRate(int rateInKBitPerSec);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetAudioSenderMaxTransmissionRate();
FSSENDERREMOTEPROC int MVSTD			fsSenderGetAudioSenderTransmissionRate();
FSSENDERREMOTEPROC int MVSTD			fsSenderGetAudioSenderFrameRate();

// Pointer Sender
FSSENDERREMOTEPROC void MVSTD			fsSenderSetPointerSenderMaxTransmissionRate(int rateInKBitPerSec);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetPointerSenderMaxTransmissionRate();
FSSENDERREMOTEPROC int MVSTD			fsSenderGetPointerSenderTransmissionRate();
FSSENDERREMOTEPROC int MVSTD			fsSenderGetPointerSenderFrameRate();

// Status Sender
FSSENDERREMOTEPROC void MVSTD			fsSenderSetStatusSenderMaxTransmissionRate(int rateInKBitPerSec);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetStatusSenderMaxTransmissionRate();

//
// Multicast Detector Settings
//
FSSENDERREMOTEPROC bool MVSTD			fsSenderAddMulticastDetector(const char* address);
FSSENDERREMOTEPROC bool MVSTD			fsSenderRemoveMulticastDetector(const char* address);
FSSENDERREMOTEPROC bool MVSTD			fsSenderWasDetectedMulticast(const char* address);

//
// Source Settings
//

// Video Source
FSSENDERREMOTEPROC int MVSTD			fsSenderGetNumVideoSources();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetVideoSource(int index);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetVideoSource();
FSSENDERREMOTEPROC const char* MVSTD	fsSenderGetVideoSourceFriendlyName(int index);

// Audio Source
FSSENDERREMOTEPROC int MVSTD			fsSenderGetNumAudioSources();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetAudioSource(int index);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetAudioSource();
FSSENDERREMOTEPROC const char* MVSTD	fsSenderGetAudioSourceFriendlyName(int index);

// Video Source Property Page
FSSENDERREMOTEPROC int MVSTD			fsSenderGetNumVideoSourcePropertyPages();
FSSENDERREMOTEPROC const char* MVSTD	fsSenderGetVideoSourcePropertyPageName(int index);
FSSENDERREMOTEPROC void MVSTD			fsSenderShowVideoSourcePropertyPage(HWND windowHandle, int index);

// Audio Source Property Page
FSSENDERREMOTEPROC int MVSTD			fsSenderGetNumAudioSourcePropertyPages();
FSSENDERREMOTEPROC const char* MVSTD	fsSenderGetAudioSourcePropertyPageName(int index);
FSSENDERREMOTEPROC void MVSTD			fsSenderShowAudioSourcePropertyPage(HWND windowHandle, int index);

// Video Clip
FSSENDERREMOTEPROC bool MVSTD			fsSenderIsPlayVideoClip();
FSSENDERREMOTEPROC bool MVSTD			fsSenderPlayVideoClip(const char* filename);

// Sound File
FSSENDERREMOTEPROC bool MVSTD			fsSenderIsPlaySoundFile();
FSSENDERREMOTEPROC bool MVSTD			fsSenderPlaySoundFile(const char* filename);


//
// Encoder Settings
//

// Video Encoder
FSSENDERREMOTEPROC int MVSTD			fsSenderGetNumVideoEncoder();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetVideoEncoder(int index);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetVideoEncoder();
FSSENDERREMOTEPROC const char* MVSTD	fsSenderGetVideoEncoderFriendlyName(int index);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetVideoEncoderPriority(int index);

// Audio Encoder
FSSENDERREMOTEPROC int MVSTD			fsSenderGetNumAudioEncoder();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetAudioEncoder(int index);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetAudioEncoder();
FSSENDERREMOTEPROC const char* MVSTD	fsSenderGetAudioEncoderFriendlyName(int index);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetAudioEncoderPriority(int index);

//
// Focus Display Settings
//
FSSENDERREMOTEPROC void MVSTD			fsSenderSetFocusDisplay(int focusDisplay);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetFocusDisplay();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetFocusFrameVisible(bool flag);
FSSENDERREMOTEPROC bool MVSTD			fsSenderGetFocusFrameVisible();

// Video Resolution
FSSENDERREMOTEPROC void MVSTD			fsSenderSetVideoResolution(int videoResolution);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetVideoResolution();

// Partial Zoom
FSSENDERREMOTEPROC void MVSTD			fsSenderSetPartialZoomSourceVideoResolution(int videoResolution);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetPartialZoomSourceVideoResolution();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetPartialZoomOutputVideoResolution(int videoResolution);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetPartialZoomOutputVideoResolution();

// Non-Linear Zoom
FSSENDERREMOTEPROC void MVSTD			fsSenderSetNonLinearZoomOutputVideoResolution(int videoResolution);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetNonLinearZoomOutputVideoResolution();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetNonLinearZoomMaskType(int maskType);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetNonLinearZoomMaskType();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetNonLinearZoomMaskSize(int width, int height);
FSSENDERREMOTEPROC void MVSTD			fsSenderGetNonLinearZoomMaskSize(int* width, int* height);

// Image Compound
FSSENDERREMOTEPROC void MVSTD			fsSenderSetImageCompoundBaseVideoResolution(int videoResolution);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetImageCompoundBaseVideoResolution();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetImageCompoundAdditionalVideoResolution(int videoResolution);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetImageCompoundAdditionalVideoResolution();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetImageCompoundMaskType(int maskType);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetImageCompoundMaskType();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetImageCompoundBlendingType(int blendingType);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetImageCompoundBlendingType();

// Other Settings
FSSENDERREMOTEPROC void MVSTD			fsSenderSetFocusCoordinate(int coordinate);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetFocusCoordinate();
FSSENDERREMOTEPROC void MVSTD			fsSenderComputeFocusRegion();

//
// Direct Video Mode Settings
//
FSSENDERREMOTEPROC void MVSTD			fsSenderSetDirectVideoModeOn(bool flag);
FSSENDERREMOTEPROC bool MVSTD			fsSenderGetDirectVideoModeOn();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetDVInterleavedModeOn(bool flag);
FSSENDERREMOTEPROC bool MVSTD			fsSenderGetDVInterleavedModeOn();
FSSENDERREMOTEPROC bool MVSTD			fsSenderIsValidDVInterleavedMode();

//
// Caption Settings
//
FSSENDERREMOTEPROC void MVSTD			fsSenderSetCaptionOn(bool flag);
FSSENDERREMOTEPROC bool MVSTD			fsSenderGetCaptionOn();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetCaption(const char* caption);
FSSENDERREMOTEPROC const char* MVSTD	fsSenderGetCaption();

//
// Video Window Settings
//
FSSENDERREMOTEPROC void MVSTD			fsSenderSetVideoWindowPolicy(int policy);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetVideoWindowPolicy();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetKeepVideoAspect(bool flag);
FSSENDERREMOTEPROC bool MVSTD			fsSenderGetKeepVideoAspect();
FSSENDERREMOTEPROC void MVSTD			fsSenderSetFitWindowToVideo(bool flag);
FSSENDERREMOTEPROC bool MVSTD			fsSenderGetFitWindowToVideo();
FSSENDERREMOTEPROC void MVSTD			fsSenderComputeVideoWindow();

//
// Volume Settings
//
FSSENDERREMOTEPROC void MVSTD			fsSenderGetVolume(int* left, int* right);
FSSENDERREMOTEPROC void MVSTD			fsSenderSetVolumeEvaluationTime(int evalTime);
FSSENDERREMOTEPROC int MVSTD			fsSenderGetVolumeEvaluationTime();

//
// Other
//
FSSENDERREMOTEPROC void MVSTD			fsSenderQuit();


// Ini File
FSSENDERREMOTEPROC bool MVSTD			fsSenderWriteIniFile(const char* filename);
FSSENDERREMOTEPROC bool MVSTD			fsSenderReadIniFile(const char* filename);
FSSENDERREMOTEPROC void MVSTD			fsSenderReadRegistry(const char* section, const char* entry, const char* defaultValue, char* value);
FSSENDERREMOTEPROC void MVSTD			fsSenderWriteRegistry(const char* section, const char* entry, const char* value);

// Callback
typedef int (*fsSenderUICallbackFunction)(const char*, void*, void*);
FSSENDERREMOTEPROC bool MVSTD			fsSenderSetUICallbackFunction(fsSenderUICallbackFunction func, void* data);

//------------------------------------------------------------------------------
#endif  //__fsSenderRemoteInterface_h__
