/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsStatus_h__
#define __fsStatus_h__
//------------------------------------------------------------------------------
#ifdef _WIN32
#ifdef FSSTATUS_EXPORTS
#define	FSSTATUSCLASS	__declspec(dllexport)
#define	FSSTATUSPROC	extern "C" __declspec(dllexport)
#else
#define	FSSTATUSCLASS	__declspec(dllimport)
#define	FSSTATUSPROC	extern "C" __declspec(dllimport)
#endif
#else
#define	FSSTATUSCLASS
#define	FSSTATUSPROC
#endif
//------------------------------------------------------------------------------
#define FSSTATUS_UNIQUEID	0x1930acbe
//------------------------------------------------------------------------------
#include <mx/mxCore/mxString.h>
//------------------------------------------------------------------------------
#define S_DIRECTVIDEOMODEON						0x00000001
#define S_DVINTERLEAVEDMODEON					0x00000002
#define S_FOCUSDISPLAY							0x00000004
#define S_PARTIALZOOMOUTPUTVIDEORESOLUTION		0x00000008
#define S_NONLINEARZOOMOUTPUTVIDEORESOLUTION	0x00000010
#define S_NONLINEARZOOMMASKTYPE					0x00000020
#define S_NONLINEARZOOMMASKWIDTH				0x00000040
#define S_NONLINEARZOOMMASKHEIGHT				0x00000080
#define S_IMAGECOMPOUNDOUTPUTVIDEORESOLUTION	0x00000100
#define S_IMAGECOMPOUNDMASKTYPE					0x00000200
#define S_IMAGECOMPOUNDBLENDINGTYPE				0x00000400
#define S_MULTICASTADDRESS						0x00000800
//------------------------------------------------------------------------------
class FSSTATUSCLASS fsStatus
{
public:
	fsStatus();
	~fsStatus();
    
public:
	mxBool		DirectVideoModeOn;
	mxBool		DvInterleavedModeOn;
	mxInt		FocusDisplay;
	mxInt		PartialZoomOutputVideoResolution;
	mxInt		NonLinearZoomOutputVideoResolution;
	mxInt		NonLinearZoomMaskType;
	mxUInt		NonLinearZoomMaskWidth;
	mxUInt		NonLinearZoomMaskHeight;
	mxInt		ImageCompoundOutputVideoResolution;
	mxInt		ImageCompoundMaskType;
	mxInt		ImageCompoundBlendingType;
	mxString	MulticastAddress;
};
//------------------------------------------------------------------------------
#endif	//__fsStatus_h__
