/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsStatusReceiver_h__
#define __fsStatusReceiver_h__
//------------------------------------------------------------------------------
#include <fs/fsStatus/fsStatus.h>
#include <mx/mxCore/mxString.h>
#include <mx/mxCore/mxObject.h>
#include <mx/mxCore/mxThread.h>
#include <flNetwork/flFMTReceiver.h>
#include <flBase/flByteStream.h>
//------------------------------------------------------------------------------
class fsStatusReceiver;
typedef mxObjectPtr<fsStatusReceiver>	fsStatusReceiverPtr;
//------------------------------------------------------------------------------
class FSSTATUSCLASS fsStatusReceiver : public mxObject
{
	MXOBJECTHEADER(fsStatusReceiver, mxObject);

public:
	typedef void	(*StatusProc)(mxInt changed, const fsStatus& status, void *data);

public:
	fsStatusReceiver(StatusProc statusProc, void *statusData);

protected:
	virtual ~fsStatusReceiver();

public:
	void			setAddress(const mxString& address);
	mxString		getAddress() const;
	void			setPort(mxUShort port);
	mxUShort		getPort() const;
	void			setTimeToLive(mxULong ttl);
	mxULong			getTimeToLive() const;

	mxUInt			getNumRejectionAddress() const;
	mxString		getRejectionAddress(mxUInt index) const;
	void			addRejectionAddress(const mxString& address);
	void			removeRejectionAddress(mxUInt index);
	void			removeAllRejectionAddress();

	void			setReceiveOn(mxBool flag);
	mxBool			getReceiveOn() const;

	mxBool			open();
	mxBool			close();
	mxBool			isOpen() const;

protected:
	void			receive(flChar *data, flUInt dataSize);

protected:
	mxUInt			threadLoop();
	static mxUInt __stdcall	threadLoopProc(void* data);

protected:
	flFMTReceiver*		_receiver;
	fsStatus			_status;
	mxBool				_isOpen;
	mxBool				_receiveOn;

	StatusProc			_statusProc;
	void*				_statusData;

	mxBool				_threadRun;
	mxThread*			_thread;

	flInputByteStream	_iStream;
};
//------------------------------------------------------------------------------
#endif //__fsStatusReceiver_h__
