/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef __fsStatusSender_h__
#define __fsStatusSender_h__
//------------------------------------------------------------------------------
#include <fs/fsStatus/fsStatus.h>
#include <mx/mxCore/mxString.h>
#include <mx/mxCore/mxObject.h>
#include <flNetwork/flFMTSender.h>
#include <flBase/flByteStream.h>
//------------------------------------------------------------------------------
class fsStatusSender;
typedef mxObjectPtr<fsStatusSender>	fsStatusSenderPtr;
//------------------------------------------------------------------------------
class FSSTATUSCLASS fsStatusSender : public mxObject
{
	MXOBJECTHEADER(fsStatusSender, mxObject);

public:
	fsStatusSender();

protected:
	virtual ~fsStatusSender();

public:
	void			setAddress(const mxString& address);
	mxString		getAddress() const;
	void			setPort(mxUShort port);
	mxUShort		getPort() const;
	void			setTimeToLive(mxULong ttl);
	mxULong			getTimeToLive() const;
	void			setMaxTransmissionRate(mxUInt rate);
	mxUInt			getMaxTransmissionRate() const;
	void			setTransmissionCount(mxUInt count);
	mxUInt			getTransmissionCount() const;
	void			setPacketSize(mxUInt size);
	mxUInt			getPacketSize() const;

	void			setTransmissionOn(mxBool flag);
	mxBool			getTransmissionOn() const;

	mxBool			open();
	mxBool			close();
	mxBool			isOpen() const;

public:
	void			send(const fsStatus& status);

protected:
	flFMTSender*		_sender;
	mxBool				_isOpen;
	mxBool				_transmissionOn;

	flOutputByteStream	_oStream;
};
//------------------------------------------------------------------------------
#endif //__fsStatusSender_h__
