/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "StdAfx.h"
#include <mx/mxCore/mxByteSwap.h>
//------------------------------------------------------------------------------
mxShort
mxByteSwap::swap(const mxShort& v)
{
	return
		((v & 0xff00)>>8) +
		((v & 0x00ff)<<8);
}
//------------------------------------------------------------------------------
mxUShort
mxByteSwap::swap(const mxUShort& v)
{
	return
		((v & 0xff00)>>8) +
		((v & 0x00ff)<<8);
}
//------------------------------------------------------------------------------
mxLong
mxByteSwap::swap(const mxLong& v)
{
	return
		((v & 0xff000000)>>24) +
		((v & 0x00ff0000)>> 8) +
		((v & 0x0000ff00)<< 8) +
		((v & 0x000000ff)<<24);
}
//------------------------------------------------------------------------------
mxULong
mxByteSwap::swap(const mxULong& v)
{
	return
		((v & 0xff000000)>>24) +
		((v & 0x00ff0000)>> 8) +
		((v & 0x0000ff00)<< 8) +
		((v & 0x000000ff)<<24);
}
//------------------------------------------------------------------------------
mxInt
mxByteSwap::swap(const mxInt& v)
{
	return
		((v & 0xff000000)>>24) +
		((v & 0x00ff0000)>> 8) +
		((v & 0x0000ff00)<< 8) +
		((v & 0x000000ff)<<24);
}
//------------------------------------------------------------------------------
mxUInt
mxByteSwap::swap(const mxUInt& v)
{
	return
		((v & 0xff000000)>>24) +
		((v & 0x00ff0000)>> 8) +
		((v & 0x0000ff00)<< 8) +
		((v & 0x000000ff)<<24);
}
//------------------------------------------------------------------------------
mxInt64
mxByteSwap::swap(const mxInt64& v)
{
	return
		((v & 0xff00000000000000)>>56) +
		((v & 0x00ff000000000000)>>40) +
		((v & 0x0000ff0000000000)>>24) +
		((v & 0x000000ff00000000)>> 8) +
		((v & 0x00000000ff000000)<< 8) +
		((v & 0x0000000000ff0000)<<24) +
		((v & 0x000000000000ff00)<<40) +
		((v & 0x00000000000000ff)<<56);
}
//------------------------------------------------------------------------------
mxUInt64
mxByteSwap::swap(const mxUInt64& v)
{
	return
		((v & 0xff00000000000000)>>56) +
		((v & 0x00ff000000000000)>>40) +
		((v & 0x0000ff0000000000)>>24) +
		((v & 0x000000ff00000000)>> 8) +
		((v & 0x00000000ff000000)<< 8) +
		((v & 0x0000000000ff0000)<<24) +
		((v & 0x000000000000ff00)<<40) +
		((v & 0x00000000000000ff)<<56);
}
//------------------------------------------------------------------------------
mxFloat
mxByteSwap::swap(const mxFloat& v)
{
	mxLong* lv = (mxLong*)&v;
	mxLong l =
		(((*lv) & 0xff000000)>>24) +
		(((*lv) & 0x00ff0000)>> 8) +
		(((*lv) & 0x0000ff00)<< 8) +
		(((*lv) & 0x000000ff)<<24);
	return *((mxFloat*)&l);
}
//------------------------------------------------------------------------------
mxDouble
mxByteSwap::swap(const mxDouble& v)
{
	mxInt64* llv = (mxInt64*)&v;
	mxInt64 ll = 0;
	ll |= (((*llv) & 0xff00000000000000)>>56);
	ll |= (((*llv) & 0x00ff000000000000)>>40);
	ll |= (((*llv) & 0x0000ff0000000000)>>24);
	ll |= (((*llv) & 0x000000ff00000000)>> 8);
	ll |= (((*llv) & 0x00000000ff000000)<< 8);
	ll |= (((*llv) & 0x0000000000ff0000)<<24);
	ll |= (((*llv) & 0x000000000000ff00)<<40);
	ll |= (((*llv) & 0x00000000000000ff)<<56);
	return *((mxDouble*)&ll);
}
//------------------------------------------------------------------------------
