/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef	__mxCore_h__
#define	__mxCore_h__
//------------------------------------------------------------------------------
#pragma warning(disable: 4251)
#pragma warning(disable: 4311)
#pragma warning(disable: 4312)
//------------------------------------------------------------------------------
#include <windows.h>
#include <cstdio>
#include <typeinfo>
#include <cassert>
//------------------------------------------------------------------------------
#ifdef _WIN32
#ifdef MXCORE_EXPORTS
#define	MXCORECLASS	__declspec(dllexport)
#define	MXCOREPROC	extern "C" __declspec(dllexport)
#else
#define	MXCORECLASS	__declspec(dllimport)
#define	MXCOREPROC	extern "C" __declspec(dllimport)
#endif
#else
#define	MXCORECLASS
#define	MXCOREPROC
#endif
//------------------------------------------------------------------------------
typedef bool					mxBool;
typedef char					mxChar;
typedef unsigned char			mxByte;
typedef short					mxShort;
typedef unsigned short			mxUShort;
typedef long					mxLong;
typedef unsigned long			mxULong;
typedef int						mxInt;
typedef unsigned int			mxUInt;
#ifdef _WIN32
typedef __int32					mxInt32;
typedef unsigned __int32		mxUInt32;
typedef __int64					mxInt64;
typedef unsigned __int64		mxUInt64;
#else
typedef long					mxInt32;
typedef unsigned long			mxUInt32;
typedef long long				mxInt64;
typedef unsigned long long		mxUInt64;
#endif
typedef float					mxFloat;
typedef double					mxDouble;
#ifdef __BORLANDC__
typedef const std::type_info&	mxClassType;
#else
typedef const type_info&		mxClassType;
#endif
//------------------------------------------------------------------------------
template<class T> inline const T mxMax(const T& x, const T& y)
{ return x > y ? x : y; }
//------------------------------------------------------------------------------
template<class T> inline const T mxMin(const T& x, const T& y)
{ return x < y ? x : y; }
//------------------------------------------------------------------------------
template<class T> inline void mxSwap(T& x, T& y)
{ T t; t = x; x = y; y = t; }
//------------------------------------------------------------------------------
class MXCORECLASS mxCore
{
public:
	static mxBool	initialize();
	static mxBool	shutdown();

private:
    mxCore();
};
//------------------------------------------------------------------------------
#endif	// !__mxCore_h__
