/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef	__mxFile_h__
#define	__mxFile_h__
//------------------------------------------------------------------------------
#include <mx/mxCore/mxString.h>
#include <mx/mxCore/mxArray.h>
#include <cstdio>
//------------------------------------------------------------------------------
class MXCORECLASS mxFile
{
public:
	enum ModeEnum
	{
		READ,
		WRITE,
		APPEND
	};

	mxFile();
	virtual ~mxFile();

public:
	virtual mxBool	open(const mxString& filename, ModeEnum mode);
	virtual mxBool	close();
	mxBool			isOpen() const;

	mxBool			isEndOfFile() const;
	mxBool			getPosition(mxInt64& pos) const;
	mxBool			setPosition(const mxInt64& pos) const;
	mxBool			flush() const;

	mxBool			push();
	mxBool			pop();

	mxInt64			getSize() const;

	mxUInt			read(void* buffer, mxUInt size, mxUInt count) const;
	mxUInt			write(void* buffer, mxUInt size, mxUInt count) const;

public:
	static const mxString		getModuleFilename();
	static const mxString		getModulePath();
	static const mxString		getTemporaryPath();
	static const mxString		getTemporaryFilename(const mxString& prefix);
	static const mxString		getFilenameWithoutPath(const mxString& name);
	static const mxString		getPathWithoutFilename(const mxString& name);
	static const mxString		getExtension(const mxString& name);
	static const mxStringArray	findFilenames(const mxString& filename);
	static const mxStringArray	findFilenames(
									const mxStringArray& searchPath,
									const mxString& filename);

protected:
	mxBool			pushQueue(const mxInt64& pos);
	mxBool			popQueue(mxInt64& pos);
	mxBool			clearQueue();

protected:
	FILE*			_fp;
	mxString		_filename;
	mxInt64			_size;
	mxInt64Array	_posQueue;
};
//------------------------------------------------------------------------------
#endif	// !__mxFile_h__
