/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef	__mxIniFile_h__
#define	__mxIniFile_h__
//------------------------------------------------------------------------------
#include <mx/mxCore/mxString.h>
//------------------------------------------------------------------------------
class MXCORECLASS mxIniFile
{
public:
	mxIniFile();
	mxIniFile(const mxString& filename);

public:
	void			setFilename(const mxString& filename);
	const mxString&	getFilename() const;

	mxUInt			readUInt(const mxString& section,
						const mxString& key, mxUInt defaultValue);
	mxBool			writeUInt(const mxString& section,
						const mxString& key, mxUInt value);

	mxFloat			readFloat(const mxString& section,
						const mxString& key, mxFloat defaultValue);
	mxBool			writeFloat(const mxString& section,
						const mxString& key, mxFloat value);

	mxString		readString(const mxString& section,
						const mxString& key, const mxString& defaultValue);
	mxBool			writeString(const mxString& section,
						const mxString& key, const mxString& value);

public:
	static void				setPath(const mxString& path);
	static const mxString&	getPath();

private:
	mxIniFile(const mxIniFile&);
	mxIniFile& operator =(const mxIniFile&);

private:
	mxString		_filename;
};
//------------------------------------------------------------------------------
#endif	// !__mxIniFile_h__
