/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef	__mxNotify_h__
#define	__mxNotify_h__
//------------------------------------------------------------------------------
#include <mx/mxCore/mxString.h>
//------------------------------------------------------------------------------
class MXCORECLASS mxNotify
{
public:
	enum OutputEnum
	{
		TO_CONSOLE,
		TO_FILE,
		TO_DEBUGWINDOW,

#ifdef _WIN32
		DEFAULT_OUTPUT = TO_DEBUGWINDOW
#else
		DEFAULT_OUTPUT = TO_CONSOLE
#endif
	};

	enum LevelEnum
	{
		ERR,
		WARN,
		NOTICE,
		INFO,
		FATAL,
		DEBUG
	};

public:
	static void			setOutput(OutputEnum output) { _output = output; }
	static OutputEnum	getOutput() { return _output; }

	static void			post(LevelEnum level, const mxChar* format...);
	static void			post(LevelEnum level, const mxString& str);

private:
	mxNotify();

private:
	static OutputEnum	_output;
};
//------------------------------------------------------------------------------
#endif	// !__mxNotify_h__
