/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#include "StdAfx.h"
#include <mx/mxCore/mxObject.h>
#include <mx/mxCore/mxNotify.h>
//------------------------------------------------------------------------------
#ifdef _DEBUG
mxUInt mxObject::_newCount = 0;
mxUInt mxObject::_destroyCount = 0;
#endif
//------------------------------------------------------------------------------
mxObject::mxObject() :
_referenceCount(0)
{
#ifdef _DEBUG
	++_newCount;
#endif
}
//------------------------------------------------------------------------------
mxObject::~mxObject()
{
#ifdef _DEBUG
	++_destroyCount;
#endif
}
//------------------------------------------------------------------------------
mxUInt
mxObject::ref()
{
	return ++_referenceCount;
}
//------------------------------------------------------------------------------
mxUInt
mxObject::unref()
{
	return (_referenceCount > 0) ? --_referenceCount : 0;
}
//------------------------------------------------------------------------------
mxUInt
mxObject::getRef() const
{
	return _referenceCount;
}
//------------------------------------------------------------------------------
void
mxObject::destroy()
{
	if (_referenceCount == 0)
		_destroy();
	else
		--_referenceCount;
}
//------------------------------------------------------------------------------
void
mxObject::_destroy()
{
	delete this;
}
//------------------------------------------------------------------------------
mxClassType
mxObject::getClassType() const
{
	return typeid(*this);
}
//------------------------------------------------------------------------------
const mxChar*
mxObject::getClassName() const
{
	return (typeid(*this)).name();
}
//------------------------------------------------------------------------------
mxBool
mxObject::isExactType(mxClassType type) const
{
	return (typeid(*this) == type) != 0;
}
//------------------------------------------------------------------------------
mxBool
mxObject::isDerivedFrom(mxClassType type) const
{
	return (type == typeid(mxObject)) != 0;
}
//------------------------------------------------------------------------------
mxClassType
mxObject::getStaticClassType()
{
	return typeid(mxObject);
}
//------------------------------------------------------------------------------
const mxChar*
mxObject::getStaticClassName()
{
	return typeid(mxObject).name();
}
//------------------------------------------------------------------------------
#ifdef	_DEBUG
void
mxObject::postInformation()
{
	mxNotify::post(mxNotify::INFO, "%s", this->getClassName());
	mxNotify::post(mxNotify::INFO, "\treferenceCount=%d", this->getRef());
}
#endif
//------------------------------------------------------------------------------
