/*
**	Copyright (c) 2003 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//----------------------------------------------------------------------------
#ifndef	__mxObject_inl__
#define	__mxObject_inl__
//----------------------------------------------------------------------------
template<class T>
inline
mxObjectPtr<T>::mxObjectPtr(T* ptr) :
_ptr(ptr)
{
	SAFE_REF(_ptr);
}
//----------------------------------------------------------------------------
template<class T>
inline
mxObjectPtr<T>::mxObjectPtr(const mxObjectPtr& objectPtr) :
_ptr(objectPtr._ptr)
{
	SAFE_REF(_ptr);
}
//----------------------------------------------------------------------------
template<class T>
inline
mxObjectPtr<T>::~mxObjectPtr()
{
	SAFE_UNREF_DESTROY(_ptr);
}
//----------------------------------------------------------------------------
template<class T>
inline
mxObjectPtr<T>::operator const mxObject*() const
{
	return _ptr;
}
//------------------------------------------------------------------------------
template<class T>
inline mxBool
mxObjectPtr<T>::operator !() const
{
	return _ptr == NULL;
}
//------------------------------------------------------------------------------
template<class T>
inline mxObjectPtr<T>&
mxObjectPtr<T>::operator =(const mxObjectPtr& objectPtr)
{
	if (_ptr != objectPtr._ptr)
	{
		SAFE_UNREF_DESTROY(_ptr);
		_ptr = objectPtr._ptr;
		SAFE_REF(_ptr);
	}

	return *this;
}
//----------------------------------------------------------------------------
template<class T>
inline T&
mxObjectPtr<T>::operator *() const
{
	assert(_ptr != NULL);
	return *_ptr;
}
//----------------------------------------------------------------------------
template<class T>
inline T*
mxObjectPtr<T>::operator ->() const
{
	return _ptr;
}
//------------------------------------------------------------------------------
#endif	// !__mxObject_inl__
