/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef	__mxRegistry_h__
#define	__mxRegistry_h__
//------------------------------------------------------------------------------
#include <mx/mxCore/mxString.h>
//------------------------------------------------------------------------------
class MXCORECLASS mxRegistry
{
public:
	mxRegistry();
	~mxRegistry();

public:
	enum RootKeyEnum
	{
		RK_CLASSES_ROOT,
		RK_CURRENT_USER,
		RK_LOCAL_MACHINE,
		RK_USERS,
		RK_CURRENT_CONFIG,
	};

	mxBool			createKey(const mxString& key,
						RootKeyEnum rootKey = RK_CURRENT_USER);
	mxBool			closeKey();

	mxUInt			readUInt(const mxString& section,
						const mxString& entry, mxUInt defaultValue);
	mxBool			writeUInt(const mxString& section,
						const mxString& entry, mxUInt value);

	mxString		readString(const mxString& section,
						const mxString& entry, const mxString& defaultValue);
	mxBool			writeString(const mxString& section,
						const mxString& entry, const mxString& value);

	mxBool			deleteSection(const mxString& section);
	mxBool			deleteValue(const mxString& section, const mxString& entry);

public:
	static void				setCompanyName(const mxString& name);
	static const mxString&	getCompanyName();

	static void				setProductName(const mxString& name);
	static const			mxString& getProductName();

private:
	HKEY			_createKey(const mxString& key, HKEY hKey);
	mxBool			_readUInt(const mxString& valueName,
						mxUInt& value, HKEY hKey);
	mxBool			_writeUInt(const mxString& valueName,
						mxUInt value, HKEY hKey);
	mxBool			_readString(const mxString& valueName,
						mxString& value, HKEY hKey);
	mxBool			_writeString(const mxString& valueName,
						const mxString& value, HKEY hKey);

private:
	mxRegistry(const mxRegistry&);
	mxRegistry& operator =(const mxRegistry&);

private:
	HKEY				_keyHandle;

	static mxString		_companyName;
	static mxString		_productName;
};
//------------------------------------------------------------------------------
#endif	// !__mxRegistry_h__
