/*
**	Copyright (c) 2003 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//----------------------------------------------------------------------------
#ifndef	__mxString_inl__
#define	__mxString_inl__
//----------------------------------------------------------------------------
inline
mxString::mxString() :
_string(NULL)
{
}
//----------------------------------------------------------------------------
inline
mxString::mxString(const mxChar* str) :
_string(NULL)
{
	*this = str;
}
//----------------------------------------------------------------------------
inline
mxString::mxString(const mxString& str) :
_string(NULL)
{
	*this = str._string;
}
//----------------------------------------------------------------------------
inline const mxChar*
mxString::c_str() const
{
	return _string;
}
//----------------------------------------------------------------------------
inline mxChar&
mxString::operator [](const int idx)
{
	return _string[idx];
}
//----------------------------------------------------------------------------
inline const mxChar&
mxString::operator [](const int idx) const
{
	return _string[idx];
}
//----------------------------------------------------------------------------
inline mxString&
mxString::operator =(const mxString& str)
{
	return *this = str._string;
}
//----------------------------------------------------------------------------
inline mxString&
mxString::operator +=(const mxString& str)
{
	return *this += str._string;
}
//----------------------------------------------------------------------------
inline mxBool
mxString::operator !() const
{
	return isEmpty();
}
//----------------------------------------------------------------------------
inline mxBool
operator ==(const mxChar* str1, const mxString& str2)
{
	return str2 == str1;
}
//----------------------------------------------------------------------------
inline mxBool
operator ==(const mxString& str1, const mxString& str2)
{
	return str1 == str2._string;
}
//----------------------------------------------------------------------------
inline mxBool
operator !=(const mxString& str1, const mxChar* str2)
{
	return !(str1 == str2);
}
//----------------------------------------------------------------------------
inline mxBool
operator !=(const mxChar* str1, const mxString& str2)
{
	return str2 != str1;
}
//----------------------------------------------------------------------------
inline mxBool
operator !=(const mxString& str1, const mxString& str2)
{
	return str1 != str2._string;
}
//----------------------------------------------------------------------------
inline mxBool
operator < (const mxChar* str1, const mxString& str2)
{
	return str2 >= str1;
}
//----------------------------------------------------------------------------
inline mxBool
operator < (const mxString& str1, const mxString& str2)
{
	return str1 < str2._string;
}
//----------------------------------------------------------------------------
inline mxBool
operator > (const mxChar* str1, const mxString& str2)
{
	return str2 <= str1;
}
//----------------------------------------------------------------------------
inline mxBool
operator > (const mxString& str1, const mxString& str2)
{
	return str1 > str2._string;
}
//----------------------------------------------------------------------------
inline mxBool
operator <=(const mxChar* str1, const mxString& str2)
{
	return str2 > str1;
}
//----------------------------------------------------------------------------
inline mxBool
operator <=(const mxString& str1, const mxString& str2)
{
	return str1 <= str2._string;
}
//----------------------------------------------------------------------------
inline mxBool
operator >=(const mxChar* str1, const mxString& str2)
{
	return str2 < str1;
}
//----------------------------------------------------------------------------
inline mxBool
operator >=(const mxString& str1, const mxString& str2)
{
	return str1 >= str2._string;
}
//----------------------------------------------------------------------------
#endif	// !__mxString_inl__
