/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//------------------------------------------------------------------------------
#ifndef	__mxThread_h__
#define	__mxThread_h__
//------------------------------------------------------------------------------
#include <mx/mxCore/mxObject.h>
#include <mx/mxCore/mxThreadHandle.h>
//------------------------------------------------------------------------------
class MXCORECLASS mxThreadHandler : public mxObject
{
	friend class mxThread;

protected:
	mxThreadHandler() : mxObject() {}
	virtual ~mxThreadHandler() {}

protected:
	virtual mxUInt	handlerProc() = 0;
};
//------------------------------------------------------------------------------
class MXCORECLASS mxThread : public mxThreadHandle
{
public:
	enum PriorityEnum
	{
		UNKNOWN_PRIORITY,

		ABOVE_NORMAL,
		BELOW_NORMAL,
		HIGHEST,
		IDLE,
		LOWEST,
		NORMAL,
		TIME_CRITICAL,

		DEFAULT_PRIORITY = NORMAL
	};

	typedef mxUInt	(__stdcall *ThreadProc)(void*);

	mxThread();
	mxThread(HANDLE handle);
	explicit mxThread(mxThreadHandler* handler,
		mxBool createSuspended = false);
	mxThread(ThreadProc proc, void* data, mxBool createSuspended = false);
	virtual ~mxThread();

public:
	mxBool			create(mxThreadHandler* handler,
						mxBool createSuspended = false);
	mxBool			create(ThreadProc proc, void* data,
						mxBool createSuspended = false);

	mxBool			suspend() const;
	mxBool			resume() const;

	void			exit(mxUInt exitCode = 0) const;
	mxBool			terminate(mxUInt exitCode = 0) const;
	mxBool			getExitCode(mxUInt& exitCode) const;

	mxBool			setPriority(PriorityEnum priority) const;
	PriorityEnum	getPriority() const;

	mxUInt			getThreadID() const;

private:
	static mxUInt WINAPI	callThreadHandlerProc(void* data);

protected:
	mxUInt			_threadID;
};
//------------------------------------------------------------------------------
#endif	// !__mxThread_h__
