/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#ifndef __fsCommandHistory_h__
#define	__fsCommandHistory_h__
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <stdio.h>
//---------------------------------------------------------------------------
class fsCommandHistory
{
public:
	fsCommandHistory(TMenuItem* HistoryBeginMenuItem,
                     TMenuItem* HistoryEndMenuItem,
                     int maxHistories = 10);
    virtual ~fsCommandHistory();

public:
	void				clear();
    void				add(TAction* action, int prefixId = -1);

public:
	void				updateAll();

protected:
	void				addOriginal(const AnsiString& caption,
    								TNotifyEvent Handler,
                                    void *data,
                                    int prefixId);


	virtual AnsiString	getPrefixIdString(int prefixId) = 0;

protected:
	TMenuItem*		_historyMenuItem;
    TMenuItem*		_historyBeginMenuItem;
    TMenuItem*		_historyEndMenuItem;

	TList*			_prefixIdList;

    int				_maxHistories;
};
//---------------------------------------------------------------------------
#endif // __fsCommandHistory_h__
