//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fsErrorMessageForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TErrorMessageForm *ErrorMessageForm;
//---------------------------------------------------------------------------
__fastcall
TErrorMessageForm::TErrorMessageForm(TComponent* Owner):
TForm(Owner)
{
	_id			= -1;
    _types		= new TList();
	_messages	= new TStringList();

    for(int i = 0; i < MAX_TYPES; i++)
    	_typeStrings[i] = "";
}
//---------------------------------------------------------------------------
__fastcall
TErrorMessageForm::~TErrorMessageForm()
{
	delete _types;
    delete _messages;
}
//---------------------------------------------------------------------------
void
TErrorMessageForm::setError(int id, int type, const AnsiString& message)
{
	if (_id == id)
    	return ;

    if (MAX_TYPES <= type)
    	return ;

    if (!Showing)
		Show();

    _id = id;

    _types->Add((void *)type);
    _messages->Add(message);

    ErrorMessageMemo->Lines->Add(_typeStrings[type] + ":\t" + message);
}
//---------------------------------------------------------------------------
void
TErrorMessageForm::setTypeString(int type, const AnsiString& str)
{
	if (MAX_TYPES <= type)
    	return ;
    _typeStrings[type] = str;
}
//---------------------------------------------------------------------------
void
TErrorMessageForm::updateForm()
{
	ErrorMessageMemo->Lines->Clear();

    for(int i = 0; i < _types->Count; i++)
	    ErrorMessageMemo->Lines->Add(_typeStrings[(int)_types->Items[i]] + ":\t" +
        						 _messages->Strings[i]);
}
//---------------------------------------------------------------------------

