/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#include "fsFlowLayout.h"
//---------------------------------------------------------------------------
fsFlowLayout::fsFlowLayout()
{
	_vgap	= 10;
    _hgap	= 10;
    _margin	= 15;
}
//---------------------------------------------------------------------------
fsFlowLayout::~fsFlowLayout()
{
}
//---------------------------------------------------------------------------
void
fsFlowLayout::setMargin(int margin)
{
	_margin = margin;
}
//---------------------------------------------------------------------------
int
fsFlowLayout::getMargin() const
{
	return _margin;
}
//---------------------------------------------------------------------------
void
fsFlowLayout::setGap(int vgap, int hgap)
{
	_vgap = vgap;
    _hgap = hgap;
}
//---------------------------------------------------------------------------
void
fsFlowLayout::getGap(int&vgap, int&hgap) const
{
	vgap = _vgap;
    hgap = _hgap;
}
//---------------------------------------------------------------------------
void
fsFlowLayout::doLayout(TScrollBox *scrollBox)
{
	int numControls = scrollBox->ControlCount;
	if (numControls == 0)
    	return ;

	int width;
    width = scrollBox->Width;

	int x, y;
    int maxCHeight;

    x = _margin - scrollBox->HorzScrollBar->Position;
    y = _margin - scrollBox->VertScrollBar->Position;

    maxCHeight = -1;

    for(int i = 0; i < numControls; i++)
    {
    	TControl *control = scrollBox->Controls[i];

        int cWidth = control->Width;
        int cHeight = control->Height;

        if (width < x + cWidth + _margin && (x != _margin))
        {
        	x = _margin - scrollBox->HorzScrollBar->Position;
            y += (maxCHeight + _vgap);
            maxCHeight = -1;
        }

        if (maxCHeight < cHeight)
        	maxCHeight = cHeight;

        control->Left = x;
        control->Top = y;

        x += (cWidth + _vgap);
    }
}
//---------------------------------------------------------------------------
