/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "fsGraph.h"
#include <limits.h>
//---------------------------------------------------------------------------
__fastcall
TGraph::TGraph()
{
	FPosition = 0;

    for(int i = 0; i < MAX_DATA; i++)
		FData[i] = INVALID_POINT;

	FColor = clLime;
}
//---------------------------------------------------------------------------
__fastcall
TGraph::~TGraph()
{
}
//---------------------------------------------------------------------------
void __fastcall
TGraph::Point(int value)
{
	FData[FPosition++] = value;
	if (MAX_DATA <= FPosition)
		FPosition = 0;
}
//---------------------------------------------------------------------------
void __fastcall
TGraph::Clear()
{
	FPosition = 0;
	for(int i = 0; i < MAX_DATA; i++)
		FData[i] = INVALID_POINT;
}
//---------------------------------------------------------------------------
void __fastcall
TGraph::Draw(TCanvas* Canvas, int w, int h, int step, int min, int max)
{
	int j;
	float x, y;

	float a = float(h) / float(min - max);
	float b = -a * max;
    float xi = w / float(step);

	Canvas->Pen->Color = FColor;

	for(x = w, j = 0; 0 < x; x -= xi, j++)
	{
		int point = GetPoint(j);
		if (point == INVALID_POINT)
			break;

		y = point * a + b;

		if (j == 0)
        	Canvas->MoveTo((int)x, (int)y);
		else
        	Canvas->LineTo((int)x, (int)y);
	}

}
//---------------------------------------------------------------------------
inline int __fastcall
TGraph::GetPoint(int index)
{
	if (MAX_DATA <= index)
		return INVALID_POINT;

	int idx = FPosition - index - 1;
	if (idx < 0)
		idx = MAX_DATA + idx;
	return FData[idx];
}
//---------------------------------------------------------------------------
