/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "fsGraphWindow.h"
#include "fsGraph.h"
//---------------------------------------------------------------------------
__fastcall
TGraphWindow::TGraphWindow(TComponent* Owner) :
inherited(Owner)
{
    FGraphs				= new TObjectList();
    FGraphs->OwnsObjects= false;

	FStep				= 100;
    FRangeMin			= 0;
    FRangeMax			= 100;

	FControl			= new TGraphWindowControl(this, FGraphs);
	FControl->Parent	= this;
    FControl->ControlStyle.Clear();
    FControl->ControlStyle << csOpaque;
}
//---------------------------------------------------------------------------
__fastcall
TGraphWindow::~TGraphWindow()
{
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall
TGraphWindow::Draw()
{
	FControl->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall
TGraphWindow::SetNumGraph(int count)
{
	FGraphs->ClassInfo();
    for(int i = 0;i < count; i++)
    	FGraphs->Add(new TGraph());
}
//---------------------------------------------------------------------------
int __fastcall
TGraphWindow::GetNumGraph() const
{
	return FGraphs->Count;
}
//---------------------------------------------------------------------------
void __fastcall
TGraphWindow::SetGraphColor(int index, TColor color)
{
	if (FGraphs->Count <= index)
    	return ;
	TGraph* graph = (TGraph *)FGraphs->Items[index];
    graph->Color = color;
}
//---------------------------------------------------------------------------
TColor __fastcall
TGraphWindow::GetGraphColor(int index) const
{
	if (FGraphs->Count <= index)
    	return clBlack;
	TGraph* graph = (TGraph *)FGraphs->Items[index];
    return graph->Color;
}
//---------------------------------------------------------------------------
void __fastcall
TGraphWindow::PointGraph(int index, int value)
{
	if (FGraphs->Count <= index)
    	return ;
	TGraph* graph = (TGraph *)FGraphs->Items[index];
    graph->Point(value);
}
//---------------------------------------------------------------------------
void __fastcall
TGraphWindow::ClearGraph(int index)
{
	if (FGraphs->Count <= index)
    	return ;
	TGraph* graph = (TGraph *)FGraphs->Items[index];
    graph->Clear();
}
//---------------------------------------------------------------------------
void __fastcall
TGraphWindow::ClearGraph()
{
	TGraph* graph;
    for(int i = 0; i < FGraphs->Count; i++)
    {
    	graph = (TGraph *)FGraphs->Items[i];
        graph->Clear();
    }
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall
TGraphWindow::Resize()
{
	FControl->Width = Width;
	FControl->Height = Height;
	inherited::Resize();
}
//---------------------------------------------------------------------------

