/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#ifndef __GraphWindow_h__
#define __GraphWindow_h__
//---------------------------------------------------------------------------
#include "fsGraphWindowControl.h"
//---------------------------------------------------------------------------
class PACKAGE TGraphWindow : public TPanel
{
	typedef TPanel	inherited;

__published:
	__property int	Step = { read = FStep, write = FStep, default = 100 };
    __property int	RangeMin = { read = FRangeMin, write = FRangeMin, default = 0 };
    __property int	RangeMax = { read = FRangeMax, write = FRangeMax, default = 100 };

public:
	__fastcall			TGraphWindow(TComponent* Owner);
	virtual __fastcall	~TGraphWindow();

public:
	void __fastcall		Draw();

	void __fastcall		SetNumGraph(int count);
	int __fastcall		GetNumGraph() const;

	void __fastcall		SetGraphColor(int index, TColor color);
	TColor __fastcall	GetGraphColor(int index) const;

	void __fastcall		PointGraph(int index, int value);
	void __fastcall		ClearGraph(int index);
	void __fastcall		ClearGraph();

protected:
	DYNAMIC void __fastcall Resize();

private:
	TObjectList*			FGraphs;
	int						FStep;
    int						FRangeMin;
    int						FRangeMax;

   	TGraphWindowControl*	FControl;
};
//---------------------------------------------------------------------------
#endif

