/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "fsGraphWindow.h"
#include "fsGraph.h"
//---------------------------------------------------------------------------
__fastcall
TGraphWindowControl::TGraphWindowControl(TComponent* Owner, TObjectList* Graphs) :
inherited(Owner)
{
	Left					= 0;
	Top						= 0;
	Width					= 320;
	Height					= 240;
	Canvas->Font->Size		= 8;

    FGraphs = Graphs;
}
//---------------------------------------------------------------------------
__fastcall
TGraphWindowControl::~TGraphWindowControl()
{
}
//---------------------------------------------------------------------------
void __fastcall
TGraphWindowControl::Paint()
{
	TCanvas*	canvas = Canvas;

	// NA
	canvas->Brush->Color = clBlack;
	canvas->FillRect(TRect(0, 0, Width, Height));

	// Obh̕`
	float i, j;
    int k;

	// Vertical
	const float NUMVERT = 20.0f;
	float incH = Width / NUMVERT;
	for(i = 0.0f, k = 0; i < Width; i += incH, k++)
	{
        canvas->Pen->Color = ((k % 2 == 0) ? clGreen : 0x00004600);

		canvas->MoveTo((int)i, 0);
		canvas->LineTo((int)i, Height);
	}

	// Horizontal
	const float NUMHORZ = 10.0f;
	float incV = Height / NUMHORZ;
	for(i = 0.0f, k = 0; i < Height; i += incV, k++)
	{
        canvas->Pen->Color = ((k % 2 == 0) ? clGreen : 0x00004600);

		canvas->MoveTo(0, (int)i);
		canvas->LineTo(Width, (int)i);
	}

    // Ot̕`
	TGraphWindow *GraphWindow = (TGraphWindow *)Owner; 

    for(int i = 0; i < FGraphs->Count; i++)
    {
    	TGraph *Graph = (TGraph *)FGraphs->Items[i];
        Graph->Draw(canvas, Width, Height, GraphWindow->Step,
        			 GraphWindow->RangeMin, GraphWindow->RangeMax); 
    }
}
//---------------------------------------------------------------------------

 