/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#ifndef __fsLanguage_h__
#define	__fsLanguage_h__
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <stdio.h>
//---------------------------------------------------------------------------
/*

T|[gNXłB
{NX́AR|[lgCaptionȂǂ𒼐ڑ삵܂B
̐ݒ͈ȉɏ]܂B

kftHǧl
{
p

kǉl
t@CF<AvP[V(EXE܂܂Ȃ)>_<R[h>.lngigqlngłt@Cj

t@C̏ꏊFsW[pX

t@CtH[}bgF
  NotationName ja	<R[hjãlCeBu\L>
  NotationName en	<R[heñlCeBu\L>
   :

  <ΏۃR|[lg>@@lCeBu
   :


kR[hl
ar ArA
it C^A
de hCc
ja {
el MV
ko ؍
en p
la e
eo GXyg
ms }[
es XyC
ru VA
fr tX
zh 

R[h͏LȊOłǂݍ݂͉\łB

*/
//---------------------------------------------------------------------------
class rsNotations;
//---------------------------------------------------------------------------
class fsLanguage
{

	enum DefaultLanguage {
    	L_JAPANESE,
        L_ENGLISH,
    };

public:
	fsLanguage(TMenuItem* LanguageMenuItem);
    virtual ~fsLanguage();

public:
    void __fastcall LanguageMenuItemOnClick(TObject *Sender);

public:
	int					getNumLanguageCode() const;
    AnsiString			getLanguageCode(int index) const;

	void				setCurrentLanguageCode(const AnsiString& langCode);
    AnsiString			getCurrentLanguageCode() const;

	virtual const AnsiString&	getDynamicWord(int id) = 0;

protected:
    virtual void		setupLanguage() = 0;
    virtual void		setupDefaultJapanese() = 0;
    virtual void		setupDefaultEnglish() = 0;

    bool				nextEntry(AnsiString& key, AnsiString& val);

private:
    void				_setupLanguage();
    void				_setupNotation();

private:
	void				readAdditionalLangCodes();
    void				readNotations(rsNotations* notations, const AnsiString& langCode);
    FILE*				openLanguageFile(const AnsiString& langCode);

private:
	int					_language;

    TStringList*		_languageCodes;
    TList*				_notationsList;

    TList*				_languageMenuItems;

	FILE*				_fp;
};
//---------------------------------------------------------------------------
class rsNotations
{
public:
	rsNotations();
    virtual ~rsNotations();

public:
	void		 	addNotation(const AnsiString& langCode, const AnsiString& notation);
    void		 	removeNotation(const AnsiString& langCode);

	int			 	getNumNotations() const;
    AnsiString		getNotation(int index) const;
    AnsiString	 	getLanguageCode(int index) const;

private:
	TStringList* 	_languageCodes;
    TStringList* 	_notations;
};
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------

