/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#ifndef fsVolumeIndicatorFormH
#define fsVolumeIndicatorFormH
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
#include "fsVolumeIndicatorTimer.h"
#include "fsGraphWindow.h"
#include <Forms.hpp>
//---------------------------------------------------------------------------
class TVolumeIndicatorForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TProgressBar *RightVolumeIndicator;
	TComboBox *DisplayTimeComboBox;
	TLabel *DisplayTimeLabel;
	TProgressBar *LeftVolumeIndicator;
	TLabel *LeftLabel;
	TLabel *RightLabel;
	TCheckBox *DisplayPauseCheckBox;
	void __fastcall DisplayTimeComboBoxChange(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall DisplayPauseCheckBoxClick(TObject *Sender);

public:
	__fastcall TVolumeIndicatorForm(TComponent* Owner);
	virtual __fastcall ~TVolumeIndicatorForm();

public:
    void __fastcall		VolumePerform(TObject *sender);

public:
    void __fastcall		updateForm();

	typedef void __fastcall (__closure *TVIEvent)(System::TObject* Sender, int *volume, int evalTime);

    __property TVIEvent VolumeRequest = { read = _volumeRequest, write = _volumeRequest, default = NULL };
    __property int DisplayTime = { read = _displayTime, write = _displayTime, default = 0 };

private:
    void		computeParam();

private:
	TVolumeIndicatorTimer*	Timer;
	TGraphWindow*			GraphWindow;

    TVIEvent				_volumeRequest;
	int						_displayTime;

    int						_evalTime;
    int						_drawUpdate;
};
//---------------------------------------------------------------------------
extern PACKAGE TVolumeIndicatorForm *VolumeIndicatorForm;
//---------------------------------------------------------------------------
#endif
