/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fsVersionInfoForm.h"
#include "fsMulticastSettingForm.h"
#include "fsReceiveMonitorForm.h"
#include "fsMultiReceiverMainForm.h"
#include "fsAddMediaForm.h"
#include "fsMainDataModule.h"
#include <fs/fsMultiReceiverRemote/fsMultiReceiverRemoteInterface.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainDataModule *MainDataModule;
//---------------------------------------------------------------------------
__fastcall
TMainDataModule::TMainDataModule(TComponent* Owner)
: TDataModule(Owner)
{
    _selectedVideoIndex = -1;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::DataModuleCreate(TObject *Sender)
{
    IniFileOpenDialog->DefaultExt	= AnsiString("ini");
    IniFileOpenDialog->Filter		= AnsiString("ݒt@C|*.ini");
    IniFileOpenDialog->Title		= "ݒt@CǍ";

    IniFileSaveDialog->DefaultExt	= AnsiString("ini");
    IniFileSaveDialog->Filter		= AnsiString("ݒt@C|*.ini");
    IniFileSaveDialog->Title		= "݂̐ݒۑ";

    MultiReceiverTimer->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::DataModuleDestroy(TObject *Sender)
{
	MultiReceiverTimer->Enabled = false;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Show
void __fastcall
TMainDataModule::ShowActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ShowVideoSelectionPanelActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ShowOriginalVideoSizeActionExecute(TObject *Sender)
{
	fsMultiReceiverSetVideoWindowMinimize(false);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ShowOriginalVideoSizeActionUpdate(TObject *Sender)
{
	ShowOriginalVideoSizeAction->Checked = !fsMultiReceiverGetVideoWindowMinimize();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ShowMinVideoSizeActionExecute(TObject *Sender)
{
	fsMultiReceiverSetVideoWindowMinimize(true);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ShowMinVideoSizeActionUpdate(TObject *Sender)
{
	ShowMinVideoSizeAction->Checked = fsMultiReceiverGetVideoWindowMinimize();
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// File
void __fastcall
TMainDataModule::FileActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::WriteIniFileActionExecute(TObject *Sender)
{
    if (IniFileSaveDialog->Execute())
    {
        AnsiString filename = IniFileSaveDialog->FileName;
        if (!fsMultiReceiverWriteIniFile(filename.c_str()))
        {
        	Application->MessageBox(
            		MultiReceiverMainForm->_language->getDynamicWord(DW_WRITEINIFILEERROR).c_str(),
                    MultiReceiverMainForm->_language->getDynamicWord(DW_ERROR).c_str(),
            		MB_OK | MB_ICONERROR);
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ReadIniFileActionExecute(TObject *Sender)
{
    if (IniFileOpenDialog->Execute())
    {
        AnsiString filename = IniFileOpenDialog->FileName;
        if (!fsMultiReceiverReadIniFile(filename.c_str()))
        {
        	Application->MessageBox(
            		MultiReceiverMainForm->_language->getDynamicWord(DW_READINIFILEERROR).c_str(),
                    MultiReceiverMainForm->_language->getDynamicWord(DW_ERROR).c_str(),
            		MB_OK | MB_ICONERROR);
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ExitRemoteActionExecute(TObject *Sender)
{
	MultiReceiverTimer->Enabled = false;
	fsMultiReceiverQuit();

    Sleep(1000);
    MultiReceiverTimer->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ExitActionExecute(TObject *Sender)
{
    MultiReceiverMainForm->Close();
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Multicast
void __fastcall
TMainDataModule::MulticastActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::MulticastAddMediaActionExecute(TObject *Sender)
{
	AddMediaForm->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::MulticastAddMediaActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::MulticastDeleteMediaActionExecute(TObject *Sender)
{
    if (Application->MessageBox(
            MultiReceiverMainForm->_language->getDynamicWord(DW_AREYOUOK).c_str(),
            MultiReceiverMainForm->_language->getDynamicWord(DW_CONFIRM).c_str(),
			MB_YESNO | MB_ICONQUESTION) == IDYES)
    {
        MultiReceiverMainForm->removeMediaReceiver(_selectedVideoIndex);
        _selectedVideoIndex = -1;
    }
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::MulticastDeleteMediaActionUpdate(TObject *Sender)
{
	MulticastDeleteMediaAction->Enabled = (_selectedVideoIndex != -1);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::MulticastShowReceiveMonitorActionExecute(TObject *Sender)
{
	ReceiveMonitorForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AddMediaOKActionExecute(TObject *Sender)
{
    AnsiString address = AddMediaForm->MediaMulticastAddressComboBox->Text;
    if (MultiReceiverMainForm->addMediaReceiver(address))
    {
        if (AddMediaForm->MediaMulticastAddressComboBox->Items->IndexOf(address) == -1)
            AddMediaForm->MediaMulticastAddressComboBox->Items->Add(address);
    }
    AddMediaForm->Close();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AddMediaOKActionUpdate(TObject *Sender)
{
    AnsiString address = AddMediaForm->MediaMulticastAddressComboBox->Text;
	AddMediaOKAction->Enabled = address.Length() != 0;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AddMediaCancelActionExecute(TObject *Sender)
{
	AddMediaForm->Close();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AddMediaCancelActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::MulticastRemoteSettingActionExecute(TObject *Sender)
{
	MulticastSettingForm->ShowModal();
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Language
void __fastcall
TMainDataModule::LanguageActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Help
void __fastcall
TMainDataModule::HelpActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VersionInfoActionExecute(TObject *Sender)
{
	VersionInfoForm->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VersionInfoActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// MulticastSettingActionList
void __fastcall
TMainDataModule::CreateIPv6AddressActionExecute(TObject *Sender)
{
	MulticastSettingForm->AddressEdit->Text = fsMultiReceiverCreateIPv6Address();
    MulticastSettingForm->_addressIsDirty = true;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CreateIPv6AddressActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CreateIPv4AddressActionExecute(TObject *Sender)
{
	MulticastSettingForm->AddressEdit->Text = fsMultiReceiverCreateIPv4Address();
    MulticastSettingForm->_addressIsDirty = true;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CreateIPv4AddressActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AddressUpdateActionExecute(TObject *Sender)
{
	AnsiString address = MulticastSettingForm->AddressEdit->Text;
    fsMultiReceiverSetAddress(address.c_str());
    MulticastSettingForm->_addressIsDirty = false;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AddressUpdateActionUpdate(TObject *Sender)
{
	AddressUpdateAction->Enabled =
    	(strlen(MulticastSettingForm->AddressEdit->Text.c_str()) != 0) &&
        MulticastSettingForm->_addressIsDirty;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TTLUpdateActionExecute(TObject *Sender)
{
	int ttl = MulticastSettingForm->TTLUpDown->Position;
    fsMultiReceiverSetTimeToLive(ttl);
    MulticastSettingForm->_timeToLiveIsDirty = false;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TTLUpdateActionUpdate(TObject *Sender)
{
	TTLUpdateAction->Enabled = MulticastSettingForm->_timeToLiveIsDirty;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// VersionInfoActionList
void __fastcall
TMainDataModule::VersionInfoOKActionExecute(TObject *Sender)
{
	VersionInfoForm->Close();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VersionInfoOKActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// MultiReceiver Timer
void __fastcall
TMainDataModule::MultiReceiverTimerTimer(TObject *Sender)
{
	int count = fsMultiReceiverGetNumMediaReceiver();

    if (count == 0)
    {
	    MultiReceiverMainForm->VideoStringGrid->RowCount = count + 2;
    	MultiReceiverMainForm->VideoStringGrid->Cells[0][1] = "";
        MultiReceiverMainForm->VideoStringGrid->Cells[1][1] = "";
        MultiReceiverMainForm->VideoStringGrid->Cells[2][1] = "";
    }
    else
    {
	    MultiReceiverMainForm->VideoStringGrid->RowCount = count + 1;
    }

    fsLanguage* language = MultiReceiverMainForm->_language;

    // Update Status Bar
	if (MultiReceiverMainForm->_remoteInvokeTimeout)
    {
    	MultiReceiverMainForm->StatusBar->Panels->Items[0]->Text =
        	language->getDynamicWord(DW_REMOTEINVOKETIMEOUT);
        return ;
    }
    else
    {
		MultiReceiverMainForm->StatusBar->Panels->Items[0]->Text = "";
    }

    // Upate Media Receiver Status
    for(int i = 0; i < count; i++)
    {
        bool socket = fsMultiReceiverGetMediaReceiverSocketOpen(i);
		bool streaming = fsMultiReceiverGetMediaReceiverStreaming(i);

		AnsiString address = AnsiString(fsMultiReceiverGetMediaReceiverAddress(i));
        AnsiString caption;
        AnsiString status;

        if (!socket)
        {
        	status = language->getDynamicWord(DW_SOCKETERROR);
            caption = "";
        }
        else if (streaming)
        {
        	status = language->getDynamicWord(DW_STATUSRECEIVE);
        	caption = AnsiString(fsMultiReceiverGetMediaReceiverCaption(i));
        }
        else
        {
        	status = language->getDynamicWord(DW_STATUSSTOP);
            caption = "";
        }

    	MultiReceiverMainForm->VideoStringGrid->Cells[0][i + 1] = address;
        MultiReceiverMainForm->VideoStringGrid->Cells[1][i + 1] = caption;
        MultiReceiverMainForm->VideoStringGrid->Cells[2][i + 1] = status;
    }
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// ReceiveMonitor Timer
void __fastcall
TMainDataModule::ReceiveMonitorTimerTimer(TObject *Sender)
{
	ReceiveMonitorForm->checkSelectedVideo();

    // Selected
    int receiveRate	= 0;
    int frameRate	= 0;
    int dropPackets	= 0;
    int dropFrames	= 0;
    int packetSize	= 0;
	if (_selectedVideoIndex != -1 && fsMultiReceiverGetMediaReceiverStreaming(_selectedVideoIndex))
    {
    	receiveRate	= fsMultiReceiverGetMediaReceiverReceiveRate(_selectedVideoIndex);
        frameRate	= fsMultiReceiverGetMediaReceiverFrameRate(_selectedVideoIndex);
        dropPackets	= fsMultiReceiverGetMediaReceiverNumDropPackets(_selectedVideoIndex);
        dropFrames	= fsMultiReceiverGetMediaReceiverNumDropFrames(_selectedVideoIndex);
        packetSize	= fsMultiReceiverGetMediaReceiverPacketSize(_selectedVideoIndex);
    }
    receiveRate /= 1024;
    ReceiveMonitorForm->ReceiveRateVideoValue->Caption = AnsiString(receiveRate);
    ReceiveMonitorForm->FrameRateVideoValue->Caption = AnsiString(frameRate);
    ReceiveMonitorForm->DropPacketVideoValue->Caption = AnsiString(dropPackets);
    ReceiveMonitorForm->DropFrameVideoValue->Caption = AnsiString(dropFrames);
    ReceiveMonitorForm->PacketSizeVideoValue->Caption = AnsiString(packetSize);

    // All
    receiveRate	= 0;
    frameRate	= 0;
    dropPackets	= 0;
    dropFrames	= 0;
    int numReceiver = fsMultiReceiverGetNumMediaReceiver();
    for(int i = 0; i < numReceiver; i++)
    {
    	if (!fsMultiReceiverGetMediaReceiverStreaming(i))
        	continue;

    	receiveRate	+= fsMultiReceiverGetMediaReceiverReceiveRate(i);
        frameRate 	+= fsMultiReceiverGetMediaReceiverFrameRate(i);
        dropPackets	+= fsMultiReceiverGetMediaReceiverNumDropPackets(i);
        dropFrames	+= fsMultiReceiverGetMediaReceiverNumDropFrames(i);
    }
    receiveRate /= 1024;
    ReceiveMonitorForm->ReceiveRateVideoAllValue->Caption = AnsiString(receiveRate);
    ReceiveMonitorForm->FrameRateVideoAllValue->Caption = AnsiString(frameRate);
    ReceiveMonitorForm->DropPacketVideoAllValue->Caption = AnsiString(dropPackets);
    ReceiveMonitorForm->DropFrameVideoAllValue->Caption = AnsiString(dropFrames);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void
TMainDataModule::setSelectedVideoIndex(int index)
{
    _selectedVideoIndex = index;
}
//---------------------------------------------------------------------------
int
TMainDataModule::getSelectedVideoIndex() const
{
    return _selectedVideoIndex;
}
//---------------------------------------------------------------------------

