/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#ifndef fsMainDataModuleH
#define fsMainDataModuleH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ActnList.hpp>

#include "fsMultiReceiverLanguage.h"
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <ImgList.hpp>
//---------------------------------------------------------------------------
class TMainDataModule : public TDataModule
{
__published:	// IDE Ǘ̃R|[lg
	TActionList *FileActionList;
	TAction *FileAction;
	TAction *WriteIniFileAction;
	TAction *ReadIniFileAction;
	TAction *ExitAction;
	TActionList *MulticastActionList;
	TAction *MulticastAction;
	TActionList *LanguageActionList;
	TAction *LanguageAction;
	TMainMenu *MainMenu;
	TMenuItem *FileMenuItem;
	TMenuItem *ReadIniFileMenuItem;
	TMenuItem *WriteIniFileMenuItem;
	TMenuItem *FileSeparator1;
	TMenuItem *ExitMenuItem;
	TMenuItem *MulticastMenuItem;
	TMenuItem *MulticastAddMediaMenuItem;
	TMenuItem *MulticastSeparator1;
	TMenuItem *MulticastShowReceiveMonitorMenuItem;
	TMenuItem *LanguageMenuItem;
	TActionList *ShowActionList;
	TAction *ShowAction;
	TMenuItem *ShowMenuItem;
	TAction *ShowVideoSelectionPanelAction;
	TMenuItem *ShowVideoSelectionPanel;
	TMenuItem *ShowSeparator1;
	TMenuItem *ShowOriginalVideoSizeMenuItem;
	TMenuItem *ShowMinVideoSizeMenuItem;
	TAction *ShowOriginalVideoSizeAction;
	TAction *ShowMinVideoSizeAction;
	TAction *MulticastAddMediaAction;
	TAction *MulticastDeleteMediaAction;
	TMenuItem *MulticastDeleteMediaMenuItem;
	TAction *MulticastShowReceiveMonitorAction;
	TAction *AddMediaOKAction;
	TAction *AddMediaCancelAction;
	TTimer *MultiReceiverTimer;
    TOpenDialog *IniFileOpenDialog;
    TSaveDialog *IniFileSaveDialog;
	TTimer *ReceiveMonitorTimer;
	TImageList *ImageList;
	TActionList *HelpActionList;
	TAction *HelpAction;
	TAction *VersionInfoAction;
	TMenuItem *HelpMenuItem;
	TMenuItem *VersionInfoMenuItem;
	TActionList *VersionInfoActionList;
	TAction *VersionInfoOKAction;
	TActionList *MulticastSettingActionList;
	TAction *CreateIPv6AddressAction;
	TAction *CreateIPv4AddressAction;
	TAction *AddressUpdateAction;
	TAction *TTLUpdateAction;
	TMenuItem *MulticastSeparator2;
	TMenuItem *MulticastRemoteSettingMenuItem;
	TAction *MulticastRemoteSettingAction;
	void __fastcall MulticastActionExecute(TObject *Sender);
	void __fastcall ShowActionExecute(TObject *Sender);
	void __fastcall FileActionExecute(TObject *Sender);
	void __fastcall ShowVideoSelectionPanelActionExecute(TObject *Sender);
	void __fastcall ShowVideoSelectionPanelActionUpdate(TObject *Sender);
	void __fastcall ShowOriginalVideoSizeActionExecute(TObject *Sender);
	void __fastcall ShowOriginalVideoSizeActionUpdate(TObject *Sender);
	void __fastcall ShowMinVideoSizeActionExecute(TObject *Sender);
	void __fastcall ShowMinVideoSizeActionUpdate(TObject *Sender);
	void __fastcall DataModuleCreate(TObject *Sender);
	void __fastcall MulticastAddMediaActionExecute(TObject *Sender);
	void __fastcall MulticastAddMediaActionUpdate(TObject *Sender);
	void __fastcall MulticastDeleteMediaActionExecute(TObject *Sender);
	void __fastcall MulticastDeleteMediaActionUpdate(TObject *Sender);
	void __fastcall MulticastShowReceiveMonitorActionExecute(TObject *Sender);
	void __fastcall LanguageActionExecute(TObject *Sender);
	void __fastcall WriteIniFileActionExecute(TObject *Sender);
	void __fastcall ReadIniFileActionExecute(TObject *Sender);
	void __fastcall ExitActionExecute(TObject *Sender);
	void __fastcall AddMediaOKActionExecute(TObject *Sender);
	void __fastcall AddMediaOKActionUpdate(TObject *Sender);
	void __fastcall AddMediaCancelActionExecute(TObject *Sender);
	void __fastcall AddMediaCancelActionUpdate(TObject *Sender);
    void __fastcall MultiReceiverTimerTimer(TObject *Sender);
    void __fastcall DataModuleDestroy(TObject *Sender);
	void __fastcall ReceiveMonitorTimerTimer(TObject *Sender);
	void __fastcall HelpActionExecute(TObject *Sender);
	void __fastcall VersionInfoActionExecute(TObject *Sender);
	void __fastcall VersionInfoActionUpdate(TObject *Sender);
	void __fastcall VersionInfoOKActionExecute(TObject *Sender);
	void __fastcall VersionInfoOKActionUpdate(TObject *Sender);
	void __fastcall CreateIPv6AddressActionExecute(TObject *Sender);
	void __fastcall CreateIPv6AddressActionUpdate(TObject *Sender);
	void __fastcall CreateIPv4AddressActionExecute(TObject *Sender);
	void __fastcall CreateIPv4AddressActionUpdate(TObject *Sender);
	void __fastcall AddressUpdateActionExecute(TObject *Sender);
	void __fastcall AddressUpdateActionUpdate(TObject *Sender);
	void __fastcall TTLUpdateActionExecute(TObject *Sender);
	void __fastcall TTLUpdateActionUpdate(TObject *Sender);
	void __fastcall MulticastRemoteSettingActionExecute(TObject *Sender);
private:	// [U[錾
public:		// [U[錾
	__fastcall TMainDataModule(TComponent* Owner);

    void        setSelectedVideoIndex(int index);
    int         getSelectedVideoIndex()const;

protected:
    int         _selectedVideoIndex;
};
//---------------------------------------------------------------------------
extern PACKAGE TMainDataModule *MainDataModule;
//---------------------------------------------------------------------------
#endif
