/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#include "fsMainDataModule.h"
#include "fsMultiReceiverMainForm.h"
#include "fsAddMediaForm.h"
#include "fsVideoSelectionForm.h"
#include "fsReceiveMonitorForm.h"
#include "fsMulticastSettingForm.h"
#include "fsVersionInfoForm.h"
#include "fsMultiReceiverLanguage.h"
#include <fs/fsMultiReceiver/fsMultiReceiverInterface.h>
//---------------------------------------------------------------------------
fsMultiReceiverLanguage::fsMultiReceiverLanguage(TMenuItem* LanguageMenuItem) :
fsLanguage(LanguageMenuItem)
{
}
//---------------------------------------------------------------------------
fsMultiReceiverLanguage::~fsMultiReceiverLanguage()
{
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
const AnsiString&
fsMultiReceiverLanguage::getDynamicWord(int id)
{
	return _dynamicWords[id];
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void
fsMultiReceiverLanguage::setupLanguage()
{
	AnsiString key, val;

	TMainDataModule			*mdm = MainDataModule;
	TAddMediaForm			*amf = AddMediaForm;
	TVideoSelectionForm		*vsf = VideoSelectionForm;
    TReceiveMonitorForm		*rmf = ReceiveMonitorForm;
    TMulticastSettingForm	*ms = MulticastSettingForm;
    TVersionInfoForm		*vf = VersionInfoForm;

	while(nextEntry(key, val))
	{
		if (key.Length() == 0)
			continue;

        const char *ckey = key.c_str();

		//
		// MultiReceiverMainForm
		//
		if (!strcmp(ckey, "MultiReceiverMainFormCaption"))
			MultiReceiverMainForm->Caption = val;
		
		//
		// MainDataModule
		//
		// FileActionList
		else if (!strcmp(ckey, "mdmFileActionCaption"))
			mdm->FileAction->Caption						= val;
		else if (!strcmp(ckey, "mdmReadIniFileActionCaption"))
			mdm->ReadIniFileAction->Caption					= val;
		else if (!strcmp(ckey, "mdmWriteIniFileActionCaption"))
			mdm->WriteIniFileAction->Caption				= val;
		else if (!strcmp(ckey, "mdmExitActionCaption"))
			mdm->ExitAction->Caption						= val;

		// ShowActionList
		else if (!strcmp(ckey, "mdmShowActionCaption"))
			mdm->ShowAction->Caption						= val;
		else if (!strcmp(ckey, "mdmShowVideoSelectionPanelCaption"))
			mdm->ShowVideoSelectionPanel->Caption			= val;
		else if (!strcmp(ckey, "mdmShowOriginalVideoSizeActionCaption"))
			mdm->ShowOriginalVideoSizeAction->Caption		= val;
		else if (!strcmp(ckey, "mdmShowMinVideoSizeActionCaption"))
			mdm->ShowMinVideoSizeAction->Caption			= val;

		// MulticastActionList
		else if (!strcmp(ckey, "mdmMulticastActionCaption"))
			mdm->MulticastAction->Caption					= val;
		else if (!strcmp(ckey, "mdmMulticastAddMediaActionCaption"))
			mdm->MulticastAddMediaAction->Caption			= val;
		else if (!strcmp(ckey, "mdmMulticastDeleteMediaActionCaption"))
			mdm->MulticastDeleteMediaAction->Caption		= val;
		else if (!strcmp(ckey, "mdmMulticastShowReceiveMonitorActionCaption"))
			mdm->MulticastShowReceiveMonitorAction->Caption	= val;
		else if (!strcmp(ckey, "mdmAddMediaOKActionCaption"))
			mdm->AddMediaOKAction->Caption					= val;
		else if (!strcmp(ckey, "mdmAddMediaCancelActionCaption"))
			mdm->AddMediaCancelAction->Caption				= val;
    	else if (!strcmp(ckey, "mdmMulticastRemoteSettingActionCaption"))
    		mdm->MulticastRemoteSettingAction->Caption		= val;

		// LanguageActionList
		else if (!strcmp(ckey, "mdmLanguageActionCaption"))
			mdm->LanguageAction->Caption					= val;

		// HelpActionList
		else if (!strcmp(ckey, "mdmHelpActionCaption"))
			mdm->HelpAction->Caption					= val;
		else if (!strcmp(ckey, "mdmVersionInfoActionCaption"))
			mdm->VersionInfoAction->Caption				= val;

		// MulticastSettingActionList
		else if (!strcmp(ckey, "mdmCreateIPv6AddressActionCaption"))
			mdm->CreateIPv6AddressAction->Caption			= val;
		else if (!strcmp(ckey, "mdmCreateIPv4AddressActionCaption"))
			mdm->CreateIPv4AddressAction->Caption			= val;
		else if (!strcmp(ckey, "mdmAddressUpdateActionCaption"))
			mdm->AddressUpdateAction->Caption				= val;
		else if (!strcmp(ckey, "mdmTTLUpdateActionCaption"))
			mdm->TTLUpdateAction->Caption					= val;

        // VersionInfoActionList
        else if (!strcmp(ckey, "mdmVersionInfoOKActionCaption"))
        	mdm->VersionInfoOKAction->Caption				= val;

		// Dialogs
		else if (!strcmp(ckey, "mdmIniFileOpenDialogFilter"))
			mdm->IniFileOpenDialog->Filter					= val;
		else if (!strcmp(ckey, "mdmIniFileOpenDialogTitle"))
			mdm->IniFileOpenDialog->Title					= val;
		else if (!strcmp(ckey, "mdmIniFileSaveDialogFilter"))
			mdm->IniFileSaveDialog->Filter					= val;
		else if (!strcmp(ckey, "mdmIniFileSaveDialogTitle"))
			mdm->IniFileSaveDialog->Title					= val;


		//
		// AddMediaForm
		//
		else if (!strcmp(ckey, "amfCaption"))
			amf->Caption									= val;
		else if (!strcmp(ckey, "amfMediaMulticastAddressLabelCaption"))
			amf->MediaMulticastAddressLabel->Caption		= val;


		//
		// VideoSelectionForm
		//
		else if (!strcmp(ckey, "vsfCaption"))
			vsf->Caption									= val;
		else if (!strcmp(ckey, "vsfSelectCaptionGroupBoxCaption"))
			vsf->SelectCaptionGroupBox->Caption				= val;
		else if (!strcmp(ckey, "vsfSelectAddressGroupBoxCaption"))
			vsf->SelectAddressGroupBox->Caption				= val;


		//
		// Receive Monitor Form
		//
		else if (!strcmp(ckey, "rmfCaption"))
			rmf->Caption									= val;
		else if (!strcmp(ckey, "rmfReceiveRateLabelCaption"))
			rmf->ReceiveRateLabel->Caption					= val;
		else if (!strcmp(ckey, "rmfFrameRateLabelCaption"))
			rmf->FrameRateLabel->Caption					= val;
		else if (!strcmp(ckey, "rmfDropPacketLabelCaption"))
			rmf->DropPacketLabel->Caption					= val;
		else if (!strcmp(ckey, "rmfDropFrameLabelCaption"))
			rmf->DropFrameLabel->Caption					= val;
		else if (!strcmp(ckey, "rmfPacketSizeLabelCaption"))
			rmf->PacketSizeLabel->Caption					= val;
		else if (!strcmp(ckey, "rmfReceiveRateVideoAllLabelCaption"))
			rmf->ReceiveRateVideoAllLabel->Caption			= val;


	    //
    	// MulticastSettingForm
	    //
		else if (!strcmp(ckey, "msCaption"))
			ms->Caption										= val;
		else if (!strcmp(ckey, "msAddressGroupBoxCaption"))
			ms->AddressGroupBox->Caption					= val;
		else if (!strcmp(ckey, "msTTLLabelCaption"))
			ms->TTLLabel->Caption							= val;


	    //
    	// VersionInfoFrom
	    //
	    else if (!strcmp(ckey, "vfCaption"))
	    	vf->Caption										= val;
    	else if (!strcmp(ckey, "vfVersionInfoSoftwareNameLabelCaption"))
    		vf->VersionInfoSoftwareNameLabel->Caption		= val;

            
		//
		// Dynamic Words
		//
		else if (!strcmp(ckey, "DW_RECEIVEVIDEO"))
			_dynamicWords[DW_RECEIVEVIDEO]					= val;
		else if (!strcmp(ckey, "DW_STATUSRECEIVE"))
			_dynamicWords[DW_STATUSRECEIVE]					= val;
		else if (!strcmp(ckey, "DW_STATUSSTOP"))
			_dynamicWords[DW_STATUSSTOP]					= val;
		else if (!strcmp(ckey, "DW_AREYOUOK"))
			_dynamicWords[DW_AREYOUOK]						= val;
		else if (!strcmp(ckey, "DW_CONFIRM"))
			_dynamicWords[DW_CONFIRM]						= val;
		else if (!strcmp(ckey, "DW_ERROR"))
			_dynamicWords[DW_ERROR]							= val;
		else if (!strcmp(ckey, "DW_SOCKETERROR"))
			_dynamicWords[DW_SOCKETERROR]					= val;
		else if (!strcmp(ckey, "DW_RECEIVEREXISTERROR"))
			_dynamicWords[DW_RECEIVEREXISTERROR]			= val;
		else if (!strcmp(ckey, "DW_ADDRECEIVERERROR"))
			_dynamicWords[DW_ADDRECEIVERERROR]				= val;
		else if (!strcmp(ckey, "DW_REMOVERECEIVERERROR"))
			_dynamicWords[DW_REMOVERECEIVERERROR]			= val;
		else if (!strcmp(ckey, "DW_READINIFILEERROR"))
			_dynamicWords[DW_READINIFILEERROR]				= val;
		else if (!strcmp(ckey, "DW_WRITEINIFILEERROR"))
			_dynamicWords[DW_WRITEINIFILEERROR]				= val;
	}
}
//---------------------------------------------------------------------------
void
fsMultiReceiverLanguage::setupDefaultJapanese()
{
    //
    // MultiReceiverMainForm
    //
    MultiReceiverMainForm->Caption = "f̓M\tgEFA";
	
	//
    // MainDataModule
    //
	TMainDataModule *mdm = MainDataModule;

	// FileActionList
	mdm->FileAction->Caption						= "t@C(&F)";
	mdm->ReadIniFileAction->Caption					= "ݒ̓Ǎ(&O)";
	mdm->WriteIniFileAction->Caption				= "ݒ̕ۑ(&W)";
	mdm->ExitAction->Caption						= "I(&X)";

	// ShowActionList
	mdm->ShowAction->Caption						= "\(&V)";
	mdm->ShowVideoSelectionPanel->Caption			= "rfIIpl̕\(&V)";
	mdm->ShowOriginalVideoSizeAction->Caption		= "rfIMTCYŕ\(&O)";
	mdm->ShowMinVideoSizeAction->Caption			= "rfIkĕ\(&M)";

	// MulticastActionList
	mdm->MulticastAction->Caption					= "}`LXg(&M)";
	mdm->MulticastAddMediaAction->Caption			= "rfIM̒ǉ(&A)";
	mdm->MulticastDeleteMediaAction->Caption		= "rfIM̍폜(&D)";
	mdm->MulticastShowReceiveMonitorAction->Caption	= "Mj^̕\(&R)";
	mdm->AddMediaOKAction->Caption					= "s";
	mdm->AddMediaCancelAction->Caption				= "LZ";
    mdm->MulticastRemoteSettingAction->Caption		= "ȕڍאݒ(&E)";

	// LanguageActionList
	mdm->LanguageAction->Caption					= "ELang(&L)";

	// HelpActionList
	mdm->HelpAction->Caption						= "wv(&H)";
	mdm->VersionInfoAction->Caption					= "o[W(&V)";

	// MulticastSettingActionList
	mdm->CreateIPv6AddressAction->Caption			= "(IPv6)";
	mdm->CreateIPv4AddressAction->Caption			= "(IPv4)";
	mdm->AddressUpdateAction->Caption				= "XV";
	mdm->TTLUpdateAction->Caption					= "XV";

    // VersionInfoActionList
    mdm->VersionInfoOKAction->Caption				= "OK";

	// Dialogs
	mdm->IniFileOpenDialog->Filter					= "ݒt@C|*.ini";
    mdm->IniFileOpenDialog->Title					= "ݒǍ";
    mdm->IniFileSaveDialog->Filter					= "ݒt@C|*.ini";
    mdm->IniFileSaveDialog->Title					= "ݒۑ";


	//
	// AddMediaForm
	//
	TAddMediaForm* amf = AddMediaForm;

	amf->Caption									= "rfIM̒ǉ";
	amf->MediaMulticastAddressLabel->Caption		= "M}`LXgAhX";


	//
	// VideoSelectionForm
	//
	TVideoSelectionForm* vsf = VideoSelectionForm;

	vsf->Caption									= "rfȊI";
	vsf->SelectCaptionGroupBox->Caption				= "MLvVI";
	vsf->SelectAddressGroupBox->Caption				= "MAhXI";


    //
    // Receive Monitor Form
    //
    TReceiveMonitorForm* rmf = ReceiveMonitorForm;
	rmf->Caption									= "Receiver Monitor";
	rmf->ReceiveRateLabel->Caption					= "rbg[g (kbit/s)";
	rmf->FrameRateLabel->Caption					= "Tv[g (sample/s)";
	rmf->DropPacketLabel->Caption					= "hbvpPbg";
    rmf->DropFrameLabel->Caption					= "hbvTv";
    rmf->PacketSizeLabel->Caption					= "pPbgTCY (byte)";
	rmf->ReceiveRateVideoAllLabel->Caption			= "MrfIv";


    //
    // MulticastSettingForm
    //
	TMulticastSettingForm *ms = MulticastSettingForm;
	ms->Caption										= "}`LXg̏ڍאݒ";
	ms->AddressGroupBox->Caption					= "}`LXgIPAhX";
	ms->TTLLabel->Caption							= "őzbvJEg";


    //
    // VersionInfoFrom
    //
    TVersionInfoForm *vf = VersionInfoForm;

    vf->Caption										= "o[W";
    vf->VersionInfoSoftwareNameLabel->Caption		= "f̓M\tgEFA v1.0";

    
	//
	// Dynamic Words
	//
	_dynamicWords[DW_RECEIVEVIDEO]					= "MrfI:";
	_dynamicWords[DW_STATUSRECEIVE]					= "M";
	_dynamicWords[DW_STATUSSTOP]					= "~";
	_dynamicWords[DW_AREYOUOK]						= "{ɂ낵łH";
	_dynamicWords[DW_CONFIRM]						= "폜";
    _dynamicWords[DW_ERROR]							= "G[";
	_dynamicWords[DW_SOCKETERROR]					= "\PbgG[";
	_dynamicWords[DW_RECEIVEREXISTERROR]			= "̃AhX͊ɑ݂Ă܂B";
	_dynamicWords[DW_ADDRECEIVERERROR]				= "rfIM̒ǉɎs܂B";
	_dynamicWords[DW_REMOVERECEIVERERROR]			= "rfIM̍폜Ɏs܂B";
	_dynamicWords[DW_READINIFILEERROR]				= "ݒ̓Ǎ݂Ɏs܂B";
	_dynamicWords[DW_WRITEINIFILEERROR]				= "ݒ̕ۑɎs܂B";
}
//---------------------------------------------------------------------------
void
fsMultiReceiverLanguage::setupDefaultEnglish()
{
    //
    // MultiReceiverMainForm
    //
    MultiReceiverMainForm->Caption = "Multi Video Receiver Software";
	
	//
    // MainDataModule
    //
	TMainDataModule *mdm = MainDataModule;

	// FileActionList
	mdm->FileAction->Caption						= "&File";
	mdm->ReadIniFileAction->Caption					= "&Load Settings";
	mdm->WriteIniFileAction->Caption				= "&Save Settings";
	mdm->ExitAction->Caption						= "&Exit";

	// ShowActionList
	mdm->ShowAction->Caption						= "&Display";
	mdm->ShowVideoSelectionPanel->Caption			= "&Video Selection Panel";
	mdm->ShowOriginalVideoSizeAction->Caption		= "&Original Video Size";
	mdm->ShowMinVideoSizeAction->Caption			= "&Minimize Video Size";

	// MulticastActionList
	mdm->MulticastAction->Caption					= "&Multicast";
	mdm->MulticastAddMediaAction->Caption			= "&Add Video";
	mdm->MulticastDeleteMediaAction->Caption		= "&Remove Video";
	mdm->MulticastShowReceiveMonitorAction->Caption	= "Receive &Monitor";
	mdm->AddMediaOKAction->Caption					= "OK";
	mdm->AddMediaCancelAction->Caption				= "Cancel";
    mdm->MulticastRemoteSettingAction->Caption		= "R&emote Control Settings";

	// LanguageActionList
	mdm->LanguageAction->Caption					= "&Language";

	// HelpActionList
	mdm->HelpAction->Caption						= "&Help";
	mdm->VersionInfoAction->Caption					= "&Version Info.";

	// MulticastSettingActionList
	mdm->CreateIPv6AddressAction->Caption			= "Generate(IPv6)";
	mdm->CreateIPv4AddressAction->Caption			= "Generate(IPv4)";
	mdm->AddressUpdateAction->Caption				= "Update";
	mdm->TTLUpdateAction->Caption					= "Update";

    // VersionInfoActionList
    mdm->VersionInfoOKAction->Caption				= "OK";

	// Dialogs
	mdm->IniFileOpenDialog->Filter					= "Setting File|*.ini";
    mdm->IniFileOpenDialog->Title					= "Load Settings";
    mdm->IniFileSaveDialog->Filter					= "Setting File|*.ini";
    mdm->IniFileSaveDialog->Title					= "Save Settings";


	//
	// AddMediaForm
	//
	TAddMediaForm* amf = AddMediaForm;

	amf->Caption									= "Add Video";
	amf->MediaMulticastAddressLabel->Caption		= "Multicast Address";


	//
	// VideoSelectionForm
	//
	TVideoSelectionForm* vsf = VideoSelectionForm;

	vsf->Caption									= "Select Video";
	vsf->SelectCaptionGroupBox->Caption				= "Select using a Caption";
	vsf->SelectAddressGroupBox->Caption				= "Select using a Address";


    //
    // Receive Monitor Form
    //
    TReceiveMonitorForm* rmf = ReceiveMonitorForm;
	rmf->Caption								= "Receiver Monitor";
	rmf->ReceiveRateLabel->Caption				= "Bit Rate (kbit/s)";
	rmf->FrameRateLabel->Caption				= "Sample Rate (sample/s)";
	rmf->DropPacketLabel->Caption				= "Number of Missing Packets";
    rmf->DropFrameLabel->Caption				= "Number of Missing Samples";
    rmf->PacketSizeLabel->Caption				= "Packet Size";
	rmf->ReceiveRateVideoAllLabel->Caption		= "Video(Total)";


    //
    // MulticastSettingForm
    //
	TMulticastSettingForm *ms = MulticastSettingForm;
	ms->Caption										= "Settings of Multicast";
	ms->AddressGroupBox->Caption					= "Multicast IP Address";
	ms->TTLLabel->Caption							= "Max. Hop Count";


    //
    // VersionInfoFrom
    //
    TVersionInfoForm *vf = VersionInfoForm;

    vf->Caption										= "Version Info.";
    vf->VersionInfoSoftwareNameLabel->Caption		= "Multi Video Receiver Software v1.0";

	//
	// Dynamic Words
	//
	_dynamicWords[DW_RECEIVEVIDEO]					= "Video:";
	_dynamicWords[DW_STATUSRECEIVE]					= "Receiving";
	_dynamicWords[DW_STATUSSTOP]					= "No Data Received";
	_dynamicWords[DW_AREYOUOK]						= "Are you OK?";
	_dynamicWords[DW_CONFIRM]						= "Delete";
    _dynamicWords[DW_ERROR]							= "Error";
	_dynamicWords[DW_SOCKETERROR]					= "Socket Error";
	_dynamicWords[DW_RECEIVEREXISTERROR]			= "Address is already exist.";
	_dynamicWords[DW_ADDRECEIVERERROR]				= "The addition of video reception went wrong.";
	_dynamicWords[DW_REMOVERECEIVERERROR]			= "Deletion of video reception went wrong.";
	_dynamicWords[DW_READINIFILEERROR]				= "Failed to Load setting.";
	_dynamicWords[DW_WRITEINIFILEERROR]				= "Failed to Save setting.";
}
//---------------------------------------------------------------------------

