/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fsMultiReceiverMainForm.h"
#include "fsVideoSelectionForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TVideoSelectionForm *VideoSelectionForm;
//---------------------------------------------------------------------------
__fastcall
TVideoSelectionForm::TVideoSelectionForm(TComponent* Owner)
: TForm(Owner)
{
	_captionList = new TObjectList();
    _addressList = new TObjectList();
    _captionSelectIndex	= -1;
    _addressSelectIndex	= -1;
}
//---------------------------------------------------------------------------
__fastcall
TVideoSelectionForm::~TVideoSelectionForm()
{
	_captionList->Clear();
	delete _captionList;

	_addressList->Clear();
    delete _addressList;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void
TVideoSelectionForm::beginList()
{
	_captionList->Clear();
	_addressList->Clear();
}
//---------------------------------------------------------------------------
void
TVideoSelectionForm::endList()
{
    SelectCaptionList->Clear();
    for(int i = 0; i < _captionList->Count; i++)
    {
    	TIndexStringEntry *entry = (TIndexStringEntry *)_captionList->Items[i];
		SelectCaptionList->Items->Add(entry->string);
    }

    SelectAddressList->Clear();
    for(int i = 0; i < _addressList->Count; i++)
    {
    	TIndexStringEntry *entry = (TIndexStringEntry *)_addressList->Items[i];
		SelectAddressList->Items->Add(entry->string);
    }

    if (_captionSelectIndex < _captionList->Count)
    	SelectCaptionList->ItemIndex = _captionSelectIndex;
    else
    	_captionSelectIndex = -1;

    if (_addressSelectIndex < _addressList->Count)
    	SelectAddressList->ItemIndex = _addressSelectIndex;
    else
    	_addressSelectIndex = -1;
}
//---------------------------------------------------------------------------
void
TVideoSelectionForm::addCaption(int index, const AnsiString& caption)
{
	_captionList->Add(new TIndexStringEntry(index, caption));
}
//---------------------------------------------------------------------------
void
TVideoSelectionForm::addAddress(int index, const AnsiString& address)
{
	_addressList->Add(new TIndexStringEntry(index, address));
}
//---------------------------------------------------------------------------
void __fastcall
TVideoSelectionForm::SelectCaptionListClick(TObject *Sender)
{
	_captionSelectIndex = SelectCaptionList->ItemIndex;
    if (_captionSelectIndex == -1)
    	return ;

	TIndexStringEntry *entry = (TIndexStringEntry *)_captionList->Items[_captionSelectIndex];
    MultiReceiverMainForm->scrollAndSelect(entry->index);
}
//---------------------------------------------------------------------------
void __fastcall
TVideoSelectionForm::SelectAddressListClick(TObject *Sender)
{
	_addressSelectIndex = SelectAddressList->ItemIndex;
	if (_addressSelectIndex == -1)
    	return ;

	TIndexStringEntry *entry = (TIndexStringEntry *)_addressList->Items[_addressSelectIndex];
    MultiReceiverMainForm->scrollAndSelect(entry->index);
}
//---------------------------------------------------------------------------

