/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fsMainDataModule.h"
#include "fsPointerSettingForm.h"
#include <fs/fsReceiverRemote/fsReceiverRemoteInterface.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPointerSettingForm *PointerSettingForm;
//---------------------------------------------------------------------------
__fastcall TPointerSettingForm::TPointerSettingForm(TComponent* Owner)
	: TForm(Owner)
{
	_formShown		= false;
    _currentPointer	= 0;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall
TPointerSettingForm::FormShow(TObject *Sender)
{
	PointerSelectionComboBox->ItemIndex = _currentPointer;
    updateForm();

	_formShown = true;
}
//---------------------------------------------------------------------------
void __fastcall
TPointerSettingForm::FormHide(TObject *Sender)
{
	_formShown = false;
}
//---------------------------------------------------------------------------
void __fastcall
TPointerSettingForm::PointerSelectionComboBoxChange(TObject *Sender)
{
	_currentPointer = PointerSelectionComboBox->ItemIndex;
    updateForm();
}
//---------------------------------------------------------------------------
void __fastcall
TPointerSettingForm::PointerShapeComboBoxChange(TObject *Sender)
{
	int index = PointerShapeComboBox->ItemIndex;
    fsReceiverSetPointer(_currentPointer, index);
}
//---------------------------------------------------------------------------
void __fastcall
TPointerSettingForm::PointerPhraseComboBoxClick(TObject *Sender)
{
	int index = PointerPhraseComboBox->ItemIndex;
	AnsiString phrase = PointerPhraseComboBox->Items->Strings[index];
    fsReceiverSetPointerPhrase(_currentPointer, phrase.c_str());
}
//---------------------------------------------------------------------------
void __fastcall
TPointerSettingForm::PointerPhraseComboBoxKeyPress(TObject *Sender, char &Key)
{
	if (Key == VK_RETURN)
    {
		AnsiString phrase = PointerPhraseComboBox->Text;
		fsReceiverSetPointerPhrase(_currentPointer, phrase.c_str());

        int index = PointerPhraseComboBox->Items->IndexOf(phrase);
        if (index == -1)
        	PointerPhraseComboBox->Items->Add(phrase);
    }
}
//---------------------------------------------------------------------------
void __fastcall
TPointerSettingForm::PointerColorREditChange(TObject *Sender)
{
	if (!_formShown)
    	return ;
    unsigned char color[3];
	color[0] = (unsigned char)PointerColorRUpDown->Position;
	color[1] = (unsigned char)PointerColorGUpDown->Position;
	color[2] = (unsigned char)PointerColorBUpDown->Position;
	fsReceiverSetPointerColor(_currentPointer, color);

    MainDataModule->ColorDialog->Color = TColor(
    			color[0] | (color[1] << 8) | (color[2] << 16));
}
//---------------------------------------------------------------------------
void __fastcall
TPointerSettingForm::PointerColorGEditChange(TObject *Sender)
{
	if (!_formShown)
    	return ;
    unsigned char color[3];
	color[0] = (unsigned char)PointerColorRUpDown->Position;
	color[1] = (unsigned char)PointerColorGUpDown->Position;
	color[2] = (unsigned char)PointerColorBUpDown->Position;
	fsReceiverSetPointerColor(_currentPointer, color);

    MainDataModule->ColorDialog->Color = TColor(
    			color[0] | (color[1] << 8) | (color[2] << 16));
}
//---------------------------------------------------------------------------
void __fastcall
TPointerSettingForm::PointerColorBEditChange(TObject *Sender)
{
	if (!_formShown)
    	return ;
    unsigned char color[3];
	color[0] = (unsigned char)PointerColorRUpDown->Position;
	color[1] = (unsigned char)PointerColorGUpDown->Position;
	color[2] = (unsigned char)PointerColorBUpDown->Position;
	fsReceiverSetPointerColor(_currentPointer, color);

    MainDataModule->ColorDialog->Color = TColor(
    			color[0] | (color[1] << 8) | (color[2] << 16));
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void
TPointerSettingForm::updateForm()
{
	//
    // Items
    //

	// Pointer Shape
    PointerShapeComboBox->ItemIndex = fsReceiverGetPointer(_currentPointer);

    // Phrase
	PointerPhraseComboBox->Text = fsReceiverGetPointerPhrase(_currentPointer);

    // Color
	unsigned char color[3];
	fsReceiverGetPointerColor(_currentPointer, color);
    PointerColorRUpDown->Position = color[0];
    PointerColorGUpDown->Position = color[1];
    PointerColorBUpDown->Position = color[2];

    // Setup Color to ColorDialog
    MainDataModule->ColorDialog->Color = TColor(
    			color[0] | (color[1] << 8) | (color[2] << 16));

    // Check PointerAutomatic Setup
    bool disable = !fsReceiverGetPointerAutomaticSetupOn();
	PointerShapeLabel->Enabled = disable;
    PointerShapeComboBox->Enabled = disable;

	PointerColorLabel->Enabled = disable;
    PointerColorRLabel->Enabled = disable;
    PointerColorGLabel->Enabled = disable;
    PointerColorBLabel->Enabled = disable;
    PointerColorREdit->Enabled = disable;
    PointerColorGEdit->Enabled = disable;
    PointerColorBEdit->Enabled = disable;
    PointerColorRUpDown->Enabled = disable;
    PointerColorGUpDown->Enabled = disable;
    PointerColorBUpDown->Enabled = disable;

    PointerColorChooseButton->Enabled = disable;

    //
    // Actions
    //
	MainDataModule->PointerCoordinateDesktopWindowAction->Checked =
    	(fsReceiverGetPointerCoordinate() == FSRECEIVER_FSC_DESKTOPWINDOW);

	MainDataModule->PointerCoordinateVideoWindowAction->Checked =
    	(fsReceiverGetPointerCoordinate() == FSRECEIVER_FSC_VIDEOWINDOW);

}
//---------------------------------------------------------------------------

