/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#ifndef fsMainDataModuleH
#define fsMainDataModuleH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ImgList.hpp>
#include <ExtCtrls.hpp>
#include <ActnList.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class fsReceiverCommandHistory;
//---------------------------------------------------------------------------
class TMainDataModule : public TDataModule
{
__published:	// IDE Ǘ̃R|[lg
	TImageList *ImageList;
	TTimer *ReceiverTimer;
    TTimer *ReceiveMonitorTimer;
    TOpenDialog *IniFileOpenDialog;
    TSaveDialog *IniFileSaveDialog;
    TMainMenu *MainMenu;
	TActionList *MulticastSettingActionList;
	TAction *AddressUpdateAction;
	TAction *TTLUpdateAction;
	TMenuItem *LanguageMenuItem;
	TActionList *LanguageActionList;
	TAction *LanguageAction;
	TActionList *OperationActionList;
	TAction *OperationAction;
	TAction *ReceiveOnOffAction;
	TAction *PointerTransmissionOnAction;
	TAction *DrawLocusOnAction;
	TAction *RaiseOnAction;
	TAction *WriteIniFileAction;
	TAction *ReadIniFileAction;
	TAction *ExitAction;
	TActionList *ShowActionList;
	TAction *ShowAction;
	TAction *FitVideoToWindowAction;
	TAction *KeepVideoAspectAction;
	TAction *OriginalVideoSizeAction;
	TAction *FitWindowToVideoAction;
	TActionList *OptionActionList;
	TAction *OptionAction;
	TAction *PointerAutoConfigOnAction;
	TAction *GeneralPointerNoneAction;
	TAction *GeneralPointerStandardAction;
	TAction *GeneralPointerArrowAction;
	TAction *GeneralPointerCircleAction;
	TAction *GeneralPointerRectangleAction;
	TAction *GeneralPointerTargetAction;
	TAction *GeneralPointerStarAction;
	TAction *GeneralPointerDetailAction;
	TAction *RaisePointer1Action;
	TAction *RaisePointer2Action;
	TAction *RaisePointer3Action;
	TAction *LocusPointer1Action;
	TAction *LocusPointer2Action;
	TAction *LocusPointer3Action;
	TAction *RaisePointerDetailAction;
	TAction *LocusPointerDetailAction;
	TAction *PointerSettingAction;
	TAction *PointerAction;
	TAction *MulticastAction;
	TAction *MulticastSettingAction;
	TAction *ReceiveMonitorShowAction;
	TActionList *HelpActionList;
	TAction *HelpAction;
	TAction *VersionInfoAction;
	TMenuItem *OperationMenuItem;
	TMenuItem *ReceiveOnOffMenuItem;
	TMenuItem *OperationSeparator1;
	TMenuItem *PointerTransmissionOnMenuItem;
	TMenuItem *RaiseOnMenuItem;
	TMenuItem *DrawLocusOnMenuItem;
	TMenuItem *OperationSeparator2;
	TMenuItem *ReadIniFileMenuItem;
	TMenuItem *WriteIniFileMenuItem;
	TMenuItem *OperationSeparator3;
	TMenuItem *OperationHistoryBeginMenuItem;
	TMenuItem *OperationHistoryEndMenuItem;
	TMenuItem *OperationSeparator4;
	TMenuItem *ExitMenuItem;
	TMenuItem *ShowMenuItem;
	TMenuItem *FitVideoToWindowMenuItem;
	TMenuItem *KeepVideoAspectMenuItem;
	TMenuItem *OriginalVideoSizeMenuItem;
	TMenuItem *FitWindowToVideoMenuItem;
	TMenuItem *OptionMenuItem;
	TMenuItem *PointerMenuItem;
	TMenuItem *PointerAutoConfigOnMenuItem;
	TAction *GeneralPointerAction;
	TAction *RaisePointerAction;
	TAction *LocusPointerAction;
	TMenuItem *GeneralPointerMenuItem;
	TMenuItem *GeneralPointerNoneMenuItem;
	TMenuItem *GeneralPointerStandardMenuItem;
	TMenuItem *GeneralPointerArrowMenuItem;
	TMenuItem *GeneralPointerCircleMenuItem;
	TMenuItem *GeneralPointerRectangleMenuItem;
	TMenuItem *GeneralPointerTargetMenuItem;
	TMenuItem *GeneralPointerStarMenuItem;
	TMenuItem *GeneralPointerDetailMenuItem;
	TMenuItem *RaisePointerMenuItem;
	TMenuItem *RaisePointer1MenuItem;
	TMenuItem *RaisePointer2MenuItem;
	TMenuItem *RaisePointer3MenuItem;
	TMenuItem *LocusPointerMenuItem;
	TMenuItem *LocusPointer1MenuItem;
	TMenuItem *LocusPointer2MenuItem;
	TMenuItem *LocusPointer3MenuItem;
	TMenuItem *RaisePointerDetailMenuItem;
	TMenuItem *LocusPointerDetailMenuItem;
	TMenuItem *PointerSeparator1;
	TMenuItem *PointerSeparator2;
	TMenuItem *PointerSettingMenuItem;
	TMenuItem *MulticastMenuItem;
	TMenuItem *MulticastSettingMenuItem;
	TMenuItem *MulticastSeparator1;
	TMenuItem *ReceiveMonitorShowMenuItem;
	TMenuItem *HelpMenuItem;
	TMenuItem *VersionInfoMenuItem;
	TActionList *PointerSettingActionList;
	TAction *PointerCoordinateDesktopWindowAction;
	TAction *PointerCoordinateVideoWindowAction;
	TAction *PointerColorChooseAction;
	TColorDialog *ColorDialog;
	TAction *AddRejectionAddressAction;
	TAction *RemoveRejectionAddressAction;
	TAction *CreateIPv6AddressAction;
	TAction *CreateIPv4AddressAction;
	TTimer *MulticastSettingTimer;
	TMenuItem *ShowSeparator1;
	TMenuItem *VolumeIndicatorShowMenuItem;
	TAction *VolumeIndicatorShowAction;
	TActionList *VersionActionList;
	TAction *VersionInfoOKAction;
	TAction *SynchronizeSenderAddressOnAction;
	void __fastcall ReceiverTimerTimer(TObject *Sender);
    void __fastcall ReceiveMonitorTimerTimer(TObject *Sender);
    void __fastcall WriteIniFileActionExecute(TObject *Sender);
    void __fastcall ReadIniFileActionExecute(TObject *Sender);
    void __fastcall DataModuleCreate(TObject *Sender);
    void __fastcall WriteIniFileActionUpdate(TObject *Sender);
    void __fastcall ReadIniFileActionUpdate(TObject *Sender);
    void __fastcall ExitActionExecute(TObject *Sender);
    void __fastcall ExitActionUpdate(TObject *Sender);
    void __fastcall MulticastSettingActionExecute(TObject *Sender);
	void __fastcall LanguageActionExecute(TObject *Sender);
	void __fastcall DataModuleDestroy(TObject *Sender);
	void __fastcall AddressUpdateActionExecute(TObject *Sender);
	void __fastcall AddressUpdateActionUpdate(TObject *Sender);
	void __fastcall TTLUpdateActionExecute(TObject *Sender);
	void __fastcall TTLUpdateActionUpdate(TObject *Sender);
	void __fastcall OperationActionExecute(TObject *Sender);
	void __fastcall ReceiveOnOffActionExecute(TObject *Sender);
	void __fastcall ReceiveOnOffActionUpdate(TObject *Sender);
	void __fastcall PointerTransmissionOnActionExecute(TObject *Sender);
	void __fastcall PointerTransmissionOnActionUpdate(TObject *Sender);
	void __fastcall DrawLocusOnActionExecute(TObject *Sender);
	void __fastcall DrawLocusOnActionUpdate(TObject *Sender);
	void __fastcall RaiseOnActionExecute(TObject *Sender);
	void __fastcall RaiseOnActionUpdate(TObject *Sender);
	void __fastcall ShowActionExecute(TObject *Sender);
	void __fastcall FitVideoToWindowActionExecute(TObject *Sender);
	void __fastcall FitVideoToWindowActionUpdate(TObject *Sender);
	void __fastcall KeepVideoAspectActionExecute(TObject *Sender);
	void __fastcall OriginalVideoSizeActionExecute(TObject *Sender);
	void __fastcall OriginalVideoSizeActionUpdate(TObject *Sender);
	void __fastcall FitWindowToVideoActionExecute(TObject *Sender);
	void __fastcall FitWindowToVideoActionUpdate(TObject *Sender);
	void __fastcall OptionActionExecute(TObject *Sender);
	void __fastcall PointerActionExecute(TObject *Sender);
	void __fastcall PointerAutoConfigOnActionExecute(TObject *Sender);
	void __fastcall PointerAutoConfigOnActionUpdate(TObject *Sender);
	void __fastcall GeneralPointerNoneActionExecute(TObject *Sender);
	void __fastcall GeneralPointerNoneActionUpdate(TObject *Sender);
	void __fastcall GeneralPointerStandardActionExecute(TObject *Sender);
	void __fastcall GeneralPointerStandardActionUpdate(TObject *Sender);
	void __fastcall GeneralPointerArrowActionExecute(TObject *Sender);
	void __fastcall GeneralPointerArrowActionUpdate(TObject *Sender);
	void __fastcall GeneralPointerCircleActionExecute(TObject *Sender);
	void __fastcall GeneralPointerCircleActionUpdate(TObject *Sender);
	void __fastcall GeneralPointerRectangleActionExecute(TObject *Sender);
	void __fastcall GeneralPointerRectangleActionUpdate(TObject *Sender);
	void __fastcall GeneralPointerTargetActionExecute(TObject *Sender);
	void __fastcall GeneralPointerTargetActionUpdate(TObject *Sender);
	void __fastcall GeneralPointerStarActionExecute(TObject *Sender);
	void __fastcall GeneralPointerStarActionUpdate(TObject *Sender);
	void __fastcall GeneralPointerDetailActionExecute(TObject *Sender);
	void __fastcall GeneralPointerDetailActionUpdate(TObject *Sender);
	void __fastcall RaisePointer1ActionExecute(TObject *Sender);
	void __fastcall RaisePointer1ActionUpdate(TObject *Sender);
	void __fastcall RaisePointer2ActionExecute(TObject *Sender);
	void __fastcall RaisePointer2ActionUpdate(TObject *Sender);
	void __fastcall RaisePointer3ActionExecute(TObject *Sender);
	void __fastcall RaisePointer3ActionUpdate(TObject *Sender);
	void __fastcall RaisePointerDetailActionExecute(TObject *Sender);
	void __fastcall RaisePointerDetailActionUpdate(TObject *Sender);
	void __fastcall LocusPointer1ActionExecute(TObject *Sender);
	void __fastcall LocusPointer1ActionUpdate(TObject *Sender);
	void __fastcall LocusPointer2ActionExecute(TObject *Sender);
	void __fastcall LocusPointer2ActionUpdate(TObject *Sender);
	void __fastcall LocusPointer3ActionExecute(TObject *Sender);
	void __fastcall LocusPointer3ActionUpdate(TObject *Sender);
	void __fastcall LocusPointerDetailActionExecute(TObject *Sender);
	void __fastcall LocusPointerDetailActionUpdate(TObject *Sender);
	void __fastcall PointerSettingActionExecute(TObject *Sender);
	void __fastcall PointerSettingActionUpdate(TObject *Sender);
	void __fastcall MulticastSettingActionUpdate(TObject *Sender);
	void __fastcall ReceiveMonitorShowActionExecute(TObject *Sender);
	void __fastcall ReceiveMonitorShowActionUpdate(TObject *Sender);
	void __fastcall HelpActionExecute(TObject *Sender);
	void __fastcall VersionInfoActionExecute(TObject *Sender);
	void __fastcall VersionInfoActionUpdate(TObject *Sender);
	void __fastcall GeneralPointerActionExecute(TObject *Sender);
	void __fastcall RaisePointerActionExecute(TObject *Sender);
	void __fastcall LocusPointerActionExecute(TObject *Sender);
	void __fastcall KeepVideoAspectActionUpdate(TObject *Sender);
	void __fastcall MulticastActionExecute(TObject *Sender);
	void __fastcall PointerCoordinateDesktopWindowActionExecute(
          TObject *Sender);
	void __fastcall PointerCoordinateDesktopWindowActionUpdate(
          TObject *Sender);
	void __fastcall PointerCoordinateVideoWindowActionExecute(
          TObject *Sender);
	void __fastcall PointerCoordinateVideoWindowActionUpdate(TObject *Sender);
	void __fastcall PointerColorChooseActionExecute(TObject *Sender);
	void __fastcall AddRejectionAddressActionExecute(TObject *Sender);
	void __fastcall AddRejectionAddressActionUpdate(TObject *Sender);
	void __fastcall RemoveRejectionAddressActionExecute(TObject *Sender);
	void __fastcall RemoveRejectionAddressActionUpdate(TObject *Sender);
	void __fastcall CreateIPv6AddressActionExecute(TObject *Sender);
	void __fastcall CreateIPv6AddressActionUpdate(TObject *Sender);
	void __fastcall CreateIPv4AddressActionExecute(TObject *Sender);
	void __fastcall CreateIPv4AddressActionUpdate(TObject *Sender);
	void __fastcall MulticastSettingTimerTimer(TObject *Sender);
	void __fastcall VolumeIndicatorShowActionExecute(TObject *Sender);
	void __fastcall VersionInfoOKActionExecute(TObject *Sender);
	void __fastcall VersionInfoOKActionUpdate(TObject *Sender);
	void __fastcall SynchronizeSenderAddressOnActionExecute(TObject *Sender);
	void __fastcall SynchronizeSenderAddressOnActionUpdate(TObject *Sender);
private:	// [U[錾
public:		// [U[錾
	__fastcall TMainDataModule(TComponent* Owner);

protected:
    fsReceiverCommandHistory*	_commandHistory;
};
//---------------------------------------------------------------------------
extern PACKAGE TMainDataModule *MainDataModule;
//---------------------------------------------------------------------------
#endif
