/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fsMainDataModule.h"
#include "fsMulticastSettingForm.h"
#include <fs/fsReceiver/fsReceiverInterface.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMulticastSettingForm *MulticastSettingForm;
//---------------------------------------------------------------------------
__fastcall
TMulticastSettingForm::TMulticastSettingForm(TComponent* Owner) :
TForm(Owner)
{
	_formShown = false;
}
//---------------------------------------------------------------------------
void __fastcall
TMulticastSettingForm::FormShow(TObject *Sender)
{
	updateForm();
    updateRejectionAddressList();

    _addressIsDirty		= false;
    _timeToLiveIsDirty	= false;

    _inputAddress		= AddressEdit->Text;
    if (_inputAddress.Length() != 0)
    	fsReceiverAddMulticastDetector(_inputAddress.c_str());

    MainDataModule->MulticastSettingTimer->Enabled = true;

    _formShown = true;
}
//---------------------------------------------------------------------------
void __fastcall
TMulticastSettingForm::FormHide(TObject *Sender)
{
	_formShown = false;

    MainDataModule->MulticastSettingTimer->Enabled = false;

	if (_inputAddress.Length() != 0)
    	fsReceiverRemoveMulticastDetector(_inputAddress.c_str());
}
//---------------------------------------------------------------------------
void __fastcall
TMulticastSettingForm::AddressEditChange(TObject *Sender)
{
	if (!_formShown)
		return;

    _addressIsDirty = true;

    if (_inputAddress.Length() != 0)
    	fsReceiverRemoveMulticastDetector(_inputAddress.c_str());

    _inputAddress = AddressEdit->Text;
    if (_inputAddress.Length() != 0)
	    fsReceiverAddMulticastDetector(_inputAddress.c_str());
}
//---------------------------------------------------------------------------
void __fastcall
TMulticastSettingForm::TTLEditChange(TObject *Sender)
{
	_timeToLiveIsDirty = true;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void
TMulticastSettingForm::updateForm()
{
	MainDataModule->SynchronizeSenderAddressOnAction->Checked =
    		fsReceiverGetSynchronizeSenderAddressOn();

	AddressEdit->Text = fsReceiverGetAddress();
    TTLEdit->Text = AnsiString(fsReceiverGetTimeToLive());
    MulticastDetectLabel->Visible = false;
}
//---------------------------------------------------------------------------
void
TMulticastSettingForm::updateRejectionAddressList()
{
	RejectionAddressList->Clear();

	int numAddress = fsReceiverGetNumRejectionAddress();
    for(int i = 0; i < numAddress; i++)
    	RejectionAddressList->Items->Add(fsReceiverGetRejectionAddress(i));

    RejectionAddressList->ItemIndex = -1;
}
//---------------------------------------------------------------------------

