/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#include "fsReceiverCommandHistory.h"
#include "fsReceiverLanguage.h"
#include "fsReceiverMainForm.h"
#include "fsMainDataModule.h"
#include <fs/fsReceiver/fsReceiverInterface.h>
//---------------------------------------------------------------------------
fsReceiverCommandHistory::fsReceiverCommandHistory(
						TMenuItem* HistoryBeginMenuItem,
						TMenuItem* HistoryEndMenuItem) :
fsCommandHistory(HistoryBeginMenuItem, HistoryEndMenuItem, 20)
{
}
//---------------------------------------------------------------------------
fsReceiverCommandHistory::~fsReceiverCommandHistory()
{
}
//---------------------------------------------------------------------------
AnsiString
fsReceiverCommandHistory::getPrefixIdString(int prefixId)
{
	AnsiString str;

	switch(prefixId)
    {
	case P_SHOW:
    	str = ReceiverMainForm->_language->getDynamicWord(DW_SHOW);
    	break;
    case P_POINTER:
    	str = ReceiverMainForm->_language->getDynamicWord(DW_POINTER);
    	break;
	case P_GENERALPOINTER:
    	str = ReceiverMainForm->_language->getDynamicWord(DW_GENERALPOINTER);
    	break;
    case P_RAISEPOINTER:
    	str = ReceiverMainForm->_language->getDynamicWord(DW_RAISEPOINTER);
    	break;
    case P_LOCUSPOINTER:
    	str = ReceiverMainForm->_language->getDynamicWord(DW_LOCUSPOINTER);
    	break;
   	case P_MULTICAST:
    	str = ReceiverMainForm->_language->getDynamicWord(DW_MULTICAST);
    	break;
    case P_READINIFILE:
    	str = ReceiverMainForm->_language->getDynamicWord(DW_READINIFILE);
    	break;
    case P_WRITEINIFILE:
    	str = ReceiverMainForm->_language->getDynamicWord(DW_WRITEINIFILE);
    	break;
    }

    return str;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void
fsReceiverCommandHistory::addReadIniFile(const AnsiString& filename)
{
	addOriginal(filename, ReadIniFileMenuItemOnExecute, NULL, P_READINIFILE);
}
//---------------------------------------------------------------------------
void
fsReceiverCommandHistory::addWriteIniFile(const AnsiString& filename)
{
	addOriginal(filename, WriteIniFileMenuItemOnExecute, NULL, P_WRITEINIFILE);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall
fsReceiverCommandHistory::ReadIniFileMenuItemOnExecute(TObject *Sender)
{
	TAction *action = (TAction *)Sender;
    fsReceiverReadIniFile(action->Caption.c_str());

    addReadIniFile(action->Caption);
}
//---------------------------------------------------------------------------
void __fastcall
fsReceiverCommandHistory::WriteIniFileMenuItemOnExecute(TObject *Sender)
{
	TAction *action = (TAction *)Sender;
    fsReceiverWriteIniFile(action->Caption.c_str());

    addWriteIniFile(action->Caption);
}
//---------------------------------------------------------------------------

