/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#include "fsMainDataModule.h"
#include "fsVersionInfoForm.h"
#include "fsMulticastSettingForm.h"
#include "fsPointerSettingForm.h"
#include "fsReceiveMonitorForm.h"
#include "fsReceiverMainForm.h"
#include "fsReceiverLanguage.h"
#include <ui/fsCommonUI/fsVolumeIndicatorForm.h>
#include <ui/fsCommonUI/fsErrorMessageForm.h>
#include <fs/fsReceiver/fsReceiverInterface.h>
//---------------------------------------------------------------------------
fsReceiverLanguage::fsReceiverLanguage(TMenuItem* LanguageMenuItem) :
fsLanguage(LanguageMenuItem)
{
}
//---------------------------------------------------------------------------
fsReceiverLanguage::~fsReceiverLanguage()
{
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
const AnsiString&
fsReceiverLanguage::getDynamicWord(int id)
{
	return _dynamicWords[id];
}
//---------------------------------------------------------------------------
void
fsReceiverLanguage::setupLanguage()
{
	AnsiString key, val;

	TMainDataModule			*mdm = MainDataModule;
	TPointerSettingForm		*ps = PointerSettingForm;
	TMulticastSettingForm	*ms = MulticastSettingForm;
	TReceiveMonitorForm		*rm = ReceiveMonitorForm;
	TVolumeIndicatorForm	*vif = VolumeIndicatorForm;
    TErrorMessageForm		*emf = ErrorMessageForm;
    TVersionInfoForm		*vf = VersionInfoForm;

	while(nextEntry(key, val))
	{
		if (key.Length() == 0)
			continue;

        const char *ckey = key.c_str();

		//
		// ReceiverMainForm
		//
		if (!strcmp(ckey, "ReceiverMainFormCaption"))
			ReceiverMainForm->Caption					= val;


		//
		// MainDataModule
		//

		// OperatonActionList
		else if (!strcmp(ckey, "mdmOperationActionCaption"))
			mdm->OperationAction->Caption				= val;
		else if (!strcmp(ckey, "mdmPointerTransmissionOnActionCaption"))
			mdm->PointerTransmissionOnAction->Caption	= val;
		else if (!strcmp(ckey, "mdmRaiseOnActionCaption"))
			mdm->RaiseOnAction->Caption					= val;
		else if (!strcmp(ckey, "mdmDrawLocusOnActionCaption"))
			mdm->DrawLocusOnAction->Caption				= val;
		else if (!strcmp(ckey, "mdmReadIniFileActionCaption"))
			mdm->ReadIniFileAction->Caption				= val;
		else if (!strcmp(ckey, "mdmWriteIniFileActionCaption"))
			mdm->WriteIniFileAction->Caption			= val;
		else if (!strcmp(ckey, "mdmExitActionCaption"))
			mdm->ExitAction->Caption					= val;

		// ShowActionList
		else if (!strcmp(ckey, "mdmShowActionCaption"))
			mdm->ShowAction->Caption					= val;
		else if (!strcmp(ckey, "mdmFitVideoToWindowActionCaption"))
			mdm->FitVideoToWindowAction->Caption		= val;
		else if (!strcmp(ckey, "mdmKeepVideoAspectActionCaption"))
			mdm->KeepVideoAspectAction->Caption			= val;
		else if (!strcmp(ckey, "mdmOriginalVideoSizeActionCaption"))
			mdm->OriginalVideoSizeAction->Caption		= val;
		else if (!strcmp(ckey, "mdmFitWindowToVideoActionCaption"))
			mdm->FitWindowToVideoAction->Caption		= val;
        else if (!strcmp(ckey, "mdmVolumeIndicatorShowActionCaption"))
        	mdm->VolumeIndicatorShowAction->Caption		= val;

		// OperationActionList
		else if (!strcmp(ckey, "mdmOptionActionCaption"))
			mdm->OptionAction->Caption					= val;
		else if (!strcmp(ckey, "mdmPointerActionCaption"))
			mdm->PointerAction->Caption					= val;
		else if (!strcmp(ckey, "mdmPointerAutoConfigOnActionCaption"))
			mdm->PointerAutoConfigOnAction->Caption		= val;
		else if (!strcmp(ckey, "mdmGeneralPointerActionCaption"))
			mdm->GeneralPointerAction->Caption			= val;
		else if (!strcmp(ckey, "mdmGeneralPointerNoneActionCaption"))
			mdm->GeneralPointerNoneAction->Caption		= val;
		else if (!strcmp(ckey, "mdmGeneralPointerStandardActionCaption"))
			mdm->GeneralPointerStandardAction->Caption	= val;
		else if (!strcmp(ckey, "mdmGeneralPointerArrowActionCaption"))
			mdm->GeneralPointerArrowAction->Caption		= val;
		else if (!strcmp(ckey, "mdmGeneralPointerCircleActionCaption"))
			mdm->GeneralPointerCircleAction->Caption	= val;
		else if (!strcmp(ckey, "mdmGeneralPointerRectangleActionCaption"))
			mdm->GeneralPointerRectangleAction->Caption	= val;
		else if (!strcmp(ckey, "mdmGeneralPointerTargetActionCaption"))
			mdm->GeneralPointerTargetAction->Caption	= val;
		else if (!strcmp(ckey, "mdmGeneralPointerStarActionCaption"))
			mdm->GeneralPointerStarAction->Caption		= val;
		else if (!strcmp(ckey, "mdmGeneralPointerDetailActionCaption"))
			mdm->GeneralPointerDetailAction->Caption	= val;
		else if (!strcmp(ckey, "mdmRaisePointerActionCaption"))
			mdm->RaisePointerAction->Caption			= val;
		else if (!strcmp(ckey, "mdmRaisePointer1ActionCaption"))
			mdm->RaisePointer1Action->Caption			= val;
		else if (!strcmp(ckey, "mdmRaisePointer2ActionCaption"))
			mdm->RaisePointer2Action->Caption			= val;
		else if (!strcmp(ckey, "mdmRaisePointer3ActionCaption"))
			mdm->RaisePointer3Action->Caption			= val;
		else if (!strcmp(ckey, "mdmRaisePointerDetailActionCaption"))
			mdm->RaisePointerDetailAction->Caption		= val;
		else if (!strcmp(ckey, "mdmLocusPointerActionCaption"))
			mdm->LocusPointerAction->Caption			= val;
		else if (!strcmp(ckey, "mdmLocusPointer1ActionCaption"))
			mdm->LocusPointer1Action->Caption			= val;
		else if (!strcmp(ckey, "mdmLocusPointer2ActionCaption"))
			mdm->LocusPointer2Action->Caption			= val;
		else if (!strcmp(ckey, "mdmLocusPointer3ActionCaption"))
			mdm->LocusPointer3Action->Caption			= val;
		else if (!strcmp(ckey, "mdmLocusPointerDetailActionCaption"))
			mdm->LocusPointerDetailAction->Caption		= val;
		else if (!strcmp(ckey, "mdmPointerSettingActionCaption"))
			mdm->PointerSettingAction->Caption			= val;
		else if (!strcmp(ckey, "mdmMulticastActionCaption"))
			mdm->MulticastAction->Caption				= val;
		else if (!strcmp(ckey, "mdmMulticastSettingActionCaption"))
			mdm->MulticastSettingAction->Caption		= val;
		else if (!strcmp(ckey, "mdmReceiveMonitorShowActionCaption"))
			mdm->ReceiveMonitorShowAction->Caption		= val;

		// LanguageActionList
		else if (!strcmp(ckey, "mdmLanguageActionCaption"))
			mdm->LanguageAction->Caption				= val;

		// HelpActionList
		else if (!strcmp(ckey, "mdmHelpActionCaption"))
			mdm->HelpAction->Caption					= val;
		else if (!strcmp(ckey, "mdmVersionInfoActionCaption"))
			mdm->VersionInfoAction->Caption				= val;

		// PointerSettingActionList
		else if (!strcmp(ckey, "mdmPointerCoordinateDesktopWindowActionCaption"))
			mdm->PointerCoordinateDesktopWindowAction->Caption	= val;
		else if (!strcmp(ckey, "mdmPointerCoordinateVideoWindowActionCaption"))
			mdm->PointerCoordinateVideoWindowAction->Caption	= val;
		else if (!strcmp(ckey, "mdmPointerColorChooseActionCaption"))
			mdm->PointerColorChooseAction->Caption				= val;

		// MulticastSettingActionList
        else if (!strcmp(ckey, "mdmSynchronizeSenderAddressOnActionCaption"))
        	mdm->SynchronizeSenderAddressOnAction->Caption = val;
		else if (!strcmp(ckey, "mdmCreateIPv6AddressActionCaption"))
			mdm->CreateIPv6AddressAction->Caption		=val;
		else if (!strcmp(ckey, "mdmCreateIPv4AddressActionCaption"))
			mdm->CreateIPv4AddressAction->Caption		=val;
		else if (!strcmp(ckey, "mdmAddressUpdateActionCaption"))
			mdm->AddressUpdateAction->Caption			=val;
		else if (!strcmp(ckey, "mdmTTLUpdateActionCaption"))
			mdm->TTLUpdateAction->Caption				=val;
		else if (!strcmp(ckey, "mdmAddRejectionAddressActionCaption"))
			mdm->AddRejectionAddressAction->Caption		=val;
		else if (!strcmp(ckey, "mdmRemoveRejectionAddressActionCaption"))
			mdm->RemoveRejectionAddressAction->Caption	=val;

        // VersionInfoActionList
        else if (!strcmp(ckey, "mdmVersionInfoOKActionCaption"))
        	mdm->VersionInfoOKAction->Caption				= val;

		// Dialogs
		else if (!strcmp(ckey, "mdmIniFileOpenDialogFilter"))
			mdm->IniFileOpenDialog->Filter				= val;
		else if (!strcmp(ckey, "mdmIniFileOpenDialogTitle"))
			mdm->IniFileOpenDialog->Title				= val;
		else if (!strcmp(ckey, "mdmIniFileSaveDialogFilter"))
			mdm->IniFileSaveDialog->Filter				= val;
		else if (!strcmp(ckey, "mdmIniFileSaveDialogTitle"))
			mdm->IniFileSaveDialog->Title				= val;


		//
		// PointerSettingForm
		//
		else if (!strcmp(ckey, "psCaption"))
			ps->Caption									= val;
		else if (!strcmp(ckey, "psPointerCoordinateGroupBoxCaption"))
			ps->PointerCoordinateGroupBox->Caption		= val;
		else if (!strcmp(ckey, "psPointerSettingGroupBoxCaption"))
			ps->PointerSettingGroupBox->Caption			= val;
		else if (!strcmp(ckey, "psPointerSelectionComboBoxItems0"))
			ps->PointerSelectionComboBox->Items->Strings[0]		= val;
		else if (!strcmp(ckey, "psPointerSelectionComboBoxItems1"))
			ps->PointerSelectionComboBox->Items->Strings[1]		= val;
		else if (!strcmp(ckey, "psPointerSelectionComboBoxItems2"))
			ps->PointerSelectionComboBox->Items->Strings[2]		= val;
		else if (!strcmp(ckey, "psPointerSelectionComboBoxItems3"))
			ps->PointerSelectionComboBox->Items->Strings[3]		= val;
		else if (!strcmp(ckey, "psPointerSelectionComboBoxItems4"))
			ps->PointerSelectionComboBox->Items->Strings[4]		= val;
		else if (!strcmp(ckey, "psPointerSelectionComboBoxItems5"))
			ps->PointerSelectionComboBox->Items->Strings[5]		= val;
		else if (!strcmp(ckey, "psPointerSelectionComboBoxItems6"))
			ps->PointerSelectionComboBox->Items->Strings[6]		= val;
		else if (!strcmp(ckey, "psPointerShapeLabelCaption"))
			ps->PointerShapeLabel->Caption				= val;
		else if (!strcmp(ckey, "psPointerShapeComboBoxItems0"))
			ps->PointerShapeComboBox->Items->Strings[0]	= val;
		else if (!strcmp(ckey, "psPointerShapeComboBoxItems1"))
			ps->PointerShapeComboBox->Items->Strings[1]	= val;
		else if (!strcmp(ckey, "psPointerShapeComboBoxItems2"))
			ps->PointerShapeComboBox->Items->Strings[2]	= val;
		else if (!strcmp(ckey, "psPointerShapeComboBoxItems3"))
			ps->PointerShapeComboBox->Items->Strings[3]	= val;
		else if (!strcmp(ckey, "psPointerShapeComboBoxItems4"))
			ps->PointerShapeComboBox->Items->Strings[4]	= val;
		else if (!strcmp(ckey, "psPointerShapeComboBoxItems5"))
			ps->PointerShapeComboBox->Items->Strings[5]	= val;
		else if (!strcmp(ckey, "psPointerShapeComboBoxItems6"))
			ps->PointerShapeComboBox->Items->Strings[6]	= val;
		else if (!strcmp(ckey, "psPointerShapeComboBoxItems7"))
			ps->PointerShapeComboBox->Items->Strings[7]	= val;
		else if (!strcmp(ckey, "psPointerShapeComboBoxItems8"))
			ps->PointerShapeComboBox->Items->Strings[8]	= val;
		else if (!strcmp(ckey, "psPointerShapeComboBoxItems9"))
			ps->PointerShapeComboBox->Items->Strings[9]	= val;
		else if (!strcmp(ckey, "psPointerShapeComboBoxItems10"))
			ps->PointerShapeComboBox->Items->Strings[10]= val;
		else if (!strcmp(ckey, "psPointerShapeComboBoxItems11"))
			ps->PointerShapeComboBox->Items->Strings[11]= val;
		else if (!strcmp(ckey, "psPointerPhraseLabelCaption"))
			ps->PointerPhraseLabel->Caption				= val;
		else if (!strcmp(ckey, "psPointerColorLabelCaption"))
			ps->PointerColorLabel->Caption				= val;


		//
		// MulticastSettingForm
		//
		else if (!strcmp(ckey, "msCaption"))
			ms->Caption									= val;
		else if (!strcmp(ckey, "msAddressGroupBoxCaption"))
			ms->AddressGroupBox->Caption				= val;
		else if (!strcmp(ckey, "msTTLLabelCaption"))
			ms->TTLLabel->Caption						= val;
		else if (!strcmp(ckey, "msRejectionAddressGroupBoxCaption"))
			ms->RejectionAddressGroupBox->Caption		= val;
		else if (!strcmp(ckey, "msCurrentAddressLabelCaption"))
			ms->CurrentAddressLabel->Caption			= val;
		else if (!strcmp(ckey, "msMulticastDetectLabelCaption"))
			ms->MulticastDetectLabel->Caption			= val;


		//
		// ReceiveMonitorForm
		//
		else if (!strcmp(ckey, "rmCaption"))
			rm->Caption									= val;
		else if (!strcmp(ckey, "rmReceiveRateLabelCaption"))
			rm->ReceiveRateLabel->Caption				= val;
		else if (!strcmp(ckey, "rmFrameRateLabelCaption"))
			rm->FrameRateLabel->Caption					= val;
		else if (!strcmp(ckey, "rmDropPacketLabelCaption"))
			rm->DropPacketLabel->Caption				= val;
		else if (!strcmp(ckey, "rmDropFrameLabelCaption"))
			rm->DropFrameLabel->Caption					= val;
		else if (!strcmp(ckey, "rmPacketSizeLabelCaption"))
			rm->PacketSizeLabel->Caption				= val;
		else if (!strcmp(ckey, "rmReceiveRateVideoMainLabelCaption"))
			rm->ReceiveRateVideoMainLabel->Caption		= val;
		else if (!strcmp(ckey, "rmReceiveRateVideoSubLabelCaption"))
			rm->ReceiveRateVideoSubLabel->Caption		= val;
		else if (!strcmp(ckey, "rmReceiveRateAudioLabelCaption"))
			rm->ReceiveRateAudioLabel->Caption			= val;
		else if (!strcmp(ckey, "rmReceiveRateFocusPointerLabelCaption"))
			rm->ReceiveRateFocusPointerLabel->Caption	= val;
		else if (!strcmp(ckey, "rmReceiveRatePointerLabelCaption"))
			rm->ReceiveRatePointerLabel->Caption		= val;

		//
		// VolumeIndicatorForm
		//
		else if (!strcmp(ckey, "vifCaption"))
			vif->Caption								= val;
		else if (!strcmp(ckey, "vifDisplayTimeLabelCaption"))
			vif->DisplayTimeLabel->Caption				= val;
		else if (!strcmp(ckey, "vifDisplayTimeComboBoxItems0"))
			vif->DisplayTimeComboBox->Items->Strings[0]	= val;
		else if (!strcmp(ckey, "vifDisplayTimeComboBoxItems1"))
			vif->DisplayTimeComboBox->Items->Strings[1]	= val;
		else if (!strcmp(ckey, "vifDisplayTimeComboBoxItems2"))
			vif->DisplayTimeComboBox->Items->Strings[2]	= val;
		else if (!strcmp(ckey, "vifDisplayTimeComboBoxItems3"))
			vif->DisplayTimeComboBox->Items->Strings[3]	= val;
		else if (!strcmp(ckey, "vifDisplayTimeComboBoxItems4"))
			vif->DisplayTimeComboBox->Items->Strings[4]	= val;
		else if (!strcmp(ckey, "vifDisplayTimeComboBoxItems5"))
			vif->DisplayTimeComboBox->Items->Strings[5]	= val;
		else if (!strcmp(ckey, "vifDisplayPauseCheckBoxCaption"))
			vif->DisplayPauseCheckBox->Caption			= val;

        //
        // ErrorMessageForm
        //
        else if (!strcmp(ckey, "emfCaption"))
        	emf->Caption = val;
		else if (!strcmp(ckey, "emf_T_WRONG_CAPTURE"))
			emf->setTypeString(FSRECEIVER_T_WRONG_CAPTURE, val);
		else if (!strcmp(ckey, "emf_T_WRONG_ENCODER"))
			emf->setTypeString(FSRECEIVER_T_WRONG_ENCODER, val);
		else if (!strcmp(ckey, "emf_T_WRONG_MEDIATYPE"))
			emf->setTypeString(FSRECEIVER_T_WRONG_MEDIATYPE, val);
		else if (!strcmp(ckey, "emf_T_NOTFOUND_DECODER"))
			emf->setTypeString(FSRECEIVER_T_NOTFOUND_DECODER, val);
		else if (!strcmp(ckey, "emf_T_UNEXPECTED"))
			emf->setTypeString(FSRECEIVER_T_UNEXPECTED, val);

	    //
    	// VersionInfoFrom
	    //
	    else if (!strcmp(ckey, "vfCaption"))
	    	vf->Caption										= val;
    	else if (!strcmp(ckey, "vfVersionInfoSoftwareNameLabelCaption"))
    		vf->VersionInfoSoftwareNameLabel->Caption		= val;

		//
		// Dynamic Words
		//
		else if (!strcmp(ckey, "DW_STOP"))
			_dynamicWords[DW_STOP]						= val;
		else if (!strcmp(ckey, "DW_START"))
			_dynamicWords[DW_START]						= val;
		else if (!strcmp(ckey, "DW_STATUSRECEIVE"))
			_dynamicWords[DW_STATUSRECEIVE]				= val;
		else if (!strcmp(ckey, "DW_STATUSSTANDBY"))
			_dynamicWords[DW_STATUSSTANDBY]				= val;
		else if (!strcmp(ckey, "DW_STATUSSTOP"))
			_dynamicWords[DW_STATUSSTOP]				= val;
		else if (!strcmp(ckey, "DW_STATUSFAILEDCONFIG"))
			_dynamicWords[DW_STATUSFAILEDCONFIG]		= val;
		else if (!strcmp(ckey, "DW_STATUSVIDEO"))
			_dynamicWords[DW_STATUSVIDEO]				= val;
		else if (!strcmp(ckey, "DW_STATUSAUDIO"))
			_dynamicWords[DW_STATUSAUDIO]				= val;
		else if (!strcmp(ckey, "DW_STATUSFOCUS"))
			_dynamicWords[DW_STATUSFOCUS]				= val;
		else if (!strcmp(ckey, "DW_STATUSNODATA"))
			_dynamicWords[DW_STATUSNODATA]				= val;
		else if (!strcmp(ckey, "DW_ERROR"))
			_dynamicWords[DW_ERROR]						= val;
		else if (!strcmp(ckey, "DW_READINIFILEERROR"))
			_dynamicWords[DW_READINIFILEERROR]			= val;
		else if (!strcmp(ckey, "DW_WRITEINIFILEERROR"))
			_dynamicWords[DW_WRITEINIFILEERROR]			= val;
		else if (!strcmp(ckey, "DW_SHOW"))
			_dynamicWords[DW_SHOW]						= val;
    	else if (!strcmp(ckey, "DW_POINTER"))
    		_dynamicWords[DW_POINTER]					= val;
		else if (!strcmp(ckey, "DW_GENERALPOINTER"))
			_dynamicWords[DW_GENERALPOINTER]			= val;
	    else if (!strcmp(ckey, "DW_RAISEPOINTER"))
		    _dynamicWords[DW_RAISEPOINTER]				= val;
	    else if (!strcmp(ckey, "DW_LOCUSPOINTER"))
		    _dynamicWords[DW_LOCUSPOINTER]				= val;
	   	else if (!strcmp(ckey, "DW_MULTICAST"))
	   		_dynamicWords[DW_MULTICAST]					= val;
	    else if (!strcmp(ckey, "DW_READINIFILE"))
		    _dynamicWords[DW_READINIFILE]				= val;
	    else if (!strcmp(ckey, "DW_WRITEINIFILE"))
		    _dynamicWords[DW_WRITEINIFILE]				= val;
	}

	vif->updateForm();
    emf->updateForm();
    fsReceiverComputeVideoWindow();
}
//---------------------------------------------------------------------------
void
fsReceiverLanguage::setupDefaultJapanese()
{
    //
    // ReceiverMainForm
    //
    ReceiverMainForm->Caption					= "ړ_̉uLc[@iMj";


    //
    // MainDataModule
    //
	TMainDataModule *mdm = MainDataModule;

	// OperatonActionList
	mdm->OperationAction->Caption				= "(&O)";
	mdm->ReceiveOnOffAction->Caption			= "";			//-> Dynamic Word
	mdm->PointerTransmissionOnAction->Caption	= "|C^̑M(&P)";
	mdm->RaiseOnAction->Caption					= "Lɂ(&R)";
	mdm->DrawLocusOnAction->Caption				= "OՕ`Lɂ(&L)";
	mdm->ReadIniFileAction->Caption				= "ݒ̓Ǎ(&O)";
	mdm->WriteIniFileAction->Caption			= "ݒ̕ۑ(&W)";
	mdm->ExitAction->Caption					= "I(&X)";

	// ShowActionList
	mdm->ShowAction->Caption					= "\(&S)";
	mdm->FitVideoToWindowAction->Caption		= "EBhEɍ킹ĕ\(&W)";
	mdm->KeepVideoAspectAction->Caption			= "cێ(&A)";
	mdm->OriginalVideoSizeAction->Caption		= "IWiTCYŕ\(&O)";
	mdm->FitWindowToVideoAction->Caption		= "EBhErfIɍ킹(&V)";
    mdm->VolumeIndicatorShowAction->Caption		= "ʃCWP[^̕\(&I)";

	// OperationActionList
	mdm->OptionAction->Caption					= "IvV(&P)";
	mdm->PointerAction->Caption					= "|C^(&P)";
	mdm->PointerAutoConfigOnAction->Caption		= "|C^`󎩓ݒ(&A)";
	mdm->GeneralPointerAction->Caption			= "ʏ̃|C^`(&G)";
	mdm->GeneralPointerNoneAction->Caption		= "Ȃ(&N)";
	mdm->GeneralPointerStandardAction->Caption	= "W(&S)";
	mdm->GeneralPointerArrowAction->Caption		= "(&A)";
	mdm->GeneralPointerCircleAction->Caption	= "~(&C)";
	mdm->GeneralPointerRectangleAction->Caption	= "lp(&R)";
	mdm->GeneralPointerTargetAction->Caption	= "Ə(&T)";
	mdm->GeneralPointerStarAction->Caption		= "(&B)";
	mdm->GeneralPointerDetailAction->Caption	= "ڍאݒŎw肵|C^`(&D)";
	mdm->RaisePointerAction->Caption			= "莞̃|C^`(&R)";
	mdm->RaisePointer1Action->Caption			= "ρ[(&P)";
	mdm->RaisePointer2Action->Caption			= "傫(&T)";
	mdm->RaisePointer3Action->Caption			= "[(&G)";
	mdm->RaisePointerDetailAction->Caption		= "ڍאݒŎw肵|C^`(&D)";
	mdm->LocusPointerAction->Caption			= "OՕ`掞̃|C^`(&L)";
	mdm->LocusPointer1Action->Caption			= "M(&P)";
	mdm->LocusPointer2Action->Caption			= "NM(&T)";
	mdm->LocusPointer3Action->Caption			= "ѕM(&B)";
	mdm->LocusPointerDetailAction->Caption		= "ڍאݒŎw肵|C^`(&D)";
	mdm->PointerSettingAction->Caption			= "ڍאݒ(&E)";
	mdm->MulticastAction->Caption				= "}`LXg(&M)";
	mdm->MulticastSettingAction->Caption		= "ڍאݒ(&E)";
	mdm->ReceiveMonitorShowAction->Caption		= "Mj^̕\(&R)";

	// LanguageActionList
	mdm->LanguageAction->Caption				= "ELang.(&L)";

	// HelpActionList
	mdm->HelpAction->Caption					= "wv(&H)";
	mdm->VersionInfoAction->Caption				= "o[W(&V)";

	// PointerSettingActionList
	mdm->PointerCoordinateDesktopWindowAction->Caption	= "ʑS";
	mdm->PointerCoordinateVideoWindowAction->Caption	= "rfIEBhE";
	mdm->PointerColorChooseAction->Caption				= "...";

	// MulticastSettingActionList
    mdm->SynchronizeSenderAddressOnAction->Caption = "M̃AhXݒɓ";
	mdm->CreateIPv6AddressAction->Caption		="(IPv6)";
	mdm->CreateIPv4AddressAction->Caption		="(IPv4)";
	mdm->AddressUpdateAction->Caption			="XV";
	mdm->TTLUpdateAction->Caption				="XV";
	mdm->AddRejectionAddressAction->Caption		="ǉ";
	mdm->RemoveRejectionAddressAction->Caption	="폜";

    // VersionInfoActionList
    mdm->VersionInfoOKAction->Caption			= "OK";

    // Dialogs
    mdm->IniFileOpenDialog->Filter				= "ݒt@C|*.ini";
    mdm->IniFileOpenDialog->Title				= "ݒǍ";
    mdm->IniFileSaveDialog->Filter				= "ݒt@C|*.ini";
    mdm->IniFileSaveDialog->Title				= "ݒۑ";


	//
    // PointerSettingForm
    //
	TPointerSettingForm* ps = PointerSettingForm;
    ps->Caption									= "|C^̏ڍאݒ";
	ps->PointerCoordinateGroupBox->Caption		= "|C^̍Wn";
	ps->PointerSettingGroupBox->Caption			= "|C^ݒ";
	ps->PointerSelectionComboBox->Items->Clear();
	ps->PointerSelectionComboBox->Items->Add("ʏ");
	ps->PointerSelectionComboBox->Items->Add("OՕ` i{^j");
	ps->PointerSelectionComboBox->Items->Add("1 i{^j");
	ps->PointerSelectionComboBox->Items->Add("2 iE{^j");
	ps->PointerSelectionComboBox->Items->Add("3 izC[j");
	ps->PointerSelectionComboBox->Items->Add("4 iTCh{^1j");
	ps->PointerSelectionComboBox->Items->Add("5 iTCh{^2j");
    ps->PointerShapeLabel->Caption				= "|C^̌`";
    ps->PointerShapeComboBox->Items->Clear();
	ps->PointerShapeComboBox->Items->Add("W");
	ps->PointerShapeComboBox->Items->Add("");
	ps->PointerShapeComboBox->Items->Add("~");
	ps->PointerShapeComboBox->Items->Add("lp");
	ps->PointerShapeComboBox->Items->Add("Ə");
	ps->PointerShapeComboBox->Items->Add("");
	ps->PointerShapeComboBox->Items->Add("M");
	ps->PointerShapeComboBox->Items->Add("NM");
	ps->PointerShapeComboBox->Items->Add("ѕM");
	ps->PointerShapeComboBox->Items->Add("1");
	ps->PointerShapeComboBox->Items->Add("2");
	ps->PointerShapeComboBox->Items->Add("3");
	ps->PointerPhraseLabel->Caption				= "t[Y";
    ps->PointerColorLabel->Caption				= "|C^̐F";


    //
    // MulticastSettingForm
    //
	TMulticastSettingForm *ms = MulticastSettingForm;
	ms->Caption									= "}`LXg̏ڍאݒ";
	ms->AddressGroupBox->Caption				= "}`LXgIPAhX";
	ms->TTLLabel->Caption						= "őzbvJEg";
	ms->RejectionAddressGroupBox->Caption		= "MIPAhX";
	ms->CurrentAddressLabel->Caption			= "ݎMIPAhX";
    ms->MulticastDetectLabel->Caption			= "Mo";


    //
    // ReceiveMonitorForm
    //
	TReceiveMonitorForm *rm = ReceiveMonitorForm;
	rm->Caption									= "Mj^";
	rm->ReceiveRateLabel->Caption				= "rbg[g (kbit/s)";
	rm->FrameRateLabel->Caption					= "Tv[g (sample/s)";
	rm->DropPacketLabel->Caption				= "hbvpPbg";
    rm->DropFrameLabel->Caption					= "hbvTv";
    rm->PacketSizeLabel->Caption				= "pPbgTCY (byte)";
	rm->ReceiveRateVideoMainLabel->Caption		= "rfI(Ҳ/÷)";
	rm->ReceiveRateVideoSubLabel->Caption		= "rfI(tH[JX)";
	rm->ReceiveRateAudioLabel->Caption			= "I[fBI";
	rm->ReceiveRateFocusPointerLabel->Caption	= "tH[JX";
	rm->ReceiveRatePointerLabel->Caption		= "|C^";

    //
    // VolumeIndicatorForm
    //
    TVolumeIndicatorForm *vif = VolumeIndicatorForm;

    vif->Caption								= "ʃCWP[^";
    vif->DisplayTimeLabel->Caption				= "\";
    vif->DisplayTimeComboBox->Items->Clear();
    vif->DisplayTimeComboBox->Items->Add("60b");
    vif->DisplayTimeComboBox->Items->Add("20b");
    vif->DisplayTimeComboBox->Items->Add("10b");
    vif->DisplayTimeComboBox->Items->Add("5b");
    vif->DisplayTimeComboBox->Items->Add("2b");
    vif->DisplayTimeComboBox->Items->Add("1b");
    vif->DisplayPauseCheckBox->Caption			= "\̈ꎞ~";
    vif->updateForm();

    //
    // ErrorMessageForm
    //
    TErrorMessageForm *emf = ErrorMessageForm;
    emf->Caption									= "G[";
    emf->setTypeString(FSRECEIVER_T_WRONG_CAPTURE, "Ή̃Lv`łB");
    emf->setTypeString(FSRECEIVER_T_WRONG_ENCODER, "Ή̃GR[_[łB");
    emf->setTypeString(FSRECEIVER_T_WRONG_MEDIATYPE, "Ή̃fBA^CvłB");
    emf->setTypeString(FSRECEIVER_T_NOTFOUND_DECODER, "fR[_܂B");
    emf->setTypeString(FSRECEIVER_T_UNEXPECTED, "\ȂG[");

    //
    // VersionInfoFrom
    //
    TVersionInfoForm *vf = VersionInfoForm;

    vf->Caption										= "o[W";
    vf->VersionInfoSoftwareNameLabel->Caption		= "FocusShare \tgEFA v1.0 (M)";

    //
    // Dynamic Words
    //
	_dynamicWords[DW_STOP]						= "~(&S)";
	_dynamicWords[DW_START]						= "s(&S)";
	_dynamicWords[DW_STATUSRECEIVE]				= "M";
	_dynamicWords[DW_STATUSSTANDBY]				= "ҋ@";
	_dynamicWords[DW_STATUSSTOP]				= "~";
	_dynamicWords[DW_STATUSFAILEDCONFIG]		= "\Ɏs܂";
	_dynamicWords[DW_STATUSVIDEO]				= "rfI";
	_dynamicWords[DW_STATUSAUDIO]				= "I[fBI";
	_dynamicWords[DW_STATUSFOCUS]				= "tH[JX";
    _dynamicWords[DW_STATUSNODATA]				= "f[^Ȃ";
    _dynamicWords[DW_ERROR]						= "G[";
    _dynamicWords[DW_READINIFILEERROR]			= "ݒ̓Ǎ݂Ɏs܂B";
	_dynamicWords[DW_WRITEINIFILEERROR]			= "ݒ̕ۑɎs܂B";
	_dynamicWords[DW_SHOW]						= "\";
    _dynamicWords[DW_POINTER]				   	= "|C^";
	_dynamicWords[DW_GENERALPOINTER]			= "ʏ̃|C^`";
    _dynamicWords[DW_RAISEPOINTER]				= "莞̃|C^`";
    _dynamicWords[DW_LOCUSPOINTER]				= "OՕ`掞̃|C^`";
   	_dynamicWords[DW_MULTICAST]					= "}`LXg";
    _dynamicWords[DW_READINIFILE]				= "ݒ̓Ǎ";
    _dynamicWords[DW_WRITEINIFILE]				= "ݒ̕ۑ";
}
//---------------------------------------------------------------------------
void
fsReceiverLanguage::setupDefaultEnglish()
{
    //
    // ReceiverMainForm
    //
    ReceiverMainForm->Caption					= "Focus Share Tool (Receiver)";


    //
    // MainDataModule
    //
	TMainDataModule *mdm = MainDataModule;

	// OperatonActionList
	mdm->OperationAction->Caption				= "&Operation";
	mdm->ReceiveOnOffAction->Caption			= "";			//-> Dynamic Word
	mdm->PointerTransmissionOnAction->Caption	= "&Pointer Transmission On";
	mdm->RaiseOnAction->Caption					= "&Raise On";
	mdm->DrawLocusOnAction->Caption				= "Draw Lo&cus On";
	mdm->ReadIniFileAction->Caption				= "&Load Setting File";
	mdm->WriteIniFileAction->Caption			= "&Save Setting File";
	mdm->ExitAction->Caption					= "E&xit";

	// ShowActionList
	mdm->ShowAction->Caption					= "&Display";
	mdm->FitVideoToWindowAction->Caption		= "Fit To &Window";
	mdm->KeepVideoAspectAction->Caption			= "Keep Window &Aspect";
	mdm->OriginalVideoSizeAction->Caption		= "&Original Size";
	mdm->FitWindowToVideoAction->Caption		= "Fit To &Video";
    mdm->VolumeIndicatorShowAction->Caption		= "Volume &Indicator";

	// OperationActionList
	mdm->OptionAction->Caption					= "O&ption";
	mdm->PointerAction->Caption					= "&Pointer";
	mdm->PointerAutoConfigOnAction->Caption		= "Pointer &Automatic Setup";
	mdm->GeneralPointerAction->Caption			= "&General Pointer Shape";
	mdm->GeneralPointerNoneAction->Caption		= "&None";
	mdm->GeneralPointerStandardAction->Caption	= "&Standard";
	mdm->GeneralPointerArrowAction->Caption		= "&Arrow";
	mdm->GeneralPointerCircleAction->Caption	= "&Circle";
	mdm->GeneralPointerRectangleAction->Caption	= "&Rectangle";
	mdm->GeneralPointerTargetAction->Caption	= "&Target";
	mdm->GeneralPointerStarAction->Caption		= "Sta&r";
	mdm->GeneralPointerDetailAction->Caption	= "Pointer of &Detail Settings";
	mdm->RaisePointerAction->Caption			= "&Raise Pointer Shape";
	mdm->RaisePointer1Action->Caption			= "&Paper";
	mdm->RaisePointer2Action->Caption			= "&Scissors";
	mdm->RaisePointer3Action->Caption			= "&Fist";
	mdm->RaisePointerDetailAction->Caption		= "Pointer of &Detail Settings";
	mdm->LocusPointerAction->Caption			= "Draw-&Locus Pointer Shape";
	mdm->LocusPointer1Action->Caption			= "&Pencil";
	mdm->LocusPointer2Action->Caption			= "&Fountain Pen";
	mdm->LocusPointer3Action->Caption			= "&Brush";
	mdm->LocusPointerDetailAction->Caption		= "Pointer of &Detail Settings";
	mdm->PointerSettingAction->Caption			= "S&ettings";
	mdm->MulticastAction->Caption				= "&Multicast";
	mdm->MulticastSettingAction->Caption		= "S&ettings";
	mdm->ReceiveMonitorShowAction->Caption		= "&Receiver Monitor";

	// LanguageActionList
	mdm->LanguageAction->Caption				= "&Language";

	// HelpActionList
	mdm->HelpAction->Caption					= "&Help";
	mdm->VersionInfoAction->Caption				= "&Version Info.";

	// PointerSettingActionList
	mdm->PointerCoordinateDesktopWindowAction->Caption	= "Desktop Window";
	mdm->PointerCoordinateVideoWindowAction->Caption	= "Video Window";
	mdm->PointerColorChooseAction->Caption				= "...";

	// MulticastSettingActionList
    mdm->SynchronizeSenderAddressOnAction->Caption = "Synchronize with Sender Address";
	mdm->CreateIPv6AddressAction->Caption		="Generate(IPv6)";
	mdm->CreateIPv4AddressAction->Caption		="Generate(IPv4)";
	mdm->AddressUpdateAction->Caption			="Update";
	mdm->TTLUpdateAction->Caption				="Update";
	mdm->AddRejectionAddressAction->Caption		="Add";
	mdm->RemoveRejectionAddressAction->Caption	="Remove";

    // VersionInfoActionList
    mdm->VersionInfoOKAction->Caption			= "OK";

    // Dialogs
    mdm->IniFileOpenDialog->Filter				= "Setting File|*.ini";
    mdm->IniFileOpenDialog->Title				= "Load Setting File";
    mdm->IniFileSaveDialog->Filter				= "Setting File|*.ini";
    mdm->IniFileSaveDialog->Title				= "Save Setting File";


	//
    // PointerSettingForm
    //
	TPointerSettingForm* ps = PointerSettingForm;
    ps->Caption									= "Settings of Pointer";
	ps->PointerCoordinateGroupBox->Caption		= "Pointer Coordinate";
	ps->PointerSettingGroupBox->Caption			= "Pointer";
	ps->PointerSelectionComboBox->Items->Clear();
	ps->PointerSelectionComboBox->Items->Add("General");
	ps->PointerSelectionComboBox->Items->Add("Draw Locus (Left Button)");
	ps->PointerSelectionComboBox->Items->Add("Raise1 (Left Button)");
	ps->PointerSelectionComboBox->Items->Add("Raise2 (Right Button)");
	ps->PointerSelectionComboBox->Items->Add("Raise3 (Wheel)");
	ps->PointerSelectionComboBox->Items->Add("Raise4 (Side Button1)");
	ps->PointerSelectionComboBox->Items->Add("Raise5 (Side Button2)");
    ps->PointerShapeLabel->Caption				= "Pointer Shape";
    ps->PointerShapeComboBox->Items->Clear();
	ps->PointerShapeComboBox->Items->Add("Standard");
	ps->PointerShapeComboBox->Items->Add("Arrow");
	ps->PointerShapeComboBox->Items->Add("Circle");
	ps->PointerShapeComboBox->Items->Add("Rectangle");
	ps->PointerShapeComboBox->Items->Add("Target");
	ps->PointerShapeComboBox->Items->Add("Star");
	ps->PointerShapeComboBox->Items->Add("Pencil");
	ps->PointerShapeComboBox->Items->Add("Fountain Pen");
	ps->PointerShapeComboBox->Items->Add("Brush");
	ps->PointerShapeComboBox->Items->Add("Rase1");
	ps->PointerShapeComboBox->Items->Add("Rase2");
	ps->PointerShapeComboBox->Items->Add("Rase3");
	ps->PointerPhraseLabel->Caption				= "Phrase";
    ps->PointerColorLabel->Caption				= "Pointer Color";


    //
    // MulticastSettingForm
    //
	TMulticastSettingForm *ms = MulticastSettingForm;
	ms->Caption									= "Settings of Multicast";
	ms->AddressGroupBox->Caption				= "Multicast IP Address";
	ms->TTLLabel->Caption						= "Max. Hop Count";
	ms->RejectionAddressGroupBox->Caption		= "Rejection IP Address";
	ms->CurrentAddressLabel->Caption			= "Receive IP Address";
    ms->MulticastDetectLabel->Caption			= "Detected";


    //
    // ReceiveMonitorForm
    //
	TReceiveMonitorForm *rm = ReceiveMonitorForm;
	rm->Caption									= "Receiver Monitor";
	rm->ReceiveRateLabel->Caption				= "Bit Rate (kbit/s)";
	rm->FrameRateLabel->Caption					= "Sample Rate (sample/s)";
	rm->DropPacketLabel->Caption				= "Number of Missing Packets";
    rm->DropFrameLabel->Caption					= "Number of Missing Samples";
    rm->PacketSizeLabel->Caption				= "Packet Size";
	rm->ReceiveRateVideoMainLabel->Caption		= "Video(Main/Context)";
	rm->ReceiveRateVideoSubLabel->Caption		= "Video(Focus)";
	rm->ReceiveRateAudioLabel->Caption			= "Audio";
	rm->ReceiveRateFocusPointerLabel->Caption	= "Focus Info.";
	rm->ReceiveRatePointerLabel->Caption		= "Pointer Info.";

    //
    // VolumeIndicatorForm
    //
    TVolumeIndicatorForm *vif = VolumeIndicatorForm;

    vif->Caption								= "Volume Indicator";
    vif->DisplayTimeLabel->Caption				= "Display Time";
    vif->DisplayTimeComboBox->Items->Clear();
    vif->DisplayTimeComboBox->Items->Add("60 seconds");
    vif->DisplayTimeComboBox->Items->Add("20 seconds");
    vif->DisplayTimeComboBox->Items->Add("10 seconds");
    vif->DisplayTimeComboBox->Items->Add("5 seconds");
    vif->DisplayTimeComboBox->Items->Add("2 seconds");
    vif->DisplayTimeComboBox->Items->Add("1 second");
    vif->DisplayPauseCheckBox->Caption			= "Pause";
    vif->updateForm();

    //
    // ErrorMessageForm
    //
    TErrorMessageForm *emf = ErrorMessageForm;
    emf->Caption									= "Error";
    emf->setTypeString(FSRECEIVER_T_WRONG_CAPTURE, "Not Supported Capture");
    emf->setTypeString(FSRECEIVER_T_WRONG_ENCODER, "Not Supported Encoder");
    emf->setTypeString(FSRECEIVER_T_WRONG_MEDIATYPE, "Not Supported Media Type");
    emf->setTypeString(FSRECEIVER_T_NOTFOUND_DECODER, "Decoder is Not Found");
    emf->setTypeString(FSRECEIVER_T_UNEXPECTED, "Unexpected Error");

    //
    // VersionInfoFrom
    //
    TVersionInfoForm *vf = VersionInfoForm;

    vf->Caption										= "Version Info.";
    vf->VersionInfoSoftwareNameLabel->Caption		= "Focus Share Software v1.0 (Receiver)";

    //
    // Dynamic Words
    //
	_dynamicWords[DW_STOP]						= "&Stop";
	_dynamicWords[DW_START]						= "&Start";
	_dynamicWords[DW_STATUSRECEIVE]				= "Receiving";
	_dynamicWords[DW_STATUSSTANDBY]				= "No Data Received";
	_dynamicWords[DW_STATUSSTOP]				= "Stopped";
	_dynamicWords[DW_STATUSFAILEDCONFIG]		= "Failed to Configuration";
	_dynamicWords[DW_STATUSVIDEO]				= "Video";
	_dynamicWords[DW_STATUSAUDIO]				= "Audio";
	_dynamicWords[DW_STATUSFOCUS]				= "Focus";
    _dynamicWords[DW_STATUSNODATA]				= "No Data";
    _dynamicWords[DW_ERROR]						= "Error";
    _dynamicWords[DW_READINIFILEERROR]			= "Failed to Load setting.";
	_dynamicWords[DW_WRITEINIFILEERROR]			= "Failed to Save setting.";
	_dynamicWords[DW_SHOW]						= "Show";
    _dynamicWords[DW_POINTER]				   	= "Pointer";
	_dynamicWords[DW_GENERALPOINTER]			= "General Pointer Shape";
    _dynamicWords[DW_RAISEPOINTER]				= "Raise Pointer Shape";
    _dynamicWords[DW_LOCUSPOINTER]				= "Draw Locus Pointer Shape";
   	_dynamicWords[DW_MULTICAST]					= "Multicast";
    _dynamicWords[DW_READINIFILE]				= "Load Setting";
    _dynamicWords[DW_WRITEINIFILE]				= "Save Setting";
}
//---------------------------------------------------------------------------

