/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#ifndef __fsReceiverLanguage_h__
#define	__fsReceiverLanguage_h__
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "ui/fsCommonUI/fsLanguage.h"
//---------------------------------------------------------------------------
// Dynamic word Definiation
enum DynamicWordEnum
{
	DW_STOP,
    DW_START,
	DW_STATUSRECEIVE,
	DW_STATUSSTANDBY,
	DW_STATUSSTOP,
	DW_STATUSFAILEDCONFIG,
	DW_STATUSVIDEO,
	DW_STATUSAUDIO,
	DW_STATUSFOCUS,
    DW_STATUSNODATA,
    DW_ERROR,
    DW_READINIFILEERROR,
	DW_WRITEINIFILEERROR,
	DW_SHOW,
    DW_POINTER,
	DW_GENERALPOINTER,
    DW_RAISEPOINTER,
    DW_LOCUSPOINTER,
   	DW_MULTICAST,
    DW_READINIFILE,
    DW_WRITEINIFILE,
	NUM_DYNAMICWORDS
};
//---------------------------------------------------------------------------
class fsReceiverLanguage : public fsLanguage
{
public:
	fsReceiverLanguage(TMenuItem* LanguageMenuItem);
    virtual ~fsReceiverLanguage();

public:
	virtual const AnsiString& getDynamicWord(int id);

protected:
	virtual void	setupLanguage();
    virtual void	setupDefaultJapanese();
    virtual void	setupDefaultEnglish();

private:
	AnsiString		_dynamicWords[NUM_DYNAMICWORDS];

};
//---------------------------------------------------------------------------
#endif // __fsReceiverLanguage_h__
//---------------------------------------------------------------------------

