/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fsFocusDisplaySettingForm.h"
#include "fsSenderMainForm.h"
#include "fsMainDataModule.h"
#include <fs/fsSenderRemote/fsSenderRemoteInterface.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFocusDisplaySettingForm *FocusDisplaySettingForm;
//---------------------------------------------------------------------------
__fastcall TFocusDisplaySettingForm::TFocusDisplaySettingForm(TComponent* Owner)
    : TForm(Owner)
{
	_formShown = false;
}
//---------------------------------------------------------------------------
void __fastcall
TFocusDisplaySettingForm::FormShow(TObject *Sender)
{
    updateForm();
	_formShown = true;
}
//---------------------------------------------------------------------------
void __fastcall
TFocusDisplaySettingForm::FormHide(TObject *Sender)
{
	_formShown = false;
}
//---------------------------------------------------------------------------
void __fastcall
TFocusDisplaySettingForm::PartialZoomOutputResolutionComboBoxChange(TObject *Sender)
{
    int index = PartialZoomOutputResolutionComboBox->ItemIndex;
    fsSenderSetPartialZoomOutputVideoResolution(index);
}
//---------------------------------------------------------------------------
void __fastcall
TFocusDisplaySettingForm::PartialZoomSourceResolutionComboBoxChange(TObject *Sender)
{
    int index = PartialZoomSourceResolutionComboBox->ItemIndex;
    fsSenderSetPartialZoomSourceVideoResolution(index);

	fsSenderComputeVideoWindow();
}
//---------------------------------------------------------------------------
void __fastcall
TFocusDisplaySettingForm::NonLinearZoomResolutionComboBoxChange(TObject *Sender)
{
    int index = NonLinearZoomResolutionComboBox->ItemIndex;
    fsSenderSetNonLinearZoomOutputVideoResolution(index);
}
//---------------------------------------------------------------------------
void __fastcall
TFocusDisplaySettingForm::NonLinearZoomMaskComboBoxChange(TObject *Sender)
{
    int index = NonLinearZoomMaskComboBox->ItemIndex;
    fsSenderSetNonLinearZoomMaskType(index);
}
//---------------------------------------------------------------------------
void __fastcall
TFocusDisplaySettingForm::NonLinearZoomMaskWidthEditChange(TObject *Sender)
{
	if (!_formShown)
    	return ;
    if (!NonLinearZoomMaskWidthEdit->Enabled)
        return ;
    int width = NonLinearZoomMaskWidthUpDown->Position;
    int height = NonLinearZoomMaskHeightUpDown->Position;
    fsSenderSetNonLinearZoomMaskSize(width, height);
}
//---------------------------------------------------------------------------
void __fastcall
TFocusDisplaySettingForm::NonLinearZoomMaskHeightEditChange(TObject *Sender)
{
	if (!_formShown)
    	return ;
    if (!NonLinearZoomMaskHeightEdit->Enabled)
        return ;
    int width = NonLinearZoomMaskWidthUpDown->Position;
    int height = NonLinearZoomMaskHeightUpDown->Position;
    fsSenderSetNonLinearZoomMaskSize(width, height);
}
//---------------------------------------------------------------------------
void __fastcall
TFocusDisplaySettingForm::ImageCompoundBaseResolutionComboBoxChange(TObject *Sender)
{
    int index = ImageCompoundBaseResolutionComboBox->ItemIndex;
    fsSenderSetImageCompoundBaseVideoResolution(index);

	fsSenderComputeVideoWindow();
}
//---------------------------------------------------------------------------
void __fastcall
TFocusDisplaySettingForm::ImageCompoundAddResolutionComboBoxChange(TObject *Sender)
{
    int index = ImageCompoundAddResolutionComboBox->ItemIndex;
    fsSenderSetImageCompoundAdditionalVideoResolution(index);

	fsSenderComputeVideoWindow();
}
//---------------------------------------------------------------------------
void __fastcall
TFocusDisplaySettingForm::ImageCompoundMaskComboBoxChange(TObject *Sender)
{
    int index = ImageCompoundMaskComboBox->ItemIndex;
    fsSenderSetImageCompoundMaskType(index);
}
//---------------------------------------------------------------------------
void __fastcall
TFocusDisplaySettingForm::ImageCompoundBlendingComboBoxChange(TObject *Sender)
{
    int index = ImageCompoundBlendingComboBox->ItemIndex;
    fsSenderSetImageCompoundBlendingType(index);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void
TFocusDisplaySettingForm::updateForm()
{
    bool enable;

    // Item
    enable = PartialZoomOutputResolutionComboBox->Enabled;
    PartialZoomOutputResolutionComboBox->Enabled = false;
    PartialZoomOutputResolutionComboBox->ItemIndex = fsSenderGetPartialZoomOutputVideoResolution();
    PartialZoomOutputResolutionComboBox->Enabled = enable;

    enable = PartialZoomSourceResolutionComboBox->Enabled;
    PartialZoomSourceResolutionComboBox->Enabled = false;
    PartialZoomSourceResolutionComboBox->ItemIndex = fsSenderGetPartialZoomSourceVideoResolution();
    PartialZoomSourceResolutionComboBox->Enabled = enable;

    enable = NonLinearZoomResolutionComboBox->Enabled;
    NonLinearZoomResolutionComboBox->Enabled = false;
    NonLinearZoomResolutionComboBox->ItemIndex = fsSenderGetNonLinearZoomOutputVideoResolution();
    NonLinearZoomResolutionComboBox->Enabled = enable;

    enable = NonLinearZoomMaskComboBox->Enabled;
    NonLinearZoomMaskComboBox->Enabled = false;
    NonLinearZoomMaskComboBox->ItemIndex = fsSenderGetNonLinearZoomMaskType();
    NonLinearZoomMaskComboBox->Enabled = enable;

    int width, height;
    fsSenderGetNonLinearZoomMaskSize(&width, &height);
    enable = NonLinearZoomMaskWidthEdit->Enabled;
    NonLinearZoomMaskWidthEdit->Enabled = false;
    NonLinearZoomMaskWidthUpDown->Position = width;
    NonLinearZoomMaskWidthEdit->Enabled = enable;

    enable = NonLinearZoomMaskHeightEdit->Enabled;
    NonLinearZoomMaskHeightEdit->Enabled = false;
    NonLinearZoomMaskHeightUpDown->Position = height;
    NonLinearZoomMaskHeightEdit->Enabled = enable;

    enable = ImageCompoundBaseResolutionComboBox->Enabled;
    ImageCompoundBaseResolutionComboBox->Enabled = false;
    ImageCompoundBaseResolutionComboBox->ItemIndex =
                fsSenderGetImageCompoundBaseVideoResolution();
    ImageCompoundBaseResolutionComboBox->Enabled = enable;

    enable = ImageCompoundAddResolutionComboBox->Enabled;
    ImageCompoundAddResolutionComboBox->Enabled = false;
    ImageCompoundAddResolutionComboBox->ItemIndex =
                fsSenderGetImageCompoundAdditionalVideoResolution();
    ImageCompoundAddResolutionComboBox->Enabled = enable;

    enable = ImageCompoundMaskComboBox->Enabled;
    ImageCompoundMaskComboBox->Enabled = false;
    ImageCompoundMaskComboBox->ItemIndex =
                fsSenderGetImageCompoundMaskType();
    ImageCompoundMaskComboBox->Enabled = enable;

    enable = ImageCompoundBlendingComboBox->Enabled;
    ImageCompoundBlendingComboBox->Enabled = false;
    ImageCompoundBlendingComboBox->ItemIndex =
                fsSenderGetImageCompoundBlendingType();
    ImageCompoundBlendingComboBox->Enabled = enable;


    // Action
	bool flag = fsSenderGetFocusFrameVisible();
	MainDataModule->ShowFocusFrameAction->Checked = flag;

	MainDataModule->FocusCoordinateDesktopWindowAction->Checked =
    	(fsSenderGetFocusCoordinate() == FSSENDER_FSC_DESKTOPWINDOW);

	MainDataModule->FocusCoordinateVideoWindowAction->Checked =
    	(fsSenderGetFocusCoordinate() == FSSENDER_FSC_VIDEOWINDOW);
}
//---------------------------------------------------------------------------

