/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

/**
ActionUpdate()nhfsSenderInterfacěďo͂ȂׂsȂB
tH[̏ԍXV́AtH[̕\ɈꊇčsB
**/

#include <vcl.h>
#pragma hdrstop

#include "fsMainDataModule.h"
#include "fsSenderMainForm.h"
#include "fsFocusDisplaySettingForm.h"
#include "fsMulticastSettingForm.h"
#include "fsSourceSettingForm.h"
#include "fsTransmissionMonitorForm.h"
#include "fsCaptionSettingForm.h"
#include "fsVersionInfoForm.h"
#include "fsSenderLanguage.h"
#include "fsSenderCommandHistory.h"
#include <ui/fsCommonUI/fsVolumeIndicatorForm.h>
#include <ui/fsCommonUI/fsErrorMessageForm.h>
#include <fs/fsSenderRemote/fsSenderRemoteInterface.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainDataModule *MainDataModule;
//---------------------------------------------------------------------------
#define MAX_VIDEOCLIPHISTORY	10
#define MAX_SOUNDFILEHISTORY	10
#define MAX_CAPTIONHISTORY		10
//---------------------------------------------------------------------------
__fastcall TMainDataModule::TMainDataModule(TComponent* Owner)
	: TDataModule(Owner)
{
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::DataModuleCreate(TObject *Sender)
{
    _captionHistories			= new TStringList();
    _videoClipHistories			= new TStringList();
    _soundFileHistories			= new TStringList();

    _videoEncoderIndices		= new TList();
    _audioEncoderIndices		= new TList();

    _commandHistory				= new fsSenderCommandHistory(
    											OperationHistoryBeginMenuItem,
                                                OperationHistoryEndMenuItem);

    _encoderShowControl			= ESC_REQUIREENCODER;

    IniFileOpenDialog->DefaultExt	= AnsiString("ini");
    IniFileOpenDialog->Filter		= AnsiString("ݒt@C|*.ini");
    IniFileOpenDialog->Title		= "ݒt@CǍ";

    IniFileSaveDialog->DefaultExt	= AnsiString("ini");
    IniFileSaveDialog->Filter		= AnsiString("ݒt@C|*.ini");
    IniFileSaveDialog->Title		= "݂̐ݒۑ";

    VideoClipOpenDialog->DefaultExt	= AnsiString("avi");
    VideoClipOpenDialog->Filter		= AnsiString("rfINbv|*.avi;*.mpg;*.*");
    VideoClipOpenDialog->Title		= "rfINbvǍ";

    SoundFileOpenDialog->DefaultExt	= AnsiString("wav");
    SoundFileOpenDialog->Filter		= AnsiString("TEht@C|*.wav;*.mp3");
    SoundFileOpenDialog->Title		= "TEht@CǍ";

    _videoSourceIsDirty = true;
    _audioSourceIsDirty = true;
    _videoEncoderIsDirty = true;
    _audioEncoderIsDirty = true;

    updateVideoSource();
    updateAudioSource();

    //
    // WXgǍ
    //
    const char *cstr;
	char str[1024];
    AnsiString entry;

    // Encoder Show Control
    switch(_encoderShowControl)
    {
	case ESC_RECOMMENDENCODER:	cstr = "Recommend";	break;
	case ESC_REQUIREENCODER:	cstr = "Require";	break;
	case ESC_ALLENCODER:		cstr = "All";		break;
	default:					cstr = "Require";	break;
    }
    fsSenderReadRegistry("SenderRemote", "EncoderShowControl", cstr, str);
	if (!strcmpi(str, "recommend"))
    	_encoderShowControl = ESC_RECOMMENDENCODER;
    else if (!strcmpi(str, "require"))
    	_encoderShowControl = ESC_REQUIREENCODER;
    else if (!strcmpi(str, "all"))
    	_encoderShowControl = ESC_ALLENCODER;
    else
    	_encoderShowControl = ESC_REQUIREENCODER;

   	updateVideoEncoder();
   	updateAudioEncoder();

	// Video Clip History
	for (int i = 0; i < MAX_VIDEOCLIPHISTORY; i++)
	{
    	entry = "HistoryVideoClip" + AnsiString(i);
		fsSenderReadRegistry("SenderRemote", entry.c_str(), "", str);
		if (strlen(str) == 0)
			break;
		if (_videoClipHistories->IndexOf(str) == -1)
			_videoClipHistories->Add(str);
	}

	// Sound File History
	for (int i = 0; i < MAX_SOUNDFILEHISTORY; i++)
	{
    	entry = "HistorySoundFile" + AnsiString(i);
		fsSenderReadRegistry("SenderRemote", entry.c_str(), "", str);
		if (strlen(str) == 0)
			break;
		if (_soundFileHistories->IndexOf(str) == -1)
			_soundFileHistories->Add(str);
	}

	// Caption History
    fsSenderReadRegistry("SenderRemote", "HistoryCaptionCount", "0", str);
	int count = atoi(str);

	for (int i = 0; i < count; i++)
	{
    	entry = "HistoryCaption" + AnsiString(i);
		fsSenderReadRegistry("SenderRemote", entry.c_str(), "", str);
		if (_captionHistories->IndexOf(str) == -1)
			_captionHistories->Add(str);
	}

    updateVideoClipHistory();
    updateSoundFileHistory();
    updateCaptionHistory();

    SenderTimer->Enabled  = true;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::DataModuleDestroy(TObject *Sender)
{
    //
	// WXg̏
    //
    const char *cstr;
    int count;
    AnsiString entry, str;

    // Encoder Show Control
    switch(_encoderShowControl)
    {
	case ESC_RECOMMENDENCODER:	cstr = "Recommend";	break;
	case ESC_REQUIREENCODER:	cstr = "Require";	break;
	case ESC_ALLENCODER:		cstr = "All";		break;
	default:					cstr = "Require";	break;
    }
    fsSenderWriteRegistry("SenderRemote", "EncoderShowControl", cstr);

	// Video Clip History
    count = _videoClipHistories->Count;
	for (int i = 0; i < count; i++)
	{
    	entry = "HistoryVideoClip" + AnsiString(i);
		fsSenderWriteRegistry("SenderRemote", entry.c_str(), _videoClipHistories->Strings[i].c_str());
	}

	// Sound File History
    count = _soundFileHistories->Count;
	for (int i = 0; i < count; i++)
	{
    	entry = "HistorySoundFile" + AnsiString(i);
		fsSenderWriteRegistry("SenderRemote", entry.c_str(), _soundFileHistories->Strings[i].c_str());
	}

	// Caption History
    count = _captionHistories->Count;
    str = AnsiString(count);
    fsSenderWriteRegistry("SenderRemote", "HistoryCaptionCount", str.c_str());

	for (int i = 0; i < count; i++)
	{
    	entry = "HistoryCaption" + AnsiString(i);
        str = _captionHistories->Strings[i];
        if (str.Length() != 0)
			fsSenderWriteRegistry("SenderRemote", entry.c_str(), str.c_str());
        else
        	fsSenderWriteRegistry("SenderRemote", entry.c_str(), "");
	}


    delete _captionHistories;
    delete _videoClipHistories;
    delete _soundFileHistories;

    delete _videoEncoderIndices;
    delete _audioEncoderIndices;

    delete _commandHistory;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Operation Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::OperationActionExecute(TObject *Sender)
{
	_commandHistory->updateAll();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionOnOffActionExecute(TObject *Sender)
{
	fsSenderSetStart(!fsSenderGetStart());
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionOnOffActionUpdate(TObject *Sender)
{                                                                
	TransmissionOnOffAction->Caption = fsSenderGetStart() ?
    				 SenderMainForm->_language->getDynamicWord(DW_STOP) :
                     SenderMainForm->_language->getDynamicWord(DW_START);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ReadIniFileActionExecute(TObject *Sender)
{
    if (IniFileOpenDialog->Execute())
    {
        AnsiString filename = IniFileOpenDialog->FileName;
        if (fsSenderReadIniFile(filename.c_str()))
        {
			fsSenderComputeVideoWindow();

    		updateVideoSourceSelection();
    		updateAudioSourceSelection();
	    	updateVideoEncoderSelection();
	    	updateAudioEncoderSelection();

            _commandHistory->addReadIniFile(filename);
        }
        else
        {
        	Application->MessageBox(
            		SenderMainForm->_language->getDynamicWord(DW_READINIFILEERROR).c_str(),
                    SenderMainForm->_language->getDynamicWord(DW_ERROR).c_str(),
            		MB_OK | MB_ICONERROR);
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::WriteIniFileActionExecute(TObject *Sender)
{
    if (IniFileSaveDialog->Execute())
    {
        AnsiString filename = IniFileSaveDialog->FileName;
        if (fsSenderWriteIniFile(filename.c_str()))
        {
            _commandHistory->addWriteIniFile(filename);
        }
        else
        {
        	Application->MessageBox(
            		SenderMainForm->_language->getDynamicWord(DW_WRITEINIFILEERROR).c_str(),
                    SenderMainForm->_language->getDynamicWord(DW_ERROR).c_str(),
            		MB_OK | MB_ICONERROR);
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ExitRemoteActionExecute(TObject *Sender)
{
	SenderTimer->Enabled = false;
	fsSenderQuit();

    Sleep(1000);
    SenderTimer->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ExitActionExecute(TObject *Sender)
{
    SenderMainForm->Close();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ExitActionUpdate(TObject *Sender)
{
    //
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Show Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ShowActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FocusDisplayNoneActionExecute(TObject *Sender)
{
	fsSenderSetFocusDisplay(FSSENDER_FSFD_NONE);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FocusDisplayNoneActionUpdate(TObject *Sender)
{
	int fd = fsSenderGetFocusDisplay();

    FocusDisplayNoneAction->Checked = (fd == FSSENDER_FSFD_NONE);
    FocusDisplayPartialZoomAction->Checked = (fd == FSSENDER_FSFD_PARTIAL_ZOOM);
    FocusDisplayNonLinearZoomAction->Checked = (fd == FSSENDER_FSFD_NON_LINEAR_ZOOM);
    FocusDisplayImageCompoundAction->Checked = (fd == FSSENDER_FSFD_IMAGE_COMPOUND);

    bool directVideoModeOn = fsSenderGetDirectVideoModeOn();
	FocusDisplayNoneAction->Enabled = !directVideoModeOn;
    FocusDisplayPartialZoomAction->Enabled = !directVideoModeOn;
	FocusDisplayNonLinearZoomAction->Enabled = !directVideoModeOn;
	FocusDisplayImageCompoundAction->Enabled = !directVideoModeOn;
    FocusDisplaySettingAction->Enabled = !directVideoModeOn;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FocusDisplayPartialZoomActionExecute(TObject *Sender)
{
	fsSenderSetFocusDisplay(FSSENDER_FSFD_PARTIAL_ZOOM);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FocusDisplayPartialZoomActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FocusDisplayNonLinearZoomActionExecute(TObject *Sender)
{
	fsSenderSetFocusDisplay(FSSENDER_FSFD_NON_LINEAR_ZOOM);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FocusDisplayNonLinearZoomActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FocusDisplayImageCompoundActionExecute(TObject *Sender)
{
	fsSenderSetFocusDisplay(FSSENDER_FSFD_IMAGE_COMPOUND);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FocusDisplayImageCompoundActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FocusDisplaySettingActionExecute(TObject *Sender)
{
	FocusDisplaySettingForm->ShowModal();

    _commandHistory->add((TAction *)Sender, P_FOCUSDISPLAY);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FitVideoToWindowActionExecute(TObject *Sender)
{
	fsSenderSetVideoWindowPolicy(FSSENDER_FSVWP_FITTOWINDOW);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_SHOW);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FitVideoToWindowActionUpdate(TObject *Sender)
{
	int vwp = fsSenderGetVideoWindowPolicy();

	bool fitToWindow = (vwp == FSSENDER_FSVWP_FITTOWINDOW);
	FitVideoToWindowAction->Checked = fitToWindow;

    bool keepVideoAspect = fsSenderGetKeepVideoAspect();
    KeepVideoAspectAction->Enabled = fitToWindow;
    KeepVideoAspectAction->Checked = fitToWindow && keepVideoAspect;


	bool orgSize = (vwp == FSSENDER_FSVWP_ORIGINALSIZE);
    OriginalVideoSizeAction->Checked = orgSize;

    bool fitToVideo = fsSenderGetFitWindowToVideo();
    FitWindowToVideoAction->Enabled = orgSize;
    FitWindowToVideoAction->Checked = orgSize && fitToVideo;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::KeepVideoAspectActionExecute(TObject *Sender)
{
	fsSenderSetKeepVideoAspect(!fsSenderGetKeepVideoAspect());
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_SHOW);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::KeepVideoAspectActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::OriginalVideoSizeActionExecute(TObject *Sender)
{
	fsSenderSetVideoWindowPolicy(FSSENDER_FSVWP_ORIGINALSIZE);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_SHOW);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::OriginalVideoSizeActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FitWindowToVideoActionExecute(TObject *Sender)
{
	fsSenderSetFitWindowToVideo(!fsSenderGetFitWindowToVideo());
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_SHOW);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FitWindowToVideoActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VolumeIndicatorShowActionExecute(TObject *Sender)
{
	VolumeIndicatorForm->Show();

    _commandHistory->add((TAction *)Sender);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Option Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::OptionActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
// Resolution
void __fastcall
TMainDataModule::ResolutionActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ResolutionSQCIFActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_SQCIF);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ResolutionSQCIFActionUpdate(TObject *Sender)
{
	int resolution = fsSenderGetVideoResolution();
    ResolutionSQCIFAction->Checked		= (resolution == FSSENDER_FSVR_SQCIF);
    ResolutionQCIFAction->Checked		= (resolution == FSSENDER_FSVR_QCIF);
    ResolutionCIFAction->Checked		= (resolution == FSSENDER_FSVR_CIF);
    Resolution160x120Action->Checked	= (resolution == FSSENDER_FSVR_160x120);
    Resolution320x240Action->Checked	= (resolution == FSSENDER_FSVR_320x240);
    Resolution360x240Action->Checked	= (resolution == FSSENDER_FSVR_360x240);
    Resolution640x480Action->Checked	= (resolution == FSSENDER_FSVR_640x480);
    Resolution720x480Action->Checked	= (resolution == FSSENDER_FSVR_720x480);
    Resolution800x600Action->Checked	= (resolution == FSSENDER_FSVR_800x600);
    Resolution1024x768Action->Checked	= (resolution == FSSENDER_FSVR_1024x768);
    Resolution1280x1024Action->Checked	= (resolution == FSSENDER_FSVR_1280x1024);
    Resolution1600x1200Action->Checked	= (resolution == FSSENDER_FSVR_1600x1200);
    ResolutionHDTV720pAction->Checked   = (resolution == FSSENDER_FSVR_HDTV720P);
    ResolutionHDTV1080iAction->Checked  = (resolution == FSSENDER_FSVR_HDTV1080I);
    ResolutionSDTV480pAction->Checked   = (resolution == FSSENDER_FSVR_SDTV480P);
    ResolutionSDTV480iAction->Checked   = (resolution == FSSENDER_FSVR_SDTV480I);
    ResolutionSourceResolutionAction->Checked = (resolution == FSSENDER_FSVR_THROUGH);

    bool directVideoModeOn = fsSenderGetDirectVideoModeOn();
    ResolutionSQCIFAction->Enabled = !directVideoModeOn;
    ResolutionQCIFAction->Enabled = !directVideoModeOn;
    ResolutionCIFAction->Enabled = !directVideoModeOn;
    Resolution160x120Action->Enabled = !directVideoModeOn;
    Resolution320x240Action->Enabled = !directVideoModeOn;
    Resolution360x240Action->Enabled = !directVideoModeOn;
    Resolution640x480Action->Enabled = !directVideoModeOn;
    Resolution720x480Action->Enabled = !directVideoModeOn;
    Resolution800x600Action->Enabled = !directVideoModeOn;
    Resolution1024x768Action->Enabled = !directVideoModeOn;
    Resolution1280x1024Action->Enabled = !directVideoModeOn;
    Resolution1600x1200Action->Enabled = !directVideoModeOn;
    ResolutionHDTV720pAction->Enabled = !directVideoModeOn;
    ResolutionHDTV1080iAction->Enabled = !directVideoModeOn;
    ResolutionSDTV480pAction->Enabled = !directVideoModeOn;
    ResolutionSDTV480iAction->Enabled = !directVideoModeOn;
    ResolutionSourceResolutionAction->Enabled = !directVideoModeOn;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ResolutionQCIFActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_QCIF);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ResolutionQCIFActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ResolutionCIFActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_CIF);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ResolutionCIFActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution160x120ActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_160x120);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution160x120ActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution320x240ActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_320x240);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution320x240ActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution360x240ActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_360x240);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution360x240ActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution640x480ActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_640x480);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution640x480ActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution720x480ActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_720x480);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution720x480ActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution800x600ActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_800x600);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution800x600ActionUpdate(TObject *Sender)
{
    //
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution1024x768ActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_1024x768);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution1024x768ActionUpdate(TObject *Sender)
{
    //
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution1280x1024ActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_1280x1024);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution1280x1024ActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution1600x1200ActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_1600x1200);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::Resolution1600x1200ActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ResolutionHDTV720pActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_HDTV720P);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ResolutionHDTV720pActionUpdate(TObject *Sender)
{
    //
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ResolutionHDTV1080iActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_HDTV1080I);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ResolutionHDTV1080iActionUpdate(TObject *Sender)
{
    //
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ResolutionSDTV480pActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_SDTV480P);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall TMainDataModule::ResolutionSDTV480pActionUpdate(
      TObject *Sender)
{
    //
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ResolutionSDTV480iActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_SDTV480I);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ResolutionSDTV480iActionUpdate(TObject *Sender)
{
    //
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ResolutionSourceResolutionActionExecute(TObject *Sender)
{
    fsSenderSetVideoResolution(FSSENDER_FSVR_THROUGH);
	fsSenderComputeVideoWindow();

    _commandHistory->add((TAction *)Sender, P_RESOLUTION);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ResolutionSourceResolutionActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
// Multicast
void __fastcall
TMainDataModule::MulticastActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VideoTransmissionOnActionExecute(TObject *Sender)
{
	fsSenderSetVideoTransmissionOn(!fsSenderGetVideoTransmissionOn());

    _commandHistory->add((TAction *)Sender);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VideoTransmissionOnActionUpdate(TObject *Sender)
{
	VideoTransmissionOnAction->Checked = fsSenderGetVideoTransmissionOn();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AudioTransmissionOnActionExecute(TObject *Sender)
{
	fsSenderSetAudioTransmissionOn(!fsSenderGetAudioTransmissionOn());

    _commandHistory->add((TAction *)Sender);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AudioTransmissionOnActionUpdate(TObject *Sender)
{
	AudioTransmissionOnAction->Checked = fsSenderGetAudioTransmissionOn();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FocusTransmissionOnActionExecute(TObject *Sender)
{
	fsSenderSetFocusTransmissionOn(!fsSenderGetFocusTransmissionOn());

    _commandHistory->add((TAction *)Sender);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FocusTransmissionOnActionUpdate(TObject *Sender)
{
	FocusTransmissionOnAction->Checked = fsSenderGetFocusTransmissionOn();
    FocusTransmissionOnAction->Enabled = (fsSenderGetFocusDisplay() != FSSENDER_FSFD_NONE);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionRateActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionRate100KbpsActionExecute(TObject *Sender)
{
    setTransmissionRate(100 * 1024);

    _commandHistory->add((TAction *)Sender, P_TRANSMISSIONRATE);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionRate100KbpsActionUpdate(TObject *Sender)
{
    getTransmissionRate();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionRate300KbpsActionExecute(TObject *Sender)
{
    setTransmissionRate(300 * 1024);

    _commandHistory->add((TAction *)Sender, P_TRANSMISSIONRATE);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionRate300KbpsActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionRate1MbpsActionExecute(TObject *Sender)
{
    setTransmissionRate(1 * 1024 * 1024);

    _commandHistory->add((TAction *)Sender, P_TRANSMISSIONRATE);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionRate1MbpsActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionRate10MbpsActionExecute(TObject *Sender)
{
    setTransmissionRate(10 * 1024 * 1024);

    _commandHistory->add((TAction *)Sender, P_TRANSMISSIONRATE);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionRate10MbpsActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionRate30MbpsActionExecute(TObject *Sender)
{
    setTransmissionRate(30 * 1024 * 1024);

    _commandHistory->add((TAction *)Sender, P_TRANSMISSIONRATE);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionRate30MbpsActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionRate100MbpsActionExecute(TObject *Sender)
{
    setTransmissionRate(100 * 1024 * 1024);

    _commandHistory->add((TAction *)Sender, P_TRANSMISSIONRATE);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionRate100MbpsActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionRate1000MbpsActionExecute(TObject *Sender)
{
    setTransmissionRate(1000 * 1024 * 1024);

    _commandHistory->add((TAction *)Sender, P_TRANSMISSIONRATE);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionRate1000MbpsActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionCountActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionCount1ActionExecute(TObject *Sender)
{
	fsSenderSetTransmissionCount(1);

    _commandHistory->add((TAction *)Sender, P_TRANSMISSIONCOUNT);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionCount1ActionUpdate(TObject *Sender)
{
	int count = fsSenderGetTransmissionCount();

	TransmissionCount1Action->Checked = (count == 1);
	TransmissionCount2Action->Checked = (count == 2);
	TransmissionCount3Action->Checked = (count == 3);
	TransmissionCount4Action->Checked = (count == 4);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionCount2ActionExecute(TObject *Sender)
{
	fsSenderSetTransmissionCount(2);

    _commandHistory->add((TAction *)Sender, P_TRANSMISSIONCOUNT);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionCount2ActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionCount3ActionExecute(TObject *Sender)
{
	fsSenderSetTransmissionCount(3);

    _commandHistory->add((TAction *)Sender, P_TRANSMISSIONCOUNT);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionCount3ActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionCount4ActionExecute(TObject *Sender)
{
	fsSenderSetTransmissionCount(4);

    _commandHistory->add((TAction *)Sender, P_TRANSMISSIONCOUNT);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionCount4ActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::MulticastSettingActionExecute(TObject *Sender)
{
    MulticastSettingForm->ShowModal();

	_commandHistory->add((TAction *)Sender, P_MULTICAST);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::MulticastSettingActionUpdate(TObject *Sender)
{
    //
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionMonitorShowActionExecute(TObject *Sender)
{
    TransmissionMonitorForm->Show();

	_commandHistory->add((TAction *)Sender, P_MULTICAST);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionMonitorShowActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
// Source
void __fastcall
TMainDataModule::SourceActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VideoSourceActionExecute(TObject *Sender)
{
	updateVideoSource();
    updateVideoSourceSelection();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VideoSourceActionUpdate(TObject *Sender)
{
	bool flag = fsSenderGetDirectVideoModeOn() && fsSenderGetDVInterleavedModeOn();

    VideoSourceAction->Enabled = !flag;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VideoClipInsertActionExecute(TObject *Sender)
{
	if (VideoClipOpenDialog->Execute())
    {
		AnsiString filename = VideoClipOpenDialog->FileName;
    	playVideoClip(filename);
        updateVideoClipHistory();
    }
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VideoClipInsertActionUpdate(TObject *Sender)
{
	bool enable = !fsSenderGetDirectVideoModeOn();

	VideoClipInsertAction->Enabled = enable;

    int beginIndex = VideoSourceMenuItem->IndexOf(VideoClipHistoryBeginMenuItem) + 1;
    int endIndex = VideoSourceMenuItem->IndexOf(VideoClipHistoryEndMenuItem);
	for(int i = beginIndex; i < endIndex; i++)
    	VideoSourceMenuItem->Items[i]->Enabled = enable;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AudioSourceActionExecute(TObject *Sender)
{
	updateAudioSource();
    updateAudioSourceSelection();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AudioSourceActionUpdate(TObject *Sender)
{
	bool flag = fsSenderGetDirectVideoModeOn() &&
    			fsSenderGetDVInterleavedModeOn();
    flag |= fsSenderIsPlayVideoClip();

    AudioSourceAction->Enabled = !flag;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::SoundFileInsertActionExecute(TObject *Sender)
{
	if (SoundFileOpenDialog->Execute())
    {
		AnsiString filename = SoundFileOpenDialog->FileName;
    	playSoundFile(filename);
        updateSoundFileHistory();
    }
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::SoundFileInsertActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CaptionSettingActionExecute(TObject *Sender)
{
	CaptionSettingForm->ShowModal();

	_commandHistory->add((TAction *)Sender, P_SOURCE);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CaptionSettingActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::SourceSettingActionExecute(TObject *Sender)
{
	SourceSettingForm->ShowModal();

	_commandHistory->add((TAction *)Sender, P_SOURCE);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::SourceSettingActionUpdate(TObject *Sender)
{
	SourceSettingAction->Enabled = !fsSenderIsPlayVideoClip();
}
//---------------------------------------------------------------------------
// Encoder
void __fastcall
TMainDataModule::EncoderActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VideoEncoderActionExecute(TObject *Sender)
{
	updateVideoEncoder();
    updateVideoEncoderSelection();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VideoEncoderActionUpdate(TObject *Sender)
{
	VideoEncoderAction->Enabled = !fsSenderGetDirectVideoModeOn();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AudioEncoderActionExecute(TObject *Sender)
{
	updateAudioEncoder();
    updateAudioEncoderSelection();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AudioEncoderActionUpdate(TObject *Sender)
{
	AudioEncoderAction->Enabled = !(fsSenderGetDirectVideoModeOn() &&
    								fsSenderGetDVInterleavedModeOn());
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::RecommendEncoderShowActionExecute(TObject *Sender)
{
	if (_encoderShowControl == ESC_RECOMMENDENCODER)
    	return ;
	_encoderShowControl	= ESC_RECOMMENDENCODER;
	_videoEncoderIsDirty = true;
	_audioEncoderIsDirty = true;
    updateVideoEncoder();
    updateAudioEncoder();

    _commandHistory->add((TAction *)Sender, P_ENCODER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::RecommendEncoderShowActionUpdate(TObject *Sender)
{
	RecommendEncoderShowAction->Checked = (_encoderShowControl == ESC_RECOMMENDENCODER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::RequireEncoderShowActionExecute(TObject *Sender)
{
	if (_encoderShowControl == ESC_REQUIREENCODER)
    	return ;
	_encoderShowControl = ESC_REQUIREENCODER;
	_videoEncoderIsDirty = true;
	_audioEncoderIsDirty = true;
    updateVideoEncoder();
    updateAudioEncoder();

    _commandHistory->add((TAction *)Sender, P_ENCODER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::RequireEncoderShowActionUpdate(TObject *Sender)
{
	RequireEncoderShowAction->Checked = (_encoderShowControl == ESC_REQUIREENCODER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AllEncoderShowActionExecute(TObject *Sender)
{
	if (_encoderShowControl == ESC_ALLENCODER)
    	return ;
	_encoderShowControl = ESC_ALLENCODER;
	_videoEncoderIsDirty = true;
	_audioEncoderIsDirty = true;
    updateVideoEncoder();
    updateAudioEncoder();

    _commandHistory->add((TAction *)Sender, P_ENCODER);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AllEncoderShowActionUpdate(TObject *Sender)
{
	AllEncoderShowAction->Checked = (_encoderShowControl == ESC_ALLENCODER);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Language Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::LanguageActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
//
// Help Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::HelpActionExecute(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VersionInfoActionExecute(TObject *Sender)
{
	VersionInfoForm->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VersionInfoActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// FocusDisplay Setting Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ShowFocusFrameActionExecute(TObject *Sender)
{
	fsSenderSetFocusFrameVisible(!fsSenderGetFocusFrameVisible());
	fsSenderComputeVideoWindow();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::ShowFocusFrameActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FocusCoordinateDesktopWindowActionExecute(TObject *Sender)
{
	fsSenderSetFocusCoordinate(FSSENDER_FSC_DESKTOPWINDOW);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FocusCoordinateDesktopWindowActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FocusCoordinateVideoWindowActionExecute(TObject *Sender)
{
	fsSenderSetFocusCoordinate(FSSENDER_FSC_VIDEOWINDOW);
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::FocusCoordinateVideoWindowActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Multicast Setting Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CreateIPv6AddressActionExecute(TObject *Sender)
{
	MulticastSettingForm->AddressEdit->Text = fsSenderCreateIPv6Address();
    MulticastSettingForm->_addressIsDirty = true;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CreateIPv6AddressActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CreateIPv4AddressActionExecute(TObject *Sender)
{
	MulticastSettingForm->AddressEdit->Text = fsSenderCreateIPv4Address();
    MulticastSettingForm->_addressIsDirty = true;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CreateIPv4AddressActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AddressUpdateActionExecute(TObject *Sender)
{
    AnsiString address = MulticastSettingForm->AddressEdit->Text;
    fsSenderSetAddress(address.c_str());
    MulticastSettingForm->_addressIsDirty = false;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AddressUpdateActionUpdate(TObject *Sender)
{
	AddressUpdateAction->Enabled =
		(strlen(MulticastSettingForm->AddressEdit->Text.c_str()) != 0) &&
		MulticastSettingForm->_addressIsDirty;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TTLUpdateActionExecute(TObject *Sender)
{
    int ttl = atoi(MulticastSettingForm->TTLEdit->Text.c_str());
    fsSenderSetTimeToLive(ttl);
    MulticastSettingForm->_ttlIsDirty = false;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TTLUpdateActionUpdate(TObject *Sender)
{
	TTLUpdateAction->Enabled
				 = MulticastSettingForm->_ttlIsDirty;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::PacketSizeUpdateActionExecute(TObject *Sender)
{
    int packetSize = atoi(MulticastSettingForm->PacketSizeEdit->Text.c_str());
    fsSenderSetPacketSize(packetSize);
    MulticastSettingForm->_packetSizeIsDirty = false;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::PacketSizeUpdateActionUpdate(TObject *Sender)
{
	PacketSizeUpdateAction->Enabled
				 = MulticastSettingForm->_packetSizeIsDirty;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Source Setting Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VideoSourcePropertyActionExecute(TObject *Sender)
{
	//int index = SourceSettingForm->VideoSourcePropertyComboBox->ItemIndex;
    //fsSenderShowVideoSourcePropertyPage(0, index);
	//fsSenderComputeVideoWindow();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VideoSourcePropertyActionUpdate(TObject *Sender)
{
	VideoSourcePropertyAction->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AudioSourcePropertyActionExecute(TObject *Sender)
{
	//int index = SourceSettingForm->AudioSourcePropertyComboBox->ItemIndex;
    //fsSenderShowAudioSourcePropertyPage(0, index);
	//fsSenderComputeVideoWindow();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::AudioSourcePropertyActionUpdate(TObject *Sender)
{
	AudioSourcePropertyAction->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::DirectVideoModeActionExecute(TObject *Sender)
{
	fsSenderSetDirectVideoModeOn(!fsSenderGetDirectVideoModeOn());
	fsSenderComputeVideoWindow();

    SourceSettingForm->updateForm();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::DirectVideoModeActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::DVInterleavedModeActionExecute(TObject *Sender)
{
	fsSenderSetDVInterleavedModeOn(!fsSenderGetDVInterleavedModeOn());
	fsSenderComputeVideoWindow();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::DVInterleavedModeActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Caption Setting Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CaptionSettingOKActionExecute(TObject *Sender)
{
    setupCaption(CaptionSettingForm->CaptionEdit->Text);
    updateCaptionHistory();

    CaptionSettingForm->Close();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CaptionSettingOKActionUpdate(TObject *Sender)
{
	CaptionSettingOKAction->Enabled = CaptionSettingForm->_captionIsDirty;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CaptionSettingCancelActionExecute(TObject *Sender)
{
	CaptionSettingForm->Close();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CaptionOffActionExecute(TObject *Sender)
{
	if (!CaptionSettingForm->_formShown)
		return ;
	CaptionSettingForm->_captionOff = !CaptionSettingForm->_captionOff;
    CaptionSettingForm->_captionIsDirty = true;
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::CaptionOffActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Version Info Action List
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VersionInfoOKActionExecute(TObject *Sender)
{
	VersionInfoForm->Close();
}
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::VersionInfoOKActionUpdate(TObject *Sender)
{
	//
}
//---------------------------------------------------------------------------

#include <stdio.h>

//---------------------------------------------------------------------------
//
// Sender Timer
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::SenderTimerTimer(TObject *Sender)
{
	fsLanguage *language = SenderMainForm->_language;

	bool valid = fsSenderGetValid();

    // Update Status bar information
	if (SenderMainForm->_remoteInvokeTimeout)
    {
    	SenderMainForm->StatusBar->Panels->Items[0]->Text =
        	language->getDynamicWord(DW_REMOTEINVOKETIMEOUT);
        return ;
    }

	AnsiString text = "";

    bool senderStarted = fsSenderGetStart();

    if (valid && senderStarted)
    {
    	text = language->getDynamicWord(DW_STATUSTRANSMIT) + ": ";

       	bool noData = true;

        if (fsSenderGetVideoTransmissionOn() && !(noData = false))
           	text += "("+ language->getDynamicWord(DW_STATUSVIDEO)+")";
        if (fsSenderGetAudioTransmissionOn() && !(noData = false))
           	text += "(" + language->getDynamicWord(DW_STATUSAUDIO)+")";
        if (fsSenderGetFocusTransmissionOn() && !(noData = false))
           	text += "(" + language->getDynamicWord(DW_STATUSFOCUS)+")";

        if (noData)
           	text += "(" + language->getDynamicWord(DW_STATUSNODATA) + ")";

        if (fsSenderIsPlaySoundFile())
        	text += " (" + language->getDynamicWord(DW_STATUSPLAYSOUNDFILE) + ")";
    }
	else
    {
    	text = language->getDynamicWord(DW_STATUSSTOP);
    }

	SenderMainForm->StatusBar->Panels->Items[0]->Text = text;

    text = "";
    if (!valid)
    {
		text = language->getDynamicWord(DW_STATUSFAILEDCONFIG);

        int id, type;
        char message[128];
        fsSenderGetErrorMessage(&id, &type, message);
        ErrorMessageForm->setError(id, type, message);
    }
    SenderMainForm->StatusBar->Panels->Items[1]->Text = text;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Send Monitor Timer
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::TransmissionMonitorTimerTimer(TObject *Sender)
{
    float receiveRate;
    int frameRate;
    char str[256];

    receiveRate = float(fsSenderGetVideoSenderMainTransmissionRate()) / 1024.0f;
    sprintf(str, "%5.3f", receiveRate);
    frameRate = fsSenderGetVideoSenderMainFrameRate();
    TransmissionMonitorForm->SendRateVideoMainValue->Caption = AnsiString(str);
    TransmissionMonitorForm->FrameRateVideoMainValue->Caption = AnsiString(frameRate);

    receiveRate = float(fsSenderGetVideoSenderSubTransmissionRate()) / 1024.0f;
    sprintf(str, "%5.3f", receiveRate);
    frameRate = fsSenderGetVideoSenderSubFrameRate();
    TransmissionMonitorForm->SendRateVideoSubValue->Caption = AnsiString(str);
    TransmissionMonitorForm->FrameRateVideoSubValue->Caption = AnsiString(frameRate);

    receiveRate = float(fsSenderGetAudioSenderTransmissionRate()) / 1024.0f;
    sprintf(str, "%5.3f", receiveRate);
    frameRate = fsSenderGetAudioSenderFrameRate();
    TransmissionMonitorForm->SendRateAudioValue->Caption = AnsiString(str);
    TransmissionMonitorForm->FrameRateAudioValue->Caption = AnsiString(frameRate);

    receiveRate = float(fsSenderGetPointerSenderTransmissionRate()) / 1024.0f;
    sprintf(str, "%5.3f", receiveRate);
    frameRate = fsSenderGetPointerSenderFrameRate();
    TransmissionMonitorForm->SendRatePointerValue->Caption = AnsiString(str);
    TransmissionMonitorForm->FrameRatePointerValue->Caption = AnsiString(frameRate);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Multicast Detection Timer
//
//---------------------------------------------------------------------------
void __fastcall
TMainDataModule::MulticastDetectionTimerTimer(TObject *Sender)
{
	AnsiString address = MulticastSettingForm->_inputAddress;
    MulticastSettingForm->MulticastDetectLabel->Visible =
    	(address.Length() != 0 && fsSenderWasDetectedMulticast(address.c_str()));
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//
// Dynamic MenuItem Handler
//
//---------------------------------------------------------------------------
// Operation History
// TODO
//---------------------------------------------------------------------------
// Video Source
void __fastcall
TMainDataModule::VideoSourceEntryMenuItemOnClick(TObject *Sender)
{
	int beginIndex = VideoSourceMenuItem->IndexOf(VideoSourceBeginMenuItem);
    int count = fsSenderGetNumVideoSources();

    for(int i = 0, ii = beginIndex + 1; i < count; i++, ii++)
    {
    	if (VideoSourceMenuItem->Items[ii] == Sender)
        {
        	VideoSourceMenuItem->Items[ii]->Checked = true;
            fsSenderSetVideoSource(i);
			fsSenderComputeVideoWindow();

            _commandHistory->addVideoSource(i, VideoSourceMenuItem->Items[ii]->Caption);
        }
        else
        {
        	VideoSourceMenuItem->Items[ii]->Checked = false;
        }
    }
}
//---------------------------------------------------------------------------
// Video Clip History
void __fastcall
TMainDataModule::VideoClipHistoryMenuItemOnClick(TObject *Sender)
{
	int beginIndex = VideoSourceMenuItem->IndexOf(VideoClipHistoryBeginMenuItem);

    for(int i = 0, ii = beginIndex + 1; i < _videoClipHistories->Count; i++, ii++)
    {
		TMenuItem* item = VideoSourceMenuItem->Items[ii];
        if (item == Sender)
        {
            playVideoClip(_videoClipHistories->Strings[i]);
            updateVideoClipHistory();
        	break;
        }
    }
}
//---------------------------------------------------------------------------
// Audio Source
void __fastcall
TMainDataModule::AudioSourceEntryMenuItemOnClick(TObject *Sender)
{
	int beginIndex = AudioSourceMenuItem->IndexOf(AudioSourceBeginMenuItem);
    int count = fsSenderGetNumAudioSources();

    for(int i = 0, ii = beginIndex + 1; i < count; i++, ii++)
    {
    	if (AudioSourceMenuItem->Items[ii] == Sender)
        {
        	AudioSourceMenuItem->Items[ii]->Checked = true;
            fsSenderSetAudioSource(i);
			fsSenderComputeVideoWindow();

            _commandHistory->addAudioSource(i, AudioSourceMenuItem->Items[ii]->Caption);
        }
        else
        {
        	AudioSourceMenuItem->Items[ii]->Checked = false;
        }
    }
}
//---------------------------------------------------------------------------
// Sound File History
void __fastcall
TMainDataModule::SoundFileHistoryMenuItemOnClick(TObject *Sender)
{
	int beginIndex = AudioSourceMenuItem->IndexOf(SoundFileHistoryBeginMenuItem);

    for(int i = 0, ii = beginIndex + 1; i < _soundFileHistories->Count; i++, ii++)
    {
		TMenuItem* item = AudioSourceMenuItem->Items[ii];
        if (item == Sender)
        {
            playSoundFile(_soundFileHistories->Strings[i]);
            updateSoundFileHistory();
        	break;
        }
    }
}
//---------------------------------------------------------------------------
// Caption History
void __fastcall
TMainDataModule::CaptionHistoryMenuItemOnClick(TObject *Sender)
{
	int beginIndex = SourceMenuItem->IndexOf(CaptionHistoryBeginMenuItem);

    for(int i = 0, ii = beginIndex + 1; i < _captionHistories->Count; i++, ii++)
    {
		TMenuItem* item = SourceMenuItem->Items[ii];
        if (item == Sender)
        {
        	setupCaption(_captionHistories->Strings[i]);
		    updateCaptionHistory();
        	break;
        }
    }
}
//---------------------------------------------------------------------------
// Video Encoder
void __fastcall
TMainDataModule::VideoEncoderEntryMenuItemOnClick(TObject *Sender)
{
	int beginIndex = VideoEncoderMenuItem->IndexOf(VideoEncoderBeginMenuItem);
    int count = _videoEncoderIndices->Count;

    for(int i = 0, ii = beginIndex + 1; i < count; i++, ii++)
    {
    	if (VideoEncoderMenuItem->Items[ii]->OnClick == NULL)
        	i--;

    	if (VideoEncoderMenuItem->Items[ii] == Sender)
        {
			int videoEncoder = (int)_videoEncoderIndices->Items[i];

        	VideoEncoderMenuItem->Items[ii]->Checked = true;
            fsSenderSetVideoEncoder(videoEncoder);
			fsSenderComputeVideoWindow();

            _commandHistory->addVideoEncoder(videoEncoder,
            						VideoEncoderMenuItem->Items[ii]->Caption);
        }
        else
        {
        	VideoEncoderMenuItem->Items[ii]->Checked = false;
        }
    }
}
//---------------------------------------------------------------------------
// Audio Encoder
void __fastcall
TMainDataModule::AudioEncoderEntryMenuItemOnClick(TObject *Sender)
{
	int beginIndex = AudioEncoderMenuItem->IndexOf(AudioEncoderBeginMenuItem);
    int count = _audioEncoderIndices->Count;

    for(int i = 0, ii = beginIndex + 1; i < count; i++, ii++)
    {
    	if (AudioEncoderMenuItem->Items[ii]->OnClick == NULL)
        	i--;

    	if (AudioEncoderMenuItem->Items[ii] == Sender)
        {
        	int audioEncoder = (int)_audioEncoderIndices->Items[i];

        	AudioEncoderMenuItem->Items[ii]->Checked = true;
            fsSenderSetAudioEncoder(audioEncoder);
			fsSenderComputeVideoWindow();

            _commandHistory->addAudioEncoder(audioEncoder,
            						AudioEncoderMenuItem->Items[ii]->Caption);
        }
        else
        {
        	AudioEncoderMenuItem->Items[ii]->Checked = false;
        }
    }
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Update MenuItem
void
TMainDataModule::updateVideoSource()
{
	if (!_videoSourceIsDirty)
    	return ;
    _videoSourceIsDirty = false;

    int numSources, curSource;

    numSources = fsSenderGetNumVideoSources();
    curSource = fsSenderGetVideoSource();

    int beginIndex = VideoSourceMenuItem->IndexOf(VideoSourceBeginMenuItem);
    int endIndex = VideoSourceMenuItem->IndexOf(VideoSourceEndMenuItem);
    clearMenuItem(VideoSourceMenuItem, beginIndex, endIndex);

	for(int i = 0; i < numSources; i++)
	{
		const char * captureFriendlyName = fsSenderGetVideoSourceFriendlyName(i);

		TMenuItem* newMenuItem = createMenuItem(VideoSourceMenuItem, captureFriendlyName,
                                                VideoSourceEntryMenuItemOnClick);
        VideoSourceMenuItem->Insert(++beginIndex, newMenuItem);

        if (i == curSource)
            newMenuItem->Checked = true;
	}
}
//---------------------------------------------------------------------------
void
TMainDataModule::updateVideoClipHistory()
{
    int numHistories;

    numHistories = _videoClipHistories->Count;

    int beginIndex = VideoSourceMenuItem->IndexOf(VideoClipHistoryBeginMenuItem);
	int endIndex = VideoSourceMenuItem->IndexOf(VideoClipHistoryEndMenuItem);
    clearMenuItem(VideoSourceMenuItem, beginIndex, endIndex);

	for(int i = 0; i < numHistories; i++)
	{
		const AnsiString& videoClipStr = _videoClipHistories->Strings[i];

		TMenuItem* newMenuItem = createMenuItem(VideoSourceMenuItem, "\"" + videoClipStr + "\"",
        										VideoClipHistoryMenuItemOnClick);
        VideoSourceMenuItem->Insert(++beginIndex, newMenuItem);
	}
}
//---------------------------------------------------------------------------
void
TMainDataModule::updateAudioSource()
{
	if (!_audioSourceIsDirty)
    	return ;
    _audioSourceIsDirty = false;

    int numSources, curSource;

    numSources = fsSenderGetNumAudioSources();
    curSource = fsSenderGetAudioSource();

    int beginIndex = AudioSourceMenuItem->IndexOf(AudioSourceBeginMenuItem);
	int endIndex = AudioSourceMenuItem->IndexOf(AudioSourceEndMenuItem);
    clearMenuItem(AudioSourceMenuItem, beginIndex, endIndex);

	for(int i = 0; i < numSources; i++)
	{
		const char * captureFriendlyName = fsSenderGetAudioSourceFriendlyName(i);

		TMenuItem* newMenuItem = createMenuItem(AudioSourceMenuItem, captureFriendlyName,
                                                AudioSourceEntryMenuItemOnClick);
        AudioSourceMenuItem->Insert(++beginIndex, newMenuItem);

        if (i == curSource)
            newMenuItem->Checked = true;
	}
}
//---------------------------------------------------------------------------
void
TMainDataModule::updateSoundFileHistory()
{
    int numHistories;

    numHistories = _soundFileHistories->Count;

    int beginIndex = AudioSourceMenuItem->IndexOf(SoundFileHistoryBeginMenuItem);
	int endIndex = AudioSourceMenuItem->IndexOf(SoundFileHistoryEndMenuItem);
    clearMenuItem(AudioSourceMenuItem, beginIndex, endIndex);

	for(int i = 0; i < numHistories; i++)
	{
		const AnsiString& soundFileStr = _soundFileHistories->Strings[i];

		TMenuItem* newMenuItem = createMenuItem(AudioSourceMenuItem, "\"" + soundFileStr + "\"",
        										SoundFileHistoryMenuItemOnClick);
        AudioSourceMenuItem->Insert(++beginIndex, newMenuItem);
	}
}
//---------------------------------------------------------------------------
void
TMainDataModule::updateCaptionHistory()
{
    int numHistories;

    numHistories = _captionHistories->Count;

    int beginIndex = SourceMenuItem->IndexOf(CaptionHistoryBeginMenuItem);
	int endIndex = SourceMenuItem->IndexOf(CaptionHistoryEndMenuItem);
    clearMenuItem(SourceMenuItem, beginIndex, endIndex);

	for(int i = 0; i < numHistories; i++)
	{
		const AnsiString& captionStr = _captionHistories->Strings[i];

		TMenuItem* newMenuItem = createMenuItem(SourceMenuItem, "\"" + captionStr + "\"",
        										CaptionHistoryMenuItemOnClick);
        SourceMenuItem->Insert(++beginIndex, newMenuItem);
	}
}
//---------------------------------------------------------------------------
void
TMainDataModule::updateVideoEncoder()
{
	if (!_videoEncoderIsDirty)
    	return ;
    _videoEncoderIsDirty = false;

    int numEncoders = fsSenderGetNumVideoEncoder();
    int beginIndex = VideoEncoderMenuItem->IndexOf(VideoEncoderBeginMenuItem);
	int endIndex = VideoEncoderMenuItem->IndexOf(VideoEncoderEndMenuItem);

    // Clear
    clearMenuItem(VideoEncoderMenuItem, beginIndex, endIndex);
	_videoEncoderIndices->Clear();

    // Enumeration
    int recommendIndex = 0;
    int generallyIndex = 0;
    int notRecommendIndex = 0;
    int recommendMenuIndex = beginIndex + 1;
    int generallyMenuIndex = beginIndex + 1;
    int notRecommendMenuIndex = beginIndex + 1;
    bool generallySepInserted = false;
    bool notRecommendSepInserted = false;

	for(int i = 0; i < numEncoders; i++)
	{
		const char * encoderFriendlyName = fsSenderGetVideoEncoderFriendlyName(i);
        int encoderPriority = fsSenderGetVideoEncoderPriority(i);

        switch(encoderPriority)
        {
		case FSSENDER_P_RECOMMEND:

	        VideoEncoderMenuItem->Insert(recommendMenuIndex++,
            			createMenuItem(VideoEncoderMenuItem,
                        			   encoderFriendlyName,
                                       VideoEncoderEntryMenuItemOnClick));

			_videoEncoderIndices->Insert(recommendIndex++, (void *)i);

            generallyMenuIndex ++;
            generallyIndex ++;
            notRecommendMenuIndex ++;
            notRecommendIndex ++;

        	break;

		case FSSENDER_P_GENERALLY:

			if (_encoderShowControl == ESC_RECOMMENDENCODER)
            	break;

            if (!generallySepInserted)
            {
				generallySepInserted = true;
		        VideoEncoderMenuItem->Insert(generallyMenuIndex++,
                				createMenuItem(VideoEncoderMenuItem, "-", NULL));

                notRecommendMenuIndex ++;
            }

	        VideoEncoderMenuItem->Insert(generallyMenuIndex++,
            			createMenuItem(VideoEncoderMenuItem,
                        			   encoderFriendlyName,
                                       VideoEncoderEntryMenuItemOnClick));

			_videoEncoderIndices->Insert(generallyIndex++, (void *)i);

            notRecommendMenuIndex ++;
            notRecommendIndex ++;

        	break;

		case FSSENDER_P_NOTRECOMMEND:

			if (_encoderShowControl != ESC_ALLENCODER)
            	break;

            if (!notRecommendSepInserted)
            {
				notRecommendSepInserted = true;
		        VideoEncoderMenuItem->Insert(notRecommendMenuIndex++,
                				createMenuItem(VideoEncoderMenuItem, "-", NULL));
            }

	        VideoEncoderMenuItem->Insert(notRecommendMenuIndex++,
            			createMenuItem(VideoEncoderMenuItem,
                        			   encoderFriendlyName,
                                       VideoEncoderEntryMenuItemOnClick));

			_videoEncoderIndices->Insert(notRecommendIndex++, (void *)i);

        	break;
        }

	}
}
//---------------------------------------------------------------------------
void
TMainDataModule::updateAudioEncoder()
{
	if (!_audioEncoderIsDirty)
    	return ;
    _audioEncoderIsDirty = false;

    int numEncoders = fsSenderGetNumAudioEncoder();
    int beginIndex = AudioEncoderMenuItem->IndexOf(AudioEncoderBeginMenuItem);
	int endIndex = AudioEncoderMenuItem->IndexOf(AudioEncoderEndMenuItem);

    // Clear
    clearMenuItem(AudioEncoderMenuItem, beginIndex, endIndex);
	_audioEncoderIndices->Clear();

    // Enumeration
    int recommendIndex = 0;
    int generallyIndex = 0;
    int notRecommendIndex = 0;
    int recommendMenuIndex = beginIndex + 1;
    int generallyMenuIndex = beginIndex + 1;
    int notRecommendMenuIndex = beginIndex + 1;
    bool generallySepInserted = false;
    bool notRecommendSepInserted = false;

	for(int i = 0; i < numEncoders; i++)
	{
		const char * encoderFriendlyName = fsSenderGetAudioEncoderFriendlyName(i);
        int encoderPriority = fsSenderGetAudioEncoderPriority(i);

        switch(encoderPriority)
        {
		case FSSENDER_P_RECOMMEND:

	        AudioEncoderMenuItem->Insert(recommendMenuIndex++,
            			createMenuItem(AudioEncoderMenuItem,
                        			   encoderFriendlyName,
                                       AudioEncoderEntryMenuItemOnClick));

			_audioEncoderIndices->Insert(recommendIndex++, (void *)i);

            generallyMenuIndex ++;
            generallyIndex ++;
            notRecommendMenuIndex ++;
            notRecommendIndex ++;

        	break;

		case FSSENDER_P_GENERALLY:

			if (_encoderShowControl == ESC_RECOMMENDENCODER)
            	break;

            if (!generallySepInserted)
            {
				generallySepInserted = true;
		        AudioEncoderMenuItem->Insert(generallyMenuIndex++,
                			createMenuItem(AudioEncoderMenuItem, "-", NULL));

                notRecommendMenuIndex ++;
            }

	        AudioEncoderMenuItem->Insert(generallyMenuIndex++,
            			createMenuItem(AudioEncoderMenuItem,
                        			   encoderFriendlyName,
                                       AudioEncoderEntryMenuItemOnClick));

			_audioEncoderIndices->Insert(generallyIndex++, (void *)i);

            notRecommendMenuIndex ++;
            notRecommendIndex ++;

        	break;

		case FSSENDER_P_NOTRECOMMEND:

			if (_encoderShowControl != ESC_ALLENCODER)
            	break;

            if (!notRecommendSepInserted)
            {
				notRecommendSepInserted = true;
		        AudioEncoderMenuItem->Insert(notRecommendMenuIndex++,
                			createMenuItem(AudioEncoderMenuItem, "-", NULL));
            }

	        AudioEncoderMenuItem->Insert(notRecommendMenuIndex++,
            			createMenuItem(AudioEncoderMenuItem,
                        			   encoderFriendlyName,
                                       AudioEncoderEntryMenuItemOnClick));

			_audioEncoderIndices->Insert(notRecommendIndex++, (void *)i);

        	break;
        }

	}
}
//---------------------------------------------------------------------------
// Update MenuItem Selection
void
TMainDataModule::updateVideoSourceSelection()
{
	int curVideoSource = fsSenderGetVideoSource();

    int beginIndex = VideoSourceMenuItem->IndexOf(VideoSourceBeginMenuItem);
    int endIndex = VideoSourceMenuItem->IndexOf(VideoSourceEndMenuItem);

    for(int i = beginIndex + 1, ii = 0; i < endIndex; i++, ii++)
    {
    	TMenuItem* menuItem = VideoSourceMenuItem->Items[i];
        menuItem->Checked = (ii == curVideoSource);
    }
}
//---------------------------------------------------------------------------
void
TMainDataModule::updateAudioSourceSelection()
{
	int curAudioSource = fsSenderGetAudioSource();

    int beginIndex = AudioSourceMenuItem->IndexOf(AudioSourceBeginMenuItem);
    int endIndex = AudioSourceMenuItem->IndexOf(AudioSourceEndMenuItem);

    for(int i = beginIndex + 1, ii = 0; i < endIndex; i++, ii++)
    {
    	TMenuItem* menuItem = AudioSourceMenuItem->Items[i];
        menuItem->Checked = (ii == curAudioSource);
    }
}
//---------------------------------------------------------------------------
void
TMainDataModule::updateVideoEncoderSelection()
{
	int curVideoEncoder = fsSenderGetVideoEncoder();

    int beginIndex = VideoEncoderMenuItem->IndexOf(VideoEncoderBeginMenuItem);
    int endIndex = VideoEncoderMenuItem->IndexOf(VideoEncoderEndMenuItem);

    for(int i = beginIndex + 1, ii = 0; i < endIndex; i++)
    {
    	TMenuItem* menuItem = VideoEncoderMenuItem->Items[i];
        if (menuItem->OnClick == NULL)
        	continue;
        menuItem->Checked = ((int)_videoEncoderIndices->Items[ii++] == curVideoEncoder);
    }
}
//---------------------------------------------------------------------------
void
TMainDataModule::updateAudioEncoderSelection()
{
	int curAudioEncoder = fsSenderGetAudioEncoder();

    int beginIndex = AudioEncoderMenuItem->IndexOf(AudioEncoderBeginMenuItem);
    int endIndex = AudioEncoderMenuItem->IndexOf(AudioEncoderEndMenuItem);

    for(int i = beginIndex + 1, ii = 0; i < endIndex; i++)
    {
    	TMenuItem* menuItem = AudioEncoderMenuItem->Items[i];
        if (menuItem->OnClick == NULL)
        	continue;
        menuItem->Checked = ((int)_audioEncoderIndices->Items[ii++] == curAudioEncoder);
    }
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void
TMainDataModule::playVideoClip(const AnsiString& filename)
{
    if (fsSenderPlayVideoClip(filename.c_str()))
    {
		int index = _videoClipHistories->IndexOf(filename);
        if (index == -1)
        {
        	_videoClipHistories->Insert(0, filename);

			if (MAX_VIDEOCLIPHISTORY < _videoClipHistories->Count)
    	    	_videoClipHistories->Delete(MAX_VIDEOCLIPHISTORY);
        }
        else
        {
        	_videoClipHistories->Delete(index);
            _videoClipHistories->Insert(0, filename);
        }
    }
    else
    {
     	Application->MessageBox(
	        SenderMainForm->_language->getDynamicWord(DW_PLAYVIDEOCLIPERROR).c_str(),
			SenderMainForm->_language->getDynamicWord(DW_ERROR).c_str(),
            MB_OK | MB_ICONERROR);
    }
	fsSenderComputeVideoWindow();
}
//---------------------------------------------------------------------------
void
TMainDataModule::playSoundFile(const AnsiString& filename)
{
    if (fsSenderPlaySoundFile(filename.c_str()))
    {
    	int index = _soundFileHistories->IndexOf(filename);
		if (index == -1)
        {
        	_soundFileHistories->Insert(0, filename);

			if (MAX_SOUNDFILEHISTORY < _soundFileHistories->Count)
    	    	_soundFileHistories->Delete(MAX_SOUNDFILEHISTORY);
        }
        else
        {
        	_soundFileHistories->Delete(index);
            _soundFileHistories->Insert(0, filename);
        }
    }
    else
    {
     	Application->MessageBox(
	        SenderMainForm->_language->getDynamicWord(DW_PLAYSOUNDFILEERROR).c_str(),
			SenderMainForm->_language->getDynamicWord(DW_ERROR).c_str(),
            MB_OK | MB_ICONERROR);
    }
	fsSenderComputeVideoWindow();
}
//---------------------------------------------------------------------------
void
TMainDataModule::setupCaption(const AnsiString& captionStr)
{
    if (captionStr.Length() != 0)
	    fsSenderSetCaption(captionStr.c_str());
    else
    	fsSenderSetCaption("");

	fsSenderSetCaptionOn(!CaptionSettingForm->_captionOff);

    int index = _captionHistories->IndexOf(captionStr);
    if (index == -1)
    {
    	_captionHistories->Insert(0, captionStr);

        if (MAX_CAPTIONHISTORY < _captionHistories->Count)
        	_captionHistories->Delete(MAX_CAPTIONHISTORY);
    }
    else
    {
    	_captionHistories->Delete(index);
        _captionHistories->Insert(0, captionStr);
    }
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void
TMainDataModule::clearMenuItem(TMenuItem* parent, int beginIndex, int endIndex)
{
    for(int i = beginIndex + 1; i < endIndex; i++)
    {
    	TMenuItem* menuItem = parent->Items[beginIndex + 1];
		parent->Delete(beginIndex + 1);
        delete menuItem;
    }
}
//---------------------------------------------------------------------------
TMenuItem*
TMainDataModule::createMenuItem(TMenuItem* parent,
								const AnsiString& caption,
                                TNotifyEvent OnClickHandler)
{
	TMenuItem *menuItem = new TMenuItem(parent);
    menuItem->Caption = caption;
    menuItem->OnClick = OnClickHandler;
    return menuItem;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void
TMainDataModule::setTransmissionRate(int rate)
{
    fsSenderSetVideoSenderMainMaxTransmissionRate(rate);
    fsSenderSetVideoSenderSubMaxTransmissionRate(rate);
    fsSenderSetAudioSenderMaxTransmissionRate(rate);
    fsSenderSetPointerSenderMaxTransmissionRate(rate);
    fsSenderSetStatusSenderMaxTransmissionRate(rate);
}
//---------------------------------------------------------------------------
void
TMainDataModule::getTransmissionRate()
{
    TransmissionRate100KbpsAction->Checked = false;
    TransmissionRate300KbpsAction->Checked = false;
    TransmissionRate1MbpsAction->Checked = false;
    TransmissionRate10MbpsAction->Checked = false;
    TransmissionRate30MbpsAction->Checked = false;
    TransmissionRate100MbpsAction->Checked = false;
    TransmissionRate1000MbpsAction->Checked = false;

    int rate1 = fsSenderGetVideoSenderMainMaxTransmissionRate();
    int rate2 = fsSenderGetVideoSenderSubMaxTransmissionRate();
    int rate3 = fsSenderGetAudioSenderMaxTransmissionRate();
    int rate4 = fsSenderGetPointerSenderMaxTransmissionRate();
    int rate5 = fsSenderGetStatusSenderMaxTransmissionRate();

    if (rate1 == rate2 && rate2 == rate3 && rate3 == rate4 && rate4 == rate5)
    {
        if (rate1 == 100 * 1024)
            TransmissionRate100KbpsAction->Checked = true;
        else if (rate1 == 300 * 1024)
            TransmissionRate300KbpsAction->Checked = true;
        else if (rate1 == 1 * 1024 * 1024)
            TransmissionRate1MbpsAction->Checked = true;
        else if (rate1 == 10 * 1024 * 1024)
            TransmissionRate10MbpsAction->Checked = true;
        else if (rate1 == 30 * 1024 * 1024)
            TransmissionRate30MbpsAction->Checked = true;
        else if (rate1 == 100 * 1024 * 1024)
            TransmissionRate100MbpsAction->Checked = true;
        else if (rate1 == 1 * 1024 * 1024 * 1024)
            TransmissionRate1000MbpsAction->Checked = true;
    }
}
//---------------------------------------------------------------------------

