/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#ifndef fsMainDataModuleH
#define fsMainDataModuleH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ImgList.hpp>
#include <ActnList.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class fsSenderCommandHistory;
//---------------------------------------------------------------------------
class TMainDataModule : public TDataModule
{
__published:	// IDE Ǘ̃R|[lg
	TActionList *FocusDisplaySettingActionList;
    TTimer *SenderTimer;
	TActionList *MulticastSettingActionList;
	TAction *AddressUpdateAction;
	TAction *TTLUpdateAction;
	TAction *PacketSizeUpdateAction;
	TTimer *TransmissionMonitorTimer;
    TOpenDialog *IniFileOpenDialog;
    TSaveDialog *IniFileSaveDialog;
    TMainMenu *MainMenu;
	TMenuItem *OperationMenuItem;
    TMenuItem *ReadIniFileMenuItem;
    TMenuItem *WriteIniFileMenuItem;
	TMenuItem *OperationSeparator2;
    TMenuItem *ExitMenuItem;
	TActionList *SourceSettingActionList;
	TAction *VideoSourcePropertyAction;
	TAction *AudioSourcePropertyAction;
	TAction *DirectVideoModeAction;
	TAction *DVInterleavedModeAction;
	TMenuItem *LanguageMenuItem;
	TActionList *LanguageActionList;
	TAction *LanguageAction;
	TAction *ShowFocusFrameAction;
	TActionList *OperationActionList;
	TActionList *ShowActionList;
	TActionList *OptionActionList;
	TActionList *HelpActionList;
	TAction *TransmissionOnOffAction;
	TAction *ReadIniFileAction;
	TAction *WriteIniFileAction;
	TAction *OperationAction;
	TAction *ShowAction;
	TAction *FocusDisplayNoneAction;
	TAction *FocusDisplayPartialZoomAction;
	TAction *FocusDisplayNonLinearZoomAction;
	TAction *FocusDisplayImageCompoundAction;
	TAction *FocusDisplaySettingAction;
	TAction *FitVideoToWindowAction;
	TAction *KeepVideoAspectAction;
	TAction *OriginalVideoSizeAction;
	TAction *FitWindowToVideoAction;
	TAction *OptionAction;
	TAction *ResolutionSQCIFAction;
	TAction *ResolutionQCIFAction;
	TAction *ResolutionCIFAction;
	TAction *Resolution160x120Action;
	TAction *Resolution320x240Action;
	TAction *Resolution360x240Action;
	TAction *Resolution640x480Action;
	TAction *Resolution720x480Action;
	TAction *Resolution1280x1024Action;
	TAction *Resolution1600x1200Action;
	TAction *ResolutionSourceResolutionAction;
	TAction *VideoTransmissionOnAction;
	TAction *AudioTransmissionOnAction;
	TAction *FocusTransmissionOnAction;
	TAction *TransmissionRate100KbpsAction;
	TAction *TransmissionRate300KbpsAction;
	TAction *TransmissionRate1MbpsAction;
	TAction *TransmissionRate10MbpsAction;
	TAction *TransmissionRate30MbpsAction;
	TAction *TransmissionRate100MbpsAction;
	TAction *TransmissionRate1000MbpsAction;
	TAction *TransmissionCount1Action;
	TAction *TransmissionCount2Action;
	TAction *TransmissionCount3Action;
	TAction *TransmissionCount4Action;
	TAction *MulticastSettingAction;
	TAction *TransmissionMonitorShowAction;
	TAction *VideoClipInsertAction;
	TAction *SoundFileInsertAction;
	TAction *CaptionSettingAction;
	TAction *SourceSettingAction;
	TAction *RecommendEncoderShowAction;
	TAction *RequireEncoderShowAction;
	TAction *AllEncoderShowAction;
	TAction *MulticastAction;
	TAction *SourceAction;
	TAction *ResolutionAction;
	TAction *TransmissionRateAction;
	TAction *TransmissionCountAction;
	TAction *VideoSourceAction;
	TAction *AudioSourceAction;
	TAction *EncoderAction;
	TAction *VideoEncoderAction;
	TAction *AudioEncoderAction;
	TAction *HelpAction;
	TAction *VersionInfoAction;
	TAction *ExitAction;
	TMenuItem *TransmissionOnOffMenuItem;
	TMenuItem *OperationSeparator1;
	TMenuItem *OperationSeparator3;
	TMenuItem *OperationHistoryBeginMenuItem;
	TMenuItem *ShowMenuItem;
	TMenuItem *FocusDisplayNoneMenuItem;
	TMenuItem *FocusDisplayPartialZoomMenuItem;
	TMenuItem *FocusDisplayNonLinearZoomMenuItem;
	TMenuItem *FocusDisplayImageCompoundMenuItem;
	TMenuItem *ShowSeparator1;
	TMenuItem *FocusDisplaySettingMenuItem;
	TMenuItem *ShowSeparator2;
	TMenuItem *FitVideoToWindowMenuItem;
	TMenuItem *KeepVideoAspectMenuItem;
	TMenuItem *ShowSeparator3;
	TMenuItem *OriginalVideoSizeMenuItem;
	TMenuItem *FitWindowToVideoMenuItem;
	TMenuItem *OptionMenuItem;
	TMenuItem *ResolutionMenuItem;
	TMenuItem *ResolutionSQCIFMenuItem;
	TMenuItem *ResolutionQCIFMenuItem;
	TMenuItem *ResolutionCIFMenuItem;
	TMenuItem *Resolution160x120MenuItem;
	TMenuItem *Resolution320x240MenuItem;
	TMenuItem *Resolution360x240MenuItem;
	TMenuItem *Resolution640x480MenuItem;
	TMenuItem *Resolution720x480MenuItem;
	TMenuItem *Resolution1280x1024MenuItem;
	TMenuItem *Resolution1600x1200MenuItem;
	TMenuItem *ResolutionSourceResolutionMenuItem;
	TMenuItem *MulticastMenuItem;
	TMenuItem *VideoTransmissionOnMenuItem;
	TMenuItem *AudioTransmissionOnMenuItem;
	TMenuItem *FocusTransmissionOnMenuItem;
	TMenuItem *MulticastSeparator1;
	TMenuItem *TransmissionRateMenuItem;
	TMenuItem *TransmissionRate100KbpsMenuItem;
	TMenuItem *TransmissionRate300KbpsMenuItem;
	TMenuItem *TransmissionRate1MbpsMenuItem;
	TMenuItem *TransmissionRate10MbpsMenuItem;
	TMenuItem *TransmissionRate30MbpsMenuItem;
	TMenuItem *TransmissionRate100MbpsMenuItem;
	TMenuItem *TransmissionRate1000MbpsMenuItem;
	TMenuItem *TransmissionCountMenuItem;
	TMenuItem *TransmissionCount1MenuItem;
	TMenuItem *TransmissionCount2MenuItem;
	TMenuItem *TransmissionCount3MenuItem;
	TMenuItem *TransmissionCount4MenuItem;
	TMenuItem *MulticastSeparator2;
	TMenuItem *MulticastSettingMenuItem;
	TMenuItem *MulticastSeparator3;
	TMenuItem *TransmissionMonitorShowMenuItem;
	TMenuItem *SourceMenuItem;
	TMenuItem *VideoSourceMenuItem;
	TMenuItem *VideoSourceBeginMenuItem;
	TMenuItem *VideoSourceSeparator1;
	TMenuItem *VideoClipInsertMenuItem;
	TMenuItem *VideoSourceSeparator2;
	TMenuItem *VideoClipHistoryBeginMenuItem;
	TMenuItem *AudioSourceMenuItem;
	TMenuItem *AudioSourceBeginMenuItem;
	TMenuItem *AudioSourceSeparator1;
	TMenuItem *SoundFileInsertMenuItem;
	TMenuItem *AudioSourceSeparator2;
	TMenuItem *SoundFileHistoryBeginMenuItem;
	TMenuItem *SourceSeparator1;
	TMenuItem *CaptionSettingMenuItem;
	TMenuItem *SourceSeparator2;
	TMenuItem *CaptionHistoryBeginMenuItem;
	TMenuItem *SourceSeparator3;
	TMenuItem *SourceSettingMenuItem;
	TMenuItem *EncoderMenuItem;
	TMenuItem *VideoEncoderMenuItem;
	TMenuItem *VideoEncoderBeginMenuItem;
	TMenuItem *AudioEncoderMenuItem;
	TMenuItem *AudioEncoderBeginMenuItem;
	TMenuItem *EncoderSeparator1;
	TMenuItem *RecommendEncoderShowMenuItem;
	TMenuItem *RequireEncoderShowMenuItem;
	TMenuItem *AllEncoderShowMenuItem;
	TMenuItem *HelpMenuItem;
	TMenuItem *VersionInfoMenuItem;
	TActionList *CaptionSettingActionList;
	TAction *CaptionSettingOKAction;
	TAction *CaptionSettingCancelAction;
	TMenuItem *CaptionHistoryEndMenuItem;
	TMenuItem *VideoSourceEndMenuItem;
	TMenuItem *VideoClipHistoryEndMenuItem;
	TMenuItem *AudioSourceEndMenuItem;
	TMenuItem *SoundFileHistoryEndMenuItem;
	TMenuItem *OperationHistoryEndMenuItem;
	TMenuItem *VideoEncoderEndMenuItem;
	TMenuItem *AudioEncoderEndMenuItem;
	TOpenDialog *VideoClipOpenDialog;
	TOpenDialog *SoundFileOpenDialog;
	TAction *CreateIPv6AddressAction;
	TAction *CreateIPv4AddressAction;
	TAction *VolumeIndicatorShowAction;
	TMenuItem *ShowSeparator4;
	TMenuItem *VolumeIndicatorShowMenuItem;
	TAction *CaptionOffAction;
	TAction *FocusCoordinateDesktopWindowAction;
	TAction *FocusCoordinateVideoWindowAction;
	TTimer *MulticastDetectionTimer;
    TMenuItem *OperationSeparator4;
    TMenuItem *ExitRemoteMenuItem;
    TAction *ExitRemoteAction;
	TImageList *ImageList;
    TMenuItem *Resolution800x600MenuItem;
    TMenuItem *Resolution1024x768MenuItem;
    TAction *Resolution800x600Action;
    TAction *Resolution1024x768Action;
    TMenuItem *ResolutionHDTV720pMenuItem;
    TMenuItem *ResolutionHDTV1080iMenuItem;
    TMenuItem *ResolutionSDTV480pMenuItem;
    TMenuItem *ResolutionSDTV480iMenuItem;
    TAction *ResolutionHDTV720pAction;
    TAction *ResolutionHDTV1080iAction;
    TAction *ResolutionSDTV480pAction;
    TAction *ResolutionSDTV480iAction;
	TActionList *VersionInfoActionList;
	TAction *VersionInfoOKAction;
	void __fastcall FocusDisplayNoneActionExecute(TObject *Sender);
	void __fastcall FocusDisplayNoneActionUpdate(TObject *Sender);
	void __fastcall FocusDisplayNonLinearZoomActionExecute(TObject *Sender);
	void __fastcall FocusDisplayNonLinearZoomActionUpdate(TObject *Sender);
	void __fastcall FocusDisplayImageCompoundActionExecute(TObject *Sender);
	void __fastcall FocusDisplayImageCompoundActionUpdate(TObject *Sender);
	void __fastcall FocusDisplaySettingActionExecute(TObject *Sender);
	void __fastcall SenderTimerTimer(TObject *Sender);
    void __fastcall MulticastSettingActionExecute(TObject *Sender);
    void __fastcall MulticastSettingActionUpdate(TObject *Sender);
    void __fastcall PacketSizeUpdateActionExecute(
          TObject *Sender);
    void __fastcall PacketSizeUpdateActionUpdate(
          TObject *Sender);
    void __fastcall AddressUpdateActionExecute(
          TObject *Sender);
    void __fastcall AddressUpdateActionUpdate(
          TObject *Sender);
    void __fastcall TTLUpdateActionExecute(TObject *Sender);
    void __fastcall TTLUpdateActionUpdate(TObject *Sender);
    void __fastcall TransmissionMonitorTimerTimer(TObject *Sender);
    void __fastcall WriteIniFileActionExecute(TObject *Sender);
    void __fastcall ReadIniFileActionExecute(TObject *Sender);
    void __fastcall DataModuleCreate(TObject *Sender);
        void __fastcall ResolutionSQCIFActionExecute(TObject *Sender);
        void __fastcall ResolutionSQCIFActionUpdate(TObject *Sender);
        void __fastcall ResolutionQCIFActionExecute(TObject *Sender);
        void __fastcall ResolutionQCIFActionUpdate(TObject *Sender);
        void __fastcall ResolutionCIFActionExecute(TObject *Sender);
        void __fastcall ResolutionCIFActionUpdate(TObject *Sender);
        void __fastcall Resolution160x120ActionExecute(TObject *Sender);
        void __fastcall Resolution160x120ActionUpdate(TObject *Sender);
        void __fastcall Resolution320x240ActionExecute(TObject *Sender);
        void __fastcall Resolution320x240ActionUpdate(TObject *Sender);
        void __fastcall Resolution360x240ActionExecute(TObject *Sender);
        void __fastcall Resolution360x240ActionUpdate(TObject *Sender);
        void __fastcall Resolution640x480ActionExecute(TObject *Sender);
        void __fastcall Resolution640x480ActionUpdate(TObject *Sender);
        void __fastcall Resolution720x480ActionExecute(TObject *Sender);
        void __fastcall Resolution720x480ActionUpdate(TObject *Sender);
    void __fastcall DataModuleDestroy(TObject *Sender);
    void __fastcall ExitActionExecute(TObject *Sender);
    void __fastcall ExitActionUpdate(TObject *Sender);
	void __fastcall SourceSettingActionExecute(TObject *Sender);
	void __fastcall SourceSettingActionUpdate(TObject *Sender);
	void __fastcall VideoSourcePropertyActionExecute(TObject *Sender);
	void __fastcall VideoSourcePropertyActionUpdate(TObject *Sender);
	void __fastcall AudioSourcePropertyActionExecute(TObject *Sender);
	void __fastcall AudioSourcePropertyActionUpdate(TObject *Sender);
	void __fastcall DirectVideoModeActionExecute(TObject *Sender);
	void __fastcall DirectVideoModeActionUpdate(TObject *Sender);
	void __fastcall DVInterleavedModeActionExecute(TObject *Sender);
	void __fastcall DVInterleavedModeActionUpdate(TObject *Sender);
	void __fastcall ResolutionActionExecute(TObject *Sender);
	void __fastcall MulticastActionExecute(TObject *Sender);
	void __fastcall SourceActionExecute(TObject *Sender);
	void __fastcall EncoderActionExecute(TObject *Sender);
	void __fastcall LanguageActionExecute(TObject *Sender);
	void __fastcall ShowFocusFrameActionExecute(TObject *Sender);
	void __fastcall ShowFocusFrameActionUpdate(TObject *Sender);
	void __fastcall OperationActionExecute(TObject *Sender);
	void __fastcall TransmissionOnOffActionExecute(TObject *Sender);
	void __fastcall TransmissionOnOffActionUpdate(TObject *Sender);
	void __fastcall ShowActionExecute(TObject *Sender);
	void __fastcall FocusDisplayPartialZoomActionExecute(TObject *Sender);
	void __fastcall FocusDisplayPartialZoomActionUpdate(TObject *Sender);
	void __fastcall FitVideoToWindowActionExecute(TObject *Sender);
	void __fastcall FitVideoToWindowActionUpdate(TObject *Sender);
	void __fastcall KeepVideoAspectActionExecute(TObject *Sender);
	void __fastcall KeepVideoAspectActionUpdate(TObject *Sender);
	void __fastcall OriginalVideoSizeActionExecute(TObject *Sender);
	void __fastcall OriginalVideoSizeActionUpdate(TObject *Sender);
	void __fastcall FitWindowToVideoActionExecute(TObject *Sender);
	void __fastcall FitWindowToVideoActionUpdate(TObject *Sender);
	void __fastcall OptionActionExecute(TObject *Sender);
	void __fastcall Resolution1280x1024ActionExecute(TObject *Sender);
	void __fastcall Resolution1280x1024ActionUpdate(TObject *Sender);
	void __fastcall Resolution1600x1200ActionExecute(TObject *Sender);
	void __fastcall Resolution1600x1200ActionUpdate(TObject *Sender);
	void __fastcall ResolutionSourceResolutionActionExecute(TObject *Sender);
	void __fastcall ResolutionSourceResolutionActionUpdate(TObject *Sender);
	void __fastcall VideoTransmissionOnActionExecute(TObject *Sender);
	void __fastcall VideoTransmissionOnActionUpdate(TObject *Sender);
	void __fastcall AudioTransmissionOnActionExecute(TObject *Sender);
	void __fastcall AudioTransmissionOnActionUpdate(TObject *Sender);
	void __fastcall FocusTransmissionOnActionExecute(TObject *Sender);
	void __fastcall FocusTransmissionOnActionUpdate(TObject *Sender);
	void __fastcall TransmissionRateActionExecute(TObject *Sender);
	void __fastcall TransmissionRate100KbpsActionExecute(TObject *Sender);
	void __fastcall TransmissionRate100KbpsActionUpdate(TObject *Sender);
	void __fastcall TransmissionRate300KbpsActionExecute(TObject *Sender);
	void __fastcall TransmissionRate300KbpsActionUpdate(TObject *Sender);
	void __fastcall TransmissionRate1MbpsActionExecute(TObject *Sender);
	void __fastcall TransmissionRate1MbpsActionUpdate(TObject *Sender);
	void __fastcall TransmissionRate10MbpsActionExecute(TObject *Sender);
	void __fastcall TransmissionRate10MbpsActionUpdate(TObject *Sender);
	void __fastcall TransmissionRate30MbpsActionExecute(TObject *Sender);
	void __fastcall TransmissionRate30MbpsActionUpdate(TObject *Sender);
	void __fastcall TransmissionRate100MbpsActionExecute(TObject *Sender);
	void __fastcall TransmissionRate100MbpsActionUpdate(TObject *Sender);
	void __fastcall TransmissionRate1000MbpsActionExecute(TObject *Sender);
	void __fastcall TransmissionRate1000MbpsActionUpdate(TObject *Sender);
	void __fastcall TransmissionCountActionExecute(TObject *Sender);
	void __fastcall TransmissionCount1ActionExecute(TObject *Sender);
	void __fastcall TransmissionCount1ActionUpdate(TObject *Sender);
	void __fastcall TransmissionCount2ActionExecute(TObject *Sender);
	void __fastcall TransmissionCount2ActionUpdate(TObject *Sender);
	void __fastcall TransmissionCount3ActionExecute(TObject *Sender);
	void __fastcall TransmissionCount3ActionUpdate(TObject *Sender);
	void __fastcall TransmissionCount4ActionExecute(TObject *Sender);
	void __fastcall TransmissionCount4ActionUpdate(TObject *Sender);
	void __fastcall TransmissionMonitorShowActionExecute(TObject *Sender);
	void __fastcall TransmissionMonitorShowActionUpdate(TObject *Sender);
	void __fastcall VideoSourceActionExecute(TObject *Sender);
	void __fastcall VideoClipInsertActionExecute(TObject *Sender);
	void __fastcall VideoClipInsertActionUpdate(TObject *Sender);
	void __fastcall AudioSourceActionExecute(TObject *Sender);
	void __fastcall SoundFileInsertActionExecute(TObject *Sender);
	void __fastcall SoundFileInsertActionUpdate(TObject *Sender);
	void __fastcall CaptionSettingActionExecute(TObject *Sender);
	void __fastcall CaptionSettingActionUpdate(TObject *Sender);
	void __fastcall VideoEncoderActionExecute(TObject *Sender);
	void __fastcall AudioEncoderActionExecute(TObject *Sender);
	void __fastcall RecommendEncoderShowActionExecute(TObject *Sender);
	void __fastcall RecommendEncoderShowActionUpdate(TObject *Sender);
	void __fastcall RequireEncoderShowActionExecute(TObject *Sender);
	void __fastcall RequireEncoderShowActionUpdate(TObject *Sender);
	void __fastcall AllEncoderShowActionExecute(TObject *Sender);
	void __fastcall AllEncoderShowActionUpdate(TObject *Sender);
	void __fastcall HelpActionExecute(TObject *Sender);
	void __fastcall VersionInfoActionExecute(TObject *Sender);
	void __fastcall VersionInfoActionUpdate(TObject *Sender);
	void __fastcall CaptionSettingOKActionExecute(TObject *Sender);
	void __fastcall CaptionSettingOKActionUpdate(TObject *Sender);
	void __fastcall CaptionSettingCancelActionExecute(TObject *Sender);
	void __fastcall CreateIPv6AddressActionExecute(TObject *Sender);
	void __fastcall CreateIPv6AddressActionUpdate(TObject *Sender);
	void __fastcall CreateIPv4AddressActionExecute(TObject *Sender);
	void __fastcall CreateIPv4AddressActionUpdate(TObject *Sender);
	void __fastcall VideoEncoderActionUpdate(TObject *Sender);
	void __fastcall AudioEncoderActionUpdate(TObject *Sender);
	void __fastcall VideoSourceActionUpdate(TObject *Sender);
	void __fastcall AudioSourceActionUpdate(TObject *Sender);
	void __fastcall VolumeIndicatorShowActionExecute(TObject *Sender);
	void __fastcall CaptionOffActionExecute(TObject *Sender);
	void __fastcall CaptionOffActionUpdate(TObject *Sender);
	void __fastcall FocusCoordinateDesktopWindowActionExecute(
          TObject *Sender);
	void __fastcall FocusCoordinateDesktopWindowActionUpdate(TObject *Sender);
	void __fastcall FocusCoordinateVideoWindowActionExecute(TObject *Sender);
	void __fastcall FocusCoordinateVideoWindowActionUpdate(TObject *Sender);
	void __fastcall MulticastDetectionTimerTimer(TObject *Sender);
    void __fastcall ExitRemoteActionExecute(TObject *Sender);
    void __fastcall Resolution800x600ActionExecute(TObject *Sender);
    void __fastcall Resolution800x600ActionUpdate(TObject *Sender);
    void __fastcall Resolution1024x768ActionExecute(TObject *Sender);
    void __fastcall Resolution1024x768ActionUpdate(TObject *Sender);
    void __fastcall ResolutionHDTV720pActionExecute(TObject *Sender);
    void __fastcall ResolutionHDTV720pActionUpdate(TObject *Sender);
    void __fastcall ResolutionHDTV1080iActionExecute(TObject *Sender);
    void __fastcall ResolutionHDTV1080iActionUpdate(TObject *Sender);
    void __fastcall ResolutionSDTV480pActionExecute(TObject *Sender);
    void __fastcall ResolutionSDTV480pActionUpdate(TObject *Sender);
    void __fastcall ResolutionSDTV480iActionExecute(TObject *Sender);
    void __fastcall ResolutionSDTV480iActionUpdate(TObject *Sender);
	void __fastcall VersionInfoOKActionExecute(TObject *Sender);
	void __fastcall VersionInfoOKActionUpdate(TObject *Sender);

private:	// [U[錾
    void __fastcall VideoSourceEntryMenuItemOnClick(TObject *Sender);
    void __fastcall VideoClipHistoryMenuItemOnClick(TObject *Sender);
    void __fastcall AudioSourceEntryMenuItemOnClick(TObject *Sender);
    void __fastcall SoundFileHistoryMenuItemOnClick(TObject *Sender);
	void __fastcall	CaptionHistoryMenuItemOnClick(TObject *Sender);
    void __fastcall VideoEncoderEntryMenuItemOnClick(TObject *Sender);
    void __fastcall AudioEncoderEntryMenuItemOnClick(TObject *Sender);

public:
    // Update MenuItem
    void        updateVideoSource();
    void		updateVideoClipHistory();
    void		updateAudioSource();
    void		updateSoundFileHistory();
    void		updateCaptionHistory();
    void		updateVideoEncoder();
    void		updateAudioEncoder();

    // Update MenuItem Selection
    void		updateVideoSourceSelection();
    void		updateAudioSourceSelection();
    void		updateVideoEncoderSelection();
    void		updateAudioEncoderSelection();

public:
    void		playVideoClip(const AnsiString& filename);
    void		playSoundFile(const AnsiString& filename);
	void		setupCaption(const AnsiString& captionStr);

private:
    void		clearMenuItem(TMenuItem* parent, int beginIndex, int endIndex);
	TMenuItem*	createMenuItem(TMenuItem* parent, const AnsiString& caption,
    							 TNotifyEvent OnClickHandler);

	void		setTransmissionRate(int rate);
    void		getTransmissionRate();

public:		// [U[錾
	__fastcall TMainDataModule(TComponent* Owner);

private:
    TStringList*			_videoClipHistories;
    TStringList*			_soundFileHistories;
    TStringList*			_captionHistories;

    TList*					_videoEncoderIndices;
    TList*					_audioEncoderIndices;

    fsSenderCommandHistory*	_commandHistory;

public:
    bool			_videoSourceIsDirty;
    bool			_audioSourceIsDirty;
    bool			_videoEncoderIsDirty;
    bool			_audioEncoderIsDirty;

    enum EncoderShowControlEnum {
		ESC_RECOMMENDENCODER,
		ESC_REQUIREENCODER,
		ESC_ALLENCODER
    };
    EncoderShowControlEnum	_encoderShowControl;
};
//---------------------------------------------------------------------------
extern PACKAGE TMainDataModule *MainDataModule;
//---------------------------------------------------------------------------
#endif
