/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#ifndef __fsSenderCommandHistory_h__
#define __fsSenderCommandHistory_h__
//---------------------------------------------------------------------------
#include <ui/fsCommonUI/fsCommandHistory.h>
//---------------------------------------------------------------------------
enum SenderPrefixIdEnum {
	P_SHOW,
    P_FOCUSDISPLAY,
   	P_MULTICAST,
    P_SOURCE,
    P_RESOLUTION,
    P_TRANSMISSIONRATE,
    P_TRANSMISSIONCOUNT,
    P_READINIFILE,
    P_WRITEINIFILE,
    P_ENCODER,
    P_VIDEOSOURCE,
    P_AUDIOSOURCE,
    P_VIDEOENCODER,
    P_AUDIOENCODER
};
//---------------------------------------------------------------------------
class fsSenderCommandHistory : public fsCommandHistory
{
public:
	fsSenderCommandHistory(TMenuItem* HistoryBeginMenuItem,
							TMenuItem* HistoryEndMenuItem);
    ~fsSenderCommandHistory();

protected:
	AnsiString		getPrefixIdString(int prefixId);

public:
	void			addReadIniFile(const AnsiString& filename);
    void			addWriteIniFile(const AnsiString& filename);

	void			addVideoSource(int index, const AnsiString& friendlyName);
    void			addAudioSource(int index, const AnsiString& friendlyName);

    void			addVideoEncoder(int index, const AnsiString& friendlyName);
    void			addAudioEncoder(int index, const AnsiString& friendlyName);

private:
	void __fastcall	ReadIniFileMenuItemOnExecute(TObject *Sender);
	void __fastcall	WriteIniFileMenuItemOnExecute(TObject *Sender);
    void __fastcall	VideoSourceMenuItemOnExecute(TObject *Sender);
    void __fastcall	AudioSourceMenuItemOnExecute(TObject *Sender);
    void __fastcall	VideoEncoderMenuItemOnExecute(TObject *Sender);
    void __fastcall	AudioEncoderMenuItemOnExecute(TObject *Sender);
};
//---------------------------------------------------------------------------
#endif //__fsSenderCommandHistory_h__

