/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#ifndef __fsSenderLanguage_h__
#define	__fsSenderLanguage_h__
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "ui/fsCommonUI/fsLanguage.h"
//---------------------------------------------------------------------------
// Dynamic word Definiation
enum DynamicWordEnum {
	DW_STOP,
    DW_START,
	DW_STATUSTRANSMIT,
	DW_STATUSSTOP,
	DW_STATUSFAILEDCONFIG,
	DW_STATUSVIDEO,
	DW_STATUSAUDIO,
	DW_STATUSFOCUS,
    DW_STATUSNODATA,
    DW_STATUSPLAYSOUNDFILE,
    DW_ERROR,
    DW_READINIFILEERROR,
	DW_WRITEINIFILEERROR,
    DW_PLAYVIDEOCLIPERROR,
    DW_PLAYSOUNDFILEERROR,
    DW_REMOTEINVOKETIMEOUT,
    DW_SHOW,
    DW_FOCUSDISPLAY,
    DW_MULTICAST,
    DW_SOURCE,
    DW_RESOLUTION,
    DW_TRANSMISSIONRATE,
    DW_TRANSMISSIONCOUNT,
    DW_READINIFILE,
    DW_WRITEINIFILE,
    DW_ENCODER,
    DW_VIDEOSOURCE,
    DW_AUDIOSOURCE,
    DW_VIDEOENCODER,
    DW_AUDIOENCODER,

	NUM_DYNAMICWORDS
};
//---------------------------------------------------------------------------
class fsSenderLanguage : public fsLanguage
{
public:
	fsSenderLanguage(TMenuItem* LanguageMenuItem);
    virtual ~fsSenderLanguage();

public:
	virtual const AnsiString& getDynamicWord(int id);

protected:
	virtual void	setupLanguage();
    virtual void	setupDefaultJapanese();
    virtual void	setupDefaultEnglish();

private:
	AnsiString		_dynamicWords[NUM_DYNAMICWORDS];
};
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------

