/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------
#include "fsMainDataModule.h"
#include "fsSenderMainForm.h"
#include "fsFocusDisplaySettingForm.h"
#include "fsMulticastSettingForm.h"
#include "fsSourceSettingForm.h"
#include "fsTransmissionMonitorForm.h"
#include "fsCaptionSettingForm.h"
#include "fsVersionInfoForm.h"
#include "fsSenderLanguage.h"
#include <ui/fsCommonUI/fsVolumeIndicatorForm.h>
#include <ui/fsCommonUI/fsErrorMessageForm.h>
#include <fs/fsSender/fsSenderInterface.h>
//---------------------------------------------------------------------------
fsSenderLanguage::fsSenderLanguage(TMenuItem* LanguageMenuItem) :
fsLanguage(LanguageMenuItem)
{
}
//---------------------------------------------------------------------------
fsSenderLanguage::~fsSenderLanguage()
{
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
const AnsiString&
fsSenderLanguage::getDynamicWord(int id)
{
	return _dynamicWords[id];
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void
fsSenderLanguage::setupLanguage()
{
	AnsiString key, val;

	TMainDataModule				*mdm = MainDataModule;
	TFocusDisplaySettingForm	*fds = FocusDisplaySettingForm;
	TMulticastSettingForm		*ms = MulticastSettingForm;
	TTransmissionMonitorForm	*tm = TransmissionMonitorForm;
	TSourceSettingForm			*ss = SourceSettingForm;
	TCaptionSettingForm			*csf = CaptionSettingForm;
	TVolumeIndicatorForm		*vif = VolumeIndicatorForm;
    TErrorMessageForm			*emf = ErrorMessageForm;
    TVersionInfoForm			*vf = VersionInfoForm;

	while(nextEntry(key, val))
    {
		if (key.Length() == 0)
        	continue;

        /*
    	char str[1024];
        sprintf(str, "Key:[%s]  Val:[%s]\n", key, val);
        OutputDebugString(str);
        */

        const char *ckey = key.c_str();

		//
		// SenderMainForm
		//
		if (!strcmp(ckey, "SenderMainFormCaption"))
			SenderMainForm->Caption = val;

		//
		// MainDataModule
		//

		// OperationActionList
		else if (!strcmp(ckey, "mdmOperationActionCaption"))
			mdm->OperationAction->Caption					= val;
		else if (!strcmp(ckey, "mdmReadIniFileActionCaption"))
			mdm->ReadIniFileAction->Caption					= val;
		else if (!strcmp(ckey, "mdmWriteIniFileActionCaption"))
			mdm->WriteIniFileAction->Caption				= val;
		else if (!strcmp(ckey, "mdmExitActionCaption"))
			mdm->ExitAction->Caption						= val;

		// ShowActionList
		else if (!strcmp(ckey, "mdmShowActionCaption"))
			mdm->ShowAction->Caption						= val;
		else if (!strcmp(ckey, "mdmFocusDisplayNoneActionCaption"))
			mdm->FocusDisplayNoneAction->Caption			= val;
		else if (!strcmp(ckey, "mdmFocusDisplayPartialZoomActionCaption"))
			mdm->FocusDisplayPartialZoomAction->Caption		= val;
		else if (!strcmp(ckey, "mdmFocusDisplayNonLinearZoomActionCaption"))
			mdm->FocusDisplayNonLinearZoomAction->Caption	= val;
		else if (!strcmp(ckey, "mdmFocusDisplayImageCompoundActionCaption"))
			mdm->FocusDisplayImageCompoundAction->Caption	= val;
		else if (!strcmp(ckey, "mdmFocusDisplaySettingActionCaption"))
			mdm->FocusDisplaySettingAction->Caption			= val;
		else if (!strcmp(ckey, "mdmFitVideoToWindowActionCaption"))
			mdm->FitVideoToWindowAction->Caption			= val;
		else if (!strcmp(ckey, "mdmKeepVideoAspectActionCaption"))
			mdm->KeepVideoAspectAction->Caption				= val;
		else if (!strcmp(ckey, "mdmOriginalVideoSizeActionCaption"))
			mdm->OriginalVideoSizeAction->Caption			= val;
		else if (!strcmp(ckey, "mdmFitWindowToVideoActionCaption"))
			mdm->FitWindowToVideoAction->Caption			= val;
		else if (!strcmp(ckey, "mdmVolumeIndicatorShowActionCaption"))
			mdm->VolumeIndicatorShowAction->Caption			= val;

		// OptionActionList
		else if (!strcmp(ckey, "mdmOptionActionCaption"))
			mdm->OptionAction->Caption						= val;
		else if (!strcmp(ckey, "mdmResolutionActionCaption"))
			mdm->ResolutionAction->Caption					= val;
		else if (!strcmp(ckey, "mdmResolutionSQCIFActionCaption"))
			mdm->ResolutionSQCIFAction->Caption				= val;
		else if (!strcmp(ckey, "mdmResolutionQCIFActionCaption"))
			mdm->ResolutionQCIFAction->Caption				= val;
		else if (!strcmp(ckey, "mdmResolutionCIFActionCaption"))
			mdm->ResolutionCIFAction->Caption				= val;
		else if (!strcmp(ckey, "mdmResolution160x120ActionCaption"))
			mdm->Resolution160x120Action->Caption			= val;
		else if (!strcmp(ckey, "mdmResolution320x240ActionCaption"))
			mdm->Resolution320x240Action->Caption			= val;
		else if (!strcmp(ckey, "mdmResolution360x240ActionCaption"))
			mdm->Resolution360x240Action->Caption			= val;
		else if (!strcmp(ckey, "mdmResolution640x480ActionCaption"))
			mdm->Resolution640x480Action->Caption			= val;
		else if (!strcmp(ckey, "mdmResolution720x480ActionCaption"))
			mdm->Resolution720x480Action->Caption			= val;
		else if (!strcmp(ckey, "mdmResolution800x600ActionCaption"))
			mdm->Resolution800x600Action->Caption           = val;
		else if (!strcmp(ckey, "mdmResolution1024x768ActionCaption"))
			mdm->Resolution1024x768Action->Caption          = val;
		else if (!strcmp(ckey, "mdmResolution1280x1024ActionCaption"))
			mdm->Resolution1280x1024Action->Caption			= val;
		else if (!strcmp(ckey, "mdmResolution1600x1200ActionCaption"))
			mdm->Resolution1600x1200Action->Caption			= val;
		else if (!strcmp(ckey, "mdmResolutionHDTV720pActionCaption"))
			mdm->ResolutionHDTV720pAction->Caption          = val;
		else if (!strcmp(ckey, "mdmResolutionHDTV1080iActionCaption"))
			mdm->ResolutionHDTV1080iAction->Caption         = val;
		else if (!strcmp(ckey, "mdmResolutionSDTV480pActionCaption"))
			mdm->ResolutionSDTV480pAction->Caption          = val;
		else if (!strcmp(ckey, "mdmResolutionSDTV480iActionCaption"))
			mdm->ResolutionSDTV480iAction->Caption          = val;
		else if (!strcmp(ckey, "mdmResolutionSourceResolutionActionCaption"))
			mdm->ResolutionSourceResolutionAction->Caption	= val;
		else if (!strcmp(ckey, "mdmMulticastActionCaption"))
			mdm->MulticastAction->Caption					= val;
		else if (!strcmp(ckey, "mdmVideoTransmissionOnActionCaption"))
			mdm->VideoTransmissionOnAction->Caption			= val;
		else if (!strcmp(ckey, "mdmAudioTransmissionOnActionCaption"))
			mdm->AudioTransmissionOnAction->Caption			= val;
		else if (!strcmp(ckey, "mdmFocusTransmissionOnActionCaption"))
			mdm->FocusTransmissionOnAction->Caption			= val;
		else if (!strcmp(ckey, "mdmTransmissionRateActionCaption"))
			mdm->TransmissionRateAction->Caption			= val;
		else if (!strcmp(ckey, "mdmTransmissionRate100KbpsActionCaption"))
			mdm->TransmissionRate100KbpsAction->Caption		= val;
		else if (!strcmp(ckey, "mdmTransmissionRate300KbpsActionCaption"))
			mdm->TransmissionRate300KbpsAction->Caption		= val;
		else if (!strcmp(ckey, "mdmTransmissionRate1MbpsActionCaption"))
			mdm->TransmissionRate1MbpsAction->Caption		= val;
		else if (!strcmp(ckey, "mdmTransmissionRate10MbpsActionCaption"))
			mdm->TransmissionRate10MbpsAction->Caption		= val;
		else if (!strcmp(ckey, "mdmTransmissionRate30MbpsActionCaption"))
			mdm->TransmissionRate30MbpsAction->Caption		= val;
		else if (!strcmp(ckey, "mdmTransmissionRate100MbpsActionCaption"))
			mdm->TransmissionRate100MbpsAction->Caption		= val;
		else if (!strcmp(ckey, "mdmTransmissionRate1000MbpsActionCaption"))
			mdm->TransmissionRate1000MbpsAction->Caption	= val;
		else if (!strcmp(ckey, "mdmTransmissionCountActionCaption"))
			mdm->TransmissionCountAction->Caption			= val;
		else if (!strcmp(ckey, "mdmTransmissionCount1ActionCaption"))
			mdm->TransmissionCount1Action->Caption			= val;
		else if (!strcmp(ckey, "mdmTransmissionCount2ActionCaption"))
			mdm->TransmissionCount2Action->Caption			= val;
		else if (!strcmp(ckey, "mdmTransmissionCount3ActionCaption"))
			mdm->TransmissionCount3Action->Caption			= val;
		else if (!strcmp(ckey, "mdmTransmissionCount4ActionCaption"))
			mdm->TransmissionCount4Action->Caption			= val;
		else if (!strcmp(ckey, "mdmMulticastSettingActionCaption"))
			mdm->MulticastSettingAction->Caption			= val;
		else if (!strcmp(ckey, "mdmTransmissionMonitorShowActionCaption"))
			mdm->TransmissionMonitorShowAction->Caption		= val;
		else if (!strcmp(ckey, "mdmSourceActionCaption"))
			mdm->SourceAction->Caption						= val;
		else if (!strcmp(ckey, "mdmVideoSourceActionCaption"))
			mdm->VideoSourceAction->Caption					= val;
		else if (!strcmp(ckey, "mdmVideoClipInsertActionCaption"))
			mdm->VideoClipInsertAction->Caption				= val;
		else if (!strcmp(ckey, "mdmAudioSourceActionCaption"))
			mdm->AudioSourceAction->Caption					= val;
		else if (!strcmp(ckey, "mdmSoundFileInsertActionCaption"))
			mdm->SoundFileInsertAction->Caption				= val;
		else if (!strcmp(ckey, "mdmCaptionSettingActionCaption"))
			mdm->CaptionSettingAction->Caption				= val;
		else if (!strcmp(ckey, "mdmSourceSettingActionCaption"))
			mdm->SourceSettingAction->Caption				= val;
		else if (!strcmp(ckey, "mdmEncoderActionCaption"))
			mdm->EncoderAction->Caption						= val;
		else if (!strcmp(ckey, "mdmVideoEncoderActionCaption"))
			mdm->VideoEncoderAction->Caption				= val;
		else if (!strcmp(ckey, "mdmAudioEncoderActionCaption"))
			mdm->AudioEncoderAction->Caption				= val;
		else if (!strcmp(ckey, "mdmRecommendEncoderShowActionCaption"))
			mdm->RecommendEncoderShowAction->Caption		= val;
		else if (!strcmp(ckey, "mdmRequireEncoderShowActionCaption"))
			mdm->RequireEncoderShowAction->Caption			= val;
		else if (!strcmp(ckey, "mdmAllEncoderShowActionCaption"))
			mdm->AllEncoderShowAction->Caption				= val;

		// LanguageActionList
		else if (!strcmp(ckey, "mdmLanguageActionCaption"))
			mdm->LanguageAction->Caption					= val;

		// HelpActionList
		else if (!strcmp(ckey, "mdmHelpActionCaption"))
			mdm->HelpAction->Caption						= val;
		else if (!strcmp(ckey, "mdmVersionInfoActionCaption"))
			mdm->VersionInfoAction->Caption					= val;

		// FocusDisplaySettingActionList
		else if (!strcmp(ckey, "mdmShowFocusFrameActionCaption"))
			mdm->ShowFocusFrameAction->Caption				= val;
		else if (!strcmp(ckey, "mdmFocusCoordinateDesktopWindowActionCaption"))
			mdm->FocusCoordinateDesktopWindowAction->Caption= val;
		else if (!strcmp(ckey, "mdmFocusCoordinateVideoWindowActionCaption"))
			mdm->FocusCoordinateVideoWindowAction->Caption	= val;

		// MulticastSettingActionList
		else if (!strcmp(ckey, "mdmCreateIPv6AddressActionCaption"))
			mdm->CreateIPv6AddressAction->Caption			= val;
		else if (!strcmp(ckey, "mdmCreateIPv4AddressActionCaption"))
			mdm->CreateIPv4AddressAction->Caption			= val;
		else if (!strcmp(ckey, "mdmAddressUpdateActionCaption"))
			mdm->AddressUpdateAction->Caption				= val;
		else if (!strcmp(ckey, "mdmTTLUpdateActionCaption"))
			mdm->TTLUpdateAction->Caption					= val;
		else if (!strcmp(ckey, "mdmPacketSizeUpdateActionCaption"))
			mdm->PacketSizeUpdateAction->Caption			= val;

		// SourceSettingActionList
		else if (!strcmp(ckey, "mdmVideoSourcePropertyActionCaption"))
			mdm->VideoSourcePropertyAction->Caption			= val;
		else if (!strcmp(ckey, "mdmAudioSourcePropertyActionCaption"))
			mdm->AudioSourcePropertyAction->Caption			= val;
		else if (!strcmp(ckey, "mdmDirectVideoModeActionCaption"))
			mdm->DirectVideoModeAction->Caption				= val;
		else if (!strcmp(ckey, "mdmDVInterleavedModeActionCaption"))
			mdm->DVInterleavedModeAction->Caption			= val;

		// CaptionSettingActionList
		else if (!strcmp(ckey, "mdmCaptionOffActionCaption"))
			mdm->CaptionOffAction->Caption					= val;
		else if (!strcmp(ckey, "mdmCaptionSettingOKActionCaption"))
			mdm->CaptionSettingOKAction->Caption			= val;
		else if (!strcmp(ckey, "mdmCaptionSettingCancelActionCaption"))
			mdm->CaptionSettingCancelAction->Caption		= val;

        // VersionInfoActionList
        else if (!strcmp(ckey, "mdmVersionInfoOKActionCaption"))
        	mdm->VersionInfoOKAction->Caption				= val;

		// Dialogs
		else if (!strcmp(ckey, "mdmIniFileOpenDialogFilter"))
			mdm->IniFileOpenDialog->Filter					= val;
		else if (!strcmp(ckey, "mdmIniFileOpenDialogTitle"))
			mdm->IniFileOpenDialog->Title					= val;
		else if (!strcmp(ckey, "mdmIniFileSaveDialogFilter"))
			mdm->IniFileSaveDialog->Filter					= val;
		else if (!strcmp(ckey, "mdmIniFileSaveDialogTitle"))
			mdm->IniFileSaveDialog->Title					= val;
		else if (!strcmp(ckey, "mdmVideoClipOpenDialogFilter"))
			mdm->VideoClipOpenDialog->Filter				= val;
		else if (!strcmp(ckey, "mdmVideoClipOpenDialogTitle"))
			mdm->VideoClipOpenDialog->Title					= val;
		else if (!strcmp(ckey, "mdmSoundFileOpenDialogFilter"))
			mdm->SoundFileOpenDialog->Filter				= val;
		else if (!strcmp(ckey, "mdmSoundFileOpenDialogTitle"))
			mdm->SoundFileOpenDialog->Title					= val;


		//
		// FocusDisplaySettingForm
		//

		else if (!strcmp(ckey, "fdsCaption"))
			fds->Caption									= val;
		else if (!strcmp(ckey, "fdsFocusCoordinateGroupBoxCaption"))
			fds->FocusCoordinateGroupBox->Caption			= val;
		else if (!strcmp(ckey, "fdsPartialZoomGroupBoxCaption"))
			fds->PartialZoomGroupBox->Caption				= val;
		else if (!strcmp(ckey, "fdsPartialZoomOutputResolutionLabelCaption"))
			fds->PartialZoomOutputResolutionLabel->Caption	= val;
		else if (!strcmp(ckey, "fdsPartialZoomSourceResolutionLabelCaption"))
			fds->PartialZoomSourceResolutionLabel->Caption	= val;
		else if (!strcmp(ckey, "fdsNonLinearZoomGroupBoxCaption"))
			fds->NonLinearZoomGroupBox->Caption				= val;
		else if (!strcmp(ckey, "fdsNonLinearZoomResolutionLabelCaption"))
			fds->NonLinearZoomResolutionLabel->Caption		= val;
		else if (!strcmp(ckey, "fdsNonLinearZoomMaskSizeLabelCaption"))
			fds->NonLinearZoomMaskSizeLabel->Caption		= val;
		else if (!strcmp(ckey, "fdsNonLinearZoomMaskWidthLabelCaption"))
			fds->NonLinearZoomMaskWidthLabel->Caption		= val;
		else if (!strcmp(ckey, "fdsNonLinearZoomMaskHeightLabelCaption"))
			fds->NonLinearZoomMaskHeightLabel->Caption		= val;
		else if (!strcmp(ckey, "fdsNonLinearZoomMaskLabelCaption"))
			fds->NonLinearZoomMaskLabel->Caption			= val;
		else if (!strcmp(ckey, "fdsNonLinearZoomMaskComboBoxItems0"))
			fds->NonLinearZoomMaskComboBox->Items->Strings[0] = val;
		else if (!strcmp(ckey, "fdsNonLinearZoomMaskComboBoxItems1"))
			fds->NonLinearZoomMaskComboBox->Items->Strings[1] = val;
		else if (!strcmp(ckey, "fdsImageCompoundGroupBoxCaption"))
			fds->ImageCompoundGroupBox->Caption				= val;
		else if (!strcmp(ckey, "fdsImageCompoundBaseResolutionLabelCaption"))
			fds->ImageCompoundBaseResolutionLabel->Caption	= val;
		else if (!strcmp(ckey, "fdsImageCompoundAddResolutionLabelCaption"))
			fds->ImageCompoundAddResolutionLabel->Caption	= val;
		else if (!strcmp(ckey, "fdsImageCompoundMaskLabelCaption"))
			fds->ImageCompoundMaskLabel->Caption			= val;
		else if (!strcmp(ckey, "fdsImageCompoundMaskComboBoxItems0"))
			fds->ImageCompoundMaskComboBox->Items->Strings[0]		= val;
		else if (!strcmp(ckey, "fdsImageCompoundMaskComboBoxItems1"))
			fds->ImageCompoundMaskComboBox->Items->Strings[1]		= val;
		else if (!strcmp(ckey, "fdsImageCompoundMaskComboBoxItems2"))
			fds->ImageCompoundMaskComboBox->Items->Strings[2]		= val;
		else if (!strcmp(ckey, "fdsImageCompoundBlendingLabelCaption"))
			fds->ImageCompoundBlendingLabel->Caption		= val;
		else if (!strcmp(ckey, "fdsImageCompoundBlendingComboBoxItems0"))
			fds->ImageCompoundBlendingComboBox->Items->Strings[0]	= val;
		else if (!strcmp(ckey, "fdsImageCompoundBlendingComboBoxItems1"))
			fds->ImageCompoundBlendingComboBox->Items->Strings[1]	= val;

		//
		// MulticastSettingForm
		//

		else if (!strcmp(ckey, "msCaption"))
			ms->Caption										= val;
		else if (!strcmp(ckey, "msAddressGroupBoxCaption"))
			ms->AddressGroupBox->Caption					= val;
		else if (!strcmp(ckey, "msTTLLabelCaption"))
			ms->TTLLabel->Caption							= val;
		else if (!strcmp(ckey, "msPacketSizeLabelCaption"))
			ms->PacketSizeLabel->Caption					= val;
		else if (!strcmp(ckey, "msTransmitCountLabelCaption"))
			ms->TransmitCountLabel->Caption					= val;
		else if (!strcmp(ckey, "msTransmitCountComboBoxItems0"))
			ms->TransmitCountComboBox->Items->Strings[0]	= val;
		else if (!strcmp(ckey, "msTransmitCountComboBoxItems1"))
			ms->TransmitCountComboBox->Items->Strings[1]	= val;
		else if (!strcmp(ckey, "msTransmitCountComboBoxItems2"))
			ms->TransmitCountComboBox->Items->Strings[2]	= val;
		else if (!strcmp(ckey, "msTransmitCountComboBoxItems3"))
			ms->TransmitCountComboBox->Items->Strings[3]	= val;
		else if (!strcmp(ckey, "msTargetTransmitRateComboBoxItems0"))
			ms->TargetTransmitRateComboBox->Items->Strings[0]		= val;
		else if (!strcmp(ckey, "msTargetTransmitRateComboBoxItems1"))
			ms->TargetTransmitRateComboBox->Items->Strings[1]		= val;
		else if (!strcmp(ckey, "msTargetTransmitRateComboBoxItems2"))
			ms->TargetTransmitRateComboBox->Items->Strings[2]		= val;
		else if (!strcmp(ckey, "msTargetTransmitRateComboBoxItems3"))
			ms->TargetTransmitRateComboBox->Items->Strings[3]		= val;
		else if (!strcmp(ckey, "msTargetTransmitRateComboBoxItems4"))
			ms->TargetTransmitRateComboBox->Items->Strings[4]		= val;
		else if (!strcmp(ckey, "msTransmitRateGroupBoxCaption"))
			ms->TransmitRateGroupBox->Caption				= val;
		else if (!strcmp(ckey, "msTransmitRateComboBoxItems6"))
			ms->TransmitRateComboBox->Items->Strings[6]		= val;
		else if (!strcmp(ckey, "msMulticastDetectLabelCaption"))
			ms->MulticastDetectLabel->Caption				= val;

		//
		// TransmissionMonitorForm
		//

		else if (!strcmp(ckey, "tmCaption"))
			tm->Caption										= val;
		else if (!strcmp(ckey, "tmSendRateLabelCaption"))
			tm->SendRateLabel->Caption						= val;
		else if (!strcmp(ckey, "tmFrameRateLabelCaption"))
			tm->FrameRateLabel->Caption						= val;
		else if (!strcmp(ckey, "tmSendRateVideoMainLabelCaption"))
			tm->SendRateVideoMainLabel->Caption				= val;
		else if (!strcmp(ckey, "tmSendRateVideoSubLabelCaption"))
			tm->SendRateVideoSubLabel->Caption				= val;
		else if (!strcmp(ckey, "tmSendRateAudioLabelCaption"))
			tm->SendRateAudioLabel->Caption					= val;
		else if (!strcmp(ckey, "tmSendRatePointerLabelCaption"))
			tm->SendRatePointerLabel->Caption				= val;

		//
		// SourceSettingForm
		//

		else if (!strcmp(ckey, "ssCaption"))
			ss->Caption										= val;
		else if (!strcmp(ckey, "ssVideoSourceGroupBoxCaption"))
			ss->VideoSourceGroupBox->Caption				= val;
		else if (!strcmp(ckey, "ssVideoSourcePropertyLabelCaption"))
			ss->VideoSourcePropertyLabel->Caption			= val;
		else if (!strcmp(ckey, "ssAudioSourceGroupBoxCaption"))
			ss->AudioSourceGroupBox->Caption				= val;
		else if (!strcmp(ckey, "ssAudioSourcePropertyLabelCaption"))
			ss->AudioSourcePropertyLabel->Caption			= val;

		//
		// CaptionSettingForm
		//

		else if (!strcmp(ckey, "csfCaption"))
			csf->Caption									= val;
		else if (!strcmp(ckey, "csfCaptionLabelCaption"))
			csf->CaptionLabel->Caption						= val;

		//
		// VolumeIndicatorForm
		//

		else if (!strcmp(ckey, "vifCaption"))
			vif->Caption									= val;
		else if (!strcmp(ckey, "vifDisplayTimeLabelCaption"))
			vif->DisplayTimeLabel->Caption					= val;
		else if (!strcmp(ckey, "vifDisplayTimeComboBoxItems0"))
			vif->DisplayTimeComboBox->Items->Strings[0]		= val;
		else if (!strcmp(ckey, "vifDisplayTimeComboBoxItems1"))
			vif->DisplayTimeComboBox->Items->Strings[1]		= val;
		else if (!strcmp(ckey, "vifDisplayTimeComboBoxItems2"))
			vif->DisplayTimeComboBox->Items->Strings[2]		= val;
		else if (!strcmp(ckey, "vifDisplayTimeComboBoxItems3"))
			vif->DisplayTimeComboBox->Items->Strings[3]		= val;
		else if (!strcmp(ckey, "vifDisplayTimeComboBoxItems4"))
			vif->DisplayTimeComboBox->Items->Strings[4]		= val;
		else if (!strcmp(ckey, "vifDisplayTimeComboBoxItems5"))
			vif->DisplayTimeComboBox->Items->Strings[5]		= val;
		else if (!strcmp(ckey, "vifDisplayPauseCheckBoxCaption"))
			vif->DisplayPauseCheckBox->Caption				= val;

        //
        // ErrorMessageForm
        //
        else if (!strcmp(ckey, "emfCaption"))
        	emf->Caption = val;
		else if (!strcmp(ckey, "emf_T_WRONG_CAPTURE"))
			emf->setTypeString(FSSENDER_T_WRONG_CAPTURE, val);
		else if (!strcmp(ckey, "emf_T_WRONG_ENCODER"))
			emf->setTypeString(FSSENDER_T_WRONG_ENCODER, val);
		else if (!strcmp(ckey, "emf_T_WRONG_MEDIATYPE"))
			emf->setTypeString(FSSENDER_T_WRONG_MEDIATYPE, val);
		else if (!strcmp(ckey, "emf_T_NOTFOUND_DECODER"))
			emf->setTypeString(FSSENDER_T_NOTFOUND_DECODER, val);
		else if (!strcmp(ckey, "emf_T_UNEXPECTED"))
			emf->setTypeString(FSSENDER_T_UNEXPECTED, val);

	    //
    	// VersionInfoFrom
	    //
	    else if (!strcmp(ckey, "vfCaption"))
	    	vf->Caption										= val;
    	else if (!strcmp(ckey, "vfVersionInfoSoftwareNameLabelCaption"))
    		vf->VersionInfoSoftwareNameLabel->Caption		= val;

		//
		// Dynamic Words
		//
		else if (!strcmp(ckey, "DW_STOP"))
			_dynamicWords[DW_STOP]							= val;
		else if (!strcmp(ckey, "DW_START"))
			_dynamicWords[DW_START]							= val;
		else if (!strcmp(ckey, "DW_STATUSTRANSMIT"))
			_dynamicWords[DW_STATUSTRANSMIT]				= val;
		else if (!strcmp(ckey, "DW_STATUSSTOP"))
			_dynamicWords[DW_STATUSSTOP]					= val;
		else if (!strcmp(ckey, "DW_STATUSFAILEDCONFIG"))
			_dynamicWords[DW_STATUSFAILEDCONFIG]			= val;
		else if (!strcmp(ckey, "DW_STATUSVIDEO"))
			_dynamicWords[DW_STATUSVIDEO]					= val;
		else if (!strcmp(ckey, "DW_STATUSAUDIO"))
			_dynamicWords[DW_STATUSAUDIO]					= val;
		else if (!strcmp(ckey, "DW_STATUSFOCUS"))
			_dynamicWords[DW_STATUSFOCUS]					= val;
		else if (!strcmp(ckey, "DW_STATUSNODATA"))
			_dynamicWords[DW_STATUSNODATA]					= val;
        else if (!strcmp(ckey, "DW_STATUSPLAYSOUNDFILE"))
        	_dynamicWords[DW_STATUSPLAYSOUNDFILE]			= val;
		else if (!strcmp(ckey, "DW_ERROR"))
			_dynamicWords[DW_ERROR]							= val;
		else if (!strcmp(ckey, "DW_READINIFILEERROR"))
			_dynamicWords[DW_READINIFILEERROR]				= val;
		else if (!strcmp(ckey, "DW_WRITEINIFILEERROR"))
			_dynamicWords[DW_WRITEINIFILEERROR]				= val;
		else if (!strcmp(ckey, "DW_PLAYVIDEOCLIPERROR"))
			_dynamicWords[DW_PLAYVIDEOCLIPERROR]			= val;
		else if (!strcmp(ckey, "DW_PLAYSOUNDFILEERROR"))
			_dynamicWords[DW_PLAYSOUNDFILEERROR]			= val;
	    else if (!strcmp(ckey, "DW_SHOW"))
		    _dynamicWords[DW_SHOW]							= val;
    	else if (!strcmp(ckey, "DW_FOCUSDISPLAY"))
    		_dynamicWords[DW_FOCUSDISPLAY]					= val;
    	else if (!strcmp(ckey, "DW_MULTICAST"))
    		_dynamicWords[DW_MULTICAST]						= val;
    	else if (!strcmp(ckey, "DW_SOURCE"))
	    	_dynamicWords[DW_SOURCE]						= val;
    	else if (!strcmp(ckey, "DW_RESOLUTION"))
	    	_dynamicWords[DW_RESOLUTION]					= val;
    	else if (!strcmp(ckey, "DW_TRANSMISSIONRATE"))
    		_dynamicWords[DW_TRANSMISSIONRATE] 				= val;
    	else if (!strcmp(ckey, "DW_TRANSMISSIONCOUNT"))
    		_dynamicWords[DW_TRANSMISSIONCOUNT]				= val;
	    else if (!strcmp(ckey, "DW_READINIFILE"))
		    _dynamicWords[DW_READINIFILE]					= val;
    	else if (!strcmp(ckey, "DW_WRITEINIFILE"))
    		_dynamicWords[DW_WRITEINIFILE]					= val;
	    else if (!strcmp(ckey, "DW_ENCODER"))
	    	_dynamicWords[DW_ENCODER]						= val;
	    else if (!strcmp(ckey, "DW_VIDEOSOURCE"))
		    _dynamicWords[DW_VIDEOSOURCE]					= val;
	    else if (!strcmp(ckey, "DW_AUDIOSOURCE"))
		    _dynamicWords[DW_AUDIOSOURCE]					= val;
	    else if (!strcmp(ckey, "DW_VIDEOENCODER"))
	    	_dynamicWords[DW_VIDEOENCODER]					= val;
	    else if (!strcmp(ckey, "DW_AUDIOENCODER"))
		    _dynamicWords[DW_AUDIOENCODER]					= val;
    }

	vif->updateForm();
    emf->updateForm();
	fsSenderComputeVideoWindow();
}
//---------------------------------------------------------------------------
void
fsSenderLanguage::setupDefaultJapanese()
{
	//
	// SenderMainForm
	//
	SenderMainForm->Caption = "ړ_̉uLc[iMj";

	//
	// MainDataModule
	//
	TMainDataModule *mdm = MainDataModule;

	// OperationActionList
	mdm->OperationAction->Caption					= "(&O)";
	mdm->TransmissionOnOffAction->Caption			= "";			//-> Dynamic Word
	mdm->ReadIniFileAction->Caption					= "ݒ̓Ǎ(&O)";
	mdm->WriteIniFileAction->Caption				= "ݒ̕ۑ(&W)";
	mdm->ExitAction->Caption						= "I(&X)";

	// ShowActionList
	mdm->ShowAction->Caption						= "\(&S)";
	mdm->FocusDisplayNoneAction->Caption			= "tH[JX\Ȃ(&N)";
	mdm->FocusDisplayPartialZoomAction->Caption		= "f̃Y[~O(&Z)";
	mdm->FocusDisplayNonLinearZoomAction->Caption	= "`Y[~O(&L)";
	mdm->FocusDisplayImageCompoundAction->Caption	= "掿̈قȂf(&C)";
	mdm->FocusDisplaySettingAction->Caption			= "ڍאݒ(&E)";
	mdm->FitVideoToWindowAction->Caption			= "EBhEɍ킹ĕ\(&W)";
	mdm->KeepVideoAspectAction->Caption				= "cێ(&K)";
	mdm->OriginalVideoSizeAction->Caption			= "IWiTCYŕ\(&O)";
	mdm->FitWindowToVideoAction->Caption			= "EBhErfIɍ킹(&V)";
	mdm->VolumeIndicatorShowAction->Caption			= "ʃCWP[^̕\(&I)";

	// OptionActionList
	mdm->OptionAction->Caption						= "IvV(&P)";
	mdm->ResolutionAction->Caption					= "𑜓x(&R)";
	mdm->ResolutionSQCIFAction->Caption				= "SQCIF(128x96)";
	mdm->ResolutionQCIFAction->Caption				= "QCIF(176x144)";
	mdm->ResolutionCIFAction->Caption				= "CIF(352x288)";
	mdm->Resolution160x120Action->Caption			= "160x120";
	mdm->Resolution320x240Action->Caption			= "320x240";
	mdm->Resolution360x240Action->Caption			= "360x240";
	mdm->Resolution640x480Action->Caption			= "640x480";
	mdm->Resolution720x480Action->Caption			= "720x480";
	mdm->Resolution800x600Action->Caption           = "800x600";
	mdm->Resolution1024x768Action->Caption          = "1024x768";
	mdm->Resolution1280x1024Action->Caption			= "1280x1024";
	mdm->Resolution1600x1200Action->Caption			= "1600x1200";
	mdm->ResolutionHDTV720pAction->Caption          = "HDTV 720p";
	mdm->ResolutionHDTV1080iAction->Caption         = "HDTV 1080i";
	mdm->ResolutionSDTV480pAction->Caption          = "SDTV 480p";
	mdm->ResolutionSDTV480iAction->Caption          = "SDTV 480i";
	mdm->ResolutionSourceResolutionAction->Caption	= "\[X̉𑜓x";
	mdm->MulticastAction->Caption					= "}`LXg(&M)";
	mdm->VideoTransmissionOnAction->Caption			= "rfȊM(&V)";
	mdm->AudioTransmissionOnAction->Caption			= "I[fBȊM(&A)";
	mdm->FocusTransmissionOnAction->Caption			= "tH[JX̑M(&F)";
	mdm->TransmissionRateAction->Caption			= "ő呍M[g(&T)";
	mdm->TransmissionRate100KbpsAction->Caption		= "100Kbps";
	mdm->TransmissionRate300KbpsAction->Caption		= "300Kbps";
	mdm->TransmissionRate1MbpsAction->Caption		= "1Mbps";
	mdm->TransmissionRate10MbpsAction->Caption		= "10Mbps";
	mdm->TransmissionRate30MbpsAction->Caption		= "30Mbps";
	mdm->TransmissionRate100MbpsAction->Caption		= "100Mbps";
	mdm->TransmissionRate1000MbpsAction->Caption	= "(&I)";
	mdm->TransmissionCountAction->Caption			= "dM(&R)";
	mdm->TransmissionCount1Action->Caption			= "&1";
	mdm->TransmissionCount2Action->Caption			= "&2";
	mdm->TransmissionCount3Action->Caption			= "&3";
	mdm->TransmissionCount4Action->Caption			= "&4";
	mdm->MulticastSettingAction->Caption			= "ڍאݒ(&E)";
	mdm->TransmissionMonitorShowAction->Caption		= "Mj^̕\(&M)";
	mdm->SourceAction->Caption						= "\[X(&S)";
	mdm->VideoSourceAction->Caption					= "rfI\[X(&V)";
	mdm->VideoClipInsertAction->Caption				= "rfINbv̑}(&C)";
	mdm->AudioSourceAction->Caption					= "I[fBI\[X(&A)";
	mdm->SoundFileInsertAction->Caption				= "TEh̑}(&S)";
	mdm->CaptionSettingAction->Caption				= "LvV̐ݒ(&C)";
	mdm->SourceSettingAction->Caption				= "ڍאݒ(&E)";
	mdm->EncoderAction->Caption						= "GR[_(&E)";
	mdm->VideoEncoderAction->Caption				= "rfIGR[_(&V)";
	mdm->AudioEncoderAction->Caption				= "I[fBIGR[_(&A)";
	mdm->RecommendEncoderShowAction->Caption		= "̂ݕ\(&R)";
	mdm->RequireEncoderShowAction->Caption			= "񐄏ȊO\(&Q)";
	mdm->AllEncoderShowAction->Caption				= "Sĕ\(&A)";

	// LanguageActionList
	mdm->LanguageAction->Caption					= "ELang(&L)";

	// HelpActionList
	mdm->HelpAction->Caption						= "wv(&H)";
	mdm->VersionInfoAction->Caption					= "o[W(&V)";

	// FocusDisplaySettingActionList
	mdm->ShowFocusFrameAction->Caption				= "tH[JXgŕ\";
	mdm->FocusCoordinateDesktopWindowAction->Caption= "ʑS";
	mdm->FocusCoordinateVideoWindowAction->Caption	= "rfIEBhE";

	// MulticastSettingActionList
	mdm->CreateIPv6AddressAction->Caption			= "(IPv6)";
	mdm->CreateIPv4AddressAction->Caption			= "(IPv4)";
	mdm->AddressUpdateAction->Caption				= "XV";
	mdm->TTLUpdateAction->Caption					= "XV";
	mdm->PacketSizeUpdateAction->Caption			= "XV";

	// SourceSettingActionList
	mdm->VideoSourcePropertyAction->Caption			= "\";
	mdm->AudioSourcePropertyAction->Caption			= "\";
	mdm->DirectVideoModeAction->Caption				= "\[XtH[}bĝ܂ܑM";
	mdm->DVInterleavedModeAction->Caption			= "DV InterleavediVideo&&Audioĵ܂ܑM";

	// CaptionSettingActionList
	mdm->CaptionOffAction->Caption					= "";
	mdm->CaptionSettingOKAction->Caption			= "s";
	mdm->CaptionSettingCancelAction->Caption		= "LZ";

    // VersionInfoActionList
    mdm->VersionInfoOKAction->Caption				= "OK";

	// Dialogs
	mdm->IniFileOpenDialog->Filter					= "ݒt@C|*.ini";
	mdm->IniFileOpenDialog->Title					= "ݒǍ";
	mdm->IniFileSaveDialog->Filter					= "ݒt@C|*.ini";
	mdm->IniFileSaveDialog->Title					= "ݒۑ";
	mdm->VideoClipOpenDialog->Filter				= "rfINbv|*.avi;*.mpg;*.mpeg";
	mdm->VideoClipOpenDialog->Title					= "rfINbv̑}";
	mdm->SoundFileOpenDialog->Filter				= "TEht@C|*.wav;*.mp3";
	mdm->SoundFileOpenDialog->Title					= "TEht@CǍ";


	//
	// FocusDisplaySettingForm
	//
	TFocusDisplaySettingForm *fds = FocusDisplaySettingForm;

	fds->Caption									= "tH[JX\̏ڍאݒ";
	fds->FocusCoordinateGroupBox->Caption			= "tH[JXʒu̍Wn";
	fds->PartialZoomGroupBox->Caption				= "f̃Y[~O";
	fds->PartialZoomOutputResolutionLabel->Caption	= "\𑜓x";
	fds->PartialZoomSourceResolutionLabel->Caption	= "f̉𑜓x";
	fds->NonLinearZoomGroupBox->Caption				= "`Y[~O";
	fds->NonLinearZoomResolutionLabel->Caption		= "\𑜓x";
	fds->NonLinearZoomMaskSizeLabel->Caption		= "}XNTCY";
	fds->NonLinearZoomMaskWidthLabel->Caption		= "F";
	fds->NonLinearZoomMaskHeightLabel->Caption		= "F";
	fds->NonLinearZoomMaskLabel->Caption			= "}XN`";
	fds->NonLinearZoomMaskComboBox->Clear();
	fds->NonLinearZoomMaskComboBox->Items->Add("`");
	fds->NonLinearZoomMaskComboBox->Items->Add("ȉ~");
	fds->ImageCompoundGroupBox->Caption				= "掿̈قȂf";
	fds->ImageCompoundBaseResolutionLabel->Caption	= "ReLXg𑜓x";
	fds->ImageCompoundAddResolutionLabel->Caption	= "tH[JX𑜓x";
	fds->ImageCompoundMaskLabel->Caption			= "}XN`";
	fds->ImageCompoundMaskComboBox->Clear();
	fds->ImageCompoundMaskComboBox->Items->Add("`");
	fds->ImageCompoundMaskComboBox->Items->Add("ȉ~");
	fds->ImageCompoundMaskComboBox->Items->Add("s͗l");
	fds->ImageCompoundBlendingLabel->Caption		= "E";
	fds->ImageCompoundBlendingComboBox->Clear();
	fds->ImageCompoundBlendingComboBox->Items->Add("P");
	fds->ImageCompoundBlendingComboBox->Items->Add("B");

	//
	// MulticastSettingForm
	//
	TMulticastSettingForm *ms = MulticastSettingForm;

	ms->Caption										= "}`LXg̏ڍאݒ";
	ms->AddressGroupBox->Caption					= "}`LXgIPAhX";
	ms->TTLLabel->Caption							= "őzbvJEg";
	ms->PacketSizeLabel->Caption					= "pPbgTCY";
	ms->TransmitCountLabel->Caption					= "dM";
	ms->TransmitCountComboBox->Items->Clear();
	ms->TransmitCountComboBox->Items->Add("1");
	ms->TransmitCountComboBox->Items->Add("2");
	ms->TransmitCountComboBox->Items->Add("3");
	ms->TransmitCountComboBox->Items->Add("4");
	ms->TargetTransmitRateComboBox->Items->Clear();
	ms->TargetTransmitRateComboBox->Items->Add("rfIM(C/ReLXg)");
	ms->TargetTransmitRateComboBox->Items->Add("rfIM(tH[JX)");
	ms->TargetTransmitRateComboBox->Items->Add("I[fBIM");
	ms->TargetTransmitRateComboBox->Items->Add("tH[JX񑗐M");
	ms->TargetTransmitRateComboBox->Items->Add("Xe[^X/񑗐M");
	ms->TransmitRateGroupBox->Caption				= "ő呍M[g";
	ms->TransmitRateComboBox->Items->Delete(6);
	ms->TransmitRateComboBox->Items->Insert(6, "");
	ms->MulticastDetectLabel->Caption				= "Mo";

	//
	// TransmissionMonitorForm
	//
	TTransmissionMonitorForm *tm = TransmissionMonitorForm;

	tm->Caption										= "Mj^";
	tm->SendRateLabel->Caption						= "rbg[g (kbit/s)";
	tm->FrameRateLabel->Caption						= "Tv[g (sample/s)";
	tm->SendRateVideoMainLabel->Caption				= "rfIiҲ/÷āj";
	tm->SendRateVideoSubLabel->Caption				= "rfIitH[JXj";
	tm->SendRateAudioLabel->Caption					= "I[fBI";
	tm->SendRatePointerLabel->Caption				= "tH[JX";

	//
	// SourceSettingForm
	//
	TSourceSettingForm *ss = SourceSettingForm;

	ss->Caption										= "\[X̏ڍאݒ";
	ss->VideoSourceGroupBox->Caption				= "rfI\[X";
	ss->VideoSourcePropertyLabel->Caption			= "vpeB";
	ss->AudioSourceGroupBox->Caption				= "I[fBI\[X";
	ss->AudioSourcePropertyLabel->Caption			= "vpeB";

	//
	// CaptionSettingForm
	//
	TCaptionSettingForm *csf = CaptionSettingForm;

	csf->Caption									= "LvV̐ݒ";
	csf->CaptionLabel->Caption						= "LvV(Sp30ȓ)";

	//
	// VolumeIndicatorForm
	//
	TVolumeIndicatorForm *vif = VolumeIndicatorForm;

	vif->Caption									= "ʃCWP[^";
	vif->DisplayTimeLabel->Caption					= "\";
	vif->DisplayTimeComboBox->Items->Clear();
	vif->DisplayTimeComboBox->Items->Add("60b");
	vif->DisplayTimeComboBox->Items->Add("20b");
	vif->DisplayTimeComboBox->Items->Add("10b");
	vif->DisplayTimeComboBox->Items->Add("5b");
	vif->DisplayTimeComboBox->Items->Add("2b");
	vif->DisplayTimeComboBox->Items->Add("1b");
	vif->DisplayPauseCheckBox->Caption				= "\̈ꎞ~";
	vif->updateForm();

    //
    // ErrorMessageForm
    //
    TErrorMessageForm *emf = ErrorMessageForm;
    emf->Caption									= "G[";
    emf->setTypeString(FSSENDER_T_WRONG_CAPTURE, "Ή̃Lv`łB");
    emf->setTypeString(FSSENDER_T_WRONG_ENCODER, "Ή̃GR[_[łB");
    emf->setTypeString(FSSENDER_T_WRONG_MEDIATYPE, "Ή̃fBA^CvłB");
    emf->setTypeString(FSSENDER_T_NOTFOUND_DECODER, "fR[_܂B");
    emf->setTypeString(FSSENDER_T_UNEXPECTED, "\ȂG[");

    //
    // VersionInfoFrom
    //
    TVersionInfoForm *vf = VersionInfoForm;

    vf->Caption										= "o[W";
    vf->VersionInfoSoftwareNameLabel->Caption		= "FocusShare \tgEFA v1.0 (M)";

	//
	// Dynamic Words
	//
	_dynamicWords[DW_STOP]							= "~(&S)";
	_dynamicWords[DW_START]							= "s(&S)";
	_dynamicWords[DW_STATUSTRANSMIT]				= "M";
	_dynamicWords[DW_STATUSSTOP]					= "~";
	_dynamicWords[DW_STATUSFAILEDCONFIG]			= "\Ɏs܂";
	_dynamicWords[DW_STATUSVIDEO]					= "rfI";
	_dynamicWords[DW_STATUSAUDIO]					= "I[fBI";
	_dynamicWords[DW_STATUSFOCUS]					= "tH[JX";
	_dynamicWords[DW_STATUSNODATA]					= "f[^Ȃ";
	_dynamicWords[DW_STATUSPLAYSOUNDFILE]			= "TEhĐ";
	_dynamicWords[DW_ERROR]							= "G[";
	_dynamicWords[DW_READINIFILEERROR]				= "ݒ̓Ǎ݂Ɏs܂B";
	_dynamicWords[DW_WRITEINIFILEERROR]				= "ݒ̕ۑɎs܂B";
	_dynamicWords[DW_PLAYVIDEOCLIPERROR]			= "rfINbv̍ĐɎs܂B";
	_dynamicWords[DW_PLAYSOUNDFILEERROR]			= "TEht@C̍ĐɎs܂B";
    _dynamicWords[DW_SHOW]							= "\";
    _dynamicWords[DW_FOCUSDISPLAY]					= "tH[JX\";
    _dynamicWords[DW_MULTICAST]						= "}`LXg";
    _dynamicWords[DW_SOURCE]						= "\[X";
    _dynamicWords[DW_RESOLUTION]					= "𑜓x";
    _dynamicWords[DW_TRANSMISSIONRATE]				= "ő呍M[g";
    _dynamicWords[DW_TRANSMISSIONCOUNT]				= "dM";
    _dynamicWords[DW_READINIFILE]					= "ݒ̓Ǎ";
    _dynamicWords[DW_WRITEINIFILE]					= "ݒ̕ۑ";
    _dynamicWords[DW_ENCODER]						= "GR[_";
    _dynamicWords[DW_VIDEOSOURCE]					= "rfI\[X";
    _dynamicWords[DW_AUDIOSOURCE]					= "I[fBI\[X";
    _dynamicWords[DW_VIDEOENCODER]					= "rfIGR[_";
    _dynamicWords[DW_AUDIOENCODER]					= "I[fBIGR[_";
}
//---------------------------------------------------------------------------
void
fsSenderLanguage::setupDefaultEnglish()
{
    //
    // SenderMainForm
    //
    SenderMainForm->Caption = "Focus Share Tool (Sender)";
	
	//
    // MainDataModule
    //
	TMainDataModule *mdm = MainDataModule;

	// OperationActionList
	mdm->OperationAction->Caption					= "&Operation";
	mdm->TransmissionOnOffAction->Caption			= "";			//-> Dynamic Word
	mdm->ReadIniFileAction->Caption					= "&Load Settings";
	mdm->WriteIniFileAction->Caption				= "&Save Settings";
	mdm->ExitAction->Caption						= "E&xit";

	// ShowActionList
	mdm->ShowAction->Caption						= "&Display";
	mdm->FocusDisplayNoneAction->Caption			= "&Normal";
	mdm->FocusDisplayPartialZoomAction->Caption		= "&Partial Zooming";
	mdm->FocusDisplayNonLinearZoomAction->Caption	= "Non-&Linar Zooming";
	mdm->FocusDisplayImageCompoundAction->Caption	= "&Composition of Different Quality Videos";
	mdm->FocusDisplaySettingAction->Caption			= "S&ettings";
	mdm->FitVideoToWindowAction->Caption			= "Fit Video to &Window";
	mdm->KeepVideoAspectAction->Caption				= "Keep Video &Aspect";
	mdm->OriginalVideoSizeAction->Caption			= "&Original Size";
	mdm->FitWindowToVideoAction->Caption			= "Fit Window to &Video";
    mdm->VolumeIndicatorShowAction->Caption			= "Volume &Indicator";

	// OptionActionList
	mdm->OptionAction->Caption						= "&Option";
	mdm->ResolutionAction->Caption					= "&Resolution";
	mdm->ResolutionSQCIFAction->Caption				= "SQCIF(128x96)";
	mdm->ResolutionQCIFAction->Caption				= "QCIF(176x144)";
	mdm->ResolutionCIFAction->Caption				= "CIF(352x288)";
	mdm->Resolution160x120Action->Caption			= "160x120";
	mdm->Resolution320x240Action->Caption			= "320x240";
	mdm->Resolution360x240Action->Caption			= "360x240";
	mdm->Resolution640x480Action->Caption			= "640x480";
	mdm->Resolution720x480Action->Caption			= "720x480";
    mdm->Resolution800x600Action->Caption           = "800x600";
    mdm->Resolution1024x768Action->Caption          = "1024x768";
	mdm->Resolution1280x1024Action->Caption			= "1280x1024";
	mdm->Resolution1600x1200Action->Caption			= "1600x1200";
    mdm->ResolutionHDTV720pAction->Caption          = "HDTV 720p";
    mdm->ResolutionHDTV1080iAction->Caption         = "HDTV 1080i";
    mdm->ResolutionSDTV480pAction->Caption          = "SDTV 480p";
    mdm->ResolutionSDTV480iAction->Caption          = "SDTV 480i";
	mdm->ResolutionSourceResolutionAction->Caption	= "&Original Resolution";
	mdm->MulticastAction->Caption					= "&Multicast";
	mdm->VideoTransmissionOnAction->Caption			= "&Video Transmission On";
	mdm->AudioTransmissionOnAction->Caption			= "&Audio Transmission On";
	mdm->FocusTransmissionOnAction->Caption			= "&Focus Info. Transmission On";
	mdm->TransmissionRateAction->Caption			= "Transmission &Rate";
	mdm->TransmissionRate100KbpsAction->Caption		= "100Kbps";
	mdm->TransmissionRate300KbpsAction->Caption		= "300Kbps";
	mdm->TransmissionRate1MbpsAction->Caption		= "1Mbps";
	mdm->TransmissionRate10MbpsAction->Caption		= "10Mbps";
	mdm->TransmissionRate30MbpsAction->Caption		= "30Mbps";
	mdm->TransmissionRate100MbpsAction->Caption		= "100Mbps";
	mdm->TransmissionRate1000MbpsAction->Caption	= "Unl&imited";
	mdm->TransmissionCountAction->Caption			= "Number of &Repetitions";
	mdm->TransmissionCount1Action->Caption			= "&1";
	mdm->TransmissionCount2Action->Caption			= "&2";
	mdm->TransmissionCount3Action->Caption			= "&3";
	mdm->TransmissionCount4Action->Caption			= "&4";
	mdm->MulticastSettingAction->Caption			= "S&ettings";
	mdm->TransmissionMonitorShowAction->Caption		= "Transmi&ssion Monitor";
	mdm->SourceAction->Caption						= "&Source";
	mdm->VideoSourceAction->Caption					= "&Video Source";
	mdm->VideoClipInsertAction->Caption				= "Insert Video &Clip";
	mdm->AudioSourceAction->Caption					= "&Audio Source";
	mdm->SoundFileInsertAction->Caption				= "Insert &Sound File";
	mdm->CaptionSettingAction->Caption				= "&Caption Settings";
	mdm->SourceSettingAction->Caption				= "S&ettings";
	mdm->EncoderAction->Caption						= "&Encoder";
	mdm->VideoEncoderAction->Caption				= "&VideoEncoder";
	mdm->AudioEncoderAction->Caption				= "&AudioEncoder";
	mdm->RecommendEncoderShowAction->Caption		= "Show &Recommended";
	mdm->RequireEncoderShowAction->Caption			= "Show Re&quired";
	mdm->AllEncoderShowAction->Caption				= "Show &All";

	// LanguageActionList
	mdm->LanguageAction->Caption					= "&Language";

	// HelpActionList
	mdm->HelpAction->Caption						= "&Help";
	mdm->VersionInfoAction->Caption					= "&Version Info.";

	// FocusDisplaySettingActionList
	mdm->ShowFocusFrameAction->Caption				= "Show Focus Frame";
    mdm->FocusCoordinateDesktopWindowAction->Caption= "Desktop Window";
    mdm->FocusCoordinateVideoWindowAction->Caption	= "Video Window";

	// MulticastSettingActionList
    mdm->CreateIPv6AddressAction->Caption			= "Generate(IPv6)";
    mdm->CreateIPv4AddressAction->Caption			= "Generate(IPv4)";
	mdm->AddressUpdateAction->Caption				= "Update";
	mdm->TTLUpdateAction->Caption					= "Update";
	mdm->PacketSizeUpdateAction->Caption			= "Update";

	// SourceSettingActionList
	mdm->VideoSourcePropertyAction->Caption			= "Show";
	mdm->AudioSourcePropertyAction->Caption			= "Show";
	mdm->DirectVideoModeAction->Caption				= "Raw Format Transmission";
	mdm->DVInterleavedModeAction->Caption			= "DV Interleaved (Video&&Audio)";

	// CaptionSettingActionList
    mdm->CaptionOffAction->Caption					= "Disable";
	mdm->CaptionSettingOKAction->Caption			= "OK";
	mdm->CaptionSettingCancelAction->Caption		= "Cancel";

    // VersionInfoActionList
    mdm->VersionInfoOKAction->Caption				= "OK";

	// Dialogs
	mdm->IniFileOpenDialog->Filter					= "Setting File|*.ini";
    mdm->IniFileOpenDialog->Title					= "Load Settings";
    mdm->IniFileSaveDialog->Filter					= "Setting File|*.ini";
    mdm->IniFileSaveDialog->Title					= "Save Settings";
	mdm->VideoClipOpenDialog->Filter				= "Video Clip|*.avi;*.mpg;*.mpeg";
    mdm->VideoClipOpenDialog->Title					= "Insert Video Clip";
	mdm->SoundFileOpenDialog->Filter				= "Sound File|*.wav;*.mp3";
    mdm->SoundFileOpenDialog->Title					= "Load Sound File";


	//
   	// FocusDisplaySettingForm
    //
	TFocusDisplaySettingForm *fds = FocusDisplaySettingForm;

    fds->Caption									= "Settings of Focus Display";
    fds->FocusCoordinateGroupBox->Caption			= "Focus Coordinate";
	fds->PartialZoomGroupBox->Caption				= "Partial Zooming";
	fds->PartialZoomOutputResolutionLabel->Caption	= "Output Resolution";
	fds->PartialZoomSourceResolutionLabel->Caption	= "Source Resolution";
	fds->NonLinearZoomGroupBox->Caption				= "Non-linear Zooming";
	fds->NonLinearZoomResolutionLabel->Caption		= "Output Resolution";
    fds->NonLinearZoomMaskSizeLabel->Caption		= "Mask Size";
    fds->NonLinearZoomMaskWidthLabel->Caption		= "WidthF";
    fds->NonLinearZoomMaskHeightLabel->Caption		= "HeightF";
    fds->NonLinearZoomMaskLabel->Caption			= "Mask Shape";
	fds->NonLinearZoomMaskComboBox->Clear();
    fds->NonLinearZoomMaskComboBox->Items->Add("Rectangle");
    fds->NonLinearZoomMaskComboBox->Items->Add("Oval");
    fds->ImageCompoundGroupBox->Caption				= "Composition of Different Quality Videos";
    fds->ImageCompoundBaseResolutionLabel->Caption	= "Context Resolution";
    fds->ImageCompoundAddResolutionLabel->Caption	= "Focus Resolution";
    fds->ImageCompoundMaskLabel->Caption			= "Mask Shape";
    fds->ImageCompoundMaskComboBox->Clear();
    fds->ImageCompoundMaskComboBox->Items->Add("Rectangle");
    fds->ImageCompoundMaskComboBox->Items->Add("Oval");
    fds->ImageCompoundMaskComboBox->Items->Add("Checker");
    fds->ImageCompoundBlendingLabel->Caption		= "Border";
    fds->ImageCompoundBlendingComboBox->Clear();
    fds->ImageCompoundBlendingComboBox->Items->Add("Simple");
    fds->ImageCompoundBlendingComboBox->Items->Add("Blending");

    //
    // MulticastSettingForm
    //
	TMulticastSettingForm *ms = MulticastSettingForm;

    ms->Caption										= "Settings of Multicast";
    ms->AddressGroupBox->Caption					= "Multicast IP Address";
	ms->TTLLabel->Caption							= "Max. Hop Count";
	ms->PacketSizeLabel->Caption					= "Packet Size";
	ms->TransmitCountLabel->Caption					= "Number of Repetitions";
    ms->TransmitCountComboBox->Items->Clear();
	ms->TransmitCountComboBox->Items->Add("1");
	ms->TransmitCountComboBox->Items->Add("2");
	ms->TransmitCountComboBox->Items->Add("3");
	ms->TransmitCountComboBox->Items->Add("4");
	ms->TargetTransmitRateComboBox->Items->Clear();
	ms->TargetTransmitRateComboBox->Items->Add("Video Transmission(Main or Context)");
	ms->TargetTransmitRateComboBox->Items->Add("Video Transmission(Focus)");
	ms->TargetTransmitRateComboBox->Items->Add("Audio Transmission");
	ms->TargetTransmitRateComboBox->Items->Add("Focus Info. Transmission");
	ms->TargetTransmitRateComboBox->Items->Add("Status/Control Info. Transmission");
	ms->TransmitRateGroupBox->Caption				= "Transmission Rate";
	ms->TransmitRateComboBox->Items->Delete(6);
    ms->TransmitRateComboBox->Items->Insert(6, "Unlimited");
    ms->MulticastDetectLabel->Caption				= "Detected";

    //
    // TransmissionMonitorForm
    //
	TTransmissionMonitorForm *tm = TransmissionMonitorForm;

    tm->Caption										= "Transmission Monitor";
	tm->SendRateLabel->Caption						= "Bit Rate (kbit/s)";
	tm->FrameRateLabel->Caption						= "Sample Rate (sample/s)";
	tm->SendRateVideoMainLabel->Caption				= "Video(Main/Context)";
	tm->SendRateVideoSubLabel->Caption				= "Video(Focus)";
	tm->SendRateAudioLabel->Caption					= "Audio";
    tm->SendRatePointerLabel->Caption				= "Focus Info.";

    //
    // SourceSettingForm
    //
	TSourceSettingForm *ss = SourceSettingForm;

	ss->Caption										= "Settings of Sources";
	ss->VideoSourceGroupBox->Caption				= "Video Source";
	ss->VideoSourcePropertyLabel->Caption			= "Property";
	ss->AudioSourceGroupBox->Caption				= "Audio Source";
	ss->AudioSourcePropertyLabel->Caption			= "Property";

    //
    // CaptionSettingForm
    //
    TCaptionSettingForm *csf = CaptionSettingForm;

    csf->Caption									= "Caption Settings";
    csf->CaptionLabel->Caption						= "Caption(within 62 characters)";

    //
    // VolumeIndicatorForm
    //
    TVolumeIndicatorForm *vif = VolumeIndicatorForm;

    vif->Caption									= "Volume Indicator";
    vif->DisplayTimeLabel->Caption					= "Display Time";
    vif->DisplayTimeComboBox->Items->Clear();
    vif->DisplayTimeComboBox->Items->Add("60 seconds");
    vif->DisplayTimeComboBox->Items->Add("20 seconds");
    vif->DisplayTimeComboBox->Items->Add("10 seconds");
    vif->DisplayTimeComboBox->Items->Add("5 seconds");
    vif->DisplayTimeComboBox->Items->Add("2 seconds");
    vif->DisplayTimeComboBox->Items->Add("1 second");
    vif->DisplayPauseCheckBox->Caption				= "Pause";
    vif->updateForm();

    //
    // ErrorMessageForm
    //
    TErrorMessageForm *emf = ErrorMessageForm;
    emf->Caption									= "Error";
    emf->setTypeString(FSSENDER_T_WRONG_CAPTURE, "Not Supported Capture");
    emf->setTypeString(FSSENDER_T_WRONG_ENCODER, "Not Supported Encoder");
    emf->setTypeString(FSSENDER_T_WRONG_MEDIATYPE, "Not Supported Media Type");
    emf->setTypeString(FSSENDER_T_NOTFOUND_DECODER, "Decoder is Not Found");
    emf->setTypeString(FSSENDER_T_UNEXPECTED, "Unexpected Error");

    //
    // VersionInfoFrom
    //
    TVersionInfoForm *vf = VersionInfoForm;

    vf->Caption										= "Version Info.";
    vf->VersionInfoSoftwareNameLabel->Caption		= "Focus Share Software v1.0 (Sender)";

    //
    // Dynamic Words
    //
	_dynamicWords[DW_STOP]							= "&Stop";
	_dynamicWords[DW_START]							= "&Start";
	_dynamicWords[DW_STATUSTRANSMIT]				= "Sending";
	_dynamicWords[DW_STATUSSTOP]					= "Stopped";
	_dynamicWords[DW_STATUSFAILEDCONFIG]			= "Failed to Configuration";
	_dynamicWords[DW_STATUSVIDEO]					= "Video";
	_dynamicWords[DW_STATUSAUDIO]					= "Audio";
	_dynamicWords[DW_STATUSFOCUS]					= "Focus";
    _dynamicWords[DW_STATUSNODATA]					= "No Data";
	_dynamicWords[DW_STATUSPLAYSOUNDFILE]			= "Reproduing Sound file";
    _dynamicWords[DW_ERROR]							= "Error";
    _dynamicWords[DW_READINIFILEERROR]				= "Failed to Load setting.";
	_dynamicWords[DW_WRITEINIFILEERROR]				= "Failed to Save setting.";
    _dynamicWords[DW_PLAYVIDEOCLIPERROR]			= "Failed to Play Video Clip.";
    _dynamicWords[DW_PLAYSOUNDFILEERROR]			= "Failed to Play Sound File.";
    _dynamicWords[DW_SHOW]							= "Show";
    _dynamicWords[DW_FOCUSDISPLAY]					= "Focus Display";
    _dynamicWords[DW_MULTICAST]						= "Multicast";
    _dynamicWords[DW_SOURCE]						= "Source";
    _dynamicWords[DW_RESOLUTION]					= "Resolution";
    _dynamicWords[DW_TRANSMISSIONRATE]				= "Transmission Rate";
    _dynamicWords[DW_TRANSMISSIONCOUNT]				= "Number of Repetitions";
    _dynamicWords[DW_READINIFILE]					= "Load Setting";
    _dynamicWords[DW_WRITEINIFILE]					= "Save Setting";
    _dynamicWords[DW_ENCODER]						= "Encoder";
    _dynamicWords[DW_VIDEOSOURCE]					= "Video Source";
    _dynamicWords[DW_AUDIOSOURCE]					= "Audio Source";
    _dynamicWords[DW_VIDEOENCODER]					= "Video Encoder";
    _dynamicWords[DW_AUDIOENCODER]					= "Audio Encoder";
}
//---------------------------------------------------------------------------

