/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fsSenderMainForm.h"
#include "fsMainDataModule.h"
#include "fsFocusDisplaySettingForm.h"
#include "fsMulticastSettingForm.h"
#include "fsTransmissionMonitorForm.h"
#include "fsSourceSettingForm.h"
#include "fsCaptionSettingForm.h"
#include "fsVersionInfoForm.h"
#include "fsSenderLanguage.h"
#include <ui/fsCommonUI/fsVolumeIndicatorForm.h>
#include <ui/fsCommonUI/fsErrorMessageForm.h>
#include <fs/fsSender/fsSenderInterface.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSenderMainForm *SenderMainForm;
//---------------------------------------------------------------------------
__fastcall TSenderMainForm::TSenderMainForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall
TSenderMainForm::FormCreate(TObject *Sender)
{
	if (!fsSenderInitialize(VideoRenderPanel->Handle))
	{
		exit(0);
		return ;
	}

    // tH[̎蓮
    ErrorMessageForm		= new TErrorMessageForm(NULL);
	MainDataModule 			= new TMainDataModule(NULL);
    FocusDisplaySettingForm	= new TFocusDisplaySettingForm(NULL);
    MulticastSettingForm	= new TMulticastSettingForm(NULL);
    TransmissionMonitorForm	= new TTransmissionMonitorForm(NULL);
    SourceSettingForm		= new TSourceSettingForm(NULL);
    CaptionSettingForm		= new TCaptionSettingForm(NULL);
    VolumeIndicatorForm		= new TVolumeIndicatorForm(NULL);
    VersionInfoForm			= new TVersionInfoForm(NULL);

    toCenter(this);
    toCenter(ErrorMessageForm);
    toCenter(FocusDisplaySettingForm);
    toCenter(MulticastSettingForm);
    toCenter(TransmissionMonitorForm);
    toCenter(SourceSettingForm);
    toCenter(CaptionSettingForm);
    toCenter(VolumeIndicatorForm);
    toCenter(VersionInfoForm);


    // ̐
    _language				= new fsSenderLanguage(MainDataModule->LanguageMenuItem);

	// TCY֎~tO
	_forbidResize			= false;

    // tH[\tO
    _formShown				= false;

	// R[obNݒ
	extern int StaticCallbackFunction(const char* command, void* param,
									  void* data);
	fsSenderSetUICallbackFunction(StaticCallbackFunction, this);

    VolumeIndicatorForm->VolumeRequest = VolumeRequest;

    //
    // WXgǍ
    //
    // Language
    char str[256];
    fsSenderReadRegistry("Sender", "Language",
    	 _language->getLanguageCode(0).c_str(), str);
    _language->setCurrentLanguageCode(str);

    // VolumeIndicator Display Time
    const char* cstr;
    switch(VolumeIndicatorForm->DisplayTime)
    {
    case 0:	cstr = "60s";	break;
    case 1:	cstr = "20s";	break;
    case 2:	cstr = "10s";	break;
    case 3:	cstr = "5s";	break;
    case 4:	cstr = "2s";	break;
    case 5:	cstr = "1s";	break;
    default:cstr = "5s";	break;
    }
    fsSenderReadRegistry("Sender", "VolumeIndicatorDisplayTime", cstr, str);
    if (!strcmpi(str, "60s"))  		VolumeIndicatorForm->DisplayTime = 0;
    else if (!strcmpi(str, "20s"))  VolumeIndicatorForm->DisplayTime = 1;
    else if (!strcmpi(str, "10s"))  VolumeIndicatorForm->DisplayTime = 2;
    else if (!strcmpi(str, "5s"))	VolumeIndicatorForm->DisplayTime = 3;
    else if (!strcmpi(str, "2s"))	VolumeIndicatorForm->DisplayTime = 4;
    else if (!strcmpi(str, "1s"))	VolumeIndicatorForm->DisplayTime = 5;
    else							VolumeIndicatorForm->DisplayTime = 3;
}
//---------------------------------------------------------------------------
void __fastcall
TSenderMainForm::FormShow(TObject *Sender)
{
	_formShown = true;
}
//---------------------------------------------------------------------------
void __fastcall
TSenderMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	_formShown = false;

	// ^C}[
	MainDataModule->SenderTimer->Enabled = false;

    //
	// WXg̏
    //

    // Language
	char str[256];
    fsSenderWriteRegistry("Sender", "Language", _language->getCurrentLanguageCode().c_str());

    // VolumeIndicator Display Time
    const char* cstr;
    switch(VolumeIndicatorForm->DisplayTime)
    {
    case 0:	cstr = "60s";	break;
    case 1:	cstr = "20s";	break;
    case 2:	cstr = "10s";	break;
    case 3:	cstr = "5s";	break;
    case 4:	cstr = "2s";	break;
    case 5:	cstr = "1s";	break;
    default:cstr = "5s";	break;
    }
    fsSenderWriteRegistry("Sender", "VolumeIndicatorDisplayTime", cstr);


    // ̍폜
    delete _language;

    // tH[̎蓮
    delete VersionInfoForm;
    delete VolumeIndicatorForm;
    delete CaptionSettingForm;
    delete SourceSettingForm;
    delete TransmissionMonitorForm;
    delete MulticastSettingForm;
    delete FocusDisplaySettingForm;
    delete MainDataModule;
    delete ErrorMessageForm;
}
//---------------------------------------------------------------------------
void __fastcall
TSenderMainForm::FormDestroy(TObject *Sender)
{
	fsSenderShutdown();
}
//---------------------------------------------------------------------------
void __fastcall
TSenderMainForm::FormKeyUp(TObject *Sender, WORD &Key, TShiftState Shift)
{
	if (Shift.Contains(ssCtrl) && Key == 'E')
		ErrorMessageForm->Show();
}
//---------------------------------------------------------------------------
void __fastcall
TSenderMainForm::VideoRenderPanelResize(TObject *Sender)
{
	if (!fsSenderIsInitialized() || !_formShown)
		return ;

    _forbidResize = true;
	fsSenderComputeVideoWindow();
    _forbidResize = false;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Callback
//---------------------------------------------------------------------------
int
StaticCallbackFunction(const char* command, void* param, void* data)
{
	if (SenderMainForm != NULL)
		return SenderMainForm->ProcessCallback(command, param);
	return 0;
}
//---------------------------------------------------------------------------
int __fastcall
TSenderMainForm::ProcessCallback(const char *command, void *param)
{
	if (!strcmp("ResizeForm", command))
    {
    	int videoSize[2];

        videoSize[0] = ((int *)param)[0];
        videoSize[1] = ((int *)param)[1];

        if (!_forbidResize)
        {
			ClientWidth = videoSize[0];
			ClientHeight = videoSize[1] + StatusBar->Height;
        }
    }
	return 0;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall
TSenderMainForm::VolumeRequest(TObject *Sender, int *volume, int evalTime)
{
	fsSenderSetVolumeEvaluationTime(evalTime);
	fsSenderGetVolume(&volume[0], &volume[1]);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void
TSenderMainForm::toCenter(TForm* form)
{
	HWND hWnd = GetDesktopWindow();
    if (hWnd == NULL)
    	return ;

    RECT rect;
    GetWindowRect(hWnd, &rect);

    int width = form->Width;
    int height = form->Height;

    int dwidth = rect.right - rect.left;
    int dheight = rect.bottom - rect.top;

    form->Left = (dwidth - width) / 2;
    form->Top = (dheight - height) / 2;
}
//---------------------------------------------------------------------------

