/*
**	Copyright (c) 2003-2004 National Institute of Multimedia Education. All rights reserved.
**	2-12 Wakaba, Mihama, Chiba, 261-0014 JAPAN
**	http://www.nime.ac.jp/
*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fsMainDataModule.h"
#include "fsSourceSettingForm.h"
#include <fs/fsSender/fsSenderInterface.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSourceSettingForm *SourceSettingForm;
//---------------------------------------------------------------------------
__fastcall
TSourceSettingForm::TSourceSettingForm(TComponent* Owner)
 : TForm(Owner)
{
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall
TSourceSettingForm::FormShow(TObject *Sender)
{
	updateForm();
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void
TSourceSettingForm::updateForm()
{
	int numProps;

    //
	// Video Source property page
    //
    
    // Items
    VideoSourcePropertyComboBox->Clear();

    numProps = fsSenderGetNumVideoSourcePropertyPages();
    for(int i = 0; i < numProps; i++)
    {
    	VideoSourcePropertyComboBox->Items->Add(
        			fsSenderGetVideoSourcePropertyPageName(i));
    }
    if (0 < numProps)
    {
    	VideoSourcePropertyComboBox->ItemIndex = 0;
        VideoSourcePropertyComboBox->Enabled = true;
    }
	else
    {
    	VideoSourcePropertyComboBox->Enabled = false;
    }

    // Actions
    MainDataModule->VideoSourcePropertyAction->Enabled = (0 < numProps);


    //
	// Audio Source property page
    //

    // Items
	AudioSourcePropertyComboBox->Clear();

    numProps = fsSenderGetNumAudioSourcePropertyPages();
    for(int i = 0; i < numProps; i++)
    {
    	AudioSourcePropertyComboBox->Items->Add(
        			fsSenderGetAudioSourcePropertyPageName(i));
    }
    if (0 < numProps)
    {
    	AudioSourcePropertyComboBox->ItemIndex = 0;
        AudioSourcePropertyComboBox->Enabled = true;
    }
    else
    {
    	AudioSourcePropertyComboBox->Enabled = false;
    }

    // Actions
    MainDataModule->AudioSourcePropertyAction->Enabled = (0 < numProps);

    //
    // Direct Video Mode
    //
	bool directVideoModeOn = fsSenderGetDirectVideoModeOn();
	MainDataModule->DirectVideoModeAction->Checked = directVideoModeOn;

	bool dvInterleavedModeOn = fsSenderGetDVInterleavedModeOn();
    bool isValidDVInterleaved = fsSenderIsValidDVInterleavedMode();

	MainDataModule->DVInterleavedModeAction->Checked = dvInterleavedModeOn;
    MainDataModule->DVInterleavedModeAction->Enabled = directVideoModeOn && isValidDVInterleaved;

}
//---------------------------------------------------------------------------

